// this sets the background color of the master UIView (when there are no windows/tab groups on it)
Titanium.UI.setBackgroundColor('#000');

// create tab group
var tabGroup = Titanium.UI.createTabGroup();

var barcode = require('com.bsl.lbarcode');
Ti.API.info("module is => " + barcode);

//
// create base UI tab and root window
//
var win1 = Titanium.UI.createWindow({  
    title:'Tab 1',
    backgroundColor:'#fff'
});

var tab1 = Titanium.UI.createTab({  
    icon:'KS_nav_views.png',
    title:'Tab 1',
    window:win1
});

var label1 = Titanium.UI.createLabel({
	color:'#000',
	font:{fontSize:48,fontFamily:'Helvetica Neue'},
	top:300,
	textAlign:'center',
	width:'auto'
});

var barcodeButton = Titanium.UI.createButton({
	title: 'Scan Barcode',
	top: 150
});

barcodeButton.addEventListener('click', function(e) {
	barcode.scan({
		success: function (data) {
			if(data && data.barcode) {
				label1.text = 'Barcode:' + data.barcode + " Format:" + data.format;
				
				//Ti.Platform.openURL(data.barcode);
				//barcodestring.text = data.barcode;
				
				//label2.text = barcodestring.text;
			} else {
				alert(JSON.stringify(data));
			}
		},

		error: function (err) {
        	alert('Error while scanning: ' + err);
        },

		cancel: function () {
			alert('Scan cancelled');
		}
	});
});

win1.add(label1);
win1.add(barcodeButton);

//
// create controls tab and root window
//
var win2 = Titanium.UI.createWindow({  
    title:'Tab 2',
    backgroundColor:'#fff'
});

var tab2 = Titanium.UI.createTab({  
    icon:'KS_nav_ui.png',
    title:'Tab 2',
    window:win2
});

var option = 1;

var input = Titanium.UI.createTextField({
	color:'#336699',
	top:100,
	width:350,
	hintText:'barcode',
	keyboardType:Titanium.UI.KEYBOARD_DEFAULT,
	returnKeyType:Titanium.UI.RETURNKEY_DEFAULT,
	borderStyle:Titanium.UI.INPUT_BORDERSTYLE_ROUNDED
});

var encodeButton = Titanium.UI.createButton({
	title: 'Encode Code39',
	top: 200
});

encodeButton.addEventListener('click', function(e) {
	if (option == 1) {
		imgView.image = barcode.encodeCode39(input.value);
	} else if (option == 2) {
		imgView.image = barcode.encodeCode128(input.value);
	} else if (option == 3) {
		imgView.image = barcode.encodeQRCode(input.value);
	} else if (option == 4) {
		imgView.image = barcode.encodeEan8(input.value);
	} else if (option == 5) {
		imgView.image = barcode.encodeEan13(input.value);
	} else if (option == 6) {
		imgView.image = barcode.encodeUpcA(input.value);
	} else if (option == 7) {
		imgView.image = barcode.encodeUpcE(input.value);
	} else if (option == 8) {
		imgView.image = barcode.encodeItf(input.value);
	}
});

var imgView = Titanium.UI.createImageView({
	top: 300
});

var activity = win2.activity;
activity.onCreateOptionsMenu = function(e) {
	var menu = e.menu;
	var menuItem1 = menu.add({title:"Code39"});
	menuItem1.icon = 'KS_nav_ui.png';
	menuItem1.addEventListener("click", function(e) {
		option = 1;
		encodeButton.title = 'Encode Code39';
	});
	var menuItem2 = menu.add({title:"Code128"});
	menuItem2.icon = 'KS_nav_ui.png';
	menuItem2.addEventListener("click", function(e) {
		option = 2;
		encodeButton.title = 'Encode Code128';
	});
	var menuItem3 = menu.add({title:"QR Code"});
	menuItem3.icon = 'KS_nav_ui.png';
	menuItem3.addEventListener("click", function(e) {
		option = 3;
		encodeButton.title = 'Encode QR Code';
	});
	var menuItem4 = menu.add({title:"Ean 8"});
	menuItem4.icon = 'KS_nav_ui.png';
	menuItem4.addEventListener("click", function(e) {
		option = 4;
		encodeButton.title = 'Encode Ean 8';
	});
	var menuItem5 = menu.add({title:"Ean 13"});
	menuItem5.icon = 'KS_nav_ui.png';
	menuItem5.addEventListener("click", function(e) {
		option = 5;
		encodeButton.title = 'Encode Ean 13';
	});
	var menuItem6 = menu.add({title:"Upc A"});
	menuItem6.icon = 'KS_nav_ui.png';
	menuItem6.addEventListener("click", function(e) {
		option = 6;
		encodeButton.title = 'Encode Upc A';
	});
	var menuItem7 = menu.add({title:"Upc E"});
	menuItem7.icon = 'KS_nav_ui.png';
	menuItem7.addEventListener("click", function(e) {
		option = 7;
		encodeButton.title = 'Encode Upc E';
	});
	var menuItem8 = menu.add({title:"ITF"});
	menuItem8.icon = 'KS_nav_ui.png';
	menuItem8.addEventListener("click", function(e) {
		option = 8;
		encodeButton.title = 'Encode ITF';
	});
};

win2.add(input);
win2.add(encodeButton);
win2.add(imgView);

//
//  add tabs
//
tabGroup.addTab(tab1);  
tabGroup.addTab(tab2);  

// open tab group
tabGroup.open();
