
//--- 1. Prepare App-Specific Environment -----------------------
Ti.include('/globals.js');

Titanium.UI.setBackgroundImage('/assets/images/ui/bg.png');

var versionNo = Ti.Platform.version;

if(Ti.Platform.osname == 'android' &&  versionNo < '2.2') {
	var win = Ti.UI.createWindow({  
		exitOnClose: true,
		fullscreen: false,
		layout: 'composite', touchEnabled:false,
	});

	win.addEventListener('open', function(e){
		var dialog = Ti.UI.createAlertDialog({
		    message: 'To ensure good user experience, we support devices running Android 2.2 and above. Thank you for your understanding.',
		    ok: 'Okay',
		    title: 'Device running unsupported Android SDK.'
	  	});
		dialog.addEventListener('click', function(e){
		    win.close();
		  });
		dialog.show();
	});
	win.open();
}

//--- Set language & language Region ---
if('zh-Hant' == Ti.Locale.currentLanguage || 'zh' == Ti.Locale.currentLanguage) { //iOS
	var langRegion = Ti.App.Properties.getString('WOConfig.langRegion', null);
	if(!langRegion) {
		var lastRunVersion = Ti.App.Properties.getString('WOApp.lastRunVersion', null);
		var currentCountry = Ti.Locale.getCurrentCountry();
		if('MO' == currentCountry || 'HK' == currentCountry || 'TW' == currentCountry || 'CN' == currentCountry || 'SG' == currentCountry){
			langRegion = ('HK' == currentCountry || 'MO' == currentCountry) ? 'HK' : 'TW';
		} else {
			var carrierInfo = require('/waveo/core/helper/carrierInfo').getCarrierInfo();
			langRegion = ('MO' == carrierInfo['isoCountryCode'] || 'HK' == carrierInfo['isoCountryCode']) ? 'HK' : 'TW';
		}
		Ti.App.Properties.setString('WOConfig.langRegion', langRegion);
	}
	if('HK' == langRegion || 'MO' == langRegion) Ti.App.Properties.setString('WOConfig.language', 'zh-Hant');
	else Ti.App.Properties.setString('WOConfig.language', 'zh-Hant_TW');
} else {
	Ti.App.Properties.setString('WOConfig.language', Ti.Locale.currentLanguage);
}

//--- Load essential resources into App namespace ---
require('/waveo/core/bootstrap').bootstrap({ configFile:'/config' });

//--- 2. Pre-flight -------------------------------
// NO database-dependent operations allowed in this phase, except for UpgradeManager
// This is to ensure that database upgrades can be done safely within this phase

$.app = App.Helper.newController('ApplicationController');
$.app.initManagers();

if (App.Config.IS_ANDROID) {
Ti.Android.currentActivity.addEventListener ('create'  , function (e){ Ti.API.info('CTK:--->ONCREATE');})
Ti.Android.currentActivity.addEventListener ('destroy' , function (e){ Ti.API.info('CTK:--->ONDESTROY');})
Ti.Android.currentActivity.addEventListener ('start'   , function (e){ Ti.API.info('CTK:--->ONSTART'); })
Ti.Android.currentActivity.addEventListener ('stop'    , function (e){ Ti.API.info('CTK:--->ONSTOP'); })
Ti.Android.currentActivity.addEventListener ('pause'   , function (e){ Ti.API.info('CTK:--->ONPAUSE'); Ti.App.fireEvent('pause',e); })
Ti.Android.currentActivity.addEventListener ('resume'  , function (e){ Ti.API.info('CTK:--->ONRESUME'); Ti.App.fireEvent('resume', e); })
/*
$.app.android = {};
$.app.android.theWindow = Ti.UI.createWindow ({exitonClose:true, navBarHidden:true});
$.app.android.theView = Ti.UI.createView ({backgroundImage:'/assets/images/ui/bg.png'});
$.app.android.theWindow.add($.app.android.theView);
$.app.android.theWindow.open();
$.app.android.theWindow.setVisible(false);
$.app.android.theWindow.addEventListener('QuitRequest',function(e){$.app.android.theWindow.close();})
*/
}


if($.app.isFirstRun()){
	$.app.firstRun();
}else{
	//--- 3. Let's Fly! -------------------------------
	$.app.start();
}

