/**
 * Pre-app launch preprations
 * 
 * note: assumes global namespace "App" have been created by app.js
 * 
 *  * @author young@waveo.com
 */
Ti.include('/globals.js');

//---  Load Core Helpers, most are required for bootstraping  ---
App.Helper = require('/waveo/core/helper/coreHelpers');

if(Ti.Platform.osname != 'android'){
   require('/waveo/core/helper/date');          // TODO [TK]  - should change to on-demand require, instead of global
}

exports.bootstrap = function(param){

    var coreSettings = require('/waveo/core/default_config');
    var appSettings = require(param.configFile);
    
    App.Version = Ti.App.version;

    //---  Load Configurations  -----
    App.Config = App.Helper.extend(coreSettings.CONFIG, appSettings.CONFIG);
    // Ti.App.Properties.setString('app_buildversion', App.Config.APP_VERSION);       // TODO  [Young]   how are these 2 used???
    // Ti.App.Properties.setString('api_preference', App.Config.API);
    // Ti.App.Properties.setBool('upgrade_'+App.Config.APP_VERSION, false);
    
    //---  Constants  ---------------
    App.Const = App.Helper.extend(coreSettings.CONST, appSettings.CONST);

    //---  Event Names  -------------
    App.Event = App.Helper.extend(coreSettings.EVENT, appSettings.EVENT);

    //---  Server API Actions  ------
    App.Action = App.Helper.extend(coreSettings.ACTION, appSettings.ACTION);

    //---  User Actions, used in usage tracking  ------
    App.UserAction = App.Helper.extend(coreSettings.UA, appSettings.UA);
    

    //------- Load Loaders  -----------------------
    var module = require('/waveo/core/helper/loaders');
    App.loadHelper = module.loadHelper;
    App.Helper.loadModule = module.loadModule;
    App.Helper.requireModel = module.requireModel;
    
    App.Helper.requireView = module.requireView;    
    App.Helper.loadView = module.loadView;
    
	App.Helper.newForm = module.newForm;
	App.Helper.newField = module.newField;
	
    App.Helper.loadStyle = module.loadStyle;
    
    App.Helper.requireController = module.requireController;
    App.Helper.newController = module.newController;
    
    App.Helper.fetchRemoteImage = module.fetchRemoteImage;


    //------- Load Core Classes  ------------------
    App.Class = require(App.Config.CORE_PATH+'jClass');
    App.WOBaseClass = require(App.Config.CORE_PATH+'WOBaseClass');
    
    App.Moment = require('/waveo/core/helper/moment');
    if('undefined' != typeof App.Config.MOMENT[App.Config.LANG]) App.Moment.lang(App.Config.LANG, App.Config.MOMENT[App.Config.LANG]);
    else App.Moment.lang('en', App.Config.MOMENT.en);
    
    App.DB2 = require('/waveo/core/helper/db');
    App.DBSource = App.Config.API.substring(7, App.Config.API.indexOf('.'));
    
    App.Model = {};
    App.Model.WOObject  = require(App.Config.CORE_PATH+'models3/WOObject');
    App.Model.WOImage	= require(App.Config.CORE_PATH+'models3/WOImage');

//    App.Style = {};
//    App.Style.WOStyle        = require(App.Config.CORE_PATH+'styles/WOStyle');
//    App.Style.WOFormStyle    = require(App.Config.CORE_PATH+'styles/'+osName+'WOFormStyle');
    
    App.View = {};
    App.View.WOViewBase     = require(App.Config.CORE_PATH+'views/WOViewBase');
    App.View.WOWindow       = require(App.Config.CORE_PATH+'views/WOWindow');
    App.View.WOList         = require(App.Config.CORE_PATH+'views/WOList');
    App.View.WOList2		= require(App.Config.CORE_PATH+'views/WOList2');
    
    App.WOEventProxy = require(App.Config.CORE_PATH+'WOEventProxy');

    App.WOFactory = require(App.Config.CORE_PATH+'controllers/WOFactory');
    App.WOFieldFactory = require(App.Config.CORE_PATH+'controllers/WOFieldFactory');
    App.WOCardFactory = require(App.Config.CORE_PATH+'controllers/WOCardFactory');
    App.WOForm = require(App.Config.CORE_PATH+'views/WOForm');

    App.Controller = {};
    App.Controller.WOManager = require(App.Config.CORE_PATH+'controllers/WOManager');

    //--- Lookup table from Alias of Controllers to the controller object, eg. 'cardLib' -> CardLibManager
    //  automatically populated when App.Helper.newController() is used to instantiate controller
    //  Controller class MUST also add the 'alias' property set to the alias, eg. 'cardLib'
    //  WARNING: the controller will stay Memory Resident, use dispose() in WOManager to make it GC
    
    App.ControllerAlias = {};
    
};

