/**
 * DataManager
 */
Ti.include('/globals.js');

var DataManager = App.Class(App.WOBaseClass, {
	className : 'DataManager',
    alias     : 'data',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
    },
    
    CONFIG : {
    	'WOSettings' : true, //only cache WOSettings.
    },
    
    CACHE : {
    	
    },
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		self.listenForEvents();
	},

	listenForEvents : function(){
		var self = this;
	},
	
	resetCache : function(model, id) {
		var self = this;
		
		model = model || false;
		id = id || false;
		
		if(model && id && 'undefined' != typeof self.CACHE[model] && 'undefined' != self.CACHE[model][id]) {
			Ti.API.error('*** Cache Cleared: CACHE['+model+']['+id+']');
			delete self.CACHE[model][id];
		} else if(true === model) {
			Ti.API.error('*** Cache Cleared: CACHE={}');
			self.CACHE = {}; //reset All.
		}
	},
	
	get : function(model, id, defaultValue) {
		var self = this;
		
		if('undefined' != typeof self.CONFIG[model] && self.CONFIG[model]) {
			if('undefined' == typeof self.CACHE[model]) self.CACHE[model] = {};
			if('undefined' == typeof self.CACHE[model][id]) self.CACHE[model][id] = self._get(model, id, defaultValue);
			else Ti.API.error('*** Cache Hit: '+'CACHE['+model+']['+id+']');
			
			return self.CACHE[model][id];
		} else {
			
			return self._get(model, id, defaultValue);
		}
	},
	
	_get : function(model, id, defaultValue) {
		var self = this;

		Ti.API.error('*** Fetch DB: '+'CACHE['+model+']['+id+']');

		id = id+'';
		defaultValue = 'undefined' == typeof defaultValue ? {} : defaultValue;
		App.Helper.requireModel(model);
		var _model = new App.Model[model](id);
		if(!_model.fetch()) return defaultValue;
		return _model.p2l();
	},

	getRelated : function(model, id, relatedModel, param) {
		var self = this;
		
		id = id+'';
		App.Helper.requireModel(model);
		var _model = new App.Model[model](id);
		_model.fetchRelated([relatedModel], param);
		return _model[relatedModel].p2l();
	},
	
	newModel : function(model, id) {
		var self = this;
		
		id = id ? id+'' : false;
		App.Helper.requireModel(model);
		id ? _model = new App.Model[model](id) : _model = new App.Model[model]();
		return _model;
	},
});

module.exports = DataManager;

//---  End of file: DataManager.js