/**
 * Handles upgrade/migration of data from old version of App to new
 * 
 * @author zhoujun@waveo.com, young@waveo.com
 */
Ti.include('/globals.js');

var WOUpgradeManager = App.Class(App.Controller.WOManager, {
	className	: 'WOUpgradeManager',

	//---  Constructor  ---------------
	initialize : function(param) {
		var self = this;
		self.base(param);
	},

	/**
	 * Check if upgrade is necessary
	 * @return {boolean}       TRUE if upgrade is Required
	 */
	needUpgrade : function(){
		
		var lastRunVersion = $.app.getLastRunVersion();
		
		if(lastRunVersion.version && lastRunVersion.version >= '2.3') return false;  //FIXME [ZJ] temporary patch for 2.3.1.
		
		var authState='', authToken='';
		if('1.x' == lastRunVersion.type) {
			authToken = $.configMgr.getOld('register_token', lastRunVersion.type);
			authState = $.configMgr.getOld('auth_state', lastRunVersion.type);
			
			if(authToken && '0' == authState) authState = App.Const.AUTH_SKIPPED;
			
		} else { // 2.xx
			var result = App.DB2.getRecord('account', {id:'1'}, 'id',null,null, 'account');
			if(result.length > 0) {
				authToken = result[0]['token'];
				authState = ('' == result[0]['auth_state']) ? App.Const.AUTH_SKIPPED : result[0]['auth_state'];
				
				/*		
				 * 	For	2.x.x	authToken	authState
				 * 		-----------------------------
				 * 		skip 	: xxx@xxx.me 	'' 	(patch to '3')
				 * 		login 	: xxx@xxx.me	'2'
				 * 		logout	: ''			'0'
				 * 
				 *	For 1.2.x
				 * 		skip 	: xxx@xxx.me 	'0'  (patch to '3')
				 * 		login 	: xxx@xxx.me	'2'
				 * 		logout	: null		    '0'
				 */
			}
		}
		if(authToken && authState) {
			$.accountMgr.setAuthToken(authToken);
			$.accountMgr.setAuthState(authState);
		} else {
			return false;
		}

        if(lastRunVersion.version && Ti.App.version != lastRunVersion.version) return true;
        return false;
	},

    /**
     * @return {integer}       count of all outstanding records across all tables to be pushed
     */
    _totalLocalUpdates : function(){
        var self = this;       

       //  TODO [ZJ] to implement
       
        return 100;        
    },

    /**
     * Flush outstanding local updates to server
     * 
     * this is a blind serialization of records by iterating through all tables &
     * JSON-ifying each outstanding record
     */
    pushLocalUpdates : function(){

        //  TODO [ZJ] to implement  (see tmp() below for existing implementation)

        return false;
    }, 
});

module.exports = WOUpgradeManager;

/**
 * End of file: WOUpgradeManager.js
 */