/**
 * Default Configuration
 */
exports.CONFIG = {
	
	/**
	 * Application properties
	 */
	APP_TYPE        : 'Perkd',
	APP_VERSION 	: Ti.App.version,
	APP_COPYRIGHT	: Ti.App.copyright,
	APP_GUID 		: Ti.App.guid,
	APP_URL 		: Ti.App.url,
	APP_SID 		: Ti.App.sessionId,
	
	/**
	 * device os properties
	 */
	// DEVICE_MACADDR	: Ti.Platform.macaddress,
	DEVICE_UUID		: Ti.Platform.createUUID(),
	DEVICE_MODEL	: Ti.Platform.model,
	DEVICE_VERSION	: Ti.Platform.version,
	DEVICE_LOCAL	: Ti.Platform.locale,
	DEVICE_USERNAME	: Ti.Platform.username,
	DEVICE_OSNAME	: Ti.Platform.osname,
	DEVICE_OSTYPE	: Ti.Platform.ostype,
	DEVICE_NAME		: Ti.Platform.name,
	
	/**
	 * Screen properties
	 */
	// DEVICE_WIDTH	: Ti.Platform.displayCaps.platformWidth,
	// DEVICE_HEIGHT	: Ti.Platform.displayCaps.platformHeight,
	// DEVICE_DPI		: Ti.Platform.displayCaps.dpi,
	
	/**
	 * Runtime environment
	 */
	IS_SIMULATOR	: (Ti.Platform.model === 'Simulator') ? true : false,
	IS_ANDROID		: (Ti.Platform.osname === 'android') ? true : false,
	IS_IPHONE		: (Ti.Platform.osname === 'iphone') ? true : false,
	
//	IS_IOS4_3		: (parseInt((Titanium.Platform.version.split("."))[0],10) == 4)?true:false,
	IS_IOS4			: (Ti.Platform.osname === 'iphone') && (Ti.Platform.version.slice(0,1) == '4'),
	
	/**
	 * API url
	 */
	CORE_PATH		: '/waveo/core/',
	IMAGE_DIR		: Ti.Filesystem.applicationDataDirectory + "images/",

    IMAGEFETCH_TIMEOUT	: 30000,	// 30 seconds for network timeout
        	
	MAX_CARD_NUMBER	: 30,			// max length of card number allowed
	
	CUSTOM_CID		: '0000-0000-0000-0000-0000',
	PERKD_ID		: '000001',			// card master ID of Perkd ID
	
	DATE_FORMAT		: 'dd MMM yyyy',
	TIME_FORMAT		: 'hh:mmtt',
	SHORTDATE_FORMAT: 'd MMM',
	
	TABLE_MAP		: {},
	
	SUPPORT_CTYPE	: (Ti.Platform.osname=='android')
						?[1,2,4,5,6,7,8,9,10,14,15,16]
						:[1,2,3,4,5,6,7,8,9,10,11,12,13],		// supported barcode types

    // define which are the optional data types are to be sync'd by SyncMgr	(default to Perkd app settings)
	SYNC            : {
                        PROFILE         : true,
                        PREFERENCE      : true,
                        PERK_EVENT      : true,
                        WOPerson		: false,
                        WOCardNumber    : false,
                        WOUser          : false,
                        WOLog	        : true,
                      },
                      
    //define model data encrpyt on/off.
	MODEL_ENCRYPT	: true,
	
	//current Langauge
	LANG : Ti.App.Properties.getString('WOConfig.language', Ti.Locale.currentLanguage),
	LANG_RG : Ti.App.Properties.getString('WOConfig.langRegion', ''),
	
	//Momentjs 
	MOMENT : {
		'en' : {//Acctually is en-gb
		    months : "January_February_March_April_May_June_July_August_September_October_November_December".split("_"),
		    monthsShort : "Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"),
		    weekdays : "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),
		    weekdaysShort : "Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),
		    weekdaysMin : "Su_Mo_Tu_We_Th_Fr_Sa".split("_"),
		    longDateFormat : {
		        LT : "h:mm A",
		        L : "DD/MM/YYYY",
		        LL : 'D MMM YYYY',
		        LLL : "D MMMM YYYY LT",
		        LLLL : "dddd, D MMMM YYYY LT",
		        l : 'D MMM',
		        ll : 'D MMM',
		        lll : "D MMMM YYYY LT",
		        llll : "dddd, D MMMM YYYY LT",
		    },
		    calendar : {
		        sameDay : '[Today at] LT',
		        nextDay : '[Tomorrow at] LT',
		        nextWeek : 'dddd [at] LT',
		        lastDay : '[Yesterday at] LT',
		        lastWeek : '[Last] dddd [at] LT',
		        sameElse : 'L'
		    },
		    relativeTime : {
		        future : "in %s",
		        past : "%s ago",
		        s : "a few seconds",
		        m : "a minute",
		        mm : "%d minutes",
		        h : "an hour",
		        hh : "%d hours",
		        d : "a day",
		        dd : "%d days",
		        M : "a month",
		        MM : "%d months",
		        y : "a year",
		        yy : "%d years"
		    },
		    ordinal : function (number) {
		        var b = number % 10,
		            output = (~~ (number % 100 / 10) === 1) ? 'th' :
		            (b === 1) ? 'st' :
		            (b === 2) ? 'nd' :
		            (b === 3) ? 'rd' : 'th';
		        return number + output;
		    },
		    week : {
		        dow : 1, // Monday is the first day of the week.
		        doy : 4  // The week that contains Jan 4th is the first week of the year.
		    }
		},
		'zh-Hant' : {
		    months : "一月_二月_三月_四月_五月_六月_七月_八月_九月_十月_十一月_十二月".split("_"),
		    monthsShort : "1月_2月_3月_4月_5月_6月_7月_8月_9月_10月_11月_12月".split("_"),
		    weekdays : "星期日_星期一_星期二_星期三_星期四_星期五_星期六".split("_"),
		    weekdaysShort : "週日_週一_週二_週三_週四_週五_週六".split("_"),
		    weekdaysMin : "日_一_二_三_四_五_六".split("_"),
		    longDateFormat : {
		        LT : "Ah點mm",
		        L : "YYYY年MMMD日",
		        LL : "YYYY年MMMD日",
		        LLL : "YYYY年MMMD日LT",
		        LLLL : "YYYY年MMMD日ddddLT",
		        l : "MMMD日",
		        ll : "YYYY年MMMD日",
		        lll : "YYYY年MMMD日LT",
		        llll : "YYYY年MMMD日ddddLT"
		    },
		    meridiem : function (hour, minute, isLower) {
		        if (hour < 9) {
		            return "早上";
		        } else if (hour < 11 && minute < 30) {
		            return "上午";
		        } else if (hour < 13 && minute < 30) {
		            return "中午";
		        } else if (hour < 18) {
		            return "下午";
		        } else {
		            return "晚上";
		        }
		    },
		    calendar : {
		        sameDay : '[今天]LT',
		        nextDay : '[明天]LT',
		        nextWeek : '[下]ddddLT',
		        lastDay : '[昨天]LT',
		        lastWeek : '[上]ddddLT',
		        sameElse : 'L'
		    },
		    relativeTime : {
		        future : "%s",
		        past : "%s前",
		        s : "幾秒",
		        m : "一分鐘",
		        mm : "%d分鐘",
		        h : "一小時",
		        hh : "%d小時",
		        d : "一天",
		        dd : "%d天",
		        M : "一個月",
		        MM : "%d個月",
		        y : "一年",
		        yy : "%d年"
		    }
		},
		'zh-Hant_TW' : {
		    months : "一月_二月_三月_四月_五月_六月_七月_八月_九月_十月_十一月_十二月".split("_"),
		    monthsShort : "1月_2月_3月_4月_5月_6月_7月_8月_9月_10月_11月_12月".split("_"),
		    weekdays : "星期日_星期一_星期二_星期三_星期四_星期五_星期六".split("_"),
		    weekdaysShort : "週日_週一_週二_週三_週四_週五_週六".split("_"),
		    weekdaysMin : "日_一_二_三_四_五_六".split("_"),
		    longDateFormat : {
		        LT : "Ah點mm",
		        L : "YYYY年MMMD日",
		        LL : "YYYY年MMMD日",
		        LLL : "YYYY年MMMD日LT",
		        LLLL : "YYYY年MMMD日ddddLT",
		        l : "MMMD日",
		        ll : "YYYY年MMMD日",
		        lll : "YYYY年MMMD日LT",
		        llll : "YYYY年MMMD日ddddLT"
		    },
		    meridiem : function (hour, minute, isLower) {
		        if (hour < 9) {
		            return "早上";
		        } else if (hour < 11 && minute < 30) {
		            return "上午";
		        } else if (hour < 13 && minute < 30) {
		            return "中午";
		        } else if (hour < 18) {
		            return "下午";
		        } else {
		            return "晚上";
		        }
		    },
		    calendar : {
		        sameDay : '[今天]LT',
		        nextDay : '[明天]LT',
		        nextWeek : '[下]ddddLT',
		        lastDay : '[昨天]LT',
		        lastWeek : '[上]ddddLT',
		        sameElse : 'L'
		    },
		    relativeTime : {
		        future : "%s",
		        past : "%s前",
		        s : "幾秒",
		        m : "一分鐘",
		        mm : "%d分鐘",
		        h : "一小時",
		        hh : "%d小時",
		        d : "一天",
		        dd : "%d天",
		        M : "一個月",
		        MM : "%d個月",
		        y : "一年",
		        yy : "%d年"
		    }
		},		
		'zh-Hans' : {
		    months : "一月_二月_三月_四月_五月_六月_七月_八月_九月_十月_十一月_十二月".split("_"),
		    monthsShort : "1月_2月_3月_4月_5月_6月_7月_8月_9月_10月_11月_12月".split("_"),
		    weekdays : "星期日_星期一_星期二_星期三_星期四_星期五_星期六".split("_"),
		    weekdaysShort : "周日_周一_周二_周三_周四_周五_周六".split("_"),
		    weekdaysMin : "日_一_二_三_四_五_六".split("_"),
		    longDateFormat : {
		        LT : "Ah点mm",
		        L : "MMMD日",
		        LL : "YYYY年MMMD日",
		        LLL : "YYYY年MMMD日LT",
		        LLLL : "YYYY年MMMD日ddddLT",
		        l : "MMMD日",
		        ll : "YYYY年MMMD日",
		        lll : "YYYY年MMMD日LT",
		        llll : "YYYY年MMMD日ddddLT"
		    },
		    meridiem : function (hour, minute, isLower) {
		        if (hour < 9) {
		            return "早上";
		        } else if (hour < 11 && minute < 30) {
		            return "上午";
		        } else if (hour < 13 && minute < 30) {
		            return "中午";
		        } else if (hour < 18) {
		            return "下午";
		        } else {
		            return "晚上";
		        }
		    },
		    calendar : {
		        sameDay : '[今天]LT',
		        nextDay : '[明天]LT',
		        nextWeek : '[下]ddddLT',
		        lastDay : '[昨天]LT',
		        lastWeek : '[上]ddddLT',
		        sameElse : 'L'
		    },
		    relativeTime : {
		        future : "%s",
		        past : "%s前",
		        s : "几秒",
		        m : "1分钟",
		        mm : "%d分钟",
		        h : "1小时",
		        hh : "%d小时",
		        d : "1天",
		        dd : "%d天",
		        M : "1个月",
		        MM : "%d个月",
		        y : "1年",
		        yy : "%d年"
		    }
		},
	},
};

exports.CONST = {
	OBJECTID		: 'id',

    AUTH_REGISTER   : '1',
    AUTH_LOGGED_IN  : '2',
    AUTH_SKIPPED    : '3',
	
	TYPE_STRING 	: 'string',
	TYPE_DATE 		: 'date',
	TYPE_NUMBER 	: 'number',
	
	FIELD_ID 		: 'id',
	FIELD_NAME 		: 'name',
	FIELD_CREATE 	: 'create_dttm',
	FIELD_FACE	 	: 'face',
	FIELD_BRAND		: 'brand',
	FIELD_FNAME		: 'fname',
	FIELD_MID		: 'mid',
	// aacount
	FIELD_MOBILE 	: 'mobile',
	FIELD_TOKEN 	: 'token',
	FIELD_AUTHSTATE : 'auth_state',
	
	// tables
	TABLE_ACCOUNT	: 'account',
	TABLE_CONTACT	: 'contact',
	TABLE_REWARD	: 'rewardset',
	TABLE_REWARDM	: 'rewardset_master',
	TABLE_OFFER		: 'offer',
	TABLE_OFFERM	: 'offer_master',
	TABLE_USER      : 'user',
	TABLE_USERM     : 'user_master',
	TABLE_CARDNUM   : 'card_number',
	TABLE_LOG       : 'log',
	TABLE_SETTINGS  : 'settings',    //app settings syncdown from server
	
	DB_OLD			: 'perkpop',
	DB_ACCOUNT		: 'account',
	DB_CACHE		: 'cache',
	DB_DATA			: 'data',
	
	WINDOW			: {
		type	: {							// WOWindow types
			auto		: 'auto',
			standalone	: 'standalone',
			tabGroup	: 'tabGroup',
			navGroup	: 'navGroup',
		},
		effect	: {							// WOWindow open effects
			fade		: 'fade',
			zoom		: 'zoom',
			flip		: exports.CONFIG.IS_IOS4 ? 'modalFlip' : 'flip',
			modal		: 'modal',
			modalFlip	: 'modalFlip',
		},
	},

    // Model Class Names	
	MODEL_CARD		: 'WOCard',
	MODEL_CARDM		: 'WOCardMaster',
	MODEL_CARDNUM   : 'WOCardNumber',
	
	MODEL_OFFER		: 'WOOffer',
	MODEL_OFFERM	: 'WOOfferMaster',
	
	MODEL_REWARD	: 'WORewardset',
	MODEL_REWARDM	: 'WORewardsetMaster',

    MODEL_USER      : 'WOUser',
    MODEL_USERM     : 'WOUserMaster',
	
	MODEL_MEDIA		: 'WOMedia',
	MODEL_USAGE     : 'WOUsage',
    MODEL_LOG       : 'WOLog',
    
    MODEL_PERSON    : 'WOPerson',
    MODEL_SETTINGS  : 'WOSettings',
    
    MODEL_PERKDEVT  : 'WOPerkdEvent',
    
    // Notification Types
    NOTIFY_CARDEXPIRY   : 'cardExpiry',
    NOTIFY_OFFEREXPIRY  : 'offerExpiry',
    NOTIFY_REWARDEXPIRY : 'rewardExpiry',

};

//--------  Server API Actions  --------
exports.ACTION = {
	
	//-------------------------------------
	// Authentication
	//-------------------------------------
	REGISTER		: 'perkd_register',					/* register new account */
	AUTHENTICATE	: 'perkd_auth',						/* Login with username & password */
	LOGIN			: 'perkd_login',					/* signin to get cookie */
	LOGOUT			: 'perkd_logout',
	SENDCODE		: 'perkd_send_code', 				/* request sms verification code */
	VERIFYMOBILE	: 'perkd_verify_mobile',
	CHANGEPSWD		: 'perkd_change_pswd',
	CHANGEMOBILE	: 'perkd_change_mobile',
	RESENDPSWD		: 'perkd_resend_pswd',
	USAGETRACK		: 'usage_track',
	PERKCODESCAN	: 'perkcode_scan',
	
	//-------------------------------------
	// Object
	//-------------------------------------
	SYNC            : 'perkd_sync',
	SYNCOBJECTS		: 'sync_objects',
	SYNCRESOURCE	: 'resource_pull',
	SYNCMASTER		: 'perkd_pull_cardmaster',
//	SYNCARD			: 'perkd_sync_cardins',
//	SYNCREWARDM		: 'rewardset_pull_master',
//	SYNCREWARD		: 'rewardset_sync_instance',
//	SYNCOFFERM		: 'offer_pull_master',
//	SYNCOFFER		: 'offer_sync_instance',
	SHARECARD		: 'perkd_share_card',
	ADDCARD			: 'perkd_add_card',
	VALIDATECARD	: 'perkd_validate_card_register_form',
	REGISTERCARD	: 'perkd_submit_register_form',
	PULLPERKEVT		: 'perkevt_pull',
	PERKEVTBACK		: 'perkevt_cbk',
	// SYNCSETTINGS	: 'settings_pull2', //TODO [ZJ]     --  for merchant 
	SYNCSETTINGS	: 'settings_pull', //TODO [ZJ]
	
	PERKEVTSTARTUP	: 'perkevt_startup',
	
	PREFUPDATE		: 'perkd_pref_update',
	PROFILEUPDATE	: 'perkd_profile_update',
	PROFILEPULL		: 'perkd_pull_profile',
	UPGRAGE			: 'perkd_upgrade',
	UPDATEDEVTOKEN	: 'perkd_update_dtoken',
	UPDATELOCATION	: 'location_sync',
	PING			: 'perkd_ping',
};

// var syncMap = {};
// syncMap[exports['CONST']['MODEL_CARD']] 	= exports['ACTION']['SYNCARD'],
// syncMap[exports['CONST']['MODEL_OFFER']] 	= exports['ACTION']['SYNCOFFER'],
// syncMap[exports['CONST']['MODEL_REWARD']] 	= exports['ACTION']['SYNCREWARD'],
// exports['ACTION']['SYNCINSTANCE'] = syncMap;

exports.UA = {
	LAUNCH			: 'launch',
};

/**
 * End of file: default_config.js
 */