/**
 * App performane benchmark helper
 * 
 * Usage:
 * 
 *      Load helper         - var benchmark = App.loadHelper('benchmark');
 *      Mark a start point  - benchmark.mark('code_start');
 *      Mark an end point   - benchmark.mark('code_end);
 *      View elapsed time   - benchmark.elapsedTime('code_start', 'code_end');
 *      List of all markers - benchmark.profile();
 * 
 * @author      young@waveo.com
 */
Ti.include('/globals.js');

var _benchHistory = {};     // stores history of all markers, identical named markers will override previous value

exports.mark = function(marker){
    _benchHistory[marker] = new Date().getTime();
	return _benchHistory[marker];
};

exports.elapsedTime = function(startMarker, endMarker){
    if(_benchHistory[startMarker] && _benchHistory[endMarker]){
        var elapsed = _benchHistory[endMarker] - _benchHistory[startMarker];
        $.watch.dog(null,'Benchmark', startMarker+'->'+endMarker+':  '+elapsed+' milliseconds');
        return elapsed;
    } else return -1;
};

exports.profile = function(){
    $.watch.dog(null, 'Benchmark', '----- Benchmark Profile -----');
    for(var marker in _benchHistory){
        $.watch.dog(null, 'Benchmark', marker+': '+_benchHistory[marker]);
    }
};

/**
 * End of file: benchmark.js
 */