/**
 * Database interface
 * 
 * @author      zhoujun@waveo.com
 */

Ti.include('/globals.js');

var helper = App.loadHelper('default'); //TODO [ZJ]
/*
 * 
var fieldValueList = [
    {
        'id' : '888999111',
        'nm' : "ZJ 'Test111' Insert",
    },
    {
        'id' : '888999222',
        'nm' : "ZJ 'Test222' Insert",
    },
];
 */
exports.insertTableRows = function(tableName, fieldValueList) {
    return _insertOrReplaceTableRows('INSERT', tableName, fieldValueList);
}

exports.replaceTableRows = function(tableName, fieldValueList) {
    return _insertOrReplaceTableRows('REPLACE', tableName, fieldValueList);
}

exports.insertTableOneRow = function(tableName, fieldValues) {
    return _insertOrReplaceTableRows('INSERT', tableName, [fieldValues]);
}

exports.replaceTableOneRow = function(tableName, fieldValues) {
    return _insertOrReplaceTableRows('REPLACE', tableName, [fieldValues]);
}

exports.upInsertTableRow = function(tableName, fieldValues, where) {
    var param = {
      'where' : where,
    };
    var count = exports.countTableRows(tableName, param);
    var result = null;
    if(count > 0) {
        //do update
        param.set = fieldValues;
        result = exports.updateTableRows(tableName, param);
    } else {
        //do insert
        result = exports.insertTableOneRow(tableName, fieldValues);
    }
    return result;
}

/*
 * 
var param = {
    'where' : {
        'nm':'%my%'
    },
    'op' : {
        'nm' : 'LIKE',  
    },
};
 */
exports.deleteTableRows = function(tableName, param) {
    var conditions={}, op={};
    if(param) param.hasOwnProperty('where') ? conditions = param.where : conditions = {};
    if(param) param.hasOwnProperty('op') ? op = param.op : op = {};

    var conditionList = [];
    var vararg = [];
    _setConditionVarargs(conditions, op, conditionList, vararg);
    var sql = "DELETE FROM `"+tableName+'`';
    if(conditionList.length > 0) {
        sql += " WHERE "+conditionList.join(' AND ');
    }
    //Ti.API.info('DBI:deleteTableRows - '+sql);
    //Ti.API.info(vararg);
    var db = exports.openDB();
    db.execute(sql, vararg);
    var affectedRows = db.getRowsAffected();
    db.close();
    return affectedRows;
}

/*
 * 
var param = {
    'set' : {
        'fname' : 'Zhou',
        'gname' : 'Jun',
    },
    'where' : {
        'nm':'%my%'
    },
    'op' : {
        'nm' : 'LIKE',  
    },
};
 */
exports.updateTableRows = function(tableName, param) {
    var setFieldValue, conditions, op, limit, setop;
    //TODO [ZJ] : need to check param Type
    if(param.hasOwnProperty('set')) {
        setFieldValue = param.set;
    } else {
        return 0;
    }
    param.hasOwnProperty('setop') ? setop = param.setop : setop = {};
    param.hasOwnProperty('where') ? conditions = param.where : conditions = {};
    param.hasOwnProperty('op') ? op = param.op : op = {};
    
    var conditionList = [];
    var setList = [];
    var vararg = [];
    for(var field in setFieldValue) {
        if(setop.hasOwnProperty(field)) {
            var _setop = setop[field];
            setList.push('`'+field+'` = `'+field+'` '+_setop+' ?');
        } else {
            setList.push('`'+field+'` = ?');
        }
        vararg.push(setFieldValue[field]);
    }
    _setConditionVarargs(conditions, op, conditionList, vararg);
    var sql = "UPDATE `"+tableName+"` SET "+setList.join(', ');
    if(conditionList.length > 0) {
        sql += " WHERE "+conditionList.join(' AND ');
    }
    //Ti.API.info('DBI:updateTableRows - '+sql);
    //Ti.API.info(vararg);
    var db = exports.openDB();
    db.execute(sql, vararg);
    var affectedRows = db.getRowsAffected();
    db.close();
    return affectedRows;
}

/*
 * 
var param = {
    'select' : ['id','nm'],
    'where' : {
        'nm':'%my%'
    },
    'op' : {
        'nm' : 'LIKE',  
    },
    'limit' : 2,
    'order' : {
        'id' : 'ASC',
        'nm' : 'DESC',
    }  
};
 */
exports.fetchTableRows = function(tableName, param, andOr, extra) {
    var selectFieldList='*', conditions={}, op={}, group={}, order={}, limit='';
    if(null == andOr) andOr = 'AND';
    if(param) {
        param.hasOwnProperty('select') ? selectFieldList = param.select : selectFieldList = '*';
        param.hasOwnProperty('where') ? conditions = param.where : conditions = {};
        param.hasOwnProperty('op') ? op = param.op : op = {};
        param.hasOwnProperty('group') ? group = param.group : group = {};
        param.hasOwnProperty('order') ? order = param.order : order = {};
        param.hasOwnProperty('limit') ? limit = " LIMIT "+param.limit : limit = '';
    }
    
    var conditionList = [];
    var vararg = [];
    _setConditionVarargs(conditions, op, conditionList, vararg);
    var selectFields = '*';
    if(helper.isArray(selectFieldList) && selectFieldList.length > 0) {
        selectFields = '`'+selectFieldList.join('`, `')+'`';
    } else if(helper.isObject(selectFieldList)) {
        var selectFieldAlias = [];
        for(var field in selectFieldList) {
            -1 == field.indexOf('(') 
            ? selectFieldAlias.push('`'+field+"` AS '"+selectFieldList[field]+"'")
            : selectFieldAlias.push(field+" AS '"+selectFieldList[field]+"'");
        }
        selectFields = selectFieldAlias.join(', ');
    }
    var sql = "SELECT "+selectFields+" FROM `"+tableName+'` WHERE 1';
    if(conditionList.length > 0) {
        sql += " AND ("+conditionList.join(' '+andOr+' ')+')';
    }
    if(extra) {
    	sql += " AND "+extra;
    }
    var groupList = [];
    for(var col in group) {
        groupList.push('`'+col+'` '+group[col])
    }
    var orderList = [];
    for(var col in order) {
        orderList.push('`'+col+'` '+order[col]);
    }
    if(groupList.length > 0) sql += " GROUP BY "+groupList.join(', ');
    if(orderList.length > 0) sql += " ORDER BY "+orderList.join(', ');
    sql += limit;
    return exports.fetchRowsToArray(sql, vararg);
}

/*
 * 
var param = {
    'select' : ['id','nm'],
    'where' : {
        'nm':'%my%'
    },
    'op' : {
        'nm' : 'LIKE',  
    }, 
};
 */
exports.fetchTableOneRow = function(tableName, param) {
    param.limit = 1;
    var result = exports.fetchTableRows(tableName, param);
    if(result.length > 0) {
        return result[0];
    } else {
        return {};
    }
}

exports.countTableRows = function(tableName, param) {
    param.select = {
        'COUNT(*)' : 'total',        
    };
    var result = exports.fetchTableOneRow(tableName, param);
    return result.total;
}

exports.executeSql = function(sql, vararg) {
    var db = exports.openDB();
    db.execute(sql, vararg);
    var affectedRows = db.getRowsAffected();
    db.close();
    return affectedRows;
}

exports.openDB = function() {
    var dbSource = Ti.Filesystem.resourcesDirectory + 'assets/database/'+App.DBSource+'.sql';
    var db = Ti.Database.install(dbSource, 'db_'+App.Config.DB_VERSION);
    if(! App.Config.IS_ANDROID) db.file.remoteBackup = false; // Binary Rejected 2.23: Apps must follow the iOS Data Storage Guidelines or they will be rejected
    return db;
}

exports.installDB = function() {
    var dbSource = Ti.Filesystem.resourcesDirectory + 'assets/database/'+App.DBSource+'.sql';
    var db = Ti.Database.install(dbSource, 'db_'+App.Config.DB_VERSION);
    if(! App.Config.IS_ANDROID) db.file.remoteBackup = false; // Binary Rejected 2.23: Apps must follow the iOS Data Storage Guidelines or they will be rejected
    db.close();
}

exports.fetch2ColsToHashArray = function(sql, vararg, keyColFieldName, valueColFieldName) {
    var db = exports.openDB();
    var rows = db.execute(sql, vararg);
    var data = {};
    while (rows.isValidRow()) {
      data[rows.fieldByName(keyColFieldName)] = rows.fieldByName(valueColFieldName);
      rows.next();
    }
    rows.close();
    db.close();
    return data;
}

exports.fetchOneColToArray = function(sql, vararg, colField) {
    var db = exports.openDB();
    var rows = db.execute(sql, vararg);
    var data = [];
    while (rows.isValidRow()) {
      data.push(rows.fieldByName(colField));
      rows.next();
    }
    rows.close();
    db.close();
    return data;
}

exports.fetchRowsToArray = function(sql, vararg) {
    if(null == vararg) {
        vararg = [];
    }
    var db = exports.openDB();
    //Ti.API.info('DBI:fetchRowsToArray - '+sql);
    //Ti.API.info(vararg);
    var rows = db.execute(sql, vararg);
    var data = [];
    var fieldList = [];
    var filedCount = (! App.Config.IS_ANDROID) ? rows.fieldCount() : rows.fieldCount;
    for(var i=0; i < filedCount; i++){
        fieldList.push(rows.fieldName(i));
    }
    while (rows.isValidRow()) {
      var row = {};
      for(var i=0; i < fieldList.length; i++) {
          row[fieldList[i]] = rows.fieldByName(fieldList[i]);
      }
      data.push(row);
      rows.next();
    }
    rows.close();
    db.close();
    return data;
}

exports.fetchOneRowToHashArray = function(sql, vararg) {
    var data = exports.fetchRowsToArray(sql, vararg);
    if (data.length > 0) {
        data = data[0];
    }
    return data;
}

function _insertOrReplaceTableRows(operate, tableName, fieldValueList) {
    var sqlList = [];
    var varargs = [];
    for(var i=0; i < fieldValueList.length; i++) {
        var fields = [];
        var values = [];
        var placeholders = [];
        for(var field in fieldValueList[i]) {
            fields.push(field);
            values.push(fieldValueList[i][field]);
            placeholders.push('?');
        }
        var sql = operate+" INTO `"+tableName+"` (`"+fields.join('`, `')+"`) VALUES ("+placeholders.join(', ')+")";
        sqlList.push(sql);
        varargs.push(values);
    }
    var db = exports.openDB();
    for(var i=0; i < sqlList.length; i++) {
        //Ti.API.info('DBI:['+operate+']TableRows - '+sqlList[i]);
        //Ti.API.info(varargs[i]);
        try { 
        	
        	db.execute(sqlList[i], varargs[i]);
        	
        } catch(E) {
        	
        	// var sqlError = {
        		// err		: 'sqlError',
        		// sql 	: sqlList[i],
        		// varargs	: varargs[i],
        	// };
        	
        	// alert(sqlError);
        };
    }
    var lastInsertRowId = db.getLastInsertRowId();
    db.close();
    return lastInsertRowId;
}

function _setConditionVarargs(conditions, op, conditionList, vararg) {
    if(null == conditions) {
        conditions = {};
    }
    if(null == op) {
        op = {};
    }
    for(var field in conditions) {
        var field_op ;
        if(op.hasOwnProperty(field)) {
            field_op = op[field];
        } else if(helper.isArray(conditions[field])) {
            field_op = 'IN';
        } else if(null === conditions[field]) {
            field_op = 'IS';
        } else {
            field_op = '=';
        }
        field_op = field_op.toUpperCase();
        switch (field_op) {
            case 'IN' :
            case 'NOT IN' :
                if(helper.isArray(conditions[field]) && conditions[field].length > 0) {
                    var askFlagList = [];
                    for(var i=0; i < conditions[field].length; i++) {
                        vararg.push(conditions[field][i]);
                        askFlagList.push('?');
                    }
                    conditionList.push('`'+field+'` '+field_op+' ('+askFlagList.join(', ')+')');
                }
                else {
                    conditionList.push(0);
                }
                break;
            case 'BETWEEN' :
                if(helper.isArray(conditions[field]) && conditions[field].length == 2) {
                    conditionList.push('`'+field+'` BETWEEN ? AND ?');
                    vararg.push(conditions[field[0]]);
                    vararg.push(conditions[field[1]]);
                }
                else {
                    conditionList.push(0);
                }
                break;
            default :
                conditionList.push('`'+field+'` '+field_op+' ?');
                vararg.push(conditions[field]);
        }
    }
}





// ------------------------------ below is old code, we used it for upgrade old version only! 1.x-2.2.2 ------------------------------
if (! App.Config.IS_ANDROID) {
	
	exports.query = function(sql, dbName, dbSource){
		var db		= exports.getDB(dbName, dbSource);
		if(App.Helper.isArray(sql)){
			var rows	= db.execute.apply(db, sql);
		}else{
			var rows	= db.execute(sql);
		}
		
		if(rows){
			var result = helper_db2array(rows, '*'); 
			rows.close();
			db.close();
			return result;
		}
		return [];
	};
	
	exports.getDB = function(dbName, dbSource){
		if(!dbName){
			dbName = App.Const.DB_DATA;
		}
		
		if(!dbSource){
			dbSource = Ti.Filesystem.resourcesDirectory + 'assets/database/'+dbName+'.sql';
		}else{
			dbSource = Ti.Filesystem.resourcesDirectory + 'assets/database/'+dbSource+'.sql';
		}
	
		var db = Ti.Database.install(dbSource, dbName);
		try{
			db.execute.apply = Function.prototype.apply;
		}catch(e){ }
		return db;
	};
	
	exports.getRecord = function(table, object, key, fields, operation, dbName){
		var db = exports.getDB(dbName);
		var condition = '';
		if(!operation){
			operation = '=';
			condition = "`"+key+"`='"+object[key]+"'";
		}else if(operation == 'in'){
			condition = "`"+key+"` in "+object[key];
		}
		var query = "select * from "+table+" where "+condition;
		var rows = db.execute(query);
		var result = helper_db2array(rows, fields);
		rows.close();
		db.close();
		if(result.length>0){
			return result;
		}else{
			return false;
		}
	}
	
	function helper_db2array(rows, result_fields){
		var result = [];
		if(!rows) return [];
		if(rows.rowCount == 0) return [];
		try{
			rows.isValidRow();
		}catch(e){
			return [];
		}
		
		if(result_fields == '*' || !result_fields){
			var result_fields = [];
			var filedCount = 0;
			if (! App.Config.IS_ANDROID){
				filedCount = rows.fieldCount();
			}else{
				filedCount = rows.fieldCount;
			}
			for(var i=0;i<filedCount;i++){
				result_fields.push(rows.fieldName(i));
			}
		}
		
		while(rows.isValidRow()) {
			var item = {};
			for (var m = 0; m < result_fields.length; m++) {
				var prop = result_fields[m];
				if (undefined == rows.fieldByName(prop) || null == rows.fieldByName(prop)) {
					item[prop] = '';
					continue;
				}
				item[prop] = rows.fieldByName(prop);
			}
			result.push(item);
			rows.next();
		}
		return result;
	}
}
// ------------------------------ end of old code, we used it for upgrade old version, 1.x-2.2.2 ------------------------------


/**
 * End of file: db.js
 */