
var DATE_FORMAT			= 'd MMM yyyy';
var TIME_FORMAT			= 'hh:mmtt';
var SHORTDATE_FORMAT	= 'd MMM';

exports.formatDate = function(date, days){
	var dateStr = '';
	var now = new Date();
	// within these days, show relative dates, -1 => no relative dates, default 7 days
	var relativeDays = ('undefined' != typeof days) ? days * 86400000 : 604800000;   // milliseconds
	if((days != -1) && (now - date) <= relativeDays){
		dateStr = exports.humaneDate(date).toLowerCase();
	}else if(now.getYear() == date.getYear()){
        if(Ti.Platform.osname=='android')	{
	 		dateStr = String.formatDate(date,'medium');
	 	}else {
	 		dateStr = date.toString(SHORTDATE_FORMAT);}        
	}else{
	//	dateStr = date.toString(DATE_FORMAT);
	 	if(Ti.Platform.osname=='android')	{
	 		dateStr =String.formatDate(date,'medium');
	 	}else {
	 		dateStr = date.toString(DATE_FORMAT);}
	}
	return dateStr;
};

exports.humaneDate = function(date, compareTo){
    var lang = {
            ago: 'Ago',
            now: 'Just Now',
            minute: 'Minute',
            minutes: 'Minutes',
            hour: 'Hour',
            hours: 'Hours',
            day: 'Day',
            days: 'Days',
            week: 'Week',
            weeks: 'Weeks',
            month: 'Month',
            months: 'Months',
            year: 'Year',
            years: 'Years'
        },
        formats = [
            [60, lang.now],
            [3600, lang.minute, lang.minutes, 60], // 60 minutes, 1 minute
            [86400, lang.hour, lang.hours, 3600], // 24 hours, 1 hour
            [604800, lang.day, lang.days, 86400], // 7 days, 1 day
            [2628000, lang.week, lang.weeks, 604800], // ~1 month, 1 week
            [31536000, lang.month, lang.months, 2628000], // 1 year, ~1 month
            [Infinity, lang.year, lang.years, 31536000] // Infinity, 1 year
        ],
        isString = typeof date == 'string',
        date = isString ?
                    new Date(('' + date).replace(/-/g,"/").replace(/[TZ]/g," ")) :
                    date,
        compareTo = compareTo || new Date(),
        seconds = (compareTo - date +
                        (compareTo.getTimezoneOffset() -
                            // if we received a GMT time from a string, doesn't include time zone bias
                            // if we got a date object, the time zone is built in, we need to remove it.
                            (isString ? 0 : date.getTimezoneOffset())
                        ) * 60000
                    ) / 1000,
        token;
 
    if(seconds < 0) {
        seconds = Math.abs(seconds);
        token = '';
    } else {
        token = ' ' + lang.ago;
    }
 
    /*
     * 0 seconds && < 60 seconds        Now
     * 60 seconds                       1 Minute
     * > 60 seconds && < 60 minutes     X Minutes
     * 60 minutes                       1 Hour
     * > 60 minutes && < 24 hours       X Hours
     * 24 hours                         1 Day
     * > 24 hours && < 7 days           X Days
     * 7 days                           1 Week
     * > 7 days && < ~ 1 Month          X Weeks
     * ~ 1 Month                        1 Month
     * > ~ 1 Month && < 1 Year          X Months
     * 1 Year                           1 Year
     * > 1 Year                         X Years
     * 
     * Single units are +10%. 1 Year shows first at 1 Year + 10%
     */
 
    function normalize(val, single)
    {
        var margin = 0.1;
        if(val >= single && val <= single * (1+margin)) {
            return single;
        }
        return val;
    }
 
    for(var i = 0, format = formats[0]; formats[i]; format = formats[++i]) {
        if(seconds < format[0]) {
            if(i === 0) {
                // Now
                return format[1];
            }
 
            var val = Math.ceil(normalize(seconds, format[3]) / (format[3]));
            return val + 
                    ' ' +
                    (val != 1 ? format[2] : format[1]) +
                    (i > 0 ? token : '');
        }
    }
};
 
exports.padzero = function(n) {
    return n < 10 ? '0' + n : n;
};
 
exports.pad2zeros = function(n) {
    if (n < 100) {
        n = '0' + n;
    }
    if (n < 10) {
        n = '0' + n;
    }
    return n;     
};
 
exports.toISOString = function(d) {
    return d.getUTCFullYear() + '-' +  this.padzero(d.getUTCMonth() + 1) + '-' + this.padzero(d.getUTCDate()) + 'T' + this.padzero(d.getUTCHours()) + ':' +  this.padzero(d.getUTCMinutes()) + ':' + this.padzero(d.getUTCSeconds()) + 'Z';
};
 
exports.fnToISO = function(d) {
    var now = new Date(d);
    var postDate = this.toISOString(now);
    return postDate;
};


// var pretty = App.loadHelper('humaneDate');
// var isoDate = pretty.fnToISO(Date.today().add(3).days());            
// var prettyDate = pretty.humaneDate(isoDate);
// var prettyDate2 = pretty.humaneDate((8).days().ago());
// var prettyDate3 = pretty.humaneDate((14).days().fromNow());
            
            
