
exports.layout = function(itemDefn){
	var numItems = itemDefn.item.length;
	var totalWidth = parseInt(itemDefn.canvas.getWidth());

	if(numItems==1){
	    //--- just centered when 1 item ---
		itemDefn.item[0].obj.left = ((totalWidth - parseInt(itemDefn.item[0].obj.width)) / 2)+'dp';
	}else{
	    //--- Calculate sum of width of items  ---
		var sumItemWidth = 0;
		for(var i=0; i<numItems; i++){
			sumItemWidth += parseInt(itemDefn.item[i].obj.width);
		}
        //--- Layout Styles  -------
		switch(itemDefn.style){
		case 'flush':
			var horSpacing = (totalWidth - sumItemWidth) / (numItems - 1);
			var leftPos = 0;
			break;
		case 'center':
			var horSpacing = (totalWidth - sumItemWidth) / numItems;
			var leftPos = (horSpacing / 2);
			break;
		}
		//--- Layout the objects passed in ---
		for(var i=0; i<numItems; i++){
			itemDefn.item[i].obj.left = leftPos+'dp';
			leftPos += horSpacing + parseInt(itemDefn.item[i].obj.width);
		}
	}
};


exports.gridLayout = function(itemDefn){
	if(Object.prototype.toString.apply(itemDefn.rowDefn) === '[object Object]'){
		var rowDefn = [];
		for(var i=0; i<itemDefn.rowDefn.amount.length; i++){
			rowDefn.push({
				amount : itemDefn.rowDefn.amount[i],
				style : itemDefn.rowDefn.style,
				layout : itemDefn.rowDefn.layout,
			});
		}
		itemDefn.rowDefn = rowDefn;
	}

	var m = 0;
	for(var i=0; i<itemDefn.rowDefn.length; i++) {
		var rowView = Ti.UI.createView(itemDefn.rowDefn[i].style || {});
		var rowItems = [];
		for(var k=0; k<itemDefn.rowDefn[i].amount; k++) {
			if(m >= itemDefn.item.length) break;
			rowView.add(itemDefn.item[m]);
			rowItems.push({obj : itemDefn.item[m]});
			m++;
		}
		//---  Layout the stamps  -----
		var layoutDefn = {
			canvas	: rowView,
			style	: itemDefn.rowDefn[i].layout,
			item	: rowItems,
		};
		exports.layout(layoutDefn);
		itemDefn.canvas.add(rowView);
	}
};


exports.layout2 = function(itemDefn){
	if(Object.prototype.toString.apply(itemDefn.rowDefn) === '[object Object]'){
		var rowDefn = [];
		for(var i=0; i<itemDefn.rowDefn.amount.length; i++){
			rowDefn.push({
				amount : itemDefn.rowDefn.amount[i],
				style : itemDefn.rowDefn.style,
				layout : itemDefn.rowDefn.layout,
			});
		}
		itemDefn.rowDefn = rowDefn;
	}

	var m = 0;
	for(var i=0; i<itemDefn.rowDefn.length; i++) {
		var rowView = Ti.UI.createView(itemDefn.rowDefn[i].style || {});
		var rowItems = [];
		for(var k=0; k<itemDefn.rowDefn[i].amount; k++) {
			if(m >= itemDefn.item.length) break;
			rowView.add(itemDefn.item[m]);
			rowItems.push({obj : itemDefn.item[m]});
			m++;
		}
		//---  Layout the stamps  -----
		var layoutDefn = {
			canvas	: rowView,
			style	: itemDefn.rowDefn[i].layout,
			item	: rowItems,
		};
		exports.layout(layoutDefn);
		itemDefn.canvas.add(rowView);
	}
};

//---  End of file: layout.js
