
function smsClass(){
}

//--- Event Name constants -----
smsClass.EVENT = {
	//--- handles these events:
	//--- produces these events:
	cancel		: 'smsDialog.cancel',
	error		: 'smsDialog.error',
	smsSent		: 'smsDialog.smsSent',
};

if (Ti.Platform.osname=='android') {	
} else {
smsClass.module = require('bencoding.sms');	
}

smsClass.canSendSMS = function(param){
	var isIphone = (Ti.Platform.model.substr(0,6).toUpperCase() == 'IPHONE') ? true : false;
	return smsClass.module.canSendText || isIphone;
};

smsClass.open = function(param){

	//---  Setup event handling  ---
	var _eventProxy = ('undefined' != typeof param.eventProxy) ? param.eventProxy : null;
	//--- automatically add my EVENT declarations to the event proxy ---
	if(_eventProxy && ('undefined' != typeof smsClass.EVENT)){
		_eventProxy.addEvents(smsClass.EVENT);
	}

	var dialog = smsClass.module.createSMSDialog({
		barColor	: '#FDCC66',
		toRecipients: param.mobiles,
		messageBody : param.message
	});

	//---  Listen for Events  ---
	dialog.addEventListener('cancelled', function(evt){
		_doCancel(evt);
	});
	dialog.addEventListener('completed', function(evt){
		_doComplete(evt);
	});
	dialog.addEventListener('errored', function(evt){
		_doError(evt);
	});

	dialog.open();
	
	//-------------------  Event Handlers  ---------------------
	function _doCancel(evt){
		_cleanUp();
		if(_eventProxy)
			_eventProxy.fireEvent(smsClass.EVENT.cancel, {});
		else
			Ti.App.fireEvent(smsClass.EVENT.cancel, {});
	}
	function _doComplete(evt){
		_cleanUp();
		if(_eventProxy)
			_eventProxy.fireEvent(smsClass.EVENT.smsSent, {});
		else
			Ti.App.fireEvent(smsClass.EVENT.smsSent);
	}
	function _doError(evt){
		_cleanUp();
		if(_eventProxy)
			_eventProxy.fireEvent(smsClass.EVENT.error, evt.message);
		else
			Ti.App.fireEvent(smsClass.EVENT.error, evt.message);
	}
	function _cleanUp(){
		dialog.removeEventListener('cancelled', _doCancel);
		dialog.removeEventListener('completed', _doComplete);
		dialog.removeEventListener('errored', _doError);
		dialog = null;
	}
};

module.exports = smsClass;

//---  End of file: smsClass.js
