/**
 * jClass for implement OOP in javascript
 * 
 * @param {Object} baseClass	The super class
 * @param {Object} prop		Child's props and methods
 */
function jClass(baseClass, prop) {
	var initializing = false;
	// only one param, create a parent CLASS
	if (typeof(baseClass) === "object") {
		prop = baseClass;
		baseClass = null;
	}
	// constructor
	function F() {
		// init
		if (!initializing) {
			// if parent exist, use "base" call parent's constructor
			if (baseClass) {
				this.baseprototype = baseClass.prototype;
			}
			if(this.init){
				this.init.apply(this, arguments);
			}else{
				Ti.API.error('init function is not implemented!');
			}
		}
	}
	// this is inherited from other CLASS
	if (baseClass) {
		initializing = true;
		F.prototype = new baseClass(prop);
		F.prototype.constructor = F;
		initializing = false;
	}
	// override
	for (var name in prop) {
		if (prop.hasOwnProperty(name)) {
			if (baseClass &&
			typeof(prop[name]) === "function" &&
			typeof(F.prototype[name]) === "function") {
				// redefine function
				var func = (function(name, fn) {
					return function() {
						this.base = baseClass.prototype[name];
						return fn.apply(this, arguments);
					};
				})(name, prop[name]);
				F.prototype[name] = func;
			} else {
				var func = prop[name];
				F.prototype[name] = func;
			}
		}
		if(typeof(prop[name]) !== 'object') F.prototype[name]['functionName'] = name;
	}
	return F;
}

module.exports = jClass;

