/**
 * WOCard
 * 
 * @author zhoujun@waveo.com
 */

Ti.include('/globals.js');
App.Helper.requireModel('WOCardMaster');
var helper = App.loadHelper('default'); //TODO [ZJ]

var WOCard = App.Class(App.Model.WOObject, {
    className : 'WOCard',
    alias	  : 'cardins',
    tableName : 'card',
    hasMaster : true,
    related : {
    	'WORewardset' 	: 'card_id',
    	'WOOffer' 		: 'card_id',
    	'WOPoints'		: 'card_id',
    },
    refered : {
    },

    init : function(param) {
        var self = this;
        self.base();
        self.initProperties(param);
    },
    
    initProperties : function(param) {
    	var self = this;
        self._propMap['masterID']	= 'mid';
        self.base(param);
    },
    
    fetchList : function() {
    	var self = this;
    	var param = {
    		order : {'instance.updated' : 'DESC'}
    	}
    	self.fetchAll(param);
    },
    
    save : function(syncDown, timestamp) {
    	var self = this;
    	if('000001' == self.data.masterID) self.base(syncDown, false);
    	else self.base(syncDown, timestamp);
    },
    
    p2l : function() {
    	var self = this;
    	if(!self.id) {
    		var list = [];
    		for(var i=0; i < self.list.length; i++) {
    			if('000001' != self.list[i].master.id) list.push(self._p2l(self.list[i].master, self.list[i].data));
    			else var iPerkdID = i;
    		}
    		if('undefined' != typeof iPerkdID) list.push(self._p2l(self.list[iPerkdID].master, self.list[iPerkdID].data)); //force put PerkdID in the bottom
    	} else {
    		var list = self._p2l(self.master, self.data);
    	}
    	return list;
    },
    
    _p2l : function(master, instance) {
    	var self = this;
    	instance.profile = instance.profile || {};
    	instance.register = instance.register || {};
		var list = {};
		list.className			= self.className;
        list.display            = self._getDisplayName(instance);
        list.hideDisplay		= instance.hideDisplay || master.hideDisplay || false;
        list.profile            = instance.profile	 	|| {}	;
        list.register           = instance.register		|| {}	;
        list.regformName        = instance.regFormName	|| '' 	;
        list.givenName          = instance.givenName 	|| ''	;
        list.familyName         = instance.familyName 	|| ''	;
        list.joined             = instance.joined  		|| null ;
        list.expiry             = instance.expiry		|| null	;
        // list.activated          = 'activated'       ;
        // list.registered         = 'registered'      ;
        list.number             = instance.number		|| 	'';
        list.showCardNo			= '000001' == master.id ? false : ('undefined' != typeof master.showCardNo ? master.showCardNo : true);
        list.isActivated        = instance.isActivated	|| 	false;
        list.isRegistered       = instance.isRegistered	||	false;
        list.fullName           = self._getFullName(master, instance);
        list.frontName          = self._getFrontName(master, instance);
        list.name				= list.frontName || master.name;
        list.masterID           = master.id;
        list.cardID             = instance.id;
        list.id                 = instance.id;
        list.brandName          = master.brandName;
        list.frontImage         = master.frontImage;
        list.thumbImage         = master.thumbImage;
        list.masterName         = master.name;
        list.profileForm        = master.profileForm ;
        list.registerForm       = master.registerForm ;
        list.shareMsg           = master.shareMsg;
        list.numFormat          = master.numFormat;
        list.allowShare         = master.allowShare;
        list.shareMode          = master.shareMode ;
        list.state              = self._getState(master, instance);
        list.barcodeType        = self._getBarcodeType(master, instance);
        list.allowScan          = master.allowScan;
        list.allowLater			= master.allowLater;
        // list.allowDel			= master.allowDel || false;
        list.about              = master.about;
        list.hasIntro           = master.hasIntro;
        list.isDigital          = (master.type+'') == 2 ? true : false ;
        list.isCustom			= '0000-0000-0000-0000-0000' == master.id ? true : false;
        list.isPerkdID          = '000001' == master.id ? true : false;
        list.canModDisplay      = 'undefined' != typeof master.canModDisplay ? master.canModDisplay : true;
        
        return list;
    },
    
    _getDisplayName : function(instance) {
        var self = this;
        var displayName = '';
        //Force use display
        var hideDisplay = instance.hideDisplay || false;
        if(hideDisplay) return '';
        
        displayName = instance.display || '';
        if('' == displayName) displayName = instance.profile.display_name || '';
        if('' == displayName) {
        	var fname = instance.profile.fname || '';
            var gname = instance.profile.gname || '';
            var account = $.dataMgr.get('WOSettings', 'account');
            var nameOrderID = account.nameOrder || 0;
            displayName = App.Helper.getDisplayName(nameOrderID, fname, gname);
        }
        return displayName;
    },
    
    _getFullName : function(master, instance) {
        var self = this;
        var cardName = self._getFrontName(master, instance);
        if('' == cardName) {
            cardName = master.name;
        }
        var suffix = App.Helper.L('dict_card');
        var cardName2 = _getCardName(cardName, ' card');
        if(cardName2 == cardName) cardName2 = _getCardName(cardName, ' Card');
        if(cardName2 == cardName) cardName2 = _getCardName(cardName, ' CARD');
        if(cardName2 == cardName) cardName2 = _getCardName(cardName, App.Helper.L('dict_card'));
        return cardName2+App.Helper.L('dict_card');
    },
    
    _getFrontName : function(master, instance) {
        var self = this;
        var display = '';
        if('0000-0000-0000-0000-0000' == master.id) {
            display = instance.profile['card_name'];
            if(!display){
                display = App.Helper.L('cardDetail_CustomCardName');
            }
        }
        return display;
    },
    
    _getBarcodeType : function(master, instance) {
        var self = this;
        
        if(instance.profile.card_number && instance.profile.card_number.type) {
            return Number(instance.profile.card_number.type);
        }
        
        var ctype   = master.barcodeType;
        switch(ctype) {
            case '-1' 	:
            case '0' 	:
            	ctype = null;
                break;
            default : 
                ctype = Number(ctype);
        }
        return ctype;
    },
    
    _getState : function(master, instance) {
        var self = this;
        if(!self._isRegistered(master, instance)) return -1;//'not_register';
        
        var expiry      = Number(instance.expiry);
        var expiryDate  = new Date(expiry*1000);
        var now         = new Date();
        if(expiry && expiry > 0 && expiryDate <= now) {
            return -2;//'expired';
        }
        return 0;//'ok';
    },
    
    _isRegistered : function(master, instance) {
        var self = this;
        if(master.needRegister && !instance.isRegistered){
            return false;
        }
        return true;
    },
    
    getMissingImages : function() {
        var self = this;
        var sql = "\
SELECT master.front_image AS key, 0 AS value FROM card instance, card_master master WHERE instance.mid = master.id \
UNION \
SELECT master.thumb_image AS key, 0 AS value FROM card instance, card_master master WHERE instance.mid = master.id";
        var urls = App.DB2.fetch2ColsToHashArray(sql, [], 'key', 'value');
        App.Helper.requireModel('WOImage');
        var images = new App.Model.WOImage();
        images.initialize();
        
        var allImageIDs = images.getAllImageIDs();
        var missingImageUrls = [];
        for(var url in urls) {
        	var imageID = Ti.Utils.md5HexDigest(url);
        	if(allImageIDs.hasOwnProperty(imageID)) continue;
        	missingImageUrls.push(url);
        }
        return missingImageUrls;
     },
         
    //---------  Reminder Manager support methods  --------------
        
    reminderEventTime : function(reminderType) {
        var self = this;
        var cardExpiryDate = null;
        var cardExpiry = Number(self.data.expiry);
        if(0 != cardExpiry) {
            cardExpiryDate = new Date(cardExpiry*1000);  // convert to milliseconds
        }
        return cardExpiryDate;
    },

    /**
     * @param   {object}    of these attributes:
     *          reminderType   - see default_config.js for reminderTypes
     *          duration       - time to Event (in milliseconds)
     * @return  {string}    notification message (localized)
     */
    reminderMessage : function(reminderParam) {
        var self = this;
        
        var message = '';
        switch (reminderParam.reminderType) {
        case App.Const.NOTIFY_CARDEXPIRY:
        	var cardFullName = self._getFullName(self.master, self.data);
        	if(reminderParam.duration==0){
        		message = String.format(App.Helper.L('ReminderMsg_CardExpiringToday'), cardFullName);
        	}else if(reminderParam.duration==1){
        		message = String.format(App.Helper.L('ReminderMsg_CardExpiringTomorrow'), cardFullName);
        	}else{
        		message = String.format(App.Helper.L('ReminderMsg_CardExpiringInNDays'), cardFullName, reminderParam.duration);
        	}
            break;
        case App.Const.NOTIFY_OFFEREXPIRY:
            break;
        case App.Const.NOTIFY_REWARDEXPIRY:
            break;
        default:
            $.watch.dog(self, self.className, "unsupported reminderType ("+reminderParam.reminderType+")");
    	}
    	
		Ti.API.error(message);    	
        return message;
    },
    
    /**
     * @return	{boolean} or {array}		true if card details are valid OR error message array
     */
    validate : function(){ //TODO [ZJ] : this is old code, can work, but not sure if good.
        var self    = this;
        var error   = [];
        var expiry  = self.data.expiry;
        var join    = self.data.joined;

		//--- Expiry and Join dates ---     
        if(expiry!=null && expiry!='' && expiry!=0 && expiry!='0') {
            expiry = Number(expiry)*1000;
            expiry = new Date(expiry);
        }else{
            expiry = null;
        }
        
        if(join!=null && join!='' && join!=0 && join!='0') {
            join = Number(join)*1000;
            join = new Date(join);
        }else{
            join = null;
        }
        if(expiry && join){
            if(join>=expiry){
                error.push({msg:App.Helper.L('date_error'), field:App.Helper.L('date_expiry')});
            }
        }
		//--- Card Number ---     //TODO [ZJ]   
        // var scanModule = App.loadHelper('Zebra');
        // var codeValid = scanModule.isValidBarcode(self.data.number, self.data.barcodeType);
        // if(true != codeValid) {
            // error.push({ msg: codeValid, field: 'Card Number' });
        // }
        if(error.length>0) {
            return error;
        } else {
            return true;
        }
    },
});

module.exports = WOCard;

function _getCardName (name, suffix) {
	var lastIndex = name.lastIndexOf(suffix);
	if(lastIndex >= 0 && lastIndex+suffix.length == name.length) var clearedName = name.substring(0, lastIndex);
	else var clearedName = name;
	return clearedName;
}

//---  End of file: WOCard.js
