/**
 * WOCardMaster
 * 
 * @author zhoujun@waveo.com
 */

Ti.include('/globals.js');
var dbi = App.loadHelper('db');          //TODO [ZJ]
var helper = App.loadHelper('default'); //TODO [ZJ]

var WOCardMaster = App.Class(App.Model.WOObject, {
    className : 'WOCardMaster',
    alias     : 'cardmas',
    tableName : 'card_master',
    hasMaster : false,
    related : {
    	'WOCard' 	: 'mid',
    },
        
    init : function(param) {
        var self = this;
        self.base();
        self.initProperties(param);
        												// //TODO [ZJ] : temporary for testing
												        // App.Helper.requireModel('WOSettings');
												        // var account = new App.Model.WOSettings('account');
												        // account.fetch();
												        // self.setLocation(account.data.givenName, account.data.familyName);        
    },
    
    initProperties : function(param) {
    	var self = this;
        self._propMap['name'] 		= 'name';
        self._propMap['desc'] 		= 'description';
        self._propMap['tag'] 		= 'tag';
        self._propMap['category']	= 'category';
        self._propMap['brandName']	= 'brand_name';
        self._propMap['frontImage']	= 'front_image';
        self._propMap['thumbImage']	= 'thumb_image';
        self._propMap['city']	    = 'city';
        
        self._location = [];
        
        self.base(param);
    },
    
    setLocation : function(city, country) {
    	var self = this;
    	city = city || '%';
    	country = country || '%';
    	var location = city+','+country;
    	self._location.push(location);
    },
    
    p2l : function() {
    	var self = this;
    	if(!self.id) {
    		var list = [];
    		for(var i=0; i < self.list.length; i++) list.push(self._p2l(self.list[i].data));
    	} else {
    		var list = self._p2l(self.data);
    	}
    	return list;
    },
    
    _p2l : function(master) {
    	var self = this;
		var list = {};
		list.className			= self.className;
		list.master             = master       	;
        list.id              	= master.id		;
        list.cardID         	= master.id		;
        list.brandName          = master.brandName;
        list.frontImage         = master.frontImage;
        list.thumbImage         = master.thumbImage;
        list.name               = master.name;
        list.desc				= master.desc;
        list.profileForm        = master.profileForm ;
        list.registerForm       = master.registerForm ;
        list.shareMsg           = master.shareMsg;
        list.numFormat          = master.numFormat;
        list.allowShare         = master.allowShare ? true : false ;
        list.shareMode          = master.shareMode ;
        list.allowScan          = master.allowScan ;
        list.about              = master.about;
        list.hasIntro           = master.hasIntro;
        list.isDigital          = (master.type+'') == '2' ? true : false ;
        list.forms              = 'forms';
        list.signupSpecial      = master.signupSpecial || {title : null,desc : null,tip : null};
        list.extraInfo			= master.extraInfo || [];
        list.isCustom			= '0000-0000-0000-0000-0000' == master.id ? true : false;
        list.formDefn			= master.formDefn || {};
        list.appVer				= master.appVer || Ti.App.version;
        list.fullName			= self.getFullName(master.name);
        return list;
    },
    
    getFullName : function(cardName) {
        var self = this;
        
        var suffix = App.Helper.L('dict_card');
        if('Card' == suffix) suffix = ' Card';
        var cardName2 = _getCardName(cardName, ' card');
        if(cardName2 == cardName) cardName2 = _getCardName(cardName, ' Card');
        if(cardName2 == cardName) cardName2 = _getCardName(cardName, ' CARD');
        if(cardName2 == cardName) cardName2 = _getCardName(cardName, suffix);
        return cardName2+suffix;
    },

    getCategories : function() {
        var self = this;

        var keywordWhere = [];
        // var keywords = ['global', 'nanjing', 'singapore'];    //TODO [ZJ]
        var keywords = $.prefMgr.getCityAware();
        keywords.push('global');
        
    	var vararg = [];
    	for(var i=0; i<keywords.length; i++) {
    		keywordWhere.push('city LIKE ?');
    		vararg.push('%`'+keywords[i]+'`%');
    	}
    	//city is empty or null, default to 'global'.
    	keywordWhere.push("city = ''");
    	keywordWhere.push('city IS NULL');
    	var cityConditions = ' AND ('+keywordWhere.join(' OR ')+')';
        
        var sql = "\
SELECT `category`, count(*) AS count \
FROM `card_master` \
WHERE `id`!='0' AND `id`!='0000-0000-0000-0000-0000' AND `is_hidden` != '1' AND `category` IS NOT NULL AND `category` <> ''"+cityConditions+' GROUP BY `category` COLLATE NOCASE';
        return App.DB2.fetchRowsToArray(sql, vararg);
    },
    
    fetchCategory : function (category) {
    	var self = this;
        var keywordWhere = [];
        // var keywords = ['global', 'nanjing', 'singapore'];    //TODO [ZJ]
        var keywords = $.prefMgr.getCityAware();
        keywords.push('global');

    	var vararg = [category];
    	for(var i=0; i<keywords.length; i++) {
    		keywordWhere.push('city LIKE ?');
    		vararg.push('%`'+keywords[i]+'`%');
    	}
    	//city is empty or null, default to 'global'.
    	keywordWhere.push("city = ''");
    	keywordWhere.push('city IS NULL');
    	var cityConditions = ' AND ('+keywordWhere.join(' OR ')+')';
        
    	self.fetchAll({
    		where : "category=? "+cityConditions,
    		vararg : vararg,
    		order : {'instance.brand_name' : 'COLLATE NOCASE ASC'},
    	});
    },
    
    searchAll : function(keywords, cityAware) {
    	var self = this;
    	
    	cityAware = cityAware || false;
    	var fields = ['name', 'tag', 'brand_name', 'city'];
    	
    	var where = [];
    	var vararg = [];
    	for(var i=0; i<keywords.length; i++) {
    		var keywordWhere = [];
    		for(var j=0; j<fields.length; j++) {
    			keywordWhere.push(fields[j]+' LIKE ?');
    			'city' == fields[j] ? vararg.push('%`'+keywords[i]+'%') : vararg.push('%'+keywords[i]+'%');
    		}
    		where.push('('+keywordWhere.join(' OR ')+')');
    	}
    	if(cityAware) {
    		var cityKeywords = $.prefMgr.getCityAware();
        	cityKeywords.push('global');
        	var keywordWhere = [];
	    	for(var i=0; i<cityKeywords.length; i++) {
	    		keywordWhere.push('city LIKE ?');
	    		vararg.push('%`'+cityKeywords[i]+'`%');
	    	}
	    	//city is empty or null, default to 'global'.
	    	keywordWhere.push("city = ''");
	    	keywordWhere.push('city IS NULL');
	    	where.push('('+keywordWhere.join(' OR ')+')');
    	}
    	where = '('+where.join(' AND ')+')';
    	Ti.API.error(where);
    	self.fetchAll({
    		where 	: where,
    		vararg 	: vararg,
    		order 	: { 'brand_name' : 'COLLATE NOCASE ASC'},
    	});
    },
    
    hasCityKeywords : function(keywords) {
    	var self = this;
    	var fields = ['city'];
    	var where = [];
    	var vararg = [];
    	for(var i=0; i<keywords.length; i++) {
    		var keywordWhere = [];
    		for(var j=0; j<fields.length; j++) {
    			keywordWhere.push(fields[j]+' LIKE ?');
    			'city' == fields[j] ? vararg.push('%`'+keywords[i]+'%') : vararg.push('%'+keywords[i]+'%');
    		}
    		where.push('('+keywordWhere.join(' OR ')+')');
    	}
    	where = '('+where.join(' OR ')+')';
    	Ti.API.error(where);
    	return self.fetchAll({
    		where 	: where,
    		vararg 	: vararg,
    	});
    },
    
    getCardFormDefn : function(cardMaster, type){ //add, edit, reg
		var self = this;
		
		if('undefined' != typeof cardMaster.formDefn && helper.isObject(cardMaster.formDefn)) {
			//get card form definition from card master.
			if(type in cardMaster.formDefn && helper.isObject(cardMaster.formDefn[type])) for(var key in cardMaster.formDefn[type]) return cardMaster.formDefn[type];
		}
		//get card form definition from settings.
		var config = $.dataMgr.get('WOSettings', 'config', false);
		if(config) {
			config.formDefn = config.formDefn || {};
			var formNameKey = type;
			if(formNameKey in config.formDefn && helper.isObject(config.formDefn[formNameKey])) 
				for(var key in config.formDefn[formNameKey]) return config.formDefn[formNameKey];
		}
		//get card form definition from code.
		if('add' == type) {
			//default cardAddForm
			var cardAddForm = {};
			cardAddForm.form = {
				name : 'cardAdd',
				style : 'form',
				properties : {
					fieldWindow : {
						style : 'fieldWindow',
					},
				}
			};
			if(cardMaster.isDigital) {
				cardAddForm.header = {
					type  : 'text',
					style : 'view_formHeader',
					properties : {
						value : App.Helper.L('addCard_digitalCardDesc'),
						style : 'label_formHeader_withCard',
					},
				};
			} else {
				cardAddForm.header = {
					type  : 'text',
					style : 'view_formHeader',
					properties : {
						value : '',
						style : 'label_formHeader_withCard',
					},
				};
			}
			cardAddForm.sections = [{},{}];
			cardAddForm.sections[0].name = 'profile';
			cardAddForm.sections[0].fields = [];
			var i = 0;
			if(cardMaster.isCustom) {
				cardAddForm.sections[0].fields[i++] = {
					name : 'card_name',
					type : 'text',
					style : 'view_formfield',
					properties : {
						row : {
							style : 'view_formRow',
						},
						hint : {
							value :  App.Helper.L('formLabel_cardname'),
							style : 'label_fieldHint_name',
						},
						field : {
							style : 'label_fieldData_name',
						},
					},
				}
			};
			cardAddForm.sections[0].fields[i++] = {
				name : 'card_number',
				type : 'barcodeScan',
				style : 'view_formfield',
				properties : {
					row : {
						style : 'view_formRow_withWindow',
					},
					hint : {
						value : App.Helper.L('formLabel_cardno'),
						style : 'label_fieldHint_cardno',
					},
					field : {
						style : 'label_fieldData_cardno',
					},
					fieldView:{
						title : App.Helper.L('TITLE_CARDNO'),
						style : 'fieldWindowElement_cardno',
					},
					config : {
						barcodeType : cardMaster.master.barcodeType,
					},
				},
			};
			cardAddForm.sections[0].fields[i++] = {
				name : 'display_name',
				type : 'text',
				style : 'view_formfield',
				properties : {
					row : {
						style : 'view_formRow',
					},
					hint : {
						value : App.Helper.L('formLabel_name'),
						style : 'label_fieldHint_name',
					},
					field : {
						style : 'label_fieldData_name',
					},
				},
			};
			cardAddForm.sections[1].name = 'validity';
			cardAddForm.sections[1].fields = [{},{}];
			cardAddForm.sections[1].fields[0] = {
				name : 'join',
				type : 'date',
				style : 'view_formfield',
				properties : {
					row : {
						style : 'view_formRow_withWindow',
					},
					label : {
						value : App.Helper.L('formLabel_join'),
						style : 'label_fieldLabel',
					},
					field : {
						style : 'label_fieldData',
					},
					config : {
						type : 'join',
					},
					fieldView : {
						label : '',
						title : App.Helper.L('TITLE_JOINDATE'),
						style : 'fieldWindowElement_date',
					},
				},
			};
			cardAddForm.sections[1].fields[1] = {
				name : 'expiry',
				type : 'date',
				style : 'view_formfield',
				properties : {
					row : {
						style : 'view_formRow_withWindow',
					},
					label : {
						value : App.Helper.L('formLabel_expire'),
						style : 'label_fieldLabel',
					},
					field : {
						style : 'label_fieldData',
					},
					config : {
						type : 'cardExpiry',
					},
					fieldView : {
						defaultLabel: App.Helper.L('formfieldwindow_cardExpiry_default'),
						label : App.Helper.L('formfieldwindow_cardExpiry'),
						title : App.Helper.L('TITLE_EXPIRYDATE'),
						style : 'fieldWindowElement_date',
					},
				},
			};
			cardAddForm.footer = {
					type  : 'text',
					style : 'view_formFooter',
					properties : {
						value : '',
						style : 'label_formFooter',
					},
				};
			return cardAddForm;
			
		} else {
			var cardRegForm = {
		      "form": {
		        "name": "registration",
		        "style": "form",
		        "properties": {
		          "fieldWindow": {
		            "style": "fieldWindow"
		          }
		        }
		      },
		      "header": {
		      	"type": 'text',
				"style": 'view_formHeader',
				"properties": {
				  "value": App.Helper.L('formLabel_submitProfileDesc'),
				  "style": 'label_formHeader',
				 },
		      },
		      "sections": [
		        {
		          "name": "profile",
		          "fields": [
		            {
		              "name": "card_number",
		              "type": "barcodeScan",
		              "style": "view_formfield",
		              "properties": {
		                "row": {
		                  "style": "view_formRow_withWindow"
		                },
		                "hint": {
		                  "value": App.Helper.L('formLabel_cardno'),
		                  "style": "label_fieldHint_cardno"
		                },
		                "field": {
		                  "style": "label_fieldData_cardno"
		                },
						"fieldView" : {
							"title" : App.Helper.L('TITLE_CARDNO'),
							"style" : "fieldWindowElement_cardno",
						},
						"config" : {
							"barcodeType" : cardMaster.master.barcodeType,
						},
		              }
		            },
		            {
		              "name": "fname",
		              "type": "text",
		              "style": "view_formfield",
		              "properties": {
		                "row": {
		                  "style": "view_formRow"
		                },
		                "hint": {
		                  "value": App.Helper.L('formLabel_familyname'),
		                  "style": "label_fieldHint_name"
		                },
		                "field": {
		                  "style": "label_fieldData_name"
		                }
		              }
		            },
		            {
		              "name": "gname",
		              "type": "text",
		              "style": "view_formfield",
		              "properties": {
		                "row": {
		                  "style": "view_formRow"
		                },
		                "hint": {
		                  "value": App.Helper.L('formLabel_givenname'),
		                  "style": "label_fieldHint_name"
		                },
		                "field": {
		                  "style": "label_fieldData_name"
		                }
		              }
		            },
		            {
		              "name": "gender",
		              "type": "tabbar",
		              "style": "view_formfield",
		              "properties": {
		                "row": {
		                  "style": "view_formRow"
		                },
		                "label": {
		                  "value": App.Helper.L('formLabel_gender'),
		                  "style": "label_fieldLabel"
		                },
		                "field": {
		                  "style": "label_fieldData"
		                },
						"config": {
						  "style": "tabbar_gender",
		                  "options": {
		                    "Female": 2,
		                    "Male": 1
		                  },
		                  "defaultValue": 2
		                }
		              }
		            },
		            {
		              "name": "birth",
		              "type": "date",
		              "style": "view_formfield",
		              "properties": {
		                "row": {
		                  "style": "view_formRow_withWindow"
		                },
		                "label": {
		                  "value": App.Helper.L('formLabel_birthday'),
		                  "style": "label_fieldLabel"
		                },
		                "field": {
		                  "style": "label_fieldData"
		                },
		                "config": {
		                  "type": "birth"
		                },
						"fieldView" : {
							"title" : App.Helper.L('TITLE_DOB'),
							"style" : "fieldWindowElement_date",
						},
					  }
		            },
		            {
		              "name": "email_opt",
		              "type": "tabbar",
		              "style": "view_formfield",
		              "properties": {
		                "row": {
		                  "style": "view_formRow"
		                },
		                "label": {
		                  "value": App.Helper.L('formLabel_emailopt'),
		                  "style": "label_fieldLabel"
		                },
		                "field": {
		                  "style": "label_fieldData"
		                },
						"config": {
		                  "style": "tabbar_opt",
		                  "options": {
		                    "Yes": "Y",
		                    "No": "N"
		                  },
		                  "defaultValue": "Y"
		                }
		              }
		            },
		            {
		              "name": "email",
		              "type": "text",
		              "style": "view_formfield",
		              "properties": {
		                "row": {
		                  "style": "view_formRow"
		                },
		                "hint": {
		                  "value": App.Helper.L('formLabel_email'),
		                  "style": "label_fieldHint_email"
		                },
		                "field": {
		                  "style": "label_fieldData_email"
		                }
		              }
		            },
		            {
		              "name": "mobile_opt",
		              "type": "tabbar",
		              "style": "view_formfield",
		              "properties": {
		                "row": {
		                  "style": "view_formRow"
		                },
		                "label": {
		                  "value": App.Helper.L('formLabel_mobileopt'),
		                  "style": "label_fieldLabel"
		                },
		                "field": {
		                  "style": "label_fieldData"
		                },
						"config": {
		                  "style": "tabbar_opt",
		                  "options": {
		                    "Yes": "Y",
		                    "No": "N"
		                  },
		                  "defaultValue": "Y"
		                }
		              }
		            },
		            {
		              "name": "mobile",
		              "type": "text",
		              "style": "view_formfield",
		              "properties": {
		                "row": {
		                  "style": "view_formRow"
		                },
		                "hint": {
		                  "value": App.Helper.L('formLabel_mobile'),
		                  "style": "label_fieldHint_mobile"
		                },
		                "field": {
		                  "style": "label_fieldData_mobile"
		                }
		              }
		            }
		          ]
		        }
		      ]
		    }
		    return cardRegForm;
		}
    },
    
    getCardEditFormDefn : function(cardMaster) {
		var self = this;
		
		if('undefined' != typeof cardMaster.formDefn && helper.isObject(cardMaster.formDefn)) {
			//get card definition from card master
			if('edit' in cardMaster.formDefn && helper.isObject(cardMaster.formDefn.edit)) return cardMaster.formDefn.edit;
		}
		
		//get card definition from settings.config
		var config = $.dataMgr.get('WOSettings', 'config', false);
		if(config) {
			config.formDefn = config.formDefn || {};
			if('edit' in config.formDefn && helper.isObject(config.formDefn.edit)) return config.formDefn.edit;
		}
		//default cardEditForm
		var cardEditForm = {};
		cardEditForm.form = {
			name : 'cardEdit',
			style : 'form',
			properties : {
				fieldWindow : {
					style : 'fieldWindow',
				},
			}
		};
		cardEditForm.sections = [{},{}];
		cardEditForm.sections[0].name = 'profile';
		cardEditForm.sections[0].fields = [];
		var i = 0;
		if(cardMaster.isCustom) {
			cardEditForm.sections[0].fields[i++] = {
				name : 'card_name',
				type : 'text',
				style : 'view_formfield',
				properties : {
					row : {
						style : 'view_formRow',
					},
					hint : {
						value : App.Helper.L('formLabel_cardname'),
						style : 'label_fieldHint_name',
					},
					field : {
						style : 'label_fieldData_name',
					},
				},
			}
		};
		cardEditForm.sections[0].fields[i++] = {
			name : 'card_number',
			type : 'barcodeScan',
			style : 'view_formfield',
			properties : {
				row : {
					style : 'view_formRow_withWindow',
				},
				hint : {
					value : App.Helper.L('formLabel_cardno'),
					style : 'label_fieldHint_cardno',
				},
				field : {
					style : 'label_fieldData_cardno',
				},
				fieldView : {
					title : App.Helper.L('TITLE_CARDNO'),
					style : 'fieldWindowElement_cardno',
				},
				config : {
					barcodeType : cardMaster.master.barcodeType,
				}
			},
		};
		cardEditForm.sections[0].fields[i++] = {
			name : 'display_name',
			type : 'text',
			style : 'view_formfield',
			properties : {
				row : {
					style : 'view_formRow',
				},
				hint : {
					value : App.Helper.L('formLabel_name'),
					style : 'label_fieldHint_name',
				},
				field : {
					style : 'label_fieldData_name',
				},
			},
		};
		cardEditForm.sections[1].name = 'validity';
		cardEditForm.sections[1].fields = [{},{}];
		cardEditForm.sections[1].fields[0] = {
			name : 'join',
			type : 'date',
			style : 'view_formfield',
			properties : {
				row : {
					style : 'view_formRow_withWindow',
				},
				label : {
					value : App.Helper.L('formLabel_join'),
					style : 'label_fieldLabel',
				},
				field : {
					style : 'label_fieldData',
				},
				config : {
					min : null,
					max : null,
					type : 'all',
				},
				fieldView : {
					title : App.Helper.L('TITLE_JOINDATE'),
					style : 'fieldWindowElement_date',
				},
			},
		};
		cardEditForm.sections[1].fields[1] = {
			name : 'expiry',
			type : 'date',
			style : 'view_formfield',
			properties : {
				row : {
					style : 'view_formRow_withWindow',
				},
				label : {
					value : App.Helper.L('formLabel_expire'),
					style : 'label_fieldLabel',
				},
				field : {
					style : 'label_fieldData',
				},
				config : {
					type : 'cardExpiry',
				},
				fieldView : {
					defaultLabel: App.Helper.L('formfieldwindow_cardExpiry_default'),
					label : App.Helper.L('formfieldwindow_cardExpiry'),
					title : App.Helper.L('date_expiry'),
					style : 'fieldWindowElement_date',
				},
			},
		};
		cardEditForm.footer = {
			type : 'text',
			style : 'view_formFooter',
			properties	: {
				value	: App.Helper.L('profileform_tip'),
				style	: 'label_formFooter',
			},
		};
		return cardEditForm;    	
    },
});

module.exports = WOCardMaster;


function _getCardName (name, suffix) {
	var lastIndex = name.lastIndexOf(suffix);
	if(lastIndex >= 0 && lastIndex+suffix.length == name.length) var clearedName = name.substring(0, lastIndex);
	else var clearedName = name;
	return clearedName;
}

/**
 * End of file: WOCardMaster.js
 */