/**
 * WOMessage
 * 
 * @author zhoujun@waveo.com
 */

Ti.include('/globals.js');
App.Helper.requireModel('WOObject');

var WOMessage = App.Class(App.Model.WOObject, {
    className : 'WOMessage',
    alias : 'message',
    tableName : 'message',
    
    STATUS : {
    	'unread' 	: 0,
    	'read'		: 1,
    },
    
    init : function(param) {
        var self = this;
        self.base();
        self.initProperties(param);
    },
    
    initProperties : function(param) {
        var self = this;
        
        self._propMap['type']       = 'type'        ; //main type : perkd, mail... etc
        self._propMap['subType']   	= 'sub_type'    ;
        self._propMap['status']		= 'status'		;
        self._propMap['startup']	= 'startup'		;
        self._propMap['validBegin']	= 'valid_begin'	;
        self._propMap['validEnd']	= 'valid_end'	;
        
        self.base(param);
    },
    
    getSyncUp : function() {
    	var self = this;
    	return [];
    },
    
    updateStatus : function(status) {
    	var self = this;
    	self.data.status = status;
    	self.save();
    },
    
    //----- Definiton of message structure -----
    getMessageStruct : function(type) {
    	var self = this;
    	var message = {};
    	switch(type) {
    		case 'issueStamp':
    			message = {
    				type : $.notifyMgr.TYPE.perkMsg,
    				subType : $.notifyMgr.SUBTYPE.perkd.issueStamp,
    				action : [],
    				content : {
    					source : '', // the stamp issued by ...
	    				sourceAction : 2, // issue
						title 	: '',
						desc	: '',
						//------ param -----	
						cardID 			: '',
						rewardsetMID	: '',
						stampIDs 		: [], // imageObj.
    				}
    			};
    			break;
    		case 'issueOffer':
    			message = {
					type : $.notifyMgr.TYPE.perkMsg,
					subType : $.notifyMgr.SUBTYPE.perkd.issueOffer,
					action : [],
					content : {
						source : '',// the offer issued by...
						sourceAction : 2,// issue
						title		: '',
						desc		: '',
						//------ param -----	
						cardID		: '',
						// rewardsetID	: '',		// will support@2.4
						// levelID		: '',
						offerIDs	: [],
					}
    			};
    			break;
    		case 'issueCard':
    			message = {
    				type	: $.notifyMgr.TYPE.perkMsg,
					subType : $.notifyMgr.SUBTYPE.perkd.issueCard,
					action	: [],
					content	: {
						source	: '',
						sourceAction : 2,
						title : '',
						desc : '',
						//------ param -----
						cardMID : param.data.cardMID,
						cardID	: param.data.cardID,
					}
    			};
    			break;
    		default:
    			message = {};
    	}
    	
    	return message;
    }
});

module.exports = WOMessage;
/**
 * End of file: WOMessage.js
 */