
Ti.include('/globals.js');

var MainController = App.Class(App.Controller.WOManager, {
	className : 'MainController',
    alias     : 'main',

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

		self.tabDefine = [
			{id:'card', 	url:'card/list',		icon: App.Config.IS_ANDROID? '/assets/images/icons/cards@2x.png' : '/assets/images/icons/cards.png', 		title:App.Helper.L('tab_card')},
			{id:'discover', url:'cardLib/discover',	icon: App.Config.IS_ANDROID? '/assets/images/icons/discover@2x.png': '/assets/images/icons/discover.png',  	title:App.Helper.L('tab_discover')},
		];
		if (App.Config.IS_ANDROID) {
			//----- Temp fix --- always set preference in Android to activate Scanner.
			$.prefMgr.set('scan','true');
		}
		if($.prefMgr.get('scan') && (Ti.Media.isCameraSupported || App.Config.IS_SIMULATOR)){
			self.tabDefine.push({id:'perkcode', url:'PerkController/main',		icon: App.Config.IS_ANDROID? '/assets/images/icons/perkcode@2x.png': '/assets/images/icons/perkcode.png',	title:App.Helper.L('tab_perkcode')});
		}
		self.tabDefine.push({id:'profile', 	url:'ProfileController/main', 	icon: App.Config.IS_ANDROID? '/assets/images/icons/me@2x.png': '/assets/images/icons/me.png', title:App.Helper.L('tab_profile')});
		self.tabDefine.push({id:'setting', 	url:'pref/main', 				icon: App.Config.IS_ANDROID? '/assets/images/icons/setting@2x.png': '/assets/images/icons/setting.png', title:App.Helper.L('tab_settings')});		
	},

	main : function(data){
		var self = this;
		
	    if (App.Config.IS_ANDROID) {
	    	Ti.Android.currentActivity.setRequestedOrientation(Titanium.Android.SCREEN_ORIENTATION_PORTRAIT);
	    }
	    
		var winObj = App.Helper.loadView('MainWindow', { tabDefine: self.tabDefine });
		winObj.render();
		return winObj;
	}
});

module.exports = MainController;

//---  End of file: MainController.js
