
Ti.include('/globals.js');

var MessageController = App.Class(App.Controller.WOManager, {
	className : 'MessageController',
	alias	  : 'message',
	
	//--- Event Name constants -----
	EVENT		: {
		//--- handles these events:
		handleMessage 	: 'message.handleMessage',
		pullMessage		: 'message.pullMessage',
		//--- produces these events:
    },

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.listenForEvents();
	},

	main : function(param){
		var self = this;
	},
	
	listenForEvents : function(){
		var self = this;

		Ti.App.addEventListener(self.EVENT.handleMessage, function(evt){
        	self.handleMessage(evt);
       	});
	},
	
	handleMessage : function() {
		var self = this;
		
		var message = $.dataMgr.newModel('WOMessage');
		message.fetchAll();
		var messageData = message.p2l();
		
		if(!messageData.length) return;
		
		$.app.route({
				url		: 'message/'+messageData[0].type,
				style	: App.Const.WINDOW.effect.flip,
				data	: { message : messageData[0] }
		});
	},
	
	issueOffer : function(param){
		var self = this;
		
		var viewParam = {
			DATA : {
				message : param.message.param
			},
		};
		var view = App.Helper.loadView('message/issueOffer', viewParam);
		var proxy = view.getEventProxy();
		var renderedView = view.render();

		proxy.addEventListener(proxy.EVENT.accept, function(evt){
			self._removeMessage(param.message.id);
		});
		
		return renderedView;
	},
	
	issueStamp : function(param){
		var self = this;
		
		var viewParam = {
			DATA : {
				message :  param.message.param
			},
		};
		var view = App.Helper.loadView('message/issueStamp', viewParam);
		var proxy = view.getEventProxy();
		var renderedView = view.render();
		
		proxy.addEventListener(proxy.EVENT.accept, function(evt){
			self._removeMessage(param.message.id);
		});
		
		return renderedView;
	},
	
	_removeMessage : function(messageID) {
		var message = $.dataMgr.newModel('WOMessage', messageID);
		message.remove(true);
	}
});

module.exports = MessageController;

//---  End of file: MessageController.js