
Ti.include('/globals.js');

var ProfileController = App.Class(App.Controller.WOManager, {
	className : 'ProfileController',

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		Ti.App.addEventListener('WOSettings.account.'+$.syncMgr.EVENT.syncUpdate, function(){
			if(self.profileWinObj){
				var account = $.dataMgr.get('WOSettings', 'account');
				var formData = {
					familyName	: account.familyName,
					givenName	: account.givenName,
					nameOrder   : {
						displayID   : account.nameOrder || 0,
						familyName	: account.familyName,
						givenName	: account.givenName,
					},
					gender 		: account.gender,
					email 		: account.email,
					birth		: account.birth,
				};
				var proxy = self.profileWinObj._eventProxy;
				proxy.fireEvent(proxy.EVENT.refresh, { data: formData });
			}
		});
	},
	
	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		// displayNameChanged : 'ProfileController.displayNameChanged',
    },

    //----------------------  Profile View Controllers  ----------------------	
	main : function(param){
		var self = this;
		
        //-----------  Setup Data Package  -----------
        var account = $.dataMgr.get('WOSettings', 'account');
        var carrierInfo = $.configMgr.getCarrierInfo();
		var viewParam = {
			DATA : {
				mobilePrefix	: '+' + carrierInfo.mobileCountryCode,
				familyName 	: account.familyName,
				givenName 	: account.givenName,
				gender 		: account.gender,
				birth 	    : account.birth,
				email 		: account.email,
				nameOrder   : account.nameOrder || 0,
			},
			tabGroupObj		: param.tabGroupObj,
		};
        //----  Load & Render View with viewParam ----
		var winObj = App.Helper.loadView('profile/ProfileWindow', viewParam);
		var proxy = winObj.getEventProxy();
		winObj.render();
        //----------  Setup Event handlers  ----------
		// proxy.addEventListener(proxy.EVENT.signup, _doSignup);
		proxy.addEventListener(proxy.EVENT.updateProfile, _doUpdateProfile);
		// proxy.addEventListener(proxy.EVENT.change, _test);
		// proxy.fireEvent(proxy.EVENT.setMode, { mode : 'display' });
        //----------  Return Window Object  ---------- 
        self.profileWinObj = winObj;
        return winObj;
        
        function _doUpdateProfile(evt) {
        	var account = $.dataMgr.newModel('WOSettings', 'account');
        	account.fetch();
        	
        	var oldFname = account.data.familyName;
        	var oldGname = account.data.givenName;
        	var oldDisplay = App.Helper.getDisplayName(account.data.nameOrder, oldFname, oldGname);
        	var newFname = evt.profile.familyName;
        	var newGname = evt.profile.givenName;
        	var newDisplay = App.Helper.getDisplayName(evt.profile.nameOrder, newFname, newGname);
        	
        	var nameRealChanged = false;
        	var nameOrderChanged = false;
        	var profileRealChanged = false;
        	for(var key in evt.profile) {
        		if(('familyName' == key || 'givenName' == key) && (account.data[key] != evt.profile[key])) nameRealChanged = true;
        		if('nameOrder' == key && account.data[key] != evt.profile[key]) nameOrderChanged = true;
        		if(account.data[key] != evt.profile[key]) profileRealChanged = true;
        		account.data[key] = evt.profile[key];
        	}
        	if(nameOrderChanged || nameRealChanged) {
        		$.prefMgr.set('cardDisplayName', newDisplay);
        		//Check cards.
        		var _cards = [];
        		var _cardMgr = $.dataMgr.newModel('WOCard');
				_cardMgr.fetchAll();
				for(var i=0; i < _cardMgr.list.length; i++) {
					var _card = _cardMgr.nth(i);
					var _cardData = _card.p2l();
					if(_cardData.canModDisplay && (_cardData.isPerkdID || _cardData.display.toLowerCase() == oldDisplay.toLowerCase())) {
						if('undefined' != typeof _card.data.profile.display_name
						|| ('undefined' != typeof _card.data.profile.fname && 'undefined' != typeof _card.data.profile.gname)) {
							_card.data.display = newDisplay;
							if('undefined' != typeof _card.data.profile.display_name) _card.data.profile.display_name = newDisplay;
							if('undefined' != typeof _card.data.profile.fname && 'undefined' != typeof _card.data.profile.gname) {
								_card.data.profile.fname = newFname;
								_card.data.profile.gname = newGname;
							}
							if(_cardData.isPerkdID){
								_card.save();
							}
							else _cards.push(_card);
						}
					}
				}
				if(_cards.length > 0) { // if detected cards have old display name.
					var dialog = Ti.UI.createAlertDialog({
						message		: String.format(App.Helper.L('ALERT_AUTOCHANGECARDNAME'), _cards.length),
						buttonNames	: [App.Helper.L('BUTTON_NO'), App.Helper.L('BUTTON_CHANGE')],
					});
					//---  Handle Action button  ---
					dialog.addEventListener('click', function(evt){
						if(1 == evt.index) {
							// Ti.App.fireEvent(self.EVENT.displayNameChanged, {
								// data : {
									// oldName : {
										// display : oldDisplay,
										// fname : oldFname,
										// gname : oldGname,
									// },
									// newName : {
										// display : newDisplay,
										// fname : newFname,
										// gname : newGname,
									// },
								// }
							// });
							for(var i=0; i<_cards.length; i++) _cards[i].save();
						}
						
						account.save();
						$.app.notify({message: App.Helper.L('profileform_updated')});
						if(nameRealChanged) 
		        			Ti.App.fireEvent($.syncMgr.EVENT.doSyncObjects, { objTypes : ['WOSettings', 'WOCard'] }); //Card Display Name will be Changed.
		        		else 
		        			Ti.App.fireEvent($.syncMgr.EVENT.doSyncObjects, { objTypes : ['WOSettings'] });
					});
					dialog.show();
				} else {
					account.save();
					$.app.notify({message: App.Helper.L('profileform_updated')});
					if(nameRealChanged) 
	        			Ti.App.fireEvent($.syncMgr.EVENT.doSyncObjects, { objTypes : ['WOSettings', 'WOCard'] }); //Card Display Name will be Changed.
	        		else 
	        			Ti.App.fireEvent($.syncMgr.EVENT.doSyncObjects, { objTypes : ['WOSettings'] });
				}
        	} else {
	        	if(profileRealChanged) {
	        		account.save();
	        		$.app.notify({message: App.Helper.L('profileform_updated')});
	        		
	        		if(nameRealChanged) 
	        			Ti.App.fireEvent($.syncMgr.EVENT.doSyncObjects, { objTypes : ['WOSettings', 'WOCard'] }); //Card Display Name will be Changed.
	        		else 
	        			Ti.App.fireEvent($.syncMgr.EVENT.doSyncObjects, { objTypes : ['WOSettings'] });
	        	}
        	}
        }
        
        // function _test(evt) {
        	// alert(evt);
        	// proxy.fireEvent(proxy.EVENT.refresh, { data : formData });
        // }
	},
	
});

module.exports = ProfileController;

//---  End of file: ProfileController.js
