
Ti.include('/globals.js');

var RewardsController = App.Class(App.Controller.WOManager, {
	className : 'RewardsController',
    alias     : 'reward', 

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
	},
	
	/*
	 * param.cardID
	 */
	list : function(param){
		var self = this;
		
		var rewardsets = $.dataMgr.getRelated('WOCard', param.data.cardID, 'WORewardset', {
			order : { 'instance.updated' : 'DESC', 'instance.created' : 'DESC' }
		});
		var total = rewardsets.length;
		
		if(1 == total) {
			$.app.isDND = false;
			var detailWin = $.app.route({
				url			: 'reward/detail', 
				data		: {
					cardID		: param.data.cardID,
					aRewardset	: rewardsets[0],
				},
				tabGroupObj	: param.tabGroupObj,
			});
			
		} else if(total > 1) {
			
			var setNo = {};
			for(var i=rewardsets.length-1; i >= 0; i--) {
				var collectedStamps = 0;
				var totalRequiredStamps = 0;
				var totalStamps = 0;
				
				var aSet = rewardsets[i];
				var masterID = aSet.masterID;
				if(!(masterID in setNo)) setNo[masterID]={ num : 0, total : 0 , indexs : [] };
								
				setNo[masterID].num++
				setNo[masterID].total++;
				setNo[masterID].indexs.push(i);
				
				var isChecking = false;
				var isFinished = true;
				for(var j=0; j < rewardsets[i].level.length; j++) {
					var aLevel = aSet.level[j];
					totalRequiredStamps += aLevel.offer.collectStamp || aLevel.stamp.length;
					collectedStamps += aLevel.collectedStamps;
					totalStamps += aLevel.stamp.length;
					if(!isChecking) isChecking = aLevel.isChecking;
					if(isFinished) isFinished = aLevel.isFinished; 
				}
				
				rewardsets[i].DATA = {
					setNo	: setNo[masterID].num,
					collectedStamps : collectedStamps,
					totalRequiredStamps	: totalRequiredStamps,
					totalStamps	: totalStamps,
					isChecking : isChecking,
					isFinished : isFinished,
				};
			}
			
			for(var masID in setNo) {
				if(1 == setNo[masID].total) {
					var index = setNo[masID].indexs[0];
					rewardsets[index].DATA.setNo = 0;
				}
			}

			//-----------  Setup Data Package  -----------
			var viewParam = {
				DATA		: {
					cardID		: param.data.cardID,
					rewardsets 	: rewardsets,
				},
				tabGroupObj	: param.tabGroupObj,
			};
			//----  Load & Render View with viewParam ----
			var winObj = App.Helper.loadView('reward/RewardsListWindow', viewParam);
			var proxy = winObj.getEventProxy();
			winObj.render();
			//----------  Setup Event handlers  ----------
//			proxy.addEventListener(proxy.EVENT.rowClicked, _goViewRewardset);
			proxy.addEventListener(proxy.EVENT.rowClicked, (function(){
				return (function (evt) {
					$.app.isDND = false;
					var detailWin = $.app.route({
						url			: 'reward/detail', 
						tabGroupObj	: winObj.tabGroupObj,
						data		: {
							cardID		: param.data.cardID,
							aRewardset	: $.dataMgr.get('WORewardset', evt.data.id),
						},
					});
				});
			})());

			//------------  Event Handlers  --------------
			function _goViewRewardset(evt) {
				$.app.isDND = false;
				var detailWin = $.app.route({
					url			: 'reward/detail', 
					tabGroupObj	: winObj.tabGroupObj,
					data		: {
						cardID		: param.data.cardID,
						aRewardset	: $.dataMgr.get('WORewardset', evt.data.id),
					},
				});
				// detailWin.papa.addEventListener('cancel', function(evt){
					// view.close();
				// });
			};
			
			//----------  Return Window Object  ---------- 
			return winObj;
			
		} else {
			
			return $.app.errorPage();
		}
	},
	
	/*
	 * param.cardID
	 * param.aRewardset
	 */
	detail : function(param){
		var self = this;
		
		//-----------  Setup Data Package  -----------
		var viewParam = {
			DATA		: {
				cardID 		: param.data.cardID,
				aRewardset 	: param.data.aRewardset,
			},
			tabGroupObj	: param.tabGroupObj,
		};
		
		//----  Load & Render View with viewParam ----
		var winObj = App.Helper.loadView('reward/RewardDetailWindow', viewParam);
		var proxy = winObj.getEventProxy();
		winObj.render();
		//----------  Setup Event handlers  ----------
		proxy.addEventListener(proxy.EVENT.clickStamp, function(evt){
			$.app.route({
				url			: 'reward/stamp',
				tabGroupObj	: winObj.tabGroupObj,
				data 		: {
					cardID : param.data.cardID,
					aStamp : evt.aStamp,
				}
			});
		});
		//----------  Return Window Object  ---------- 
		return winObj;
		
		//------------  Event Handlers  --------------
		
	},
	
	/*
	 * param.cardID
	 */
	offerList : function(param){
		var self = this;
		
		//-----------  Setup Data Package  -----------
		var offers = $.dataMgr.getRelated('WOCard', param.data.cardID, 'WOOffer', {
			order : { 'instance.created' : 'DESC' }
		});
		var total = offers.length;		
		var viewParam = {
			DATA 	: {
				cardID : param.data.cardID,
				offers : offers,
			},
			navGroupObj	: param.navGroupObj || undefined,
			tabGroupObj	: param.tabGroupObj || undefined,
		};
		if(offers.length>0) {
			
			//----  Load & Render View with viewParam ----
			var winObj = App.Helper.loadView('reward/OffersWindow', viewParam);
			var proxy = winObj.getEventProxy();
			winObj.render();
			//----------  Setup Event handlers  ----------
			proxy.addEventListener(proxy.EVENT.redeemOffer, (function (){
				return (function (evt) {
					var data = evt.data;
					// data : {
						// cardID : self.DATA.cardID,
						// offerID : anOffer.id,
						// currentPage : self.UI.offerDetailScrollableView.currentPage,
					// };
					var offer = $.dataMgr.newModel('WOOffer', data.offerID);
					offer.doRedeem();
					offer.fetch();
					offerData = offer.p2l();
					proxy.fireEvent(proxy.EVENT.doRefresh, {
							data : {
								page : data.currentPage,
								anOffer : offerData,
							}
					});
					
					Ti.App.fireEvent($.syncMgr.EVENT.doSyncObjects, {
			        	objTypes	: [ 'WOOffer']
			        });
					
					//View coupon
					var _viewParam = {
						DATA : {
							title	: App.Helper.L('TITLE_REDEEMOFFER'),
							anOffer	: offerData,
						},
						effect		: App.Const.WINDOW.effect.flip,
					};
					var _winObj= App.Helper.loadView('reward/OffersRedeem', _viewParam);
					var _proxy = _winObj.getEventProxy();
					_winObj.render();
					_winObj.open();
					
				});	
			})());
//			proxy.addEventListener(proxy.EVENT.unlockOffer, _doUnlockOffer);
			proxy.addEventListener(proxy.EVENT.unlockOffer, (function (){
				return (function (evt) {
					var data = evt.data;
					
					var _viewParam = {
						DATA : {
							title : App.Helper.L('TITLE_UNLOCKOFFER'),
							passwords : data.passwords,
						},
						effect		: App.Const.WINDOW.effect.flip,
					};
					var _winObj= App.Helper.loadView('reward/OffersUnlock', _viewParam);
					var _proxy = _winObj.getEventProxy();
					_winObj.render();
					_winObj.open();
					
					_proxy.addEventListener(_proxy.EVENT.passedCheck, function(evt){
						var offer = $.dataMgr.newModel('WOOffer', data.offerID);
						offer.doUnlock();
						offer.fetch();
						proxy.fireEvent(proxy.EVENT.doRefresh, {
							data : {
								page : data.currentPage,
								anOffer : offer.p2l(),
							}
						});
						_winObj.close({ animated : true });
					});
					
					Ti.App.fireEvent($.syncMgr.EVENT.doSyncObjects, {
			        	objTypes	: [ 'WOOffer']
			        });
				});				
			})());
			
			//----------  Return rendered View  ---------- 
			return winObj;
		
			//------------  Event Handlers  --------------
			function _doRedeemOffer(evt) {
				
				var data = evt.data;
				// data : {
					// cardID : self.DATA.cardID,
					// offerID : anOffer.id,
					// currentPage : self.UI.offerDetailScrollableView.currentPage,
				// };
				var offer = $.dataMgr.newModel('WOOffer', data.offerID);
				offer.doRedeem();
				offer.fetch();
				offerData = offer.p2l();
				proxy.fireEvent(proxy.EVENT.doRefresh, {
						data : {
							page : data.currentPage,
							anOffer : offerData,
						}
				});
				
				Ti.App.fireEvent($.syncMgr.EVENT.doSyncObjects, {
		        	objTypes	: [ 'WOOffer']
		        });
				
				//View coupon
				var _viewParam = {
					DATA : {
						title	: App.Helper.L('TITLE_REDEEMOFFER'),
						anOffer	: offerData,
					},
					effect		: App.Const.WINDOW.effect.flip,
				};
				var _winObj= App.Helper.loadView('reward/OffersRedeem', _viewParam);
				var _proxy = _winObj.getEventProxy();
				_winObj.render();
				_winObj.open();
			}
			
			function _doUnlockOffer(evt) {
				
				var data = evt.data;
				
				var _viewParam = {
					DATA : {
						title : App.Helper.L('TITLE_UNLOCKOFFER'),
						passwords : data.passwords,
					},
					effect		: App.Const.WINDOW.effect.flip,
				};
				var _winObj= App.Helper.loadView('reward/OffersUnlock', _viewParam);
				var _proxy = _winObj.getEventProxy();
				_winObj.render();
				_winObj.open();
				
				_proxy.addEventListener(_proxy.EVENT.passedCheck, function(evt){
					var offer = $.dataMgr.newModel('WOOffer', data.offerID);
					offer.doUnlock();
					offer.fetch();
					proxy.fireEvent(proxy.EVENT.doRefresh, {
						data : {
							page : data.currentPage,
							anOffer : offer.p2l(),
						}
					});
					_winObj.close({ animated : true });
				});
				
				Ti.App.fireEvent($.syncMgr.EVENT.doSyncObjects, {
		        	objTypes	: [ 'WOOffer']
		        });
			}
		}
		return $.app.errorPage();			//  FIXME  [ZJ]
	},
	
	redeem : function(param){ //TODO [ZJ] redeem : function(param){
		var self = this;
		
		var winObj = App.Helper.loadView('reward/RedeemWindow', param);
		return winObj();
	},

	stamp : function(param) {
		var self = this;
		
		//-----------  Setup Data Package  -----------
		var viewParam = {
			DATA		: { 
				cardID 	: param.data.cardID,
				aStamp 	: param.data.aStamp,
			},
			tabGroupObj	: param.tabGroupObj,
		};
		
		//----  Load & Render View with viewParam ----
		var winObj = App.Helper.loadView('reward/StampDetailWindow', viewParam);
		winObj.render();
		//----------  Setup Event handlers  ----------
	
		//----------  Return rendered View  ---------- 
		return winObj;
	
		//------------  Event Handlers  --------------
	},
	
	/*
	 * param.cardID
	 */
	points : function(param){
		var self = this;
		
		//-----------  Setup Data Package  -----------
		// var points = $.dataMgr.getRelated('WOCard', param.cardID, 'WOPoints');

		var viewParam = {
			DATA 	: {
				cardID 		: param.data.cardID,
				points 		: $.dataMgr.getRelated('WOCard', param.data.cardID, 'WOPoints', {
					order : {'instance.transacted':'DESC'},
				}),
				
				pointsState : {
					// TODO [ZJ] 
				},
			},
			tabGroupObj	: param.tabGroupObj,
		};
		// if(offers.length>0) {
			
			//----  Load & Render View with viewParam ----
			var winObj = App.Helper.loadView('points/PointsWindow', viewParam);
			winObj.render();
			//----------  Setup Event handlers  ----------
		
			//----------  Return rendered View  ---------- 
			return winObj;
		
			//------------  Event Handlers  --------------
		// }
		// return $.app.errorPage();
	},
});

module.exports = RewardsController;

//---  End of file: RewardsController.js
