/**
 * Produces Form Objects from: form definition + form data + styles
 * 
 * @author zhoujun@waveo.com
 */
Ti.include('/globals.js');

var CardAddForm = App.Class(App.WOForm, {
	className : 'CardAddForm',

	getHeaderView : function(header){
		var self = this;
		
		var headerView = Ti.UI.createView(self.STYLE.view_formHeader);
		var cardFrame = Ti.UI.createView(self.STYLE.view.cardFrame);
		self.cardView = self._drawCard(cardFrame);
		headerView.add(cardFrame);
		if(self.DATA.cardMaster.isDigital) headerView.add(self.base(header));
		// if(true) headerView.add(self.base(header));   // TODO [ZJ] : Temporary for testing
		return headerView;
	},
	
	_drawCard : function(theView) {
		var self = this;
		if(self.DATA.cardMaster.id == App.Config.CUSTOM_CID){
			self.DATA.cardMaster.frontName = self.DATA.cardMaster.brandName;
		}
		var cardDefn = {
			name		: self.DATA.cardMaster.name,
			style		: self.STYLE.view.cardFace,
			properties 	: {
				cardObj			: self.DATA.cardMaster,
				format			: $.cardMgr.factory.FORMAT.standard,
				cardFront		: true,
				shadow			: true,
				showName		: true,
			},
		};
		var cardData = {};
		self.cardWidget = $.cardMgr.factory.make(cardDefn, cardData);
		self.cardWidget.setMode('display');
		
		self.cardWidget.parent = theView;		// required by animateAddCard()  !!!
		
		var cardView = self.cardWidget.getView();
		theView.add(cardView);

		return cardView;
	},
	
	//---  Get Card Widget OBj from form and 'pass-on' it on for animation, eg. by animateCardAdd()
	getCardWidget : function(){
		var self = this;
		//  REMEMBER:  card animation controller can remove the view from it's original parent view:
		//  self.cardObj.parent.remove(self.cardView);
		return self.cardWidget;
	},
});

module.exports = CardAddForm;

//---  End of file: CardAddForm.js
