/**
 * Produces Form Objects from: form definition + form data + styles
 * 
 * @author zhoujun@waveo.com
 */
Ti.include('/globals.js');
if (App.Config.IS_ANDROID) {
Ti.include('/waveo/core/WOAndroidUtils.js');
}

var CardEditForm = App.Class(App.WOForm, {
	className : 'CardEditForm',

	getFooterView : function(footer){
		var self = this;
		
	//	var footerView = Ti.UI.createView(self.STYLE.view_formFooter);
	//	footerView.add(self.base(footer));
		var footerView = self.base(footer);
		
		var deleteBtn = Ti.UI.createButton(self.STYLE.btn.deleteCard);
		deleteBtn.title = App.Helper.L('delete_card');
		footerView.add(deleteBtn);
		
		deleteBtn.addEventListener('touchstart', function(){
			deleteBtn.backgroundGradient = self.STYLE.buttonSelectGradient;
		});
		deleteBtn.addEventListener('touchend', function(){
			deleteBtn.backgroundGradient=self.STYLE.buttonGradient;
		});
		deleteBtn.addEventListener('click', function(evt){
			if (App.Config.IS_ANDROID) {
				if (checkIfButtonWasClickedThenDisableForShortPeriod
					(evt.source,1000)) {
						return;
					}
			}
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			self._eventProxy.fireEvent(self._eventProxy.EVENT.deleteCard, { cardID : self.DATA.aCard.id, viewClick: evt.source });				
		});
		return footerView;
	},
});

module.exports = CardEditForm;

//---  End of file: CardEditForm.js
