 /**
 * AccountMgtStyle
 */
var WOStyle = require('/waveo/perkd/styles/WOStyle');

AccountMgtStyle.className = 'AccountMgtStyle';

AccountMgtStyle.STYLE = {
//style must exist and would be used in WOWindow
	baseWindow :WOStyle.STYLE.baseWindow,
	navGroup :WOStyle.STYLE.navGroup,
	window : WOStyle.STYLE.window,
	windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.STYLE.titlebarShadowContainer,
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,
	
	buttonGradient: WOStyle.BUTTON_BG.alert,
	buttonSelectGradient: WOStyle.BUTTON_BG.alertSelected,
	buttonGradient_main: WOStyle.BUTTON_BG.main,
	buttonGradient_mainSelected: WOStyle.BUTTON_BG.mainSelected,
	
	LINE2:	{backgroundColor: '#1363C0', top: '0', left:'80dp', width: '1dp', height:'100%'},
	LINE3:	{backgroundColor: '#4D9EF8', top: '0', left:'81dp', width: '1dp', height:'100%'},

	view :{
		scrollableBg: WOStyle.STYLE.scrollableBg,
		canvas	: {
        	top:0, left:'0', right:'0',
        	height: Ti.UI.SIZE,
        	layout: 'vertical',
    	},
		canvas_absolute	: {
        	top:0, left:'15dp', right:'15dp',
	       	height:'100%',
 	      	layout: 'composite',
    	},

		flexFooter: WOStyle.STYLE.flexFooter,

		mobileNo:{
			left:'0', right:'0', top:'0', height: Ti.UI.SIZE,
			layout: 'vertical',
		},
		enterMobileNoBg : {
			height:'45dp', top: '8dp', layout: 'composite',
			borderRadius: WOStyle.DEVICEDP.dp10,
			borderWidth: WOStyle.DEVICEDP.dp1,
			borderColor: '#4d4d4d',
			backgroundColor:'#53000000',			
		},
		enterCountryCode : {
			height:'40dp', top: '5dp', layout: 'composite',
			borderRadius: WOStyle.DEVICEDP.dp6,
			borderWidth: WOStyle.DEVICEDP.dp1,
			borderColor: '#2990FE',
			backgroundGradient: {
				type:'linear', colors:['#2990FE','#0056E5'],
				startPoint:{x:0,y:0}, endPoint:{x:0,y:'100%'},
				backFillStart:false
			},
		},
		arrow: {
			right:'8dp', width:'16dp', heigh:'16dp',
			image: '/assets/images/buttons/next.png',
		},
		verification : {
			left:'0', right:'0', top:'0', height:'115dp',
			layout: 'vertical', opacity: 0,
		},
		verificationcode : {
			left:0, right:0, top:'5dp', textAlign: 'left',
			borderRadius: WOStyle.DEVICEDP.dp10,
			borderWidth: WOStyle.DEVICEDP.dp1,
			borderColor:'#4d4d4d',
			backgroundColor:'#53000000', 
		},
		password : {
			left:0, right:0, top:'60dp', 
			borderRadius: WOStyle.DEVICEDP.dp10,
			borderWidth: WOStyle.DEVICEDP.dp1,
			borderColor:'#4d4d4d',
			backgroundColor:'#53000000', 
			height: Ti.UI.SIZE,
			layout: 'vertical'
		},
	},
	title:{
		L3c : {
			top:'3dp', height: '40dp', left:0,
			font: WOStyle.FONT.b15, color:'white', opacity: 0.8,  
			textAlign: 'left', 
			width: '50%',
		},
	},
	label:{
		mobileLabel :{
			top:'35dp', left:'25dp',
			font:WOStyle.FONT.n15, 
			color:'#FFFFFF', opacity:0.5,
			textAlign:'left',
		},
		mobileNo :{
			top:'8dp', left:'25dp', right:'25dp',
			font:WOStyle.FONT.b35,
			minimumFontSize: '28sp',
			color:'#FFFFFF',
			textAlign:'left',
		},
		tips :{
			top:'0', left:'25dp', right:'25dp',
			font:WOStyle.FONT.n15,
			color:'#FFFFFF', opacity:0.6,
			textAlign:'left',
		},
		desc :{
			font:WOStyle.FONT.n18, touchEnabled:false, color:'#FFFFFF', opacity:0.5,
			height:Ti.UI.SIZE, top:'35dp', left:'5dp', right:'5dp', textAlign:'left',
		},
		manageAction : {
			left:'10dp', 
			font: WOStyle.IS_ANDROID ?  WOStyle.FONT.b20 : WOStyle.FONT.n20, 
			color: '#FFFFFF', opacity:0.6,
			textAlign:'left', touchEnabled:false
		},
		codeResend: {
			right: '50dp', top: '195dp',
			font: WOStyle.IS_ANDROID ?  WOStyle.FONT.b18 : WOStyle.FONT.n18, 
			color: '#FFFFFF', opacity: 1,
			textAlign:'right', width:Ti.UI.SIZE,
		},
	},

	tableView: WOStyle.merge(WOStyle.STYLE.tableView, {
		left: '12dp',
		right:'12dp',
		width: null,
		height:  WOStyle.IS_ANDROID? '100dp' : '125dp',
		top: WOStyle.IS_ANDROID? '20dp': 0,
	}),
	tableRow:{
		backgroundColor:'#53000000',
		backgroundSelectedColor: '#0272ED',
		color:'#FFFFFF', height: '45dp',
		selectionStyle: WOStyle.IS_ANDROID ? null : Ti.UI.iPhone.TableViewCellSelectionStyle.BLUE,
		hasChild:true
	},
	textfield:{
		oldPSW: WOStyle.merge(WOStyle.TEXTFIELD_PASSWORD, {
			hintText:App.Helper.L('account_label_oldPassword'), height:'45dp',
			returnKeyType:Ti.UI.RETURNKEY_NEXT,
		}),
		newPSW: WOStyle.merge(WOStyle.TEXTFIELD_PASSWORD, {
			hintText:App.Helper.L('account_label_newPassword'), height:'45dp',
			returnKeyType:Ti.UI.RETURNKEY_NEXT,
		}),
		confirmPSW: WOStyle.merge(WOStyle.TEXTFIELD_PASSWORD, {
			hintText:App.Helper.L('account_label_confirmPassword'), height:'45dp',
			returnKeyType:Ti.UI.RETURNKEY_GO,
		}),
		mobile: WOStyle.merge(WOStyle.TEXTFIELD_MOBILE, {
			returnKeyType:Ti.UI.RETURNKEY_GO, top: WOStyle.IS_ANDROID ? 0:'4dp',
			font:WOStyle.FONT.n30, height: WOStyle.IS_ANDROID ?'50dp':'40dp',
		}),
		verificationcode: WOStyle.merge(WOStyle.TEXTFIELD_PASSWORD, {
			returnKeyType:Ti.UI.RETURNKEY_GO, height:'45dp',
			font:WOStyle.FONT.b24, textAlign: 'center',
		}),
		HIDDEN: WOStyle.TEXTFIELD_HIDDEN,
	},
	seprator:{
			 left:0, right:0, top:0, height:'1dp',
			backgroundColor:'#4d4d4d'
	},
	
	btn: {
	 	logout: WOStyle.merge(WOStyle.STYLE.btn.alert, {
	 		width:'210dp',
		}),
		submitCode: WOStyle.merge(WOStyle.STYLE.btn.main, {
			left:'40dp',  right: '40dp', top: '135dp',
			height: '40dp', opacity: 0,
		}),
		cancel: WOStyle.SYSTEMBUTTON.CANCEL,
	},

	btnLabel :{
		countryCode:	{font: WOStyle.FONT.b20, textAlign: 'center', color: '#FFFFFF', touchEnabled: false, left: '0', width: '80dp'},
		countryName:	{font: WOStyle.FONT.b20, minimumFontSize: '14sp', textAlign: 'center', color: '#FFFFFF', touchEnabled: false, right: '24dp', left: '85dp'}

	},
};

function AccountMgtStyle(param){
}

module.exports = AccountMgtStyle;

//---  End of file: AccountMgtStyle.js
