
/**
 * AuthStyle
 */

var WOStyle = require('/waveo/perkd/styles/WOStyle');
var FormStyle = require('/waveo/perkd/styles/FormStyle');

AuthStyle.className = 'AuthStyle';
AuthStyle.TITLE = {}, //TOBEDELETED

AuthStyle.VIEW = WOStyle.merge(WOStyle.STYLE.scrollBg,{backgroundColor: '#FFBA00',});
AuthStyle.CANVAS = WOStyle.merge(WOStyle.STYLE.canvas,{top:null, left:'16dp', right:'16dp',});

//text style
AuthStyle.H1 = {
	left:0, right:0, top:  WOStyle.IS_ANDROID ? '10dp' : 0, height:Ti.UI.SIZE,
	font: WOStyle.FONT.b35, textAlign:'center', color:'#FFFFFF',
};
AuthStyle.H2 = {
	left:0, right:0, top: '35dp', bottom: '5dp',
	textAlign:'left', height:Ti.UI.SIZE, color:'#FFFFFF',
	font: WOStyle.FONT.b20, opacity: 0.8,
};

AuthStyle.DESC = {
	left:0, right:0, top:0, height:Ti.UI.SIZE,
	textAlign:'left', color:'#FFFFFF', font: WOStyle.FONT.n18, opacity: 0.8, 
};

AuthStyle.LINK = {
	top:'25dp', left:0, width:Ti.UI.SIZE, height:Ti.UI.SIZE,
	font: WOStyle.FONT.b20,	color:'#FFFFFF', opacity:0.6,
	shadowOffset: {x:1,y:1},
};
AuthStyle.BTN_GO = {
	width:'37dp', height:'37dp', right:0,
	backgroundImage: '/assets/images/buttons/go_btn.png',
	backgroundSelectedImage: '/assets/images/buttons/go_btn.png',
};
AuthStyle.BTN_BACK	= {
	left:'10dp', top:'20dp', width:'45dp', height:'32dp',
	backgroundImage: '/assets/images/buttons/back.png',
	backgroundSelectedImage: '/assets/images/buttons/back.png',
	zIndex: 10000,
};
AuthStyle.BTN_LABEL	= {textAlign:'right', right: '10dp', font: WOStyle.FONT.b30, color:'#FFFFFF'};

AuthStyle.FORM = {
	left:0, right:0, width:'100%', height: Ti.UI.SIZE,  top:'12dp',
	backgroundColor: '#FFFFFF',
	borderRadius: WOStyle.DEVICEDP.dp6,
	borderWidth: WOStyle.DEVICEDP.dp1,
	borderColor: '#FFFFFF',
	layout : 'vertical',
};
AuthStyle.FORM_LINE = {
	backgroundColor: '#E1E1E1',
	left: 0, right: 0, top: '-1dp', width: '100%', height:'1dp',
};
AuthStyle.TEXTFIELD = {
	left: WOStyle.IS_ANDROID ? '0' : '8dp',  right: WOStyle.IS_ANDROID ? '0' : '6dp',
	top: WOStyle.IS_ANDROID ? '0' : '2dp', height:'40dp',
	color: '#000000', font: WOStyle.IS_ANDROID? WOStyle.FONT.b20 : WOStyle.FONT.n20,
	backgroundColor: 'transparent',
	borderWidth: 0, borderColor: 'transparent', borderStyle:Ti.UI.INPUT_BORDERSTYLE_NONE,
	softKeyboardOnFocus: WOStyle.IS_ANDROID ? Ti.UI.Android.SOFT_KEYBOARD_SHOW_ON_FOCUS : null,
	clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
	touchEnabled: true,	autocorrect: false,
	returnKeyType: Ti.UI.RETURNKEY_NEXT,
};

AuthStyle.TEXTFIELD_MOBILE = WOStyle.merge(AuthStyle.TEXTFIELD, {
	top: WOStyle.IS_ANDROID ? '0' : '4dp',
	keyboardType: WOStyle.IS_ANDROID? Ti.UI.KEYBOARD_PHONE_PAD : Ti.UI.KEYBOARD_NUMBERS_PUNCTUATION,
	hintText: App.Helper.L('account_label_mobilePhoneNumber'),
});

AuthStyle.TEXTFIELD_PASSWORD = WOStyle.merge(AuthStyle.TEXTFIELD, {
	keyboardType: WOStyle.IS_ANDROID? Ti.UI.KEYBOARD_DEFAULT : Ti.UI.KEYBOARD_NUMBERS_PUNCTUATION,
	passwordMask: true, returnKeyType:	Ti.UI.RETURNKEY_GO, hintText: App.Helper.L('auth_PASSWORD'),
});


AuthStyle.STYLE = {
	SCREEN :{
		width: WOStyle.DEVICE.width,
		height: WOStyle.DEVICE.height,
	},
    baseWindow :  WOStyle.STYLE.baseWindow,
    navGroup :  WOStyle.STYLE.navGroup,
	window : WOStyle.merge(WOStyle.STYLE.window, {
        backgroundColor:'#FFBA00',
        backgroundImage: null,
	}),
	buttonGradient: WOStyle.BUTTON_BG.main,
	buttonSelectGradient: WOStyle.BUTTON_BG.mainSelected,
	buttonGradient_sub: WOStyle.BUTTON_BG.sub,
	buttonSelectGradient_sub: WOStyle.BUTTON_BG.subSelected,
	TEXTFIELD_HIDDEN: WOStyle.TEXTFIELD_HIDDEN,
	activityIndicator:	WOStyle.STYLE.activityIndicator,
	toolBar:		WOStyle.STYLE.toolBar,
	datePickerArea: WOStyle.STYLE.datePickerArea,
	datePickerPanel: WOStyle.STYLE.datePickerPanel,

//Country Code
	selector:{
		view :	WOStyle.merge(WOStyle.STYLE.btn.main, {height:'40dp', top: '0', bottom: '-4dp', layout: 'composite'}),	
		LINE1:	{backgroundColor: '#1363C0', top: '0', left:'80dp', width: '1dp', height:'100%'},
		LINE2:	{backgroundColor: '#4D9EF8', top: '0', left:'81dp', width: '1dp', height:'100%'},
		arrow:	{right:'8dp', width:'16dp', heigh:'16dp', image: '/assets/images/buttons/next.png'},
		countryCode:	{font: WOStyle.FONT.b20, textAlign: 'center', color: '#FFFFFF', touchEnabled: false, left: '0', width: '80dp'},
		countryName:	{font: WOStyle.FONT.b20, minimumFontSize: '14sp', textAlign: 'center', color: '#FFFFFF', touchEnabled: false, right: '24dp', left: '85dp'}
	},
	
	goNext: {
		view:		{right:'5dp', top:'25dp', bottom:'10dp', height:'38dp', layout: 'horizontal', width: Ti.UI.SIZE},
		btnLabel:	{textAlign:'right', right:'15dp', top: WOStyle.IS_CH? '7dp' : '5dp', width: Ti.UI.SIZE, font: WOStyle.FONT.b30, color:'#FFFFFF'},
		btn:		AuthStyle.BTN_GO,
	},

	btn: {
		flexSpace : WOStyle.SYSTEMBUTTON.FLEXIBLE_SPACE,
		done : WOStyle.SYSTEMBUTTON.DONE,
		clear : WOStyle.SYSTEMBUTTON.CLEAR,
	},
// Login View
	Login:{
		view:		AuthStyle.VIEW,
		canvas:		AuthStyle.CANVAS,
		H1:			WOStyle.merge(AuthStyle.H1, {textAlign: 'left'}),
		H2:			AuthStyle.H2,
		link:		AuthStyle.LINK,

		form:		WOStyle.merge(AuthStyle.FORM, {top:0, right: '50dp', width:'auto'}),
		separetor:	AuthStyle.FORM_LINE,
		signupBtn:	WOStyle.merge(WOStyle.STYLE.btn.main, {left: 0, right: '50dp'}),
		loginFrame:	{height: Ti.UI.SIZE, layout: 'composite'},
		loginBtn:	WOStyle.merge(AuthStyle.BTN_GO, {top: WOStyle.IS_ANDROID ? '34dp' : '22dp',}),		

		F_Mobile:	WOStyle.merge(AuthStyle.TEXTFIELD_MOBILE, {font: WOStyle.FONT.n30, height: WOStyle.IS_ANDROID ?'50dp':'40dp'}),
		F_Password:	WOStyle.merge(AuthStyle.TEXTFIELD_PASSWORD, {font: WOStyle.FONT.n30, height: WOStyle.IS_ANDROID ?'50dp':'40dp'}),

		backBtn:	AuthStyle.BTN_BACK,
	},
	PerkdLogin:{
		link:		WOStyle.merge(AuthStyle.LINK, {bottom: '50dp'}),
	},
// Sign Up Window
	Signup:{
		view:		AuthStyle.VIEW,
		canvas:		AuthStyle.CANVAS,
		backBtn:	AuthStyle.BTN_BACK,

		H1:			WOStyle.merge(AuthStyle.H1, {left: '10dp'}),
		H2:			WOStyle.merge(AuthStyle.H2, {top: '20dp'}),
		form:		AuthStyle.FORM,
		separetor:	AuthStyle.FORM_LINE,

		formLabel:	{left:0, width:'110dp', height:'40dp', font: WOStyle.IS_ANDROID? WOStyle.FONT.b20 : WOStyle.FONT.n20, color:'#AAAAAA', textAlign:'left'},
		formField:	{height:Ti.UI.SIZE, layout: 'composite', left: '10dp', right: '10dp'},
		
		F_GivenName:	WOStyle.merge(AuthStyle.TEXTFIELD, {
						autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS, hintText: App.Helper.L('auth_GIVENNAME')}),
		F_FamilyName:	WOStyle.merge(AuthStyle.TEXTFIELD, {
						autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS, hintText: App.Helper.L('auth_FAMILYNAME')}),
		F_Birth:		{right:0, height:'40dp', font: WOStyle.IS_ANDROID? WOStyle.FONT.b20 : WOStyle.FONT.n20, color:'#000000', textAlign:'right', touchEnabled:false},
		F_Gender:		WOStyle.STYLE.tabbedBar.gender,
		F_Mobile:		WOStyle.merge(AuthStyle.TEXTFIELD_MOBILE, {
						font: WOStyle.FONT.n30,  height: WOStyle.IS_ANDROID ?'50dp':'40dp', returnKeyType:  Ti.UI.RETURNKEY_GO}),
	},
	
	Reason:{ //used fir Srartup window & Later Window
		view:		AuthStyle.VIEW,
		canvas:		AuthStyle.CANVAS,
		backBtn:	AuthStyle.BTN_BACK,

		H1:			AuthStyle.H1,
		title:		WOStyle.merge(AuthStyle.H2, {opacity: 1}),
		desc:		WOStyle.merge(AuthStyle.DESC, {font: WOStyle.FONT.b15}),

		frame:		{left:0, right:0, top:0, height:Ti.UI.SIZE},
		image:		{top:'25dp', left:'5dp', width:'72dp', height:'72dp'},
		textBox:	{left:'95dp', right:0, top:0, height:Ti.UI.SIZE, layout: 'vertical',},
	},
	Later:{ //Later Window Only
		H1:			AuthStyle.H1,
		H2:			WOStyle.merge(AuthStyle.H2, {top: 0, textAlign: 'center'}),
		link:		WOStyle.merge(AuthStyle.LINK, {top: '15dp'}),

		title:		WOStyle.merge(AuthStyle.H2, {opacity: 1, top: '25dp'}),
		image:		{top:'15dp', left:'5dp', width:'72dp', height:'72dp'},
		signupBtn:	WOStyle.merge(WOStyle.STYLE.btn.main, {left: '30dp', right: '30dp', top: '20dp'}),
	},	
	Verify:{
		view:		AuthStyle.VIEW,
		canvas:		AuthStyle.CANVAS,

		H1:			AuthStyle.H1,
		H2:			AuthStyle.H2,
		link:		WOStyle.merge(AuthStyle.LINK,{top: '40dp', bottom: '80dp'}),
		form:		WOStyle.merge(AuthStyle.FORM, {top:0, right: '50dp', width:'auto'}),
		frame:		{height: Ti.UI.SIZE, layout: 'composite'},
		verifyBtn:	AuthStyle.BTN_GO,
		
		F_CODE : WOStyle.merge(AuthStyle.TEXTFIELD_PASSWORD, {font: WOStyle.FONT.b24, height: '48dp', hintText: App.Helper.L('auth_ENTERVERIFICATIONHINT'),}),
	},	
	Resend:{
		view:		AuthStyle.VIEW,
		canvas:		AuthStyle.CANVAS,
		backBtn:	AuthStyle.BTN_BACK,
		resendBtn:	WOStyle.merge(WOStyle.STYLE.btn.main, {left: '65dp', right: '65dp', top: '30dp', bottom: '20dp'}),
		
		H1:			AuthStyle.H1,
		desc:		WOStyle.merge(AuthStyle.DESC, {top:'25dp', bottom: '5dp'}),
		form:		AuthStyle.FORM,

		F_Mobile:	WOStyle.merge(AuthStyle.TEXTFIELD_MOBILE, {
					font: WOStyle.FONT.n30, left: '10dp', height: WOStyle.IS_ANDROID ?'50dp':'40dp', returnKeyType:  Ti.UI.RETURNKEY_GO}),

		frame:		{left:'0', top:'0', height:Ti.UI.SIZE, layout: 'horizontal', width: Ti.UI.SIZE, zIndex: 10000,},
		btnLabel:	{textAlign:'left', left:'0', top: WOStyle.IS_ANDROID ?'24dp':'27dp', width: Ti.UI.SIZE, font: WOStyle.FONT.b24, color:'#FFFFFF', zIndex: 10000,},
	},


	PushRequest:{
		view:		AuthStyle.VIEW,
		canvas:		AuthStyle.CANVAS,
		H1:			AuthStyle.H1,
		desc:		WOStyle.merge(AuthStyle.DESC, {left:'18dp', right:'18dp', top: '15dp', textAlign: 'center', font: WOStyle.FONT.n20}),

		todo:			{left:'10dp', right:'10dp', top: 0, height:'80dp', font: WOStyle.FONT.b24, opacity:0.9, color:'#FFFFFF', textAlign: 'center'},
		okBtn:			WOStyle.merge(WOStyle.STYLE.btn.main, {top: '90dp', left:'65dp',  right: '65dp'}),
		continueBtn:	WOStyle.merge(WOStyle.STYLE.btn.main, {top: '95dp',  right:'15dp', width: Math.round(0.38*WOStyle.DEVICE.width)}),
		laterBtn:		WOStyle.merge(WOStyle.STYLE.btn.sub, {top: '95dp', left:'15dp', width: Math.round(0.38*WOStyle.DEVICE.width)}),


		frame:		{top:'35dp', layout: 'composite', height:'180dp'},
		contentBox: {top:0, bottom:0, left:0, right:0, layout: 'composite', height:'180dp'}
	},


	Restore:{
		text:			{left:0, right:0, top:  WOStyle.IS_ANDROID? Math.round(0.3*WOStyle.DEVICE.height) : Math.round(0.35*WOStyle.DEVICE.height),
						font: WOStyle.FONT.b24, opacity:0.9, color:'#FFFFFF', textAlign: 'center',},
		slider:			{width: '60%', min: 0, value: 0, enabled: false,},
		progressBar:	{top:  Math.round(0.42*WOStyle.DEVICE.height), height	:'20dp', width: Math.round(0.6*WOStyle.DEVICE.width),
						opacity	: 0.7,  style	: Ti.UI.iPhone.ProgressBarStyle.BAR},
	},

	Upgrade:{
		text:			{left:0, right:0, top:  WOStyle.IS_ANDROID? Math.round(0.3*WOStyle.DEVICE.height) : Math.round(0.35*WOStyle.DEVICE.height),
						font: WOStyle.FONT.b24, opacity:0.9, color:'#FFFFFF', textAlign: 'center',},
	},

	PerkIDSkipped:{
		view:		AuthStyle.VIEW,
		canvas:		AuthStyle.CANVAS,
		backBtn:	AuthStyle.BTN_BACK,

		H1:			WOStyle.merge(AuthStyle.H1, {font: WOStyle.FONT.b32}),
		link:		WOStyle.merge(AuthStyle.LINK, {left:null}),

		signupBtn:	WOStyle.merge(WOStyle.STYLE.btn.main, {left: '15dp', right: '15dp', top: '35dp'}),

		loginFrame:	{height: Ti.UI.SIZE, layout: 'composite', top: '70dp'},
		desc:		{font: WOStyle.FONT.b18, opacity: 0.8, top:'5dp', left: '5dp', width: Ti.UI.SIZE, color: '#FFFFFF'},
		loginBtn:	WOStyle.merge(WOStyle.STYLE.btn.main, {height: '30dp', width: '90dp', right: 0,}),		
		btnLabel:	{font: WOStyle.FONT.b20, textAlign: 'center', color: '#FFFFFF', touchEnabled: false, right: 0, top:'5dp', width: '90dp'},

	},

};


function AuthStyle(){};

module.exports = AuthStyle;

/**
 * End of file:AuthStyle.js
 */