/**
 * CardDetailStyle
 */

var WOStyle = require('/waveo/perkd/styles/WOStyle');

CardDetailStyle.className = 'CardDetailStyle';

CardDetailStyle.STYLE = {
	
//style must exist and would be used in WOWindow
	baseWindow :WOStyle.STYLE.baseWindow,
	navGroup :WOStyle.STYLE.navGroup,
	window : WOStyle.STYLE.window,
	windowTitle: WOStyle.STYLE.windowTitle,

	buttonGradient: WOStyle.BUTTON_BG.main,
	buttonSelectGradient: WOStyle.BUTTON_BG.mainSelected,
	buttonGradient_sub: WOStyle.BUTTON_BG.sub,
	buttonSelectGradient_sub: WOStyle.BUTTON_BG.subSelected,

	
	view :{
		canvas: WOStyle.merge(WOStyle.STYLE.canvas,{
			height: WOStyle.DEVICE.height, //detuct the toolbar height
		}),
		flexFooter: {
			height: Ti.UI.FILL,
			layout: 'composite',
			top: '-65dp', // toolbar height 444 + 20 status bar height
		},
    	cardFace:{
			top: Math.round(0.065*WOStyle.DEVICE.height),
			width:	WOStyle.DEVICE.width,
			height: '204dp' //TODO should be calculated based on card size
		},
		cardDashboard :{
			 width:'288dp', height:'80dp', //top: WOStyle.IS_ANDROID? '10dp': null,
			 borderRadius: WOStyle.DEVICEDP.dp8,
			 borderWidth: WOStyle.DEVICEDP.dp1,
			 borderColor:'#D04D4D4D',
			 backgroundColor:'#16000000',
			 layout: 'horizontal',
		},
		btnFrame:{
    		width:'72dp', height:'72dp', left:0, top: '4dp',
			borderRadius: WOStyle.DEVICEDP.dp8,
		}
	},
	label :{
		name:{
			font : WOStyle.FONT.b35, minimumFontSize:'18sp',
			textAlign:'center',color:'white', 
			top:'10dp', left:'25dp', right:'25dp', height:'40dp',
		},
		name_android:{
			font : WOStyle.FONT.b24, textAlign:'center',color:'white', 
			top:'10dp', left:'25dp', right:'25dp', height:'50dp',
		},
	    btnLabel : {
	        bottom: '8dp',
	        font: WOStyle.FONT.b15,
			textAlign:'center',
			color:'#FFFFFF',  opacity:0.4, touchEnable: false,
	    },
	    btnValue : {
	       bottom: '23dp',
	       height: '40dp',
	       font: WOStyle.FONT.b35,  minimumFontSize: '21sp',
		   textAlign:'center',  color:'#FFFFFF', touchEnable: false,
	    },
	    manageAccount : {
			left:'10dp', 
			font: WOStyle.IS_ANDROID ?  WOStyle.FONT.b20 : WOStyle.FONT.n20, 
            color: '#FFFFFF', opacity:0.6,
			textAlign:'left', touchEnabled:false
		},
	},
	tableView: WOStyle.merge(WOStyle.STYLE.tableView, {
		height:'95dp',
	}),
	tableRow:{
		backgroundColor:'#53000000',
		backgroundSelectedColor: '#0272ED',
		color:'#FFFFFF',  height:'50dp',
		selectionStyle: WOStyle.IS_ANDROID ? null : Ti.UI.iPhone.TableViewCellSelectionStyle.BLUE,
		hasChild:true
	},
	btn :{
		flexSpace : WOStyle.SYSTEMBUTTON.FLEXIBLE_SPACE,
		fixSpace : WOStyle.SYSTEMBUTTON.FIXED_SPACE,

   		lock: {
   			width:'41dp', height:'41dp', zIndex:999,
			backgroundImage: 'assets/images/buttons/unlocked.png',
   		},
   		main: WOStyle.STYLE.btn.main,
   		sub: WOStyle.STYLE.btn.sub,
	},
	toolBar: WOStyle.STYLE.btnToolBar,
};

		
if(WOStyle.IS_ANDROID){
	CardDetailStyle.STYLE.btn.done = WOStyle.merge (WOStyle.ANDROID_BUTTON, {
		title: App.Helper.L('BUTTON_DONE'), width : '60dp', borderColor: '#79303030', left:'300dp',
		backgroundGradient:{
			type:'linear', 
			colors:[
					{color:'#262626', offset:0.02},
					{color:'#4d4d4d', offset:0.04},
					{color:'#303030', offset:0.05},				
					{color:'#000001', offset:1.0},
				], 
			startPoint:{x:0,y:0}, 
			endPoint:  {x:0,y:'100%'}, 
		},
	});
 	CardDetailStyle.STYLE.btn.cardinfo = WOStyle.merge (WOStyle.ANDROID_IMGBUTTON, {
		image: '/assets/images/buttons/info@2x.png',
		width : '30dp', // backgroundColor: '#79FF0000'
	});

	CardDetailStyle.STYLE.btn.edit = WOStyle.merge (WOStyle.ANDROID_IMGBUTTON, {
		image: '/assets/images/buttons/edit@2x.png',
		width : '30dp',  //backgroundColor: '#79FF0000'
	});

	CardDetailStyle.STYLE.btn.scan = WOStyle.merge (WOStyle.ANDROID_IMGBUTTON, {
		image	: '/assets/images/buttons/scan@2x.png',
		width : '30dp',  //backgroundColor: '#79FF0000'
	});		
}else{
	CardDetailStyle.STYLE.btn.done = WOStyle.SYSTEMBUTTON.DONE;
 	CardDetailStyle.STYLE.btn.cardinfo = WOStyle.SYSTEMBUTTON.ABOUT;

	CardDetailStyle.STYLE.btn.edit = {
		systemButton:Ti.UI.iPhone.SystemButton.PLAIN,
		image: '/assets/images/buttons/edit.png',
		width: '50dp', height: '30dp', 
	};

	CardDetailStyle.STYLE.btn.scan = {
		systemButton: Ti.UI.iPhone.SystemButton.PLAIN,
		image	: '/assets/images/buttons/scan.png',
		width : '30dp', height : '30dp',
	};
};

function CardDetailStyle(param){
}

module.exports = CardDetailStyle;

//---  End of file:CardDetailStyle.js
