/**
 * CardFactoryStyle
 */
var WOStyle = require('/waveo/perkd/styles/WOStyle');

CardFactoryStyle.className = 'CardFactoryStyle';

CardFactoryStyle.STYLE = {
	thumbnail	: {
		imageFrame	: { width: '72dp', height: '45dp', top:'5dp', left:'8dp', borderRadius: WOStyle.DEVICEDP.dp6, touchEnabled: false,},
		image		: { width: '72dp', height: '45dp', borderRadius: WOStyle.DEVICEDP.dp6,  touchEnabled: false,},
		back		: { width: '72dp', height: '45dp', borderRadius: WOStyle.DEVICEDP.dp6, backgroundColor: '#FEFEFE', touchEnabled: false, },
		barcode		: { left: '2dp', right: '2dp', height: '16dp', top: '6dp' },
		qrcode		: { width: '24dp',  height: '24dp', top: '6dp' },
		nocode		: {
			width: '100%', height: '12dp', top: '8dp',
      		backgroundGradient: {
				type		: 'linear',
				colors		: ['#AAAAAA','#999999'],
				startPoint	: {x:0, y:0},
				endPoint	: {x:0, y:'100%'},
				backFillStart : true, opacity: 0.6,
			},
			touchEnabled: false,
		},
		cardNumber	: {
			font	: WOStyle.FONT.n8, minimumFontSize: '5sp',
			color	: '#000000', textAlign: 'center',
			bottom	: (1 + 5 + 2 + 2)+'dp',				// FACE_LBDT_BT+FACE_LBDT_H+SPL_H
			height: '10dp',
			left: '2dp', right: '2dp',
			touchEnabled: false,
		},
		cardName	: {
        	font	: WOStyle.FONT.n8, minimumFontSize: '5sp',
			color	: '#000000', textAlign:'center',
			shadowOffset: {x:0,y:2}, shadowColor: '#FFF',
			bottom: '6dp', height: '10dp',
			left: '2dp', right: '2dp', 
			touchEnabled: false,
		},
		joinDate	: {
			view	:{
				layout: 'horizontal', 
				left: '2dp', width: Ti.UI.SIZE, 
				bottom: '1dp', height: Ti.UI.SIZE,
				touchEnabled: false,
			},
			label 	: {
		        left: 0, width: Ti.UI.SIZE, 
		        bottom: 0, height: Ti.UI.SIZE,
		        color: '#BBBBBB', textAlign: 'center', 	
		        font:  WOStyle.FONT.n5,
		        touchEnabled: false,
			},
			date	: {
		        left:'1dp', width:  Ti.UI.SIZE, 
		        bottom: 0, height: Ti.UI.SIZE,
		        font:  WOStyle.FONT.n5,
		        color: '#666666', textAlign: 'center',
		        touchEnabled: false,
			},
		},
		expiryDate	: {
			view	:{
				layout: 'horizontal',
				right: '2dp', width: Ti.UI.SIZE, 
 				bottom: '1dp', height: Ti.UI.SIZE,
 				touchEnabled: false,
			},
			label 	: {
		        right: '1dp', width: Ti.UI.SIZE, 
		        bottom: 0, height: Ti.UI.SIZE,
		        color: '#BBBBBB', textAlign: 'center', 	
		        font:  WOStyle.FONT.n5,
		        touchEnabled: false,
			},
			date	: {
		        right:0, width:  Ti.UI.SIZE, 
		        bottom: 0, height: Ti.UI.SIZE,
		        font:  WOStyle.FONT.n5,
		        color: '#666666', textAlign: 'center',
		        touchEnabled: false,
			},
		},
		separator	: {
	        width: '100%', bottom: (1 + 5 + 2)+'dp',			// FACE_LBDT_BT + FACE_LBDT_H + 2,
	        height: '1dp', backgroundColor: '#EAEAEA', touchEnabled: false,
		},
		badge		: {
        	backgroundImage: '/assets/images/icons/alert@2x@2x.png',
			right: '0', top: '0', width: '18dp', height: '18dp', touchEnabled: false,
		},
		shadow		: {
			top:0, left:0, width: '88dp', height: '55dp', 
			backgroundColor: 'transparent',
		    shadow:{
		        shadowRadius	: 2,
		        shadowOpacity	: 0.4,
		        shadowOffset	: {x: 1, y: 2},
		    },
		    touchEnabled: false,
		},
	},
	standard	: {
		imageFrame	: {width: '288dp', height: '180dp', borderRadius: WOStyle.DEVICEDP.dp15, touchEnabled: false, },
		image		: {width: '288dp', height: '180dp', borderRadius: WOStyle.DEVICEDP.dp15, touchEnabled: false,},
		back		: { width: '288dp', height: '180dp', borderRadius: WOStyle.DEVICEDP.dp15,  touchEnabled: false, backgroundColor: '#FEFEFE',},
		barcode		: { width: '244dp', height: '72dp',  top: '20dp', touchEnabled: false,},
		barcodex    : { width: '366dp', height: '108dp',  top: '2dp', touchEnabled: false,}, //top = barcode.top - barcode.height*0.25
		qrcode		: { width: WOStyle.IS_ANDROID? '160dp' : '128dp', height: WOStyle.IS_ANDROID? '160dp' : '128dp', top:WOStyle.IS_ANDROID? '0': '16dp',  touchEnabled: false, },
		qrcode2		: {
			qrcode : { width: WOStyle.IS_ANDROID? '135dp' : '100dp', height: WOStyle.IS_ANDROID? '135dp' : '100dp', top:WOStyle.IS_ANDROID? '0': '16dp',  },
			cardNumber : {
				font	: WOStyle.IS_ANDROID? WOStyle.FONT.b20 : WOStyle.FONT.n26, minimumFontSize: '15sp',
				color	: 'black', textAlign: 'center',
				bottom	:WOStyle.IS_ANDROID?  '35dp' : (4 + 20 + 5 + 1 )+'dp',				// FACE_LBDT_BT+FACE_LBDT_H+SPL_H+4
				height:  WOStyle.IS_ANDROID? '22dp' : '30dp',
				left: '10dp', right: '10dp',
				touchEnabled: false,
			}
		},
		nocode		: {
			width: '100%', height: '40dp', top: '25dp',
      		backgroundGradient: {
				type		: 'linear',
				colors		: ['#AAAAAA','#999999'],
				startPoint	: {x:0, y:0},
				endPoint	: {x:0, y:'100%'},
				backFillStart : true, opacity: 0.6,
			},
			touchEnabled: false,
		},
		cardNumber	: {
			font	: WOStyle.IS_ANDROID? WOStyle.FONT.b20 : WOStyle.FONT.n35, minimumFontSize: '15sp',
			color	: 'black', textAlign: 'center',
			bottom	: (4 + 20 + 5 + 1 + 4)+'dp',				// FACE_LBDT_BT+FACE_LBDT_H+SPL_H+4
			height: WOStyle.IS_ANDROID? '42dp' :'38dp',
			left: '10dp', right: '10dp',
			touchEnabled: false,
		},
		cardName	: {
        	font	:  WOStyle.IS_ANDROID? WOStyle.FONT.b20 : WOStyle.FONT.n35, minimumFontSize: '21sp',
			color	: '#000000', textAlign:'center',
			shadowOffset: {x:0,y:2}, shadowColor: '#FFFFFF',
			bottom: '6dp',
			height:  WOStyle.IS_ANDROID? '42dp' : '40dp', 
			left: '15dp', right: '15dp',
			touchEnabled: false,
		},
		joinDate	: {
			view	:{
				layout: 'horizontal',
				left: '12dp', width: Ti.UI.SIZE,
				bottom: '4dp', height: Ti.UI.SIZE,
				touchEnabled: false,
			},
			label 	: {
		        left: 0, width: Ti.UI.SIZE, 
		        bottom: 0, height: Ti.UI.SIZE,
		        color: '#BBBBBB', textAlign: 'center', 	
		        font: WOStyle.FONT.n15,
		        touchEnabled: false,
			},
			date	: {
		        left: '5dp', width: Ti.UI.SIZE, 
		        font: WOStyle.FONT.n15,
		        bottom: 0, height: Ti.UI.SIZE,
		        color: '#666666', textAlign: 'center',
		        touchEnabled: false,
			},
		},
		expiryDate	: {
			view	:{
				layout: 'horizontal', 
				right: '12dp', width: Ti.UI.SIZE, 
				bottom: '4dp', height: Ti.UI.SIZE,
				touchEnabled: false, 
			},
			label 	: {
		        right: '5dp', width: Ti.UI.SIZE, 
		        bottom: 0, height: Ti.UI.SIZE, 
		        color: '#BBBBBB', textAlign: 'center', 	
		        font: WOStyle.FONT.n15,
		        touchEnabled: false,
			},
			date	: {
		        right: 0, width: Ti.UI.SIZE, 
		        bottom: 0, height: Ti.UI.SIZE, 
		        font: WOStyle.FONT.n15,
		        color: '#666666', textAlign: 'center',
		        touchEnabled: false,
			},
		},
		separator	: {
	        width: '100%', bottom: (4 + 20 + 4)+'dp',			// FACE_LBDT_BT + FACE_LBDT_H + 5,
	        height: '1dp', backgroundColor: '#EAEAEA', touchEnabled: false,
		},
		badge		: {
        	backgroundImage: '/assets/images/icons/alert@2x@2x.png',
			right: '3dp', top: '2dp', width: '36dp', height: '36dp', touchEnabled: false,
		},
		shadow		: {
			top: 0, width: '320dp', height: '204dp',
			backgroundColor: 'transparent',
		    shadow:{
		        shadowRadius	: 4,
		        shadowOpacity	: 0.4,
		        shadowOffset	: {x: 2, y: 3},
		    },
		    touchEnabled: false,
		},
		position    : {
		    landscapeLeft   : { top: Math.round((WOStyle.DEVICE.height-200)/2), left: -2 },
		    landscapeRight  : { top: Math.round((WOStyle.DEVICE.height-200)/2), left: 4  },
		    portrait        : { top: Math.round(WOStyle.DEVICE.height/8-30),  left: 0  },
		},
	},
	cardIntro	: {
		imageFrame	: { width: '144dp', height: '90dp', left:WOStyle.IS_ANDROID? '5dp' : '10dp', borderRadius: WOStyle.DEVICEDP.dp6, touchEnabled: false,},
		image		: { width: '144dp', height: '90dp', borderRadius: WOStyle.DEVICEDP.dp6, },
		back		: { width: '144dp', height: '90dp', borderRadius: WOStyle.DEVICEDP.dp6, backgroundColor: '#FEFEFE' },
		barcode		: { left: '5dp', right: '5dp',  height: '30dp', top: '12dp' },
		qrcode		: { width: '64dp',  height: '64dp', top: '6dp' },
		nocode		: {
			width: '100%', height: '24dp', top: '15dp',
      		backgroundGradient: {
				type		: 'linear',
				colors		: ['#AAAAAA','#999999'],
				startPoint	: {x:0, y:0},
				endPoint	: {x:0, y:'100%'},
				backFillStart : true, opacity: 0.6,
			},
			touchEnabled: false,
		},
		cardNumber	: {
			font	: WOStyle.FONT.n18, minimumFontSize: '12sp',
			color	: '#000000', textAlign: 'center',
			bottom	: (3 + 8 + 3+ 1 + 3)+'dp',	// LAND_LBDT_BT+LAND_LBDT_H+SPL_H+8
			height: '20dp',
			left: '5dp', right: '5dp',
			touchEnabled: false,
		},
		cardName	: {
        	font	: WOStyle.FONT.b20, minimumFontSize: '12sp',
			color	: '#000000', textAlign:'center',
			shadowOffset: {x:0,y:2}, shadowColor: '#FFF',
			bottom: '6dp', height: '24dp', 
			left: '5dp', right: '5dp',
			touchEnabled: false,
		},
		joinDate	: {
			view	:{
				layout: 'horizontal',
				left: '5dp', width: Ti.UI.SIZE,
				bottom: '3dp', height: Ti.UI.SIZE,
				touchEnabled: false,
			},
			label 	: {
		        left: 0, width: Ti.UI.SIZE, 
		        bottom: 0, height: Ti.UI.SIZE,
		        color: '#BBBBBB', textAlign: 'center', 	
		        font: WOStyle.FONT.n8,
		        touchEnabled: false,
			},
			date	: {
		        left: '2dp', width: Ti.UI.SIZE, 
		        font: WOStyle.FONT.n8,
		        bottom: 0, height: Ti.UI.SIZE,
		        color: '#666666', textAlign: 'center',
		        touchEnabled: false,
			},
		},
		expiryDate	: {
			view	:{
				layout: 'horizontal', 
				right: '5dp', width: Ti.UI.SIZE, 
				bottom: '3dp', height: Ti.UI.SIZE,
				touchEnabled: false, 
			},
			label 	: {
		        right: '2dp', width: Ti.UI.SIZE, 
		        bottom: 0, height: Ti.UI.SIZE, 
		        color: '#BBBBBB', textAlign: 'center', 	
		        font: WOStyle.FONT.n8,
		        touchEnabled: false,
			},
			date	: {
		        right: 0, width: Ti.UI.SIZE, 
		        bottom: 0, height: Ti.UI.SIZE, 
		        font: WOStyle.FONT.n8,
		        color: '#666666', textAlign: 'center',
		        touchEnabled: false,
			},
		},
		separator	: {
	        width: '100%', bottom: (3 + 8 + 4)+'dp',			// FACE_LBDT_BT + FACE_LBDT_H + 4,
	        height: '1dp', backgroundColor: '#EAEAEA', touchEnabled: false,
		},
		badge		: {
        	backgroundImage: '/assets/images/icons/alert@2x@2x.png',
			right: '0', top: '0', width: '24dp', height: '24dp', touchEnabled: false,
		},
		shadow		: {
			top:0, left:0, width: '160dp', height: '100dp',
			backgroundColor: 'transparent',
		    shadow:{
		        shadowRadius	: 2,
		        shadowOpacity	: 0.4,
		        shadowOffset	: {x: 1, y: 2},
		    },
		    touchEnabled: false,
		},
	},
	landscape	: {
		imageFrame	: { width: '432dp', height: '270dp',borderRadius: WOStyle.DEVICEDP.dp23, touchEnabled: false,},
		image		: { width: '432dp', height: '270dp', borderRadius: WOStyle.DEVICEDP.dp23, touchEnabled: false, },
		
		back		: { width: '432dp', height: '270dp', borderRadius: WOStyle.DEVICEDP.dp23, backgroundColor: '#FEFEFE',  touchEnabled: false,},
		
		//barcode		: { left:  '22dp', right: '22dp', height: '75dp',  top: '20dp', touchEnabled: false,},
		
		barcode		: { left: '33dp', right: '33dp', height: '108dp', top: '30dp'},
		qrcode		: { width: '180dp', height: '180dp', top: '25dp',},
		nocode		: {
			width: '100%', height: '64dp', top: '40dp', 
      		backgroundGradient: {
				type		: 'linear',
				colors		: ['#AAAAAA','#999999'],
				startPoint	: {x:0, y:0},
				endPoint	: {x:0, y:'100%'},
				backFillStart : true, opacity: 0.6,
			},
			touchEnabled: false,
		},
		cardNumber	: {
			font	: WOStyle.FONT.n35, minimumFontSize: '18sp',
			color	: '#000000', textAlign: 'center',
			bottom	: (10 + 24 + 12 + 8)+'dp',	// LAND_LBDT_BT+LAND_LBDT_H+SPL_H+8
			height: '40dp',
			left: '15dp', right: '15dp',
			touchEnabled: false,
		},
		cardName	: {
 	       	font	: WOStyle.FONT.b35, minimumFontSize: '30sp',
			color	: '#000000', textAlign:'center',
			shadowOffset: {x:0,y:2}, shadowColor: '#FFFFFF',
			bottom: '10dp', height: '40dp',
			left: '20dp', right: '20dp',
			touchEnabled: false,
		},
		joinDate	: {
			view	:{
				layout: 'horizontal',
				left: '15dp', width: Ti.UI.SIZE,
				bottom: '10dp', height: Ti.UI.SIZE,
				touchEnabled: false,
			},
			label 	: {
		        left: 0, width: Ti.UI.SIZE, 
		        bottom: 0, height: Ti.UI.SIZE,
		        color: '#BBBBBB', textAlign: 'center', 	
		        font: WOStyle.FONT.n20,
		        touchEnabled: false,
			},
			date	: {
		        left: '8dp', width: Ti.UI.SIZE, 
		        bottom: 0, height: Ti.UI.SIZE,
		        font: WOStyle.FONT.n20,
		        color: '#666666', textAlign: 'center',
		        touchEnabled: false,
			},
		},
		expiryDate	: {
			view	:{
				layout: 'horizontal',
				right: '15dp', width: Ti.UI.SIZE, 
				bottom: '10dp', height: Ti.UI.SIZE,
				touchEnabled: false,
			},
			label 	: {
		        right: '8dp', width: Ti.UI.SIZE, 
		        color: '#BBBBBB', textAlign: 'center', 	
		        font: WOStyle.FONT.n20,
		        bottom: 0, height: Ti.UI.SIZE,
		        touchEnabled: false,
			},
			date	: {
		        right: 0, width: Ti.UI.SIZE, 
		        font: WOStyle.FONT.n20,
		        bottom: 0, height: Ti.UI.SIZE,
		        color: '#666666', textAlign: 'center',
		        touchEnabled: false,
			},
		},
		separator	: {
	        width: '100%', bottom: (10 + 24 + 12)+'dp',			// FACE_LBDT_BT + FACE_LBDT_H + 12,
	        height: '1dp', backgroundColor: '#EAEAEA', touchEnabled: false,
		},
		badge		: {
        	backgroundImage: '/assets/images/icons/alert@2x@2x.png',
			right: '10dp', top: '10dp', width: '36dp', height: '36dp', touchEnabled: false,
		},
		shadow		: {
			top: 0, width: '480dp', height: '320dp',
			backgroundColor: 'transparent',
		    shadow:{
		        shadowRadius	: 4,
		        shadowOpacity	: 0.6,
		        shadowOffset	: {x: 3, y: 5},
		    },
		    touchEnabled: false,
		},
	},
	singleRow	: {
		frame		: { width: WOStyle.DEVICE.width, height: '55dp', touchEnabled: false,},
		imageFrame		: {touchEnabled: false,},
		image		: {touchEnabled: false,},
		brandName	: {
			font	: WOStyle.FONT.n15,
			minimumFontSize: '12sp',
			color	: '#FFFFFF', opacity:0.4, textAlign: 'left',
			height	: WOStyle.IS_ANDROID ? (WOStyle.IS_CH?'16dp':'17dp') :'18dp', top: '8dp', left: '88dp', right: '10dp',
			touchEnabled : false, 
		},
		cardName	: {
			font: WOStyle.IS_ANDROID ?  WOStyle.FONT.b20 : WOStyle.FONT.n20, 
			minimumFontSize: '18sp',
			color	: '#FFFFFF', textAlign: 'left', 
			height	: WOStyle.IS_ANDROID ? (WOStyle.IS_CH?'21dp':'22dp') :'23dp', bottom: '6dp', left: '88dp', right: '10dp',
			touchEnabled : false,
		},
		badge		: {
        	// backgroundImage: '/assets/images/icons/alert@2x@2x.png',
    		// left: '64dp', top: '0', width: '18dp', height: '18dp', touchEnabled: false,
		},
		shadow		: {
			touchEnabled: false,
		},
	},
};
	
function CardFactoryStyle(){
}

module.exports = CardFactoryStyle;

/**
 * End of file: CardFactoryStyle.js
 */