/**
 * CardIntroStyle used in Card Intro & Card About Window
 */
var WOStyle = require('/waveo/perkd/styles/WOStyle');
var FormStyle = require('/waveo/perkd/styles/FormStyle');

CardIntroStyle.className = 'CardIntroStyle';

CardIntroStyle.STYLE = {
	buttonGradient: WOStyle.BUTTON_BG.main,
	buttonSelectGradient: WOStyle.BUTTON_BG.mainSelected,

//style must exist and would be used in WOWindow
	baseWindow :WOStyle.STYLE.baseWindow,
	navGroup :WOStyle.STYLE.navGroup,
	window : WOStyle.STYLE.window,
	windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.STYLE.titlebarShadowContainer,
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,
	
	view : {
		scrollableBg: WOStyle.merge(WOStyle.STYLE.scrollableBg, {
			layout: 'vertical', 
		}),
		cardSinup: {
			width:'100%', height: '100dp', top:'17dp', bottom: '20dp', layout: 'composite',
		},
		cardFace: {
			left:0, top: 0, width: '160dp', height: '100dp',
		},
		cardName: {
			left:'165dp', right:0,  top: '10dp', height: '80dp',
			layout: 'vertical',
		},
	},
	webView:{
		about:{
			width:'100%', height:'100%', top:0,
			backgroundColor: 'transparent',
		},
		cardDesc:{
			width: '292dp', 
			backgroundColor: 'transparent',
			willHandleTouches: true,
			touchEnabled: true,
		},
		cardDesc_android:{
			width: (WOStyle.DEVICEDP.width-30)+'dp', top: 0, height: Ti.UI.SIZE,
			backgroundColor: 'transparent',
			touchEnabled: false,
		}
	},
	label:{
		cardName:{
			top: 0, left: 0,
			color: '#FFFFFF',
			font	: WOStyle.FONT.b20,
			textAlign: 'left',
		},
		cardDesc:{
			top: 0, width: '292dp', 
			color: '#FFFFFF',
			font	: WOStyle.FONT.n18,
			textAlign: 'left',
			touchEnabled: false,
		},
		cardDesc_android:{
			top: 0, left: 0,
			color: '#FFFFFF',
			font	: WOStyle.FONT.n18,
			textAlign: 'left',
			touchEnabled: false,
		}
	},

////-- FORM: FormStyle.FORM,
	form: FormStyle.FORM,
	
////--- FORM Elements
	// view
	view_formHeader: FormStyle.HEADER_FOOTER_VIEW,
	view_formFooter: WOStyle.merge(FormStyle.HEADER_FOOTER_VIEW, {
		height: '20dp',
	}),

	view_formRow: FormStyle.ROW,
	view_formRow_withWindow: FormStyle.Row_withWindow,

	view_formfield : FormStyle.FORMFIELD,

// default Label, Hint, Data Style for this FORM
	label_fieldLabel: WOStyle.merge(FormStyle.FORMFIELD_LABEL,{
		left:'30dp', right:0, width: null, opacity: 1,
		top: '2dp', height: Ti.UI.FILL,
		minimumFontSize: '20sp', //same with font Size
		touchEnabled:true,
	}),
	label_fieldData: WOStyle.merge(FormStyle.FORMFIELD_VALUE,{
		left:'30dp', 
		top: '3dp', height: Ti.UI.FILL,
	}),

//	fieldWindowElement
	fieldWindow: WOStyle.STYLE.window,
	fieldView_webview : FormStyle.FIELDWINDOWELEMENT_WEBVIEW,

//	Button
	btn:{
		signup: WOStyle.merge(WOStyle.STYLE.btn.main, {
			right: '8dp', bottom: '3',
			width: '80dp', height: '28dp',
		}),
		signupLabel:{
			font: WOStyle.FONT.b15,
			right: '8dp', width: '80dp',
			height: '18dp',  bottom: '7dp',
			color: '#FFFFFF',
			textAlign: 'center', touchEnabled: false,
		}
	},	
};

function CardIntroStyle(param){
}

module.exports = CardIntroStyle;

//---  End of file:CardIntroStyle.js
