/**
 * CardListStyle
 */
var WOStyle = require('/waveo/perkd/styles/WOStyle');

CardListStyle.className = 'CardListStyle';

CardListStyle.STYLE = {
	buttonGradient: WOStyle.BUTTON_BG.main,
	buttonSelectGradient: WOStyle.BUTTON_BG.mainSelected,
	DEVICEDP: {
		dp15: WOStyle.DEVICEDP.dp15
	},
	SCREEN :{
		width: WOStyle.DEVICEDP.width,
		height: WOStyle.DEVICEDP.height,
	},
//style must exist and would be used in WOWindow
    baseWindow :  WOStyle.STYLE.baseWindow,
    navGroup :  WOStyle.STYLE.navGroup,
	window : WOStyle.STYLE.window,

    windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.merge(WOStyle.STYLE.titlebarShadowContainer,{
		top: WOStyle.IS_ANDROID? '-44dp' : 0,
	}),
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,
	titlebar:  WOStyle.STYLE.titlebar,
	perkd_btn:		WOStyle.STYLE.perkd_btn,
		
//customize style  	
    view :{
		scrollableBg : WOStyle.STYLE.scrollableBg,
    	canvas : WOStyle.STYLE.canvas_absolute,
    	tableViewCanvas:{
    		top: WOStyle.IS_ANDROID? 0 : '44dp', layout: 'composite',
    		backgroundImage: WOStyle.IMAGE.windowBackground,
    	},
    	hiddenTip:{
    		width:'100%', layout: 'composite',
    		backgroundImage: WOStyle.IMAGE.windowBackground,
    	},
    	noResultFrame:{
    		top: '43dp', width:'100%', height: Ti.UI.FILL,
    		backgroundImage: WOStyle.IMAGE.windowBackground,
			zIndex:100, layout: 'composite',
    	},
    	noResultCanvas:{
    		layout: 'vertical', height: Ti.UI.SIZE,
    	},
    	cardFace:{
			top: 0,
			width:	WOStyle.DEVICE.width,
			height: '204dp' //TODO should be calculated based on card size
		},
    },
 	tableView: {
 		top: 0, 
	    backgroundColor:'transparent',
		separatorColor:'transparent',
 	},
	tableRow1:{
			height: '204dp',
			backgroundSelectedColor: '#C4C4C4',
			selectionStyle: WOStyle.IS_ANDROID? undefined : Ti.UI.iPhone.TableViewCellSelectionStyle.GRAY,
			touchEnabled : false,
		},
	tableRow2:{
			height: '55dp',
			backgroundSelectedColor: '#0272ED',
			selectionStyle: WOStyle.IS_ANDROID? undefined : Ti.UI.iPhone.TableViewCellSelectionStyle.BLUE,
			touchEnabled : false,
		}, //Card List View Style == Master List Style
	tableRow3: {
			height: '45dp', hasChild:true,
			backgroundSelectedColor: '#0272ED',
			selectionStyle: WOStyle.IS_ANDROID? undefined : Ti.UI.iPhone.TableViewCellSelectionStyle.BLUE,
		}, //Card Category List
	
	title:{
		L1:{
			left:0, right:0, height: Ti.UI.SIZE,
			textAlign:'center',
			font: WOStyle.FONT.b60,
			color:'#FFFFFF', opacity:0.6,
		},
		L2:{
			left:0, right:0, top:'40dp',
			font: WOStyle.FONT.n18,
			textAlign:'center', height:'21dp',
			color:'#FFFFFF', opacity:0.8,
		},
	},
	desc:{
		L1:{
			left:0, right:0, top: '25dp', height: Ti.UI.SIZE,
			textAlign:'center',
			font:WOStyle.FONT.b24,
			color:'white',
		},
		//card list:  Tap on "+" to add
		L1b:{
			left:0, right:0, bottom: '20dp',
			font:WOStyle.FONT.n20, opacity:0.5,
			textAlign:'center', color:'white'
		},
	},
	label:{
		categoryName : {
    	 	left: '15dp', right:'10dp', top:'13dp', height:'23dp',
			font: WOStyle.IS_ANDROID ?  WOStyle.FONT.b20 : WOStyle.FONT.n20, 
			minimumFontSize:'15sp',
			color:'#FFFFFF',  textAlign:'left', 
			touchEnabled:false,
		},
		addCustomCard : {
    	 	left: '15dp', right:'10dp', top:'13dp', height:'23dp',
			font: WOStyle.FONT.b20,
			color:'#FFBA00',  textAlign:'left', 
			touchEnabled:false,
		},
	},
	
//--- Add button
    btn: {
    	add : {
	        width:'40dp', height:'30dp', top:'8dp', right:'8dp',
	        labels:[{image:'/assets/images/buttons/addbtn.png'}],
	        style: Ti.UI.iPhone.SystemButtonStyle.BAR,
	        backgroundColor:'#FDCC66',
    	},
    	add_android : {
	        width:'40dp', height:'30dp', top:'8dp',
	        labels:[{image:'/assets/images/buttons/addbtn@2x.png', width: '18dp'}],
			backgroundGradient: {
				type:'linear', colors:['#F5D699','#F9BA3E'],
				startPoint:{x:0,y:0}, endPoint:{x:0,y:'100%'},
				backFillStart:false
			}
		},
    	add_android_image: {
	        width:'18dp', height:'18dp',
    	},
    	addCustomCard : WOStyle.merge(WOStyle.STYLE.btn.main, {
	        width: '210dp', top: '15dp',
    	}),
    },
    tabbedBar: {
	    cardListSwitcher : {
	        labels:[
	            {image: '/assets/images/buttons/align_just.png'},
	            {image: '/assets/images/buttons/image_text.png'},
	        ], 
	        style: Ti.UI.iPhone.SystemButtonStyle.BAR,
	        backgroundColor:'#FDCC66',
	        right: '70dp',  width:'90dp', height:'30dp', top:'8dp',
	   	 },
	   	 cardListSwitcher_android : {
			width:'90dp', right: '70dp',  height:'30dp', top:'8dp',
	        labels:[
	            {image: '/assets/images/buttons/align_just@2x.png', width: '24dp'},
	            {image: '/assets/images/buttons/image_text@2x.png', width: '24dp'},
	        ], 
			backgroundGradient:{
				type:'linear', colors: ['#FFDFA0','#DCA935'],
				startPoint:{x:0,y:0}, endPoint:{x:0,y:'100%'},
				backFillStart:false
			},
	   	 },
   	 },

//--- SearchBar
	searchBar: WOStyle.SEARCHBAR,
};

function CardListStyle(param){
}

module.exports = CardListStyle;

//---  End of file: CardListStyle.js
