/**
 * CitySearchStyle
 */
var WOStyle = require('/waveo/perkd/styles/WOStyle');

CitySearchStyle.className = 'CitySearchStyle';

CitySearchStyle.STYLE = {
	buttonGradient: WOStyle.BUTTON_BG.main,
	buttonSelectGradient: WOStyle.BUTTON_BG.mainSelected,
	DEVICEDP: {
		dp15: WOStyle.DEVICEDP.dp15
	},
	SCREEN :{
		width: WOStyle.DEVICEDP.width,
		height: WOStyle.DEVICEDP.height,
	},
//style must exist and would be used in WOWindow
    baseWindow :  WOStyle.STYLE.baseWindow,
    navGroup :  WOStyle.STYLE.navGroup,
	window : WOStyle.STYLE.window,

    windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.merge(WOStyle.STYLE.titlebarShadowContainer,{
		top: WOStyle.IS_ANDROID? '-44dp' : 0,
	}),
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,
	titlebar:  WOStyle.STYLE.titlebar,
	perkd_btn:		WOStyle.STYLE.perkd_btn,
		
//customize style  	
    view :{
		scrollableBg : WOStyle.STYLE.scrollableBg,
    	canvas : WOStyle.STYLE.canvas_absolute,
    	tableViewCanvas:{
    		top: WOStyle.IS_ANDROID? 0 : '44dp', layout: 'composite',
    		backgroundImage: WOStyle.IMAGE.windowBackground,
    	},
    	hiddenTip:{
    		width:'100%', layout: 'composite',
    		backgroundImage: WOStyle.IMAGE.windowBackground,
    	},
    	noResultFrame:{
    		top: '43dp', width:'100%', height: Ti.UI.FILL,
    		backgroundImage: WOStyle.IMAGE.windowBackground,
			zIndex:100, layout: 'composite',
    	},
    	noResultCanvas:{
    		layout: 'vertical', left: '20dp', right: '20dp', height: Ti.UI.SIZE,
    	},
    },
 	tableView: {
 		top: 0, 
	    backgroundColor:'transparent',
		separatorColor:'transparent',
 	},
	tableRow: {
			height: '55dp', hasChild:false,
			backgroundSelectedColor: '#0272ED',
			selectionStyle: WOStyle.IS_ANDROID? undefined : Ti.UI.iPhone.TableViewCellSelectionStyle.BLUE,
		}, //Card Category List
	
	label:{
		city : {
    	 	left: '10dp', right:'110dp', height: '45dp',
			font: WOStyle.FONT.b20, 
			color:'#FFFFFF',  textAlign:'left', 
			touchEnabled:false,
		},
		country : {
    	 	right : '10dp', height: '36dp', width: '100dp',
			color: '#FFFFFF', touchEnabled:false, textAlign: 'right',
		 	font: WOStyle.FONT.n17, opacity: 0.6,
		},

		state : {
    	 	right : '10dp', top:'10dp', height: '18dp', width: '100dp',
			color: '#FFFFFF', touchEnabled:false, textAlign: 'right',
		 	font: WOStyle.FONT.n15, opacity: 0.6,
		},

		countrystate : {
    	 	right : '10dp', bottom:'7dp', height: '17dp', width: '100dp',
			color: '#FFFFFF', touchEnabled:false, textAlign: 'right',
		 	font: WOStyle.FONT.n15, opacity: 0.6,
		},
		
		desc:{
			left:0, right:0, top: '25dp', bottom: '45dp', height: Ti.UI.SIZE,
			textAlign:'center',
			font:WOStyle.FONT.b24,
			color:'#FFFFFF',
		},
		title:{
			left:0, right:0, height: Ti.UI.SIZE,
			textAlign:'center',
			font: WOStyle.FONT.b60,
			color:'#FFFFFF', opacity:0.6,
		}

	},

//--- SearchBar
	searchBar: WOStyle.SEARCHBAR,
};

function CitySearchStyle(param){
}

module.exports = CitySearchStyle;

//---  End of file: CitySearchStyle.js
