/**
 * FormStyle
 */

//-----------------  Public Static properties  ------------------
var WOStyle = require('/waveo/perkd/styles/WOStyle');

FormStyle.className = 'FormStyle';

FormStyle.FORM = {
	width: WOStyle.IS_ANDROID ? (WOStyle.DEVICEDP.width-30)+'dp':'310dp',
	style:Ti.UI.iPhone.TableViewStyle.GROUPED,
	separatorStyle:Ti.UI.iPhone.TableViewSeparatorStyle.NONE,
	backgroundColor:'transparent',
	separatorColor:'#4d4d4d',
	showVerticalScrollIndicator:false,
},
FormStyle.HEADER_FOOTER_VIEW = {
	top:0, width: WOStyle.IS_ANDROID ? (WOStyle.DEVICEDP.width-30)+'dp':'310dp',
	height: Ti.UI.SIZE, layout: 'vertical',
};
FormStyle.SECTION_HEADER_FOOTER_VIEW = {
	width: WOStyle.IS_ANDROID ? (WOStyle.DEVICEDP.width-30)+'dp':'310dp',
	top: 0,
	height:'auto', layout: 'vertical',
};
FormStyle.HEADERLABEL = {
	top: '25dp', bottom: '5dp',  height: Ti.UI.SIZE,
	left: WOStyle.IS_ANDROID ? '8dp':'20dp', right: WOStyle.IS_ANDROID ? '8dp':'18dp',
	font: WOStyle.FONT.n18, 
	color:'#FFFFFF',
	textAlign:'left',  opacity:0.8,
};
FormStyle.FOOTERLABEL = {
	top: '10dp', bottom: '10dp', height: Ti.UI.SIZE,
	left: WOStyle.IS_ANDROID ? '8dp':'20dp', right: WOStyle.IS_ANDROID ? '8dp':'18dp', 
	color:'#FFFFFF',
	textAlign:'left', 
	font: WOStyle.FONT.n17,
	opacity:0.4,
};
FormStyle.ROW = {
	selectionStyle: Ti.UI.iPhone.TableViewCellSelectionStyle.NONE,
	height: '42dp',
	backgroundColor:'#16000000',
	touchEnabled: false,
	hasChild: false,
};
FormStyle.Row_withWindow = WOStyle.merge(FormStyle.ROW, {
	selectionStyle: WOStyle.IS_ANDROID? null: Ti.UI.iPhone.TableViewCellSelectionStyle.BLUE,
	backgroundSelectedColor: WOStyle.IS_ANDROID? '#0272ED' : null,
	hasChild: true, touchEnabled:false,
}),
FormStyle.FORMFIELD = {
	left: '10dp', right: '10dp', top:0, height:'42dp',
	layout: 'composite', touchEnabled: false,
};
FormStyle.FORMFIELD_LABEL = {
	left: 0, height:'42dp', width:'35%',
	textAlign:'left', 
	font: WOStyle.IS_ANDROID? WOStyle.FONT.n18 : WOStyle.FONT.n20,
	minimumFontSize: '15sp',
	color:'#FFFFFF',
	opacity: 0.4,
	touchEnabled:false,
};
FormStyle.FORMFIELD_LABEL_FULLWIDTH = WOStyle.merge(FormStyle.FORMFIELD_LABEL, {width:'100%'});

FormStyle.FORMFIELD_HINT = {
	left:'35%', right:'100dp', height:'42dp',
	textAlign:'right',
	font: WOStyle.IS_ANDROID? WOStyle.FONT.n18 : WOStyle.FONT.n20,
	minimumFontSize: '15sp',
	color:'#FFFFFF',
	opacity: 0.4,
	touchEnabled:false,
};
FormStyle.FORMFIELD_HINT_ASLABEL = FormStyle.FORMFIELD_LABEL;
FormStyle.FORMFIELD_HINT_ASLABEL_FULLWIDTH = FormStyle.FORMFIELD_LABEL_FULLWIDTH;

FormStyle.TEXTFIELD = WOStyle.TEXTFIELD;

FormStyle.FORMFIELD_VALUE = WOStyle.merge(FormStyle.TEXTFIELD, {
	left:'35%', right: 0, textAlign: 'right', minimumFontSize: '20sp', touchEnabled:false,
});  // shared for TEXTFIELD & LABEL
FormStyle.FORMFIELD_VALUE_FULLWIDTH = WOStyle.merge(FormStyle.FORMFIELD_VALUE, {
	left: '0', textAlign: 'left',
});

// field: name
FormStyle.FORMFIELD_VALUE_NAME = WOStyle.merge(FormStyle.FORMFIELD_VALUE_FULLWIDTH, {
	autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_WORDS,
});
FormStyle.FORMFIELD_HINT_NAME = FormStyle.FORMFIELD_HINT_ASLABEL_FULLWIDTH;

// field: email
FormStyle.FORMFIELD_VALUE_EMAIL = WOStyle.merge(FormStyle.FORMFIELD_VALUE_FULLWIDTH, {
	autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
	keyboardType: Ti.UI.KEYBOARD_EMAIL,
});
FormStyle.FORMFIELD_HINT_EMAIL = FormStyle.FORMFIELD_HINT_ASLABEL_FULLWIDTH;

// field: mobile no
FormStyle.FORMFIELD_VALUE_MOBILE = WOStyle.merge(FormStyle.FORMFIELD_VALUE_FULLWIDTH, {
	keyboardType:  WOStyle.IS_ANDROID? Ti.UI.KEYBOARD_PHONE_PAD : Ti.UI.KEYBOARD_NUMBERS_PUNCTUATION,
});
FormStyle.FORMFIELD_HINT_MOBILE = FormStyle.FORMFIELD_HINT_ASLABEL_FULLWIDTH;


// field: card no
FormStyle.FORMFIELD_VALUE_CARDNO = WOStyle.merge(FormStyle.FORMFIELD_VALUE_FULLWIDTH, {
	keyboardType: WOStyle.IS_ANDROID? Ti.UI.KEYBOARD_DEFAULT : Ti.UI.KEYBOARD_NUMBERS_PUNCTUATION,
});
FormStyle.FORMFIELD_HINT_CARDNO = FormStyle.FORMFIELD_HINT_ASLABEL_FULLWIDTH;

//TABBAR
if(WOStyle.IS_ANDROID){
	FormStyle.FORMFIELD_TABBAR = {
		backgroundGradient:{
			type:'linear', colors:['#AAAAAA','#111111'],
			startPoint:{x:0,y:0}, endPoint:{x:0,y:'100%'},
			backFillStart:false
		},
		font: WOStyle.FONT.b15,
		borderColor: '#30000000',
		right: 0,
		top: '11%',
		height:'80%',
		width: '120dp',
	};
} else {
	FormStyle.FORMFIELD_TABBAR = {
		backgroundColor:'#666666',
		style:Titanium.UI.iPhone.SystemButtonStyle.BAR,
		right: 0,
		top: '11%',
		height:'80%',
		width: '120dp',
	};
};
FormStyle.FORMFIELD_TABBAR_GENDER = FormStyle.FORMFIELD_TABBAR;
FormStyle.FORMFIELD_TABBAR_OPT = FormStyle.FORMFIELD_TABBAR;


//FIELD WINDOW ELEMENT 
FormStyle.FIELDWINDOWELEMENT_DATE = {
	windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.STYLE.titlebarShadowContainer,
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,
	toolBar: WOStyle.STYLE.toolBar,
	datePicker: WOStyle.STYLE.datePicker,
	datePickerArea: WOStyle.STYLE.datePickerArea,
	label: {
		tip: {
			textAlign: 'center',
			top: '60dp',
			width: '290dp',
			//left:'15dp', right:'15dp',
			font: WOStyle.FONT.n24,
			color:'#FFFFFF', opacity: 0.6,
		}
	},
	systemButton:{
		DONE: WOStyle.SYSTEMBUTTON.DONE,
		CLEAR: WOStyle.SYSTEMBUTTON.CLEAR,
		FLEXIBLE_SPACE: WOStyle.SYSTEMBUTTON.FLEXIBLE_SPACE,
	}
};
FormStyle.FIELDWINDOWELEMENT_CARDNO = {
	buttonGradient_scan: WOStyle.BUTTON_BG.main,
	buttonSelectGradient_scan: WOStyle.BUTTON_BG.mainSelected,

	windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.STYLE.titlebarShadowContainer,
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,
	
	view:{
		canvas: WOStyle.merge(WOStyle.STYLE.canvas,{
			width: '288dp', left: null, right: null,
		}),
		codeNo:{
			left:0, right:0, top: '30dp', height: '50dp',
			borderRadius: WOStyle.DEVICEDP.dp8, borderWidth: WOStyle.DEVICEDP.dp1, borderColor:'#4d4d4d',
			backgroundColor: '#31000000',
		},
		scanCode:{
			left:'1dp', right:'1dp', top: '15dp', height: '40dp',
		},
	},
	label:{
		tip:{
			left:'8dp', right:'8dp', top: '15dp', opacity:0.4, color:'#FFFFFF',
			font: WOStyle.FONT.n18,
		},
		btnScan:{
			left:'58dp', right: '10dp', top: WOStyle.IS_ANDROID ? '9dp' : '11dp', opacity:0.8,  color:'#FFFFFF',
			textAlign: 'left',
			font: WOStyle.IS_ANDROID ? WOStyle.FONT.b20 : WOStyle.FONT.n20,
			touchEnabled: false,
		},
	},	
	img: {
		scan:{
			image: WOStyle.IS_ANDROID ? '/assets/images/icons/barcode@2x.png' : '/assets/images/icons/barcode.png',
			left:'10dp', height:'27dp', width:'40dp',  touchEnabled: false,
		}
	},
	textfield:{
		cardNo: WOStyle.merge(FormStyle.TEXTFIELD, {
			font: WOStyle.FONT.b24, height: '50dp',
			hintText:App.Helper.L('formHint_cardno'), 
			keyboardType: WOStyle.IS_ANDROID? Ti.UI.KEYBOARD_DEFAULT : Ti.UI.KEYBOARD_NUMBERS_PUNCTUATION,
			returnKeyType:Titanium.UI.RETURNKEY_DONE,
		}),
	},
	btn :{
		scan: WOStyle.merge(WOStyle.STYLE.btn.main,{
			left: 0, right: 0, height: '40dp',
		})
	},
	systemButton:{
		DONE: WOStyle.SYSTEMBUTTON.DONE,
		SAVE: WOStyle.SYSTEMBUTTON.SAVE,
		CANCEL: WOStyle.SYSTEMBUTTON.CANCEL,
		EDIT: WOStyle.SYSTEMBUTTON.EDIT,
	}
};
FormStyle.FIELDWINDOWELEMENT_SLIDER = {
	windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.STYLE.titlebarShadowContainer,
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,
	
	view:{
		canvas: WOStyle.STYLE.canvas,
	},
	label:{
		desc:{
			width:'80%', top : '60dp', 
			color: '#FFFFFF', opacity: 0.6, textAlign: 'center',
			font: WOStyle.FONT.b20,
		},
		data:{
			width:'90%', top : '15dp', height: '64dp',
			color: '#FFFFFF', textAlign: 'center',				
			font: WOStyle.FONT.b60, minimumFontSize: '32sp',
		},
		tip:{
			width:'100%', top : '5dp',
			color: '#FFFFFF', textAlign: 'center',
			font: WOStyle.IS_ANDROID? WOStyle.FONT.n18 : WOStyle.FONT.n20,
		},

	},
	slider :{
		width:'80%', top : '60dp', height:'auto',
	},
	systemButton:{
		DONE: WOStyle.SYSTEMBUTTON.DONE,
		CANCEL: WOStyle.SYSTEMBUTTON.CANCEL,
	}
};
FormStyle.FIELDWINDOWELEMENT_WEBVIEW = {
	windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.STYLE.titlebarShadowContainer,
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,
	view:{
		webViewCanvas:{
			top:'0', height: Ti.UI.FILL,
			width: '100%', backgroundColor: 'transparent',
		}
	},
};

FormStyle.FIELDWINDOWELEMENT_NAMEORDER = {
	windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.STYLE.titlebarShadowContainer,
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,
	view:{
		canvas: WOStyle.STYLE.canvas,
	},
	
	picker: ({bottom : WOStyle.IS_ANDROID? null : 0, top : WOStyle.IS_ANDROID? '20dp' : null}),
	label: {
		tip: {
			textAlign: 'center',
			top: '60dp',
			width: '290dp',
			font: WOStyle.FONT.n24,
			color:'#FFFFFF', opacity: 0.6,
		}
	},
};

FormStyle.FIELDWINDOWELEMENT_LANG = {
	windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.STYLE.titlebarShadowContainer,
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,
	view:{
		canvas:  WOStyle.STYLE.scrollableCanvas,
	},
	tableView:	WOStyle.STYLE.tableView,
	tableRow: {
		backgroundColor:'#53000000',
		color:'#FFFFFF', height: '42dp',
		selectionStyle: WOStyle.IS_ANDROID? null: Ti.UI.iPhone.TableViewCellSelectionStyle.BLUE,
		backgroundSelectedColor: WOStyle.IS_ANDROID? '#0272ED' : null,
	},
	label: {
    	 	left: '10dp', right:'10dp',
			font: WOStyle.FONT.b20, 
			color:'#FFFFFF',  textAlign:'left', 
			touchEnabled:false,
    },
	img:{
    	unCheckIcon:{
    		right	: '8dp', width : '32dp', height : '32dp',
	        image	: WOStyle.IS_ANDROID? '/assets/images/icons/unchecked@2x.png': '/assets/images/icons/unchecked.png',
	        touchEnabled : false,
    	},
       checkIcon:{
    		right	: '8dp', width : '32dp', height : '32dp',
	        image	: WOStyle.IS_ANDROID? '/assets/images/icons/checked@2x.png': '/assets/images/icons/checked.png',
	        touchEnabled : false,
    	}
    }, 
};


FormStyle.FIELDWINDOWELEMENT_CITY = {
	window: WOStyle.merge(WOStyle.STYLE.window, {
		navBarHidden: true,
	}),
	windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.STYLE.titlebarShadowContainer,
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,
	buttonGradient_main: WOStyle.BUTTON_BG.main,
	buttonGradient_mainSelected: WOStyle.BUTTON_BG.mainSelected,

	view:{
		canvas:  WOStyle.STYLE.scrollableCanvas,
		location:  {top: '0', layout: 'vertical', height: Ti.UI.SIZE,},
		toggle: {
			left: '15dp', right:'15dp', height:'42dp',
			borderRadius: WOStyle.DEVICEDP.dp10,
			borderWidth: WOStyle.DEVICEDP.dp1,
			borderColor:'#4d4d4d',
			backgroundColor:'#53000000',
		},
	},

	label: {
		desc:  {
			left:'25dp', right:'25dp', 
			top: '25dp', height: Ti.UI.SIZE, 
			font: WOStyle.FONT.n18,
			color:'#FFFFFF',
			textAlign:'left',
		},
    	location: {
    	 	left: '10dp', right:'10dp',
			font: WOStyle.FONT.b20, 
			color:'#FFFFFF',  textAlign:'left', 
			touchEnabled:false,
    	 },
		tips :{
			top:'10dp', left:'25dp', right:'25dp', height: Ti.UI.SIZE, bottom: '30dp',
			font:WOStyle.FONT.n15,
			color:'#FFFFFF', opacity:0.6,
			textAlign:'left',
		},
	},
	btn:{
			add: WOStyle.merge(WOStyle.STYLE.btn.main,{
			top:0, bottom: '60dp', height: '40dp', width:'210dp',
			title:App.Helper.L('formfieldwindow_city_btn'), 
		})
		
	},
	systemButton:{
		DONE: WOStyle.SYSTEMBUTTON.DONE,
		CANCEL: WOStyle.SYSTEMBUTTON.CANCEL,
	},
	switcher :{right :'5dp',}
};


FormStyle.FIELDWINDOWELEMENT_POLICY ={
	window: WOStyle.merge(WOStyle.STYLE.window, {
		navBarHidden: true,
	}),
	windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.STYLE.titlebarShadowContainer,
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,
	buttonGradient_main: WOStyle.BUTTON_BG.main,
	buttonGradient_mainSelected: WOStyle.BUTTON_BG.mainSelected,
 
	view:{
		webViewCanvas:{
			top:'0', height: Ti.UI.FILL,
			width: '100%', backgroundColor: 'transparent',
		}
	},
	button: {
		height: '28dp',
		backgroundImage: null,
		backgroundSelectedImage: null,
		color: '#80FFFFFF',
		font: {
			fontSize: '14sp',
			fontFamily: 'Helvetica-Bold',
		},
	},
	buttonAlert: {
		height: '28dp',
		backgroundImage: null,
		backgroundSelectedImage: null,
		color: '#f96262',
		font: {
			fontSize: '14sp',
			fontFamily: 'Helvetica-Bold',
		},
	},
	buttonMain: {
		height: '28dp',
		backgroundImage: null,
		backgroundSelectedImage: null,
		color: '#FFFFFF',
		font: {
			fontSize: '14sp',
			fontFamily: 'Helvetica-Bold',
		},
	},
	buttonHighlight: {
		height: '28dp',
		backgroundImage: null,
		backgroundSelectedImage: null,
		color: '#2990FE',
		font: {
			fontSize: '14sp',
			fontFamily: 'Helvetica-Bold',
		},
	},
	toolbar: {
		bottom:'0', height: '44dp', width: WOStyle.IS_ANDROID? WOStyle.DEVICEDP.width+'dp' : '100%',
		borderTop: true, borderBottom: false, translucent: true,
		barColor: '#000000'
	},
	
};


FormStyle.STYLE = {

};


function FormStyle(param){
	
}

module.exports = FormStyle;

//---  End of file: FormStyle.js
