/**
 * Offer style
 */
var WOStyle = require('/waveo/perkd/styles/WOStyle');

OfferRedeemStyle.className = 'OfferRedeemStyle';

OfferRedeemStyle.STYLE = {
	baseWindow :WOStyle.STYLE.baseWindow,
	navGroup :WOStyle.STYLE.navGroup,
	window : WOStyle.merge(WOStyle.STYLE.window, {
		backgroundColor: '#FFFFFF',
		backgroundImage: null,
	}),
	windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.merge(WOStyle.STYLE.titlebarShadowContainer,{top: '0'}),
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,	
	titlebar:		WOStyle.STYLE.titlebar,
		
	view : {
		scrollableBg : {
			left:0, top:'44dp', width:'100%', height:Ti.UI.FILL,
			contentHeight: Ti.UI.SIZE, contentWidth:'100%',
			layout: 'composite',
		},
		canvas:{
			top: '25dp', left:'15dp', right:'15dp', height:Ti.UI.SIZE, bottom: '40dp', layout: 'vertical',
		},

		btn:{
			top	: 0, width: '288dp', //remember to set width, otherwise layout will be broken
			height	: Ti.API.SIZE,
			layout: 'composite',
		},

		couponCodeBg:{
			top: '10dp', left:'0', right:'0', height: '275dp',
			layout: 'composite',
			backgroundImage: '/assets/images/ui/codebg.png',
		},
		couponCodeFrame:{
			left:'15dp', right:'15dp', top:'20dp',
			height: '180dp',
			layout: 'composite',
		},
		QRCode:{
		 	width:WOStyle.IS_ANDROID?  '240dp': '180dp', height: WOStyle.IS_ANDROID? '240dp' :  '180dp', 
		},
		barCode:{
			width: '240dp', height: WOStyle.IS_ANDROID? '75dp' : '140dp',
		}
	},

	label: {
		couponBrand: {
			top: 0, left:0, right: 0, height: Ti.UI.SIZE,
			font:WOStyle.FONT.b15, textAlign:'left',
			color:'#000000',
		},
		couponName: {
			top: '3dp', left:0, right: 0, height: Ti.UI.SIZE,
			font: WOStyle.FONT.b24, textAlign:'left',
			color:'#000000', 
		},
		codeLabel:{
			left:0, right:0, height: '90dp',
			font:{fontFamily:'Courier New', fontSize:'64sp'},
			minimumFontSize: '48sp',
			color:'#000000', textAlign:'center',
		},
		codeLabel_withCode:{
			left:'5dp', right:'5dp', bottom: '8dp', height: '80dp',
			font: {fontFamily:'Courier New', fontSize:WOStyle.IS_ANDROID? '21sp' : '54sp'},
			minimumFontSize: '18sp', 
			color:'#000000', textAlign:'center',
		},
		couponDesc:{
			top: '15dp', left:0, right: 0, height: Ti.UI.SIZE,
			font: WOStyle.FONT.n18, textAlign:'left',
			color:'#000000', opacity:0.8,
		},
	},
	systemButton:{
		btnLabel:{
			width: '60dp',
			right: '5dp',
			font: {
					fontSize: '12sp',
					fontFamily: 'Helvetica-Bold',
				},
			textAlign:'center',
			color:'#FFFFFF',
			shadowOffset: {x: 0, y:-1},
			shadowColor: '#A5000000',
			height: Ti.UI.SIZE,
			touchEnabled: false,
		},
		DONE: {
				width: '60dp',
				height: '28dp',
				borderRadius: WOStyle.DEVICEDP.dp6,
				borderWidth: WOStyle.DEVICEDP.dp1,
				borderColor: '#AC7720',
				right:  '5dp',
				backgroundImage: null,
				backgroundSelectedImage: null,
				backgroundGradient:{
					type:'linear', colors: ['#F8B769','#F58500'],
					startPoint:{x:0,y:0}, endPoint:{x:0,y:'100%'},
					backFillStart:false
				},
				
		}
	},
};


function OfferRedeemStyle(){
	
};



module.exports = OfferRedeemStyle;

/**
 * End of file:OfferRedeemStyle.js
 */