/**
 * Offer style
 */
var WOStyle = require('/waveo/perkd/styles/WOStyle');

OfferStyle.className = 'OfferStyle';

OfferStyle.OfferImg = {
	height: WOStyle.IS_ANDROID? ((WOStyle.DEVICEDP.width/320*210)+'dp') : '210dp'
}

OfferStyle.STYLE = {
	baseWindow :WOStyle.STYLE.baseWindow,
	navGroup :WOStyle.STYLE.navGroup,
	window : WOStyle.STYLE.window,
	windowTitle: WOStyle.STYLE.windowTitle,
	titlebarShadowContainer: WOStyle.STYLE.titlebarShadowContainer,
	titlebarShadow:		WOStyle.STYLE.titlebarShadow,	
	
	buttonGradient_mainSelected: WOStyle.BUTTON_BG.mainSelected,
	buttonGradient_main:  WOStyle.BUTTON_BG.main,
	SCREEN:{
		width:	WOStyle.DEVICEDP.width,
		height: WOStyle.DEVICEDP.height,
	},

	scrollImgShadow:	{
		bottom: '0', right:'0', left: '0',
		height: '210dp',
		backgroundImage: '/assets/images/ui/imgshadow.png',
		touchEnabled: false,
	},
		
	view : {
		scrollableBg : {
			left:0, top:0, width:'100%', height:'100%',
			contentHeight:Ti.UI.SIZE, contentWidth:'100%',
		},
		canvas	: {
	       	top:0, left:0, right:0,
	       	height: Ti.UI.SIZE,
	       	layout: 'vertical',
	    },
		scrollableViewImage:{
			showPagingControl : true,
			pagingControlHeight : '18dp',
			overlayEnabled: true,
			pagingControlColor : '00000000',
			top : 0,  height: OfferStyle.OfferImg.height,
			backgroundColor: '#45000000',
		},	
		obj_DetailsFrame:{
			 left:0, right:0, bottom: '20dp',
			 top: OfferStyle.OfferImg.height,
	       	 height: Ti.UI.SIZE,
		},

		ImageFrame:{
			top: 0, width: '100%', height: OfferStyle.OfferImg.height, 		
		},
		imageView:{
			width:  WOStyle.IS_ANDROID? WOStyle.DEVICEDP.width+'dp' : '320dp',
			height: OfferStyle.OfferImg.height, 
			backgroundColor: '#dedede',
			scaleType: 'centerCrop',
		},
		stampImageFrame:{
			top: '0', width:'320dp', height:'290dp',
		},
		imageViewStamp:{
			top: '30dp', width:'240dp', height:'240dp', 
		},
		obj_Details:{
			width: '320dp', top:0,
			layout:'vertical', height: Ti.UI.SIZE,
		},
		obj_tips:{
			top: '10dp',  height: '18dp', bottom: '10dp',
			right: '12dp', width: Ti.UI.SIZE,
			layout : 'horizontal', 
		},
		obj_statusContainer:{
			 	right:0, left: 0,
			 	top:'-6dp', 
				height:'80dp',
				backgroundColor: 'transparent',
			    shadow:{
			        shadowRadius	: 2,
			        shadowOpacity	: 0.3,
			        shadowOffset	: {x: 1, y: 2},
			    },
				touchEnabled: false,
			},
		obj_status:{
			width: Ti.UI.SIZE,
			height: '40dp',
			right: '10dp',
			top: '0',
			borderWidth: '1dp',
			borderRadius : WOStyle.DEVICEDP.dp6,
			backgroundImage: '/assets/images/ui/statusbg.png',
			// backgroundGradient:{
				// type:'linear',
				// colors: [ {color:'#00FFFFFF', position : 0.9}, {color:'#80FFFFFF', position : 0.98},{color:'#20FFFFFF', position : 1}],
				// startPoint: {x:0,y:0}, endPoint:{x:0,y:'100%'},
				// backFillStart: false
			// },
			backgroundColor: null,
			touchEnabled: false,
		},
		
		offerStatus:{
			height : Ti.UI.SIZE, width: '290dp', top:'15dp', bottom:'15dp',
			layout: 'composite',
		},		
		statusDesc :{
			layout : 'composite', width:'100%', height : Ti.UI.SIZE,
			touchEnabled: false, 
			borderWidth: WOStyle.DEVICEDP.dp1, borderRadius: WOStyle.DEVICEDP.dp10, borderColor:'transparent',
		},	
		// used in reward page
		stampRow:{
			width: '100%', layout : 'horizontal', 
		},
	},
	webView:{
		tandc:{
			left: 0, right:0, height: Ti.UI.SIZE,
			font: WOStyle.FONT.n18,
	//		scalesPageToFit: false,
			backgroundColor: 'transparent',
	//	willHandleTouches: true,
			touchEnabled: false,
		},
		stampDesc:{
			left: 0, right:0,
			font: WOStyle.FONT.n18,
	//		scalesPageToFit: false,
			backgroundColor: 'transparent',
	//		willHandleTouches: true,
			touchEnabled: false,
		}
	},

	label:{
		obj_name: {
			left:'15dp', right: '12dp', 
			bottom: '13dp', height: '28dp',
			font: WOStyle.FONT.b24, textAlign:'left',
			color:'#FFFFFF', minimumFontSize: '21sp',
			shadowColor: '#80000000', zIndex: 10,
			shadowOffset:{x:-1, y:-1,}
		},
		obj_validDate:{
			top: 0, height: '17dp', right: 0, width: Ti.UI.SIZE, left: '10dp', 
			font: WOStyle.FONT.b15, textAlign:'right',
			color:'#2F9AFE',
		},
		obj_brand: {
			left:'15dp', right: '12dp', top: '-5dp', bottom: '5dp', height: Ti.UI.SIZE,
			font: WOStyle.FONT.b18, textAlign:'left',
			color:'#FFFFFF',
		},
		obj_desc:{
			top: '0', left:'15dp', right: '12dp', height: Ti.UI.SIZE,
			font: WOStyle.IS_ANDROID? WOStyle.FONT.n18 : WOStyle.FONT.n20, textAlign:'left',
			color:'#FFFFFF', opacity:0.6,
		},
		obj_tc:{
			top: '15dp', left:0, right: 0, height: Ti.UI.SIZE,
			font: WOStyle.FONT.b15, textAlign:'left',
			color:'#FFFFFF',
		},
		obj_status:{
				font: WOStyle.FONT.b18,
				color: '#FFFFFF',
				left: '15dp',
				right: '15dp',
				width: Ti.UI.SIZE,
				bottom: '6dp',
		},
		// used for offer page only
		btnLabel:{
			height: Ti.UI.SIZE,  top: '13dp', bottom: '9dp', left: '10dp',
			font: WOStyle.FONT.b24, 
			color: '#FFFFFF', touchEnabled: false,
		},
		btnsubLabel:{
			height: Ti.UI.SIZE,  bottom: '10dp', right: '10dp',
			font: WOStyle.FONT.n15, textAlign:'right',
			color: '#FFFFFF', touchEnabled: false, opacity:0.6,
		},
		// used for reward page only
		levelInfo: {
			width: Ti.UI.SIZE,
		    font : WOStyle.FONT.b15, textAlign : 'left',
		    color:'#FFFFFF', opacity:0.3, top : 0, right: 0,  height: '18dp',
		},
		stampDesc: {
			top: '0', left:'20dp', right: '20dp', bottom: '30dp', height: Ti.UI.SIZE,
			font: WOStyle.IS_ANDROID? WOStyle.FONT.n18 : WOStyle.FONT.n20, textAlign:'left',
			color:'#FFFFFF', opacity:0.8,
		},
		tandc:{
			left: 0, right:0, height: Ti.UI.SIZE,
			font: WOStyle.FONT.n18,
			backgroundColor: 'transparent',
			touchEnabled: false,
		},

	},
	line: {
		backgroundColor: '#606060', height:'1dp', bottom: '10dp', top: 0,
	},
	btn:{
		unlock: WOStyle.merge(WOStyle.STYLE.btn.main, {
			width: '210dp',  height: '56dp'
		}),
		redeem: WOStyle.merge(WOStyle.STYLE.btn.main, {
			width: '210dp', height: '56dp',
		}),
	}
};



function OfferStyle(){
}


module.exports = OfferStyle;

/**
 * End of file:OfferStyle.js
 */