/**
 * WOStyle
 */

WOStyle.className = 'WOStyle';

WOStyle.IS_ANDROID = (Ti.Platform.osname === 'android');
// WOStyle.IS_TRADITIONALCH = (Ti.Locale.currentLanguage=== 'zh-Hant');
// WOStyle.IS_SIMPLIFYCH = (Ti.Locale.currentLanguage=== 'zh-Hans');
// WOStyle.IS_CH =  WOStyle.IS_SIMPLIFYCH || WOStyle.IS_TRADITIONALCH;
WOStyle.IS_CH = ('zh-Hant' == App.Config.LANG.substr(0, 7));

// Ti.API.info( "font= "+ WOStyle.IS_TRADITIONALCH);
// Ti.API.info( "font AAAA= "+ App.Config.LANG);

function WOStyle(param){
}

/**
 * Simple merge & override of 1st level Style properties from options to target
 * 
 * @param {Object} target		NOTE: target & options NOT modified
 * @param {Object} options
 */
WOStyle.merge = function(target, options){
	var merged = _clone(target);
	for(p in options){
		merged[p] = options[p];
    }
    return merged;
};

//-----------------------  Private Methods  --------------------------------
function _clone(obj){
    if(typeof(obj) != 'object' || obj === null){ 
        return obj;
    }
    var newObj = new obj.constructor();  
    for(key in obj){
        newObj[key] = _clone(obj[key]); 
    } 
    return newObj;
};

WOStyle.DEVICE = {
	width	: Ti.Platform.displayCaps.platformWidth,
	height	: Ti.Platform.displayCaps.platformHeight,
};
WOStyle.DEVICEDP = {
	width:	Ti.Platform.displayCaps.platformWidth * 160 / Titanium.Platform.displayCaps.dpi,
	height:	Ti.Platform.displayCaps.platformHeight  * 160 / Titanium.Platform.displayCaps.dpi,
	toPx:	Titanium.Platform.displayCaps.dpi/160,
	dp1:	WOStyle.IS_ANDROID?	1*Titanium.Platform.displayCaps.dpi/160		: 1,
	dp6:	WOStyle.IS_ANDROID?	6*Titanium.Platform.displayCaps.dpi/160		: 6,
	dp8:	WOStyle.IS_ANDROID?	8*Titanium.Platform.displayCaps.dpi/160		: 8,
	dp10:	WOStyle.IS_ANDROID?	10*Titanium.Platform.displayCaps.dpi/160	: 10,
	dp15:	WOStyle.IS_ANDROID?	15*Titanium.Platform.displayCaps.dpi/160	: 15,
	dp23:	WOStyle.IS_ANDROID?	23*Titanium.Platform.displayCaps.dpi/160	: 23,
};

WOStyle.IMAGE = {
	windowBackground: WOStyle.IS_ANDROID ? '/assets/images/ui/bg@2x.png' : '/assets/images/ui/bg.png',
	barImage : WOStyle.IS_ANDROID ? '/assets/images/ui/titlebar@2x.jpg' : '/assets/images/ui/titlebar.jpg',
};

WOStyle.COLOR = {
	titleBar : '#FABA36',
	windowBgColor :'#3D3D3D',
};

// 	
// WOStyle.TYPE = {
	// bold : WOStyle.IS_TRADITIONALCH? 'STHeitiTC-Medium': (WOStyle.IS_SIMPLIFYCH? 'STHeitiTC-Medium' : 'Melbourne-Bold'),
	// normal : WOStyle.IS_TRADITIONALCH? 'STHeitiTC-Light': (WOStyle.IS_SIMPLIFYCH? 'STHeitiSC-Light' : 'Melbourne'),
// };

WOStyle.TYPE = {
	bold :'Melbourne-Bold',
	normal :'Melbourne',
};

WOStyle.FONT	= {
	b60	: { fontSize:  WOStyle.IS_CH? '59sp' : '60sp', fontFamily: WOStyle.TYPE.bold }, 
	b35	: { fontSize:  WOStyle.IS_CH? '34sp' : '35sp', fontFamily: WOStyle.TYPE.bold },
	b32	: { fontSize:  WOStyle.IS_CH? '31sp' : '32sp', fontFamily: WOStyle.TYPE.bold },  
	b30	: { fontSize:  WOStyle.IS_CH? '29sp' : '30sp', fontFamily: WOStyle.TYPE.bold },  //tbd
	b24	: { fontSize:  WOStyle.IS_CH? '23sp' : '24sp', fontFamily: WOStyle.TYPE.bold },
	b20	: { fontSize:  WOStyle.IS_CH? '19sp' : '20sp', fontFamily: WOStyle.TYPE.bold },
	b18	: { fontSize:  WOStyle.IS_CH? '17sp' : '18sp', fontFamily: WOStyle.TYPE.bold },
	b15	: { fontSize:  WOStyle.IS_CH? '14sp' : '15sp', fontFamily: WOStyle.TYPE.bold },
	b13:  { fontSize:  WOStyle.IS_CH? '12sp' : '13sp', fontFamily: WOStyle.TYPE.bold },
	b12	: { fontSize:  WOStyle.IS_CH? '11sp' : '12sp', fontFamily: WOStyle.TYPE.bold}, //Reward Set no 

	n30	: { fontSize:  WOStyle.IS_CH? '29sp' : '30sp', fontFamily: WOStyle.TYPE.normal },  //tbd
	n26	: { fontSize:  WOStyle.IS_CH? '25sp' : '26sp', fontFamily: WOStyle.TYPE.normal}, //only in reward set list
	n24	: { fontSize:  WOStyle.IS_CH? '23sp' : '24sp', fontFamily: WOStyle.TYPE.normal},
	n22	: { fontSize:  WOStyle.IS_CH? '21sp' : '22sp', fontFamily: WOStyle.TYPE.normal},
	n20	: { fontSize:  WOStyle.IS_CH? '19sp' : '20sp', fontFamily: WOStyle.TYPE.normal},
	n18	: { fontSize:  WOStyle.IS_CH? '17sp' : '18sp', fontFamily: WOStyle.TYPE.normal},
	n17	: { fontSize:  WOStyle.IS_CH? '16sp' : '17sp', fontFamily: WOStyle.TYPE.normal},
	n15	: { fontSize:  WOStyle.IS_CH? '14sp' : '15sp', fontFamily: WOStyle.TYPE.normal},
	n12	: { fontSize:  WOStyle.IS_CH? '11sp' : '12sp', fontFamily: WOStyle.TYPE.normal}, //points font 
	
// used for card factory
	n35	: { fontSize: WOStyle.IS_CH? '34sp' : '35sp', fontFamily: WOStyle.TYPE.normal},
	n8	: { fontSize:'8sp', fontFamily: WOStyle.TYPE.normal}, 
	n5	: { fontSize:'5sp', fontFamily: WOStyle.TYPE.normal},
};


// WOStyle.FONT	= {
	// b60	: { fontSize:'60sp', fontFamily: WOStyle.TYPE.bold }, 
	// b35	: { fontSize:'35sp', fontFamily: WOStyle.TYPE.bold },
	// b32	: { fontSize:'32sp', fontFamily: WOStyle.TYPE.bold },  
	// b30	: { fontSize:'30sp', fontFamily: WOStyle.TYPE.bold },  //tbd
	// b24	: { fontSize:'24sp', fontFamily: WOStyle.TYPE.bold },
	// b20	: { fontSize:'20sp', fontFamily: WOStyle.TYPE.bold },
	// b18	: { fontSize:'18sp', fontFamily: WOStyle.TYPE.bold },
	// b15	: { fontSize:'15sp', fontFamily: WOStyle.TYPE.bold },
	// b12	: { fontSize:'12sp', fontFamily: WOStyle.TYPE.bold}, //Reward Set no 
// 
	// n26	: { fontSize:'26sp', fontFamily: WOStyle.TYPE.normal}, //only in reward set list
	// n22	: { fontSize:'22sp', fontFamily: WOStyle.TYPE.normal},
	// n24	: { fontSize:'24sp', fontFamily: WOStyle.TYPE.normal},
	// n20	: { fontSize:'20sp', fontFamily: WOStyle.TYPE.normal},
	// n18	: { fontSize:'18sp', fontFamily: WOStyle.TYPE.normal},
	// n16	: { fontSize:'16sp', fontFamily: WOStyle.TYPE.normal},
	// n15	: { fontSize:'15sp', fontFamily: WOStyle.TYPE.normal},
	// n12	: { fontSize:'12sp', fontFamily: WOStyle.TYPE.normal}, //points font 
// 	
// // used for card factory
	// n35	: { fontSize:'35sp', fontFamily: WOStyle.TYPE.normal},
	// n8	: { fontSize:'8sp', fontFamily: WOStyle.TYPE.normal}, 
	// n5	: { fontSize:'5sp', fontFamily: WOStyle.TYPE.normal},
// };

WOStyle.TEXTFIELD = {
	left: WOStyle.IS_ANDROID ? 0 : '12dp', right: WOStyle.IS_ANDROID ? 0 : '8dp', top:0, height:'42dp',
	font: WOStyle.FONT.b20, color: '#FFFFFF',
	backgroundColor: 'transparent',
	borderWidth: 0, borderColor: 'transparent', borderStyle:Ti.UI.INPUT_BORDERSTYLE_NONE,
	softKeyboardOnFocus: WOStyle.IS_ANDROID ? Ti.UI.Android.SOFT_KEYBOARD_SHOW_ON_FOCUS : null,
	clearButtonMode: Ti.UI.INPUT_BUTTONMODE_ONFOCUS,
	touchEnabled: true,
	autocorrect: false,
};

WOStyle.TEXTFIELD_MOBILE = WOStyle.merge(WOStyle.TEXTFIELD, {
	keyboardType: WOStyle.IS_ANDROID? Ti.UI.KEYBOARD_PHONE_PAD : Ti.UI.KEYBOARD_NUMBERS_PUNCTUATION,
	hintText: App.Helper.L('account_label_mobilePhoneNumber'),
});

WOStyle.TEXTFIELD_PASSWORD = WOStyle.merge(WOStyle.TEXTFIELD, {
	keyboardType: WOStyle.IS_ANDROID? Ti.UI.KEYBOARD_DEFAULT : Ti.UI.KEYBOARD_NUMBERS_PUNCTUATION,
	passwordMask: true,
});

WOStyle.TEXTFIELD_HIDDEN = {
	left:0, right:0, top:0, height: 1,
	backgroundColor: 'transparent',
	borderWidth: 0, borderColor: 'transparent', borderStyle:Ti.UI.INPUT_BORDERSTYLE_NONE,
	autocorrect: false,
	softKeyboardOnFocus: WOStyle.IS_ANDROID ? Ti.UI.Android.SOFT_KEYBOARD_HIDE_ON_FOCUS : null,
};
WOStyle.BUTTON = {
	style: WOStyle.IS_ANDROID ? null : Ti.UI.iPhone.SystemButtonStyle.PLAIN,
	borderRadius: WOStyle.DEVICEDP.dp6,
	borderWidth: WOStyle.DEVICEDP.dp1,
	height: WOStyle.IS_ANDROID ?'44dp' :'42dp',
	font: WOStyle.FONT.b24,
	textAlign:'center',
	color: '#FFFFFF',
	selectedColor:  '#FFFFFF',
//	backgroundImage: null,
};
WOStyle.ANDROID_BUTTON = {
	backgroundColor: 'transparent',
	backgroundImage: null,
	backgroundSelectedImage: null,
	backgroundSelectedColor: 'transparent',
	backgroundGradient: null,
	borderRadius: WOStyle.DEVICEDP.dp6,
	borderWidth: WOStyle.DEVICEDP.dp1,
	borderColor: '#504D4D4D',
	height: '30dp',
	width: '60dp',
	font: WOStyle.FONT.b15,
	textAlign:'center',
	color: '#FFFFFF',
	selectedColor:  '#FFFFFF',
};
WOStyle.ANDROID_IMGBUTTON = {
	backgroundColor: 'transparent',
	backgroundImage: null,
	backgroundSelectedImage: null,
	backgroundSelectedColor: 'transparent',
	backgroundGradient: null,
	height: '30dp',
	font: WOStyle.FONT.b15,
	textAlign:'center',
	color: '#FFFFFF',
	selectedColor:  '#FFFFFF',
};

WOStyle.BUTTON_BG = {
	main:{
		type:'linear', colors:['#2990FE','#0056E5'],
//		type:'linear', colors:['#A75C9DFF','#C7004EFF'],
		startPoint:{x:0,y:0}, endPoint:{x:0,y:'100%'},
		backFillStart:false
	},
	mainSelected:{
		type:'linear', colors:['#0056E5','#2990FE'],
//		type:'linear', colors:['#C7004EFF','#A75C9DFF'],
		startPoint:{x:0,y:0}, endPoint:{x:0,y:'100%'},
		backFillStart:false
	},
	sub:{
		type:'linear', colors:['#66DADADA','#40666666'],
		startPoint:{x:0,y:0}, endPoint:{x:0,y:'100%'},
		backFillStart:false
	},
	subSelected:{
		type:'linear', colors:['#40666666','#66DADADA'],
		startPoint:{x:0,y:0}, endPoint:{x:0,y:'100%'},
		backFillStart:false
	},
	alert:{
		type:'linear', colors:['#f96262','#d13a3a'],
		startPoint:{x:0,y:0}, endPoint:{x:0,y:'100%'},
		backFillStart:false
	},
	alertSelected:{
		type:'linear', colors:['#d13a3a','#f96262'],
		startPoint:{x:0,y:0}, endPoint:{x:0,y:'100%'},
		backFillStart:false
	},
};
if(WOStyle.IS_ANDROID){
	WOStyle.SYSTEMBUTTON = {
	//nav bars and toolbars only.
		EDIT : WOStyle.merge (WOStyle.ANDROID_BUTTON, {title:App.Helper.L('BUTTON_EDIT')}),
		SAVE : WOStyle.merge (WOStyle.ANDROID_BUTTON, {title:App.Helper.L('BUTTON_SAVE')}),
		DONE : WOStyle.merge (WOStyle.ANDROID_BUTTON, {title:App.Helper.L('BUTTON_DONE')}),
		CANCEL : WOStyle.merge (WOStyle.ANDROID_BUTTON, {title:App.Helper.L('BUTTON_CANCEL'),  width: '65dp'}),
		REGISTER : WOStyle.merge (WOStyle.ANDROID_BUTTON, {title:App.Helper.L('BUTTON_REGISTER'), width: '75dp'}),
		LATER : WOStyle.merge (WOStyle.ANDROID_BUTTON, {title:App.Helper.L('BUTTON_LATER')}),
		SHARE : WOStyle.merge (WOStyle.ANDROID_BUTTON, {title:App.Helper.L('BUTTON_SHARE')}),
		CLEAR : WOStyle.merge (WOStyle.ANDROID_BUTTON, {title:App.Helper.L('BUTTON_CLEAR')}),
	};
} else {
	WOStyle.SYSTEMBUTTON = {
		ABOUT: {systemButton:	Ti.UI.iPhone.SystemButton.INFO_LIGHT},
		DONE :{systemButton:Ti.UI.iPhone.SystemButton.DONE,},
		SAVE :{systemButton:	Ti.UI.iPhone.SystemButton.SAVE},
		REGISTER : {style:Ti.UI.iPhone.SystemButtonStyle.BAR, title:App.Helper.L('BUTTON_REGISTER')},
		LATER : {style:Ti.UI.iPhone.SystemButtonStyle.BAR, title:App.Helper.L('BUTTON_LATER')},

		EDIT :{systemButton:	Ti.UI.iPhone.SystemButton.EDIT},
		CANCEL :{systemButton:	Ti.UI.iPhone.SystemButton.CANCEL},
		CLEAR :{title:App.Helper.L('BUTTON_CLEAR'), style:Ti.UI.iPhone.SystemButtonStyle.BAR},
		SHARE :{title:App.Helper.L('BUTTON_SHARE'), style:Ti.UI.iPhone.SystemButtonStyle.BAR},
		FLEXIBLE_SPACE :{systemButton: Ti.UI.iPhone.SystemButton.FLEXIBLE_SPACE},
		FIXED_SPACE :{width: '25dp', systemButton: Ti.UI.iPhone.SystemButton.FIXED_SPACE},
	};


}
//button

WOStyle.SEARCHBAR = {
	showCancel:true, barColor:'#FDCC66', top:0,
	autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
	autocorrect:false, 
	backgroundGradient:{
		type:'linear', colors: ['#fde3ad','#fdcc67'],
		startPoint:{x:0,y:0}, endPoint:{x:0,y:'100%'},
		backFillStart:false
	},
	softKeyboardOnFocus: WOStyle.IS_ANDROID ? Ti.UI.Android.SOFT_KEYBOARD_SHOW_ON_FOCUS : null,
	touchEnabled: true,
	focusable : true,
},

WOStyle.STYLE = {
// If it is a window please include these codes on top of ur style file.
	// baseWindow :WOStyle.STYLE.baseWindow,
	// navGroup :WOStyle.STYLE.navGroup,
	// window : WOStyle.STYLE.window,
	// windowTitle: WOStyle.STYLE.windowTitle,
    baseWindow : {},
	navGroup :{top: 0},
	window : {
		top:0, left:0,
		width: WOStyle.DEVICE.width,
		backgroundImage: WOStyle.IMAGE.windowBackground,
		backgroundColor: WOStyle.COLOR.windowBgColor,
		barImage: WOStyle.IMAGE.barImage,
		barColor: WOStyle.COLOR.titleBar,
	},
	windowTitle : {
	//	width: '60%',
		font :   WOStyle.IS_ANDROID? WOStyle.FONT.b20 : WOStyle.FONT.b24,
		minimumFontSize : '16sp',
		color : '#A15209',
	 	shadowColor : 'white',
		shadowOffset : {x : 0, y : 1},
		textAlign : 'center',
		touchable: false,
		left: WOStyle.IS_ANDROID? '70dp':null,
		right: WOStyle.IS_ANDROID? '70dp':null,
	},
// General VIEW	
	scrollableBg : {
		left:0, top:0, width:'100%', height:'100%',
		contentHeight:Ti.UI.SIZE, contentWidth:'100%',
       	layout: 'composite', 
	},

	scrollableCanvas : {
		left:0, top:0, width:'100%', height:'100%',
		contentHeight: Ti.UI.SIZE, contentWidth:'100%',
       	layout: 'vertical',
	},
	scrollBg : {
		left:0, right:0, top:0, height:'100%',
		contentHeight: Ti.UI.SIZE, contentWidth:'100%',
       	layout: 'composite',
	},
	canvas	: {
       	left:0, right:0, top:0,
       	height: Ti.UI.SIZE,
       	layout: 'vertical',
    },
    canvas_absolute	: {
       	top:0, left:0, right:0,
       	height:'100%',
       	layout: 'composite',
    },
	flexFooter: {
		height: Ti.UI.FILL,
       	layout: 'composite',
	},
	tableView:{
		style: WOStyle.IS_ANDROID ? null : Ti.UI.iPhone.TableViewStyle.GROUPED,
		separatorStyle: WOStyle.IS_ANDROID ? null : Ti.UI.iPhone.TableViewSeparatorStyle.NONE,
		backgroundColor:'transparent',
		separatorColor:'#4d4d4d',
		showVerticalScrollIndicator:false,
		scrollable:false,
		left:WOStyle.IS_ANDROID ? null : '12dp',
		right: WOStyle.IS_ANDROID ? null : '12dp', 
		width: WOStyle.IS_ANDROID ? '288dp' : null,
		rowHeight:'45dp',
	},

	activityIndicator:{
		style: Titanium.UI.iPhone.ActivityIndicatorStyle.BIG,
	},
	
	//  used by FORM
	
	fieldWindow:{},

////////--- waveo button
	btn:{
		main:  WOStyle.merge(WOStyle.BUTTON, {
			borderColor: '#2990FE',
			backgroundGradient: WOStyle.BUTTON_BG.main,
		}),
		sub:  WOStyle.merge(WOStyle.BUTTON, {
			borderColor: '#66DADADA',
			backgroundGradient: WOStyle.BUTTON_BG.sub,
		}),
		alert:  WOStyle.merge(WOStyle.BUTTON, {
			borderColor: '#d13a3a',
			backgroundGradient: WOStyle.BUTTON_BG.alert,
		}),
	},
	
////////--- titlebar layout
	titlebarShadowContainer:{
	 	top:'-44dp', right:0, left: 0, height:'90dp',
		shadow:{
	        shadowRadius	: 12,
	        shadowOpacity	: 0.45,
	        shadowOffset	: {x: 5, y: 10},
		},
		zIndex: 99999,
		touchEnabled: false,
	},
	titlebarShadow : {
		top: 0, right:'-15dp', left: '-15dp',
		height: '44dp',
		zIndex: 99999,
		backgroundColor: WOStyle.COLOR.windowBgColor,	
    },
    titlebar : {
		top: 0, right:0, left: 0,
		height: '44dp',
		zIndex: 100000,
		backgroundImage: WOStyle.IMAGE.barImage,
		backgroundColor: WOStyle.COLOR.windowBgColor,
    },
	perkd_btn : {
        width:'100dp', height:'44dp', left:'5dp',
        backgroundImage: WOStyle.IS_ANDROID ? '/assets/images/buttons/perkid@2x.png' : '/assets/images/buttons/perkid.png',
	},
//////--toolBar
	toolBar: {
		bottom:'215dp', height: '44dp', width: WOStyle.IS_ANDROID? WOStyle.DEVICEDP.width+'dp' : '100%',
		borderTop: true, borderBottom: false, translucent: true,
		barColor: '#999'
	},
	btnToolBar: {
		width: WOStyle.IS_ANDROID? WOStyle.DEVICEDP.width+'dp' : '100%', height: '44dp',
 		bottom : 0, barColor : '#000000',
	},
////--datePicker
	datePicker:{
		type: Ti.UI.PICKER_TYPE_DATE,
		left:0, right:0, bottom: (WOStyle.IS_ANDROID)? null : 0,
	},
	datePickerArea:{
		left:0, right:0, bottom: 0, height: '215dp',
		backgroundColor: '#262626',
	},
	datePickerPanel:{
		left:0, right:0, bottom: 0, height: '259dp',
	},
///////--tabbedBar Gender
	tabbedBar: {
		gender: {
			labels: [{title:App.Helper.L('Male'), width: WOStyle.IS_CH? '45dp' : '60dp'}, {title:App.Helper.L('Female'), width: WOStyle.IS_CH? '45dp' : (WOStyle.IS_ANDROID? '79dp':'60dp')}],
//			labels: [{title:App.Helper.L('Male'), width: WOStyle.IS_CH? '45dp' : (WOStyle.IS_ANDROID? '60dp':'45dp')}, {title:App.Helper.L('Female'), width: WOStyle.IS_CH? '45dp' : (WOStyle.IS_ANDROID? '79dp':'64dp')}],
			backgroundColor:'#666666',
			borderColor: WOStyle.IS_ANDROID? '#555555' : 'transparent',
			font: WOStyle.FONT.b15,
			height:'32dp', top:'5dp', 
			width: WOStyle.IS_CH? '91dp' : (WOStyle.IS_ANDROID? '140dp':'121dp'), right:0,
			style: WOStyle.IS_ANDROID ? null : Ti.UI.iPhone.SystemButtonStyle.BAR,
			backgroundGradient: WOStyle.IS_ANDROID ? ({type:'linear', colors:['#79DDDDDD','#222222'], startPoint:{x:0,y:0}, endPoint:{x:0,y:'100%'}, backFillStart:false}) : null,
		},
	},

};

module.exports = WOStyle;

//---  End of file: WOStyle.js

