/**
 * PerkIDSkippedWindow
 */
Ti.include('/globals.js');

var PerkIDSkippedWindow = App.Class(App.View.WOWindow, {
	className 	: 'PerkIDSkippedWindow',
	stylePath	: 'AuthStyle',

	//--- Event Name constants -----
	EVENT		: {
		//--- Controller to handle:
		signup			: 'PerkIDWindow.signup',
		login			: 'PerkIDWindow.login',
		later			: 'PerkIDWindow.later',
	//	account			: 'PerkIDWindow.account',
    },

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

	    self.WINDOW.title	= '';
	    self.WINDOW.type	= App.Const.WINDOW.type.navGroup;
	    self.WINDOW.effect	= App.Const.WINDOW.effect.flip;
		self.WINDOW.hideNavBar = true;
	},
	
	draw : function(param){
		var self = this;

		var canvas = Ti.UI.createView(self.STYLE.PerkIDSkipped.canvas);
		
		//----- Cancel Button  ----------------
		B_Back = Ti.UI.createButton(self.STYLE.PerkIDSkipped.backBtn);
		B_Back.addEventListener('touchstart', function(){
			B_Back.opacity=0.5;
		});
		B_Back.addEventListener('touchend', function(){
			B_Back.opacity=1;
		});
		B_Back.addEventListener('click', function(evt){
			self.close({ animated : true });
		});
		
		//------- Title  ----------------------
		var L_Oops = Ti.UI.createLabel(self.STYLE.PerkIDSkipped.H1);
		L_Oops.text = App.Helper.L('auth_OOPS');
		canvas.add(L_Oops);

		//----- Signup Button  ------------------
		var B_Signup = Ti.UI.createButton(self.STYLE.PerkIDSkipped.signupBtn);
		B_Signup.title = App.Helper.L('auth_PERKIDSIGNUP');

		B_Signup.addEventListener('touchstart', function(){
			B_Signup.backgroundGradient = self.STYLE.buttonSelectGradient;
		});
		B_Signup.addEventListener('touchend', function(){
			B_Signup.backgroundGradient=self.STYLE.buttonGradient;
		});	
		B_Signup.addEventListener('click', _doSignUp);
		canvas.add(B_Signup);
		
		//------  Subtitle  -------------------
		var L_WhyNeed = Ti.UI.createLabel(self.STYLE.PerkIDSkipped.link);
        L_WhyNeed.text = App.Helper.L('auth_WHYNEED');
        L_WhyNeed.addEventListener('click', _doLater);
		canvas.add(L_WhyNeed);
		
		
		//----- Sign-In Button  ------------------
		var V_Login = Ti.UI.createView(self.STYLE.PerkIDSkipped.loginFrame);

		var L_LoginDesc =Ti.UI.createLabel(self.STYLE.PerkIDSkipped.desc);
		L_LoginDesc.text = App.Helper.L('auth_ALREADYHAVE');
		
		var B_Login = Ti.UI.createButton(self.STYLE.PerkIDSkipped.loginBtn);
		var L_Login = Ti.UI.createLabel(self.STYLE.PerkIDSkipped.btnLabel);
		L_Login.text = App.Helper.L('BUTTON_LOGIN');
		
		B_Login.addEventListener('touchstart', function(){
			B_Login.backgroundGradient = self.STYLE.buttonSelectGradient;
		});
		B_Login.addEventListener('touchend', function(){
			B_Login.backgroundGradient=self.STYLE.buttonGradient;
		});
		
		B_Login.addEventListener('click', _doLogin);

		V_Login.add(L_LoginDesc);		
		V_Login.add(B_Login);
		V_Login.add(L_Login);
		canvas.add(V_Login);

		//------------  Place components onto View  -----------
		self.VIEW.add(canvas);
		self.VIEW.add(B_Back);

		//---------------------  Controller Event Handlers  ----------------------
		function _doSignUp(evt){
			self._eventProxy.fireEvent(self.EVENT.signup, {});
		}
        function _doLogin(evt){
			self._eventProxy.fireEvent(self.EVENT.login, {});
		}
		function _doLater(evt){
	       	L_WhyNeed.color='#000000';
	        L_WhyNeed.opacity=0.5;
	        L_WhyNeed.shadowColor = "#FFFFFF";
            
            self._eventProxy.fireEvent(self.EVENT.later, {
            	isSkipped	: self.DATA.isSkipped,
            });
			L_WhyNeed.color='#FFFFFF';
			L_WhyNeed.opacity=0.8;
			L_WhyNeed.shadowColor = "transparent";
        }
	},	

	dispose : function(){
		var self = this;

		self.base();
	},
});

module.exports = PerkIDSkippedWindow;

//---  End of file:PerkIDWindow.js
