/**
 * UpdateMobileWindow
 */
Ti.include('/globals.js');

var UpdateMobileWindow = App.Class(App.View.WOWindow, {
	className 	: 'UpdateMobileWindow',
	stylePath 	: 'AccountMgtStyle',

	EVENT		: {
		//--- Controller to handle:
		updateMobileNo	: 'UpdateMobileWindow.updateMobileNo',
		verifyCode		: 'UpdateMobileWindow.later',
		resendCode		: 'UpdateMobileWindow.resendCode',
		searchCountry	: 'UpdateMobileWindow.searchCountry',
		mobileVerified	: 'UpdateMobileWindow.mobileVerified',
		//--- events from Controller:
		mobileUpdated	: 'UpdateMobileWindow.mobileUpdated',
		codeSent		: 'UpdateMobileWindow.codeSent',
    },

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		self.WINDOW.hideTabBar = true;				
		self.WINDOW.title = App.Helper.L('TITLE_MOBILENUMBER');
		
		self.NEWMOBILE = {
			countryCode : self.DATA.countryCode,
			mobileNum : '',
			mobileNo  : '',
		};
	},
	
	draw : function(param){
		var self = this;
		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		
		self.VIEW.add(titlebarShadowContainer);
			
		var canvas = Ti.UI.createView(self.STYLE.view.canvas_absolute);

		//Android Start use a hidden textfield to fix the autofocus issue temporarily
		if (App.Config.IS_ANDROID) {
			var F_HIDDEN = Ti.UI.createTextField(self.STYLE.textfield.HIDDEN);
			canvas.add(F_HIDDEN);
		};
		//Android END		//----------------------  Form 1 -----------------------------
 
 		var view_mobileNo = Ti.UI.createView(self.STYLE.view.mobileNo);		

        //----  Description text  ----
 		var lbl_desc = Ti.UI.createLabel(self.STYLE.label.desc);
        lbl_desc.text = App.Helper.L('account_updateMobileNumberDesc');

        //----  Field: Mobile No.  ----
		var view_CountryCode =  Ti.UI.createView(self.STYLE.view.enterCountryCode);

		var line2 = Ti.UI.createView (self.STYLE.LINE2);
		var line3 = Ti.UI.createView (self.STYLE.LINE3);
	
		self.L_CountryCode = Ti.UI.createLabel(self.STYLE.btnLabel.countryCode);
		self.L_CountryCode.text = '+'+self.DATA.countryCode;
		
		self.L_CountryName = Ti.UI.createLabel(self.STYLE.btnLabel.countryName);
		self.L_CountryName.text = self.DATA.countryName;
		var arrow = Ti.UI.createImageView(self.STYLE.view.arrow);

		view_CountryCode.add(self.L_CountryCode);
		view_CountryCode.add(line2);
		view_CountryCode.add(line3);
		view_CountryCode.add(self.L_CountryName);
		view_CountryCode.add(arrow);

		view_CountryCode.addEventListener('click', function(evt){
			view_CountryCode.backgroundGradient = self.STYLE.buttonGradient_mainSelected;
			self._eventProxy.fireEvent(self.EVENT.searchCountry, {});
			view_CountryCode.backgroundGradient = self.STYLE.buttonGradient_main;
		});

		var view_mobileNoField = Ti.UI.createView(self.STYLE.view.enterMobileNoBg);
		var F_MOBILENO = Ti.UI.createTextField(self.STYLE.textfield.mobile);

		F_MOBILENO.addEventListener('focus', function(){
			if(!F_MOBILENO.value){
			 	 if(App.Config.IS_ANDROID) F_MOBILENO.setSelection(F_MOBILENO.value.length,F_MOBILENO.value.length)
			 }
		});
		F_MOBILENO.addEventListener('return', _doUpdateMobileNo);
        view_mobileNoField.add(F_MOBILENO);
 
		view_mobileNo.add(lbl_desc);
		view_mobileNo.add(view_CountryCode);
		view_mobileNo.add(view_mobileNoField);
 
        //-----------------------  Form 2 ----------------------------
		var view_verification = Ti.UI.createView(self.STYLE.view.verification);

        //----  Field: verification code  ----
	    var lbl_entercode = Ti.UI.createLabel(self.STYLE.label.desc);
        lbl_entercode.text = App.Helper.L('account_ENTERVERIFICATION');

 		F_VERIFICATIONCODE = Ti.UI.createTextField(self.STYLE.textfield.verificationcode);
        F_VERIFICATIONCODE.addEventListener('return', _doVerifyCode);

		var view_code = Ti.UI.createView(self.STYLE.view.verificationcode);
		view_code.height = F_VERIFICATIONCODE.height;
        
        view_code.add(F_VERIFICATIONCODE);
       
		//----  add UI elements to Form 2  ----
		view_verification.add(lbl_entercode);
		view_verification.add(view_code);

		var B_submit = Ti.UI.createButton(self.STYLE.btn.submitCode);
       B_submit.title = App.Helper.L('account_submit');
       B_submit.addEventListener('click', _doVerifyCode);


       //----  Code Resend  ----
		self.L_codeResend = Ti.UI.createLabel(self.STYLE.label.codeResend);
		self.L_codeResend.text = App.Helper.L('account_RESENDCODE');
		self.L_codeResend.addEventListener('click', _doResendCode);

		
        //----  add UI elements to Form 1  ----		
		var viewScrollableBg = Ti.UI.createScrollView(self.STYLE.scrollableBg);
		canvas.add(view_mobileNo);
		canvas.add(view_verification);
		canvas.add(B_submit);
		canvas.add(self.L_codeResend);

		viewScrollableBg.add(canvas);

		view_verification.visible = false;
		B_submit.visible = false;
		self.L_codeResend.visible =false;
		
		
		viewScrollableBg.addEventListener('click', function(){
			F_VERIFICATIONCODE.blur();
			F_MOBILENO.blur();
		});


		//------------  Place components onto View  -----------		
		self.VIEW.add(viewScrollableBg);
		// self.VIEW.addEventListener('close', function(e){
			// F_VERIFICATIONCODE.blur();
			// F_MOBILENO.blur();
		// });


		//---------------------  Controller Event Handlers  ----------------------
        function _doUpdateMobileNo(evt){
        	var mobileNo = self.L_CountryCode.text+F_MOBILENO.value;
            if(!F_MOBILENO.value || mobileNo == self.DATA.countryCode){
                $.app.showAlert(App.Helper.L('mobile_error'), App.Helper.L('TITLE_CHANGEMOBILE'));
                return;
            }
            
            //---  Confirm Update mobile  ----
			var comfirmAlert = Ti.UI.createAlertDialog({
				title       : App.Helper.L('TITLE_CONFIRM'),
				message     : String.format(App.Helper.L('confirm_mobile'), mobileNo),
				buttonNames : [App.Helper.L('BUTTON_CANCEL'), App.Helper.L('BUTTON_OK')]
			});
			comfirmAlert.show();
			comfirmAlert.addEventListener('click', function(evt){
				if(evt.index == 1){
					self.NEWMOBILE.countryCode = self.L_CountryCode.text;
		            self.NEWMOBILE.mobileNum = F_MOBILENO.value;
		            self.NEWMOBILE.mobileNo = self.L_CountryCode.text+F_MOBILENO.value;
		            // F_MOBILENO.value = evt.mobileNum;
		
					//---  Listen for Controller response  ---
					self._eventProxy.addEventListener(self.EVENT.mobileUpdated, _handleMobileUpdated);
					//---  Call Controller  ---
					self._eventProxy.fireEvent(self.EVENT.updateMobileNo, {
						countryCode : self.NEWMOBILE.countryCode,
						mobileNum   : self.NEWMOBILE.mobileNum,
						mobileNo	: mobileNo,
					});
				}
			});
        }
        function _doVerifyCode(){
        	B_submit.backgroundGradient = self.STYLE.buttonGradient_mainSelected;
        	
            if(! F_VERIFICATIONCODE.value){
                $.app.showAlert(App.Helper.L('no_code'));
 	        	B_submit.backgroundGradient = self.STYLE.buttonGradient_main;
               return;
            }
			//---  Call Controller  ---
			self._eventProxy.fireEvent(self.EVENT.verifyCode, {
				mobileNo	: self.NEWMOBILE.mobileNo,
                resend      : false,
                code        : F_VERIFICATIONCODE.value,
			});
        	B_submit.backgroundGradient = self.STYLE.buttonGradient_main;
        }
        function _doResendCode(){
        	self.L_codeResend.opacity = 0.5;
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();

			//---  Listen for Controller response  ---
			self._eventProxy.addEventListener(self.EVENT.codeSent, _handleCodeSent);
			//---  Call Controller  ---
			self._eventProxy.fireEvent(self.EVENT.resendCode, {
				mobileNo	: self.NEWMOBILE.mobileNo,
                resend      : true,
			});
        	self.L_codeResend.opacity = 1;
        }

		//-------------  Events from Controllers  ----------
		function _handleMobileUpdated(evt){
			self._eventProxy.removeEventListener(self.EVENT.mobileUpdated, _handleMobileUpdated);
			
            // F_MOBILENO.value = evt.mobileNum;
            $.app.showAlert(String.format(App.Helper.L('cm_code_sent'), self.NEWMOBILE.mobileNo), App.Helper.L('TITLE_CHANGEMOBILE'));

             if(!view_verification.visible){
     			view_mobileNo.visible = false;
     			
     			setTimeout(function(){
            		self.L_codeResend.visible = true;
                },6000);
                
            	view_verification.visible = true;
            	B_submit.visible  = true;
           		view_verification.animate({
     				 opacity:1,
     				 duration:500
     			});
     			B_submit.animate({
     				opacity:1,
     				duration:500
     			});
     		}
     		
     		var cancelBtn = Ti.UI.createButton(self.STYLE.btn.cancel);
     		cancelBtn.title = App.Helper.L('BUTTON_CANCEL');
     		self.VIEW.setLeftNavButton(cancelBtn);
     		
     		cancelBtn.addEventListener('click', function(evt){
     			F_VERIFICATIONCODE.blur();
     			self.close({animated:true});
     		});
		}
		function _handleCodeSent(evt){
			self._eventProxy.removeEventListener(self.EVENT.codeSent, _handleCodeSent);
			
			if(!evt.error){
				$.app.showAlert(String.format(App.Helper.L('cm_code_sent'), self.NEWMOBILE.mobileNo), App.Helper.L('TITLE_CHANGEMOBILE'));
			}
		}		
	},
	
	updateCountry : function(country){
		var self = this;
		self.L_CountryCode.text = '+'+country.code;
		self.L_CountryName.text = country.name;
	},
	
	dispose:function(){
		var self = this;
		self.base();
		
	}
});

module.exports = UpdateMobileWindow;

//---  End of file: UpdateMobileWindow.js
