/**
 * UpdatePasswordWindow
 */
Ti.include('/globals.js');

var UpdatePasswordWindow = App.Class(App.View.WOWindow, {
	className 	: 'UpdatePasswordWindow',
	stylePath 	: 'AccountMgtStyle',

	EVENT		: {
		//--- Controller to handle:
		changePassword	: 'UpdatePasswordWindow.changePassword',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		self.WINDOW.hideTabBar = true;				
		self.WINDOW.title = App.Helper.L('account_title_changePassword');
	},
	
	draw : function(param){
		var self = this;
		
		var _old;
		var _new;
		var _confirm;
		
		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		
		self.VIEW.add(titlebarShadowContainer);
			
		var canvas = Ti.UI.createView(self.STYLE.view.canvas_absolute);

		//Android Start use a hidden textfield to fix the autofocus issue temporarily
		if (App.Config.IS_ANDROID) {
			var F_HIDDEN = Ti.UI.createTextField(self.STYLE.textfield.HIDDEN);
			canvas.add(F_HIDDEN);
		};
		//Android END
		
		//---  Title  -------------------------
		var lbl_desc = Ti.UI.createLabel(self.STYLE.label.desc);
		lbl_desc.text= App.Helper.L('account_label_changeYourPassword');
		canvas.add(lbl_desc);

		//---  Form  --------------------------
		var changePSWForm = Ti.UI.createView(self.STYLE.view.password);
		//---  Old Password  --------
		var F_OLDPASSWORD = Ti.UI.createTextField(self.STYLE.textfield.oldPSW);
		F_OLDPASSWORD.addEventListener('return', function(e){
			F_NEWPASSWORD.focus();
		});
		//---  New Password  --------
		var F_NEWPASSWORD = Ti.UI.createTextField(self.STYLE.textfield.newPSW);
		F_NEWPASSWORD.addEventListener('return', function(e){
			F_CONFIRMPSWD.focus();
		});
		//---  Confirm New Password  --------
		var F_CONFIRMPSWD = Ti.UI.createTextField(self.STYLE.textfield.confirmPSW);
		F_CONFIRMPSWD.addEventListener('return', _doChangePassword);
				
		var viewSeprator1 = Ti.UI.createView(self.STYLE.seprator);
		var viewSeprator2 = Ti.UI.createView(self.STYLE.seprator);

		//------------  Place components onto View  -----------		
		changePSWForm.add(F_OLDPASSWORD);
		changePSWForm.add(viewSeprator1);
		changePSWForm.add(F_NEWPASSWORD);
		changePSWForm.add(viewSeprator2);
		changePSWForm.add(F_CONFIRMPSWD);
				
		canvas.add(changePSWForm);
		self.VIEW.add(canvas);
		
		self.VIEW.addEventListener ('click', function(){
			F_OLDPASSWORD.blur();
			F_CONFIRMPSWD.blur();
			F_CONFIRMPSWD.blur();
		});
	
		//---------------------  Controller Event Handlers  ----------------------
		function _doChangePassword(evt){
			_old		= F_OLDPASSWORD.value;
			_new		= F_NEWPASSWORD.value;
			_confirm	= F_CONFIRMPSWD.value;
			
			if(!_old ){
				F_OLDPASSWORD.focus();
				return;
			}
			if(!_new ){
				F_NEWPASSWORD.focus();
				return;
			}
			if(!_confirm ){
				F_CONFIRMPSWD.focus();
				return;
			}
			
			if(_new != _confirm){
				$.app.showAlert(App.Helper.L('pswd_not_match'), App.Helper.L('TITLE_CHANGEPASSWORD'));
				return;
			}

			//---  Call Controller  ---
			self._eventProxy.fireEvent(self.EVENT.changePassword, {
				oldPassword		: _old,
				newPassword		: _new,
			});
			
			if(App.Config.IS_ANDROID){
				Ti.UI.Android.hideSoftKeyboard();
			}
		}
	},
	
	dispose : function(){
		var self = this;
		self.base();
	}
});

module.exports = UpdatePasswordWindow;

//--- End of file: UpdatePasswordWindow.js