/**
 * LoginView
 */
Ti.include('/globals.js');

var LoginView = App.Class(App.View.WOWindow, {
	className	: 'LoginView',
	stylePath	: 'AuthStyle',
	
	//--- Event Name constants -----
	EVENT		: {
		//--- view controller to handle:
		signup			: 'LoginView.signup',
		later			: 'LoginView.later',
		login			: 'LoginView.login',
		resendPswd		: 'LoginView.resendPswd',
    },
	
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

	    self.WINDOW.type = App.Const.WINDOW.type.navGroup;
	    self.WINDOW.hideNavBar = true;
	},
	
	draw : function(param){	
		var self = this;

		var scrollBg = Ti.UI.createScrollView(self.STYLE.Login.view);
		var canvas = Ti.UI.createView(self.STYLE.Login.canvas);

		//---  Title  ---------------------
		var L_Welcome = Ti.UI.createLabel(self.STYLE.Login.H1);
	//	L_Welcome.top = 0.2*self.STYLE.SCREEN.height;
		L_Welcome.text = App.Helper.L('auth_WELCOME');
		
		var L_Signup = Ti.UI.createLabel(self.STYLE.Login.H2);
		L_Signup.text = App.Helper.L('auth_SIGNUP');
		
		canvas.add(L_Welcome);
		canvas.add(L_Signup);

		//---   Don't have ...Two buttons  -----
		var B_Signup = Ti.UI.createButton(self.STYLE.Login.signupBtn);
		B_Signup.title = App.Helper.L('BUTTON_SIGNUPNOW');
		B_Signup.addEventListener('touchstart', function(){
			B_Signup.backgroundGradient = self.STYLE.buttonSelectGradient;
		});
		B_Signup.addEventListener('touchend', function(){
			B_Signup.backgroundGradient = self.STYLE.buttonGradient;
		});
		B_Signup.addEventListener('click', _doSignup);
		canvas.add(B_Signup);
		
		// var L_Later = Ti.UI.createLabel(self.STYLE.Login.link);
		// L_Later.text = App.Helper.L('auth_LATER');
// 		
		// L_Later.addEventListener('click', _doLater);
		// canvas.add(L_Later);
		
		
		//---  Sign-in Form  ---------------------------
		var L_Login = Ti.UI.createLabel(self.STYLE.Login.H2);
		L_Login.text = App.Helper.L('auth_LOGIN');

		canvas.add(L_Login);
		
		var V_LoginFrame = Ti.UI.createView(self.STYLE.Login.loginFrame);	
		var FM_Login = Ti.UI.createView(self.STYLE.Login.form);	
		V_LoginFrame.add(FM_Login);		
		
		//---  Mobile No.  -----------
		var F_MOBILENO = Ti.UI.createTextField(self.STYLE.Login.F_Mobile)
		var F_PASSWORD = Ti.UI.createTextField(self.STYLE.Login.F_Password);

		F_MOBILENO.addEventListener('blur', function(){
			Ti.API.info('CTKKB:MOBILENO:blurred');
//			self.lastFocused = undefined;
		});
		F_MOBILENO.addEventListener('focus', function(){
			Ti.API.info('CTKKB:MOBILENO:focused');
			if(!F_MOBILENO.value){
				F_MOBILENO.value = self.DATA.mobilePrefix;
				if(App.Config.IS_ANDROID) F_MOBILENO.setSelection(F_MOBILENO.value.length,F_MOBILENO.value.length);
			}
		});
		F_MOBILENO.addEventListener('return', function(){
			F_PASSWORD.focus();
		});				

		//---  Password  -----------
		F_PASSWORD.addEventListener('blur', function(){
			Ti.API.info('CTKKB:F_PASSWORD:blurred');
//			self.lastFocused = undefined;
		});
		F_PASSWORD.addEventListener('focus', function(){
			Ti.API.info('CTKKB:F_PASSWORD:focused');
		});
		F_PASSWORD.addEventListener('return', _doLogin);		

		//Android Start use a hidden textfield to fix the autofocus issue temporarily
		if (App.Config.IS_ANDROID) {
			var F_HIDDEN = Ti.UI.createTextField(self.STYLE.TEXTFIELD_HIDDEN);
			FM_Login.add(F_HIDDEN);
			F_HIDDEN.addEventListener('blur', function(){
				Ti.API.info('CTKKB:F_HIDDEN:blurred');
			});
			F_HIDDEN.addEventListener('focus', function(){
				Ti.API.info('CTKKB:F_HIDDEN:focused');
			});
		};
		//Android END

		var line = Ti.UI.createView (self.STYLE.Login.separetor);

		FM_Login.add(F_MOBILENO);
		FM_Login.add(line);
		FM_Login.add(F_PASSWORD);
	
		//---  Sign-in Button  ---------
		var B_Login = Ti.UI.createButton(self.STYLE.Login.loginBtn);

		B_Login.addEventListener('click', _doLogin);
		V_LoginFrame.add(B_Login);

		canvas.add(V_LoginFrame);


		//---  Forgot Password ---------
		var L_ForgetPsw = Ti.UI.createLabel(self.STYLE.Login.link);
		L_ForgetPsw.text = App.Helper.L('auth_FORGETPSW');
		
		L_ForgetPsw.addEventListener('click', _doForgotPassword);
		canvas.add(L_ForgetPsw);

		//------------  Place components onto View  -----------
		scrollBg.add(canvas);
		scrollBg.addEventListener('click', function(e){
			F_MOBILENO.blur();
			F_PASSWORD.blur();
		});
		self.VIEW.add(scrollBg);
		
		//---------------------  Controller Event Handlers  ----------------------
		function _doSignup(evt){
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			self._eventProxy.fireEvent(self.EVENT.signup, {});
		}
		function _doLater(evt){
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			//---  Call Controller  ---
			self._eventProxy.fireEvent(self.EVENT.later, {});
		}
		function _doLogin(evt){
			B_Login.opacity=0.5;
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			if(!F_MOBILENO.value || F_MOBILENO.value == self.DATA.mobilePrefix){
				$.app.showAlert(App.Helper.L('mobile_error'), App.Helper.L('TITLE_LOGIN'));
				B_Login.opacity=1;
				return;
			}
			if(!F_PASSWORD.value){
				$.app.showAlert(App.Helper.L('pswd_required'), App.Helper.L('TITLE_LOGIN'));
				B_Login.opacity=1;
				return;
			}
			//---  Call Controller  ---
			self._eventProxy.fireEvent(self.EVENT.login, {
				mobileNo	: F_MOBILENO.value,
				pswd		: F_PASSWORD.value,
			});
			B_Login.opacity=1;
		}
		function _doForgotPassword(evt){
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			L_ForgetPsw.color='#000000';
            L_ForgetPsw.opacity=0.5;
            L_ForgetPsw.shadowColor = "#FFFFFF";
			
			if(!F_MOBILENO.value || F_MOBILENO.value == self.DATA.mobilePrefix) {
				$.app.showAlert(App.Helper.L('mobile_error'), App.Helper.L('TITLE_LOGIN'));
				L_ForgetPsw.color='#FFFFFF';
                L_ForgetPsw.opacity=0.6;
                L_ForgetPsw.shadowColor = "transparent";
				return;
			}
			//---  Call Controller  ---
			self._eventProxy.fireEvent(self.EVENT.resendPswd, {
				mobileNo	: F_MOBILENO.value,
			});
			L_ForgetPsw.color='#FFFFFF';
            L_ForgetPsw.opacity=0.6;
            L_ForgetPsw.shadowColor = "transparent";
		}
	},
});

module.exports = LoginView;

//---  End of file: LoginView.js
