/**
 * PerkdIDLoginView
 */
Ti.include('/globals.js');

var PerkdIDLoginView = App.Class(App.View.WOWindow, {
	className	: 'PerkdIDLoginView',
	stylePath	: 'AuthStyle',

	//--- Event Name constants -----
	EVENT		: {
		//--- view controller to handle:
		login			: 'PerkdIDLoginView.login',
		resendPswd		: 'PerkdIDLoginView.resendPswd',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.WINDOW.hideNavBar = true;
	},
	
	draw : function(param){
		var self = this;

		//---  Cancel button  ----------------------
		B_Back = Ti.UI.createButton(self.STYLE.Login.backBtn);
		B_Back.addEventListener('touchstart', function(){
			B_Back.opacity=0.5;
		});
		B_Back.addEventListener('touchend', function(){
			B_Back.opacity=1;
		});
		B_Back.addEventListener('click', function(e){
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			self.back(self.VIEW);
		});
				
		var canvas = Ti.UI.createView(self.STYLE.Login.canvas);
		//---  Title  ------------------------------
		var L_Welcome = Ti.UI.createLabel(self.STYLE.Login.H1);
		L_Welcome.text = App.Helper.L('auth_WELCOME');
		canvas.add(L_Welcome);
		
		//---  Sign-in Form  -----------------------
		var L_Login = Ti.UI.createLabel(self.STYLE.Login.H2);
		L_Login.text = App.Helper.L('auth_LOGIN');
		
		canvas.add(L_Login);

		var V_LoginFrame = Ti.UI.createView(self.STYLE.Login.loginFrame);	
		var FM_Login = Ti.UI.createView(self.STYLE.Login.form);	
		V_LoginFrame.add(FM_Login);		

		//---  Mobile No.  ------		
		var F_MOBILENO = Ti.UI.createTextField(self.STYLE.Login.F_Mobile)
		F_MOBILENO.addEventListener('focus', function(){
			if(!F_MOBILENO.value){
				F_MOBILENO.value = self.DATA.mobilePrefix;
			 	if(App.Config.IS_ANDROID) F_MOBILENO.setSelection(F_MOBILENO.value.length,F_MOBILENO.value.length)
			}
		});
		F_MOBILENO.addEventListener('return', function(){
			F_PASSWORD.focus();
		});	
		
		//---  Password  -----------
		var F_PASSWORD = Ti.UI.createTextField(self.STYLE.Login.F_Password);
		F_PASSWORD.addEventListener('return', _doLogin);		
	
		var line = Ti.UI.createView (self.STYLE.Login.separetor);
		
		FM_Login.add(F_MOBILENO);
		FM_Login.add(line);
		FM_Login.add(F_PASSWORD);

		//---  Sign-in Button  ---------
		var B_Login = Ti.UI.createButton(self.STYLE.Login.loginBtn);
		B_Login.addEventListener('click', _doLogin);
		V_LoginFrame.add(B_Login);

		canvas.add(V_LoginFrame);

		//---  Forgot Password ---------
		var L_ForgetPsw = Ti.UI.createLabel(self.STYLE.PerkdLogin.link);
		L_ForgetPsw.text = App.Helper.L('auth_FORGETPSW');
		
		L_ForgetPsw.addEventListener('click', _doForgotPassword);
		canvas.add(L_ForgetPsw);
		
		//------------  Place components onto View  -----------
		var scrollBg = Ti.UI.createScrollView(self.STYLE.Login.view);
		scrollBg.add(B_Back);
		scrollBg.add(canvas);

		scrollBg.addEventListener('click', function(e){
			F_MOBILENO.blur();
			F_PASSWORD.blur();
		});
		self.VIEW.add(scrollBg);

		//---------------------  Controller Event Handlers  ----------------------
		function _doLogin(evt){
			B_Login.opacity=0.5;
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			if(!F_MOBILENO.value || F_MOBILENO.value == self.DATA.mobilePrefix){
				$.app.showAlert(App.Helper.L('mobile_error'), App.Helper.L('TITLE_LOGIN'));
				B_Login.opacity=1;
				return;
			}
			if(!F_PASSWORD.value){
				$.app.showAlert(App.Helper.L('pswd_required'), App.Helper.L('TITLE_LOGIN'));
				B_Login.opacity=1;
				return;
			}
			//---  Call Controller  ---
			self._eventProxy.fireEvent(self.EVENT.login, {
				mobileNo	: F_MOBILENO.value,
				pswd		: F_PASSWORD.value,
			});
			B_Login.opacity=1;
		}

		function _doForgotPassword(evt){
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			L_ForgetPsw.color='#000000';
            L_ForgetPsw.opacity=0.5;
            L_ForgetPsw.shadowColor = "#FFFFFF";
			
			if(!F_MOBILENO.value || F_MOBILENO.value == self.DATA.mobilePrefix) {
				$.app.showAlert(App.Helper.L('mobile_error'), App.Helper.L('TITLE_LOGIN'));
				L_ForgetPsw.color='#FFFFFF';
                L_ForgetPsw.opacity=0.6;
                L_ForgetPsw.shadowColor = "transparent";
				return;
			}
			//---  Call Controller  ---
			self._eventProxy.fireEvent(self.EVENT.resendPswd, {
				mobileNo	: F_MOBILENO.value,
			});
			L_ForgetPsw.color='#FFFFFF';
            L_ForgetPsw.opacity=0.6;
            L_ForgetPsw.shadowColor = "transparent";
		}

	},
});

module.exports = PerkdIDLoginView;

/**
 * End of file: PerkdIDLoginView.js
 */