/**
 * ResendCodeWindow
 */
Ti.include('/globals.js');

var ResendCodeWindow = App.Class(App.View.WOWindow, {
	className 	: 'ResendCodeWindow',
	stylePath 	: 'AuthStyle',

	//--- Event Name constants -----
	EVENT		: {
		//--- events from Controller:
		codeSent		: 'ResendCodeWindow.codeSent',
		//--- view controller to handle:
		resendCode		: 'ResendCodeWindow.resendCode',
		searchCountry	: 'ResendCodeWindow.searchCountry',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.WINDOW.hideNavBar = true;
		if('undefined' == typeof param.navGroupObj){
			self.WINDOW.type = App.Const.WINDOW.type.navGroup;
		}
		self.WINDOW.effect = App.Const.WINDOW.effect.flip;
		
		// self.DATA.countryCode = '99';
		// self.DATA.countryName = 'Billlllll';
		// self.DATA.mobileNum = '7654321';
		
		self.RESEND = {
			countryCode : self.DATA.countryCode,
			countryName : self.DATA.countryName,
			mobileNum	: self.DATA.mobileNum,
		},
		
		self.DATA;
	},
	
	draw : function(param){
		var self = this;

		self.stopLoading();
		var canvas = Ti.UI.createView(self.STYLE.Resend.canvas);
		
		//---  Cancel Button  ------------
		var V_Back = Ti.UI.createView(self.STYLE.Resend.frame);
		var B_Back = Ti.UI.createButton(self.STYLE.Resend.backBtn);
		var L_Back = Ti.UI.createLabel(self.STYLE.Resend.btnLabel);
		L_Back.text = App.Helper.L('auth_BACKTOENTER');
	
		V_Back.add(B_Back);	
		V_Back.add(L_Back);	
		V_Back.addEventListener('touchstart', function(){
			V_Back.opacity=0.5;
		});
		V_Back.addEventListener('touchend', function(){
			V_Back.opacity=1;
		});
		V_Back.addEventListener('click', function(e){
			if (App.Config.IS_ANDROID)	Ti.UI.Android.hideSoftKeyboard();
			// self.back(self.VIEW);
			self.close({animated:true});
		});
		
		//---  Title & subtitle  ---------------------------
		var L_ResendCode = Ti.UI.createLabel(self.STYLE.Resend.H1);
		L_ResendCode.text = App.Helper.L('auth_RESENDCODE');
		canvas.add(L_ResendCode);
		
		// self._drawVerifyArea(canvas);
		self._drawResendArea(canvas);
		//------------  Place components onto View  -----------
		var scrollBg = Ti.UI.createScrollView(self.STYLE.Resend.view);
		scrollBg.addEventListener('click', function(){
			self.F_MOBILENO.blur();
		});
		
		scrollBg.add(V_Back);
		scrollBg.add(canvas);
		self.VIEW.add(scrollBg);
	},
	
	_drawResendArea : function(canvas){
		var self = this;
		
		//Android Start use a hidden textfield to fix the autofocus issue temporarily
		if (App.Config.IS_ANDROID) {
			var F_HIDDEN = Ti.UI.createTextField(self.STYLE.TEXTFIELD_HIDDEN);
			F_HIDDEN.addEventListener('blur', function(){
				Ti.API.info('CTKKB:F_HIDDEN:blurred');
			});
			F_HIDDEN.addEventListener('focus', function(){
				Ti.API.info('CTKKB:F_HIDDEN:focused');
			});
			canvas.add(F_HIDDEN);
		};
		
		//---  Mobile No  ------------------
		
		var L_Mobile = Ti.UI.createLabel(self.STYLE.Resend.desc);
		L_Mobile.text = App.Helper.L('auth_CONFIRMMOBILE');

		var line2 = Ti.UI.createView (self.STYLE.selector.LINE1);
		var line3 = Ti.UI.createView (self.STYLE.selector.LINE2);
		
		var V_CountryCode =  Ti.UI.createView(self.STYLE.selector.view);
		self.L_CountryCode = Ti.UI.createLabel(self.STYLE.selector.countryCode);
		self.L_CountryCode.text = '+'+self.DATA.countryCode;
		
		self.L_CountryName = Ti.UI.createLabel(self.STYLE.selector.countryName);
		self.L_CountryName.text = self.DATA.countryName;
		var arrow = Ti.UI.createImageView(self.STYLE.selector.arrow);

		V_CountryCode.add(self.L_CountryCode);
		V_CountryCode.add(line2);
		V_CountryCode.add(line3);
		V_CountryCode.add(self.L_CountryName);
		V_CountryCode.add(arrow);
		

		V_CountryCode.addEventListener('click', function(evt){
			V_CountryCode.backgroundGradient = self.STYLE.buttonSelectGradient;
			self._eventProxy.fireEvent(self.EVENT.searchCountry, {});
			V_CountryCode.backgroundGradient = self.STYLE.buttonGradient;
		})
				
		var FM_Mobile =  Ti.UI.createView(self.STYLE.Resend.form);
		self.F_MOBILENO = Ti.UI.createTextField(self.STYLE.Resend.F_Mobile);
		self.F_MOBILENO.value = self.DATA.mobileNum;
		
		self.F_MOBILENO.addEventListener('blur', function(evt){
			if('' != evt.value) {
				self.RESEND.mobileNum = evt.value;
			}
			else {
				self.F_MOBILENO.value = self.RESEND.mobileNum;
			}
		});
		
		FM_Mobile.add(self.F_MOBILENO);
		
		
		var B_Resend = Ti.UI.createLabel(self.STYLE.Resend.resendBtn);
		B_Resend.text = App.Helper.L('auth_RESEND');
		
		B_Resend.addEventListener('click', _doResendCode);

		canvas.add(L_Mobile);
		canvas.add(V_CountryCode);
		canvas.add(FM_Mobile);
		canvas.add(B_Resend);
		
		return canvas;
		
		function _doResendCode(evt){
		B_Resend.backgroundGradient = self.STYLE.buttonSelectGradient;
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			//---  Confirm Resend  ----
			var comfirmAlert = Ti.UI.createAlertDialog({
				title       : App.Helper.L('TITLE_VERIFICATION'),
				message     : String.format(App.Helper.L('confirm_mobile'), '+'+self.RESEND.countryCode+self.RESEND.mobileNum),
				buttonNames : [App.Helper.L('BUTTON_CANCEL'), App.Helper.L('BUTTON_OK')]
			});
			comfirmAlert.show();
			comfirmAlert.addEventListener('click', function(e){
				if(e.index == 1){
					self._eventProxy.addEventListener(self.EVENT.codeSent, _handleCodeSent);
					//---  Call Controller  ---
					self._eventProxy.fireEvent(self.EVENT.resendCode, {
						countryCode : self.RESEND.countryCode,
						countryName : self.RESEND.countryName,
						mobileNum	: self.RESEND.mobileNum,
		                mobileNo    : self.RESEND.countryCode+self.RESEND.mobileNum,
					});
				}
			});
			//---  Listen for Controller response  ---
			B_Resend.backgroundGradient = self.STYLE.buttonGradient;
		}
		//-------------  Events from Controllers  ----------
		function _handleCodeSent(evt){
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();

			self._eventProxy.removeEventListener(self.EVENT.codeSent, _handleCodeSent);
			if(!evt.error){
				
				var profile = Ti.App.Properties.getObject('tmp_reg_form', {});
				profile.countryCode = self.RESEND.countryCode;
				profile.countryName = self.RESEND.countryName;
				profile.mobileNum = self.RESEND.mobileNum;
				profile.mobileNo = '+'+self.RESEND.countryCode+self.RESEND.mobileNum;
				Ti.App.Properties.setObject('tmp_reg_form', profile);
				
				$.app.showAlert(String.format(App.Helper.L('cm_code_sent'), '+'+self.RESEND.countryCode+self.RESEND.mobileNum), App.Helper.L('TITLE_VERIFICATION'));
			}
		}
	},
	
	updateCountry : function(country){
		var self = this;
		self.RESEND.countryCode = country.code;
		self.RESEND.countryName = country.name;
		self.L_CountryCode.text = '+'+self.RESEND.countryCode;
		
		self.L_CountryName.text = self.RESEND.countryName;
	},
	
});

module.exports = ResendCodeWindow;

//---  End of file: ResendCodeWindow.js
