/**
 * StartupWindow
 */
Ti.include('/globals.js');

var StartupWindow = App.Class(App.View.WOWindow, {
	className 	: 'StartupWindow',
	stylePath 	: 'AuthStyle',

	//--- Event Name constants -----
	EVENT		: {
		//--- events from Controller:
		// //--- view controller to handle:
		goNext		: 'StartupWindow.goNext',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.WINDOW.hideNavBar = true;
		if('undefined' == typeof param.navGroupObj){
			self.WINDOW.type = App.Const.WINDOW.type.navGroup;
		}
		self.WINDOW.effect = App.Const.WINDOW.effect.flip;
	},
	
	draw : function(param){
		var self = this;

		self.stopLoading();
		var canvas = Ti.UI.createView(self.STYLE.Reason.canvas);

		//---  Title & subtitle  ---------------------------
		var L_WithPerkd = Ti.UI.createLabel(self.STYLE.Reason.H1);
		L_WithPerkd.text = App.Helper.L('auth_WITHPERKD');
		canvas.add(L_WithPerkd);
		
		//---  Always get Your Perks  ----------------------
		var V_Reason1 = Ti.UI.createView(self.STYLE.Reason.frame);

		var I_Image1 = Ti.UI.createImageView(self.STYLE.Reason.image);
		I_Image1.image = '/assets/images/ui/later_pic1.png';
		
		var V_textBox1 = Ti.UI.createView (self.STYLE.Reason.textBox);
		
		var L_ReasonTitle1 = Ti.UI.createLabel(self.STYLE.Reason.title);
		L_ReasonTitle1.text = App.Helper.L('auth_KNOW1TITLE');
		
		var L_ReasonDesc1 =  Ti.UI.createLabel(self.STYLE.Reason.desc);
		L_ReasonDesc1.text = App.Helper.L('auth_KNOW1DESC');
		V_Reason1.add(I_Image1);
		V_textBox1.add(L_ReasonTitle1);
		V_textBox1.add(L_ReasonDesc1);
		V_Reason1.add(V_textBox1);
		canvas.add(V_Reason1);

		//---  Never Lose Your Cards  ----------------------
		var V_Reason2 = Ti.UI.createView(self.STYLE.Reason.frame);

		var I_Image2 = Ti.UI.createImageView(self.STYLE.Reason.image);
		I_Image2.image = '/assets/images/ui/later_pic2.png';
		
		var V_textBox2 = Ti.UI.createView (self.STYLE.Reason.textBox);
		
		var L_ReasonTitle2 = Ti.UI.createLabel(self.STYLE.Reason.title);;
		L_ReasonTitle2.text = App.Helper.L('auth_KNOW2TITLE');
		
		var L_ReasonDesc2 = Ti.UI.createLabel(self.STYLE.Reason.desc);
		L_ReasonDesc2.text = App.Helper.L('auth_KNOW2DESC');
		V_Reason2.add(I_Image2);
		V_textBox2.add(L_ReasonTitle2);
		V_textBox2.add(L_ReasonDesc2);
		V_Reason2.add(V_textBox2);
		canvas.add(V_Reason2);

		//Android Start use a hidden textfield to fix the autofocus issue temporarily
		if (App.Config.IS_ANDROID) {
			var F_HIDDEN = Ti.UI.createTextField(self.STYLE.TEXTFIELD_HIDDEN);
			canvas.add(F_HIDDEN);
		};
		//Android END

		var V_Next =	Ti.UI.createView(self.STYLE.goNext.view);
		
		var B_Next = Ti.UI.createButton(self.STYLE.goNext.btn);
		var L_Next = Ti.UI.createLabel(self.STYLE.goNext.btnLabel);
		L_Next.text = App.Helper.L('LABEL_GONEXT');

		V_Next.add(L_Next);
		V_Next.add(B_Next);
		
		V_Next.addEventListener('touchstart', function(){
			V_Next.opacity=0.5;
		});
		V_Next.addEventListener('touchend', function(){
			V_Next.opacity=1;
		});
		V_Next.addEventListener('click', function(evt){
			self._eventProxy.fireEvent(self.EVENT.goNext, {});
		});
	
		canvas.add(V_Next);

		//------------  Place components onto View  -----------
		self.VIEW.add(canvas);
	},
	
});

module.exports = StartupWindow;

//---  End of file: StartupWindow.js
