/**
 * VerifyWindow
 */
Ti.include('/globals.js');

var VerifyWindow = App.Class(App.View.WOWindow, {
	className 	: 'VerifyWindow',
	stylePath 	: 'AuthStyle',

	//--- Event Name constants -----
	EVENT		: {
		//--- events from Controller:
		codeSent		: 'VerifyWindow.codeSent',
		//--- view controller to handle:
		resendCode		: 'VerifyWindow.resendCode',
		verifyCode		: 'VerifyWindow.verifyCode',
		searchCountry	: 'SignupWindow.searchCountry',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.WINDOW.hideNavBar = true;
		if('undefined' == typeof param.navGroupObj){
			self.WINDOW.type = App.Const.WINDOW.type.navGroup;
		}
		self.WINDOW.effect = App.Const.WINDOW.effect.flip;
		
		// self.DATA.countryCode = '99';
		// self.DATA.countryName = 'Billlllll';
		// self.DATA.mobileNum = '7654321';
		
		self.RESEND = {
			countryCode : self.DATA.countryCode,
			mobileNum	: self.DATA.mobileNum,
		},
		
		self.DATA;
	},
	
	draw : function(param){
		var self = this;

		self.stopLoading();
		var canvas = Ti.UI.createView(self.STYLE.Verify.canvas);
		
		//---  Title & subtitle  ---------------------------
		var L_Verify = Ti.UI.createLabel(self.STYLE.Verify.H1);
		L_Verify.text = App.Helper.L('auth_VERIFICATIONCODE');
		canvas.add(L_Verify);
		
		self._drawVerifyArea(canvas);
		var L_Resend = self._drawResendArea(canvas);
		setTimeout(function(){
			L_Resend.visible = true;
		}, 3000);
		//------------  Place components onto View  -----------
		var scrollBg = Ti.UI.createScrollView(self.STYLE.Verify.view);
		scrollBg.addEventListener('click', function(){
			self.F_CODE.blur();
		});
		
		scrollBg.add(canvas);
		self.VIEW.add(scrollBg);
	},
	
	_drawVerifyArea : function(canvas){
		var self = this;

		//Android Start use a hidden textfield to fix the autofocus issue temporarily
		if (App.Config.IS_ANDROID) {
			var F_HIDDEN = Ti.UI.createTextField(self.STYLE.TEXTFIELD_HIDDEN);
			canvas.add(F_HIDDEN);
		};
		//Android END
				

		var L_EnterCode = Ti.UI.createLabel(self.STYLE.Verify.H2);
		L_EnterCode.text = App.Helper.L('auth_ENTERVERIFICATION');
				
		//---  CodeInput  -----------------
		var V_CODE = Ti.UI.createView(self.STYLE.Verify.frame);

		var FM_CODE = Ti.UI.createView(self.STYLE.Verify.form);
		self.F_CODE = Ti.UI.createTextField(self.STYLE.Verify.F_CODE);
		self.F_CODE.addEventListener('return', _doVerifyCode);

		var B_Verify = Ti.UI.createView(self.STYLE.Verify.verifyBtn);
		B_Verify.addEventListener('click', _doVerifyCode);

		FM_CODE.add(self.F_CODE);
		
		V_CODE.add(FM_CODE);
		V_CODE.add(B_Verify);

		canvas.add(L_EnterCode);
		canvas.add(V_CODE);
		
		return canvas;
		
		function _doVerifyCode(evt){
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			B_Verify.opacity = 0.5;
			var activationCode = self.F_CODE.value;
			if(!activationCode){
				$.app.showAlert(App.Helper.L('no_code'), App.Helper.L('TITLE_VERIFICATION'));
				B_Verify.opacity = 1;
				return;
			}
			//---  Call Controller  ---
			var profile = Ti.App.Properties.getObject('tmp_reg_form');
			self._eventProxy.fireEvent(self.EVENT.verifyCode, {
                mobileNo    : profile.mobileNo || '',
                code        : activationCode,
			});
			B_Verify.opacity = 1;
		}
	},
	
	_drawResendArea : function(canvas){
		var self = this;
		
		var L_Resend = Ti.UI.createLabel(self.STYLE.Verify.link);
		L_Resend.text = App.Helper.L('auth_RESENDAGAIN');
		L_Resend.visible = false;

		L_Resend.addEventListener('click', function(evt){
			L_Resend.color='#000000';
            L_Resend.opacity=0.5;
            L_Resend.shadowColor = "#FFFFFF";
			self._eventProxy.fireEvent(self.EVENT.resendCode, {});
			L_Resend.color='#FFFFFF';
            L_Resend.opacity=0.6;
            L_Resend.shadowColor = "transparent";
		});
		
		if(canvas) canvas.add(L_Resend);
		return L_Resend;
	},
});

module.exports = VerifyWindow;

//---  End of file: VerifyWindow.js
