
/**
 * CardAddWindow
 */
Ti.include('/globals.js');
var helper = App.loadHelper('default'); //TODO [ZJ]
if (App.Config.IS_ANDROID) {
Ti.include('/waveo/core/WOAndroidUtils.js');
}

var CardAddWindow = App.Class(App.View.WOWindow, {
	className 	: 'CardAddWindow',
	stylePath	: 'CardFormStyle',
	
	EVENT : {
		//--- Handles these events:
		formSubmit		: 'CardAddWindow.formSubmit',
		//--- Produces these events:
		goPerkdIDView	: 'Nav.goPerkdIDView',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.WINDOW.hideTabBar = true;
	    self.WINDOW.title = self.DATA.cardMaster.isDigital ? App.Helper.L('TITLE_SIGNUP') : App.Helper.L('TITLE_ADDCARD');

 	// --- DATA Package from Controller ---
		// self.DATA.form;
		// self.DATA.cardMaster;
		// self.DATA.authState;
		// self.DATA.formData

	// --- Form ---
		self.FORM = null;
	},
		
	draw : function(param){
		var self = this;
		
		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		self.VIEW.add(titlebarShadowContainer);
			
		self.canvas = self._addMainView(self.VIEW);
		self._addForm(self.canvas);
		self._addCancelBtn(self.VIEW);
		(self.DATA.cardMaster.isDigital && self.DATA.authState.state != App.Const.AUTH_LOGGED_IN) ? self._addSignupBtn(self.VIEW) : self._addSubmitBtn(self.VIEW);
	
		if(App.Config.IS_ANDROID) {
			self.VIEW.addEventListener('close', fnc=function(){
				self.VIEW.removeEventListener('close',fnc);			
				Ti.App.fireEvent('SIGNUP_BUTTON_RESET_EVENT');
			});
		}
	
	},
	
	// ------------------------ Draw UI Components -----------------------
	_addMainView : function(myWindow) {
		var self = this;
		
		var mainView = Ti.UI.createView(self.STYLE.view.canvas);
		myWindow.add(mainView);
		return mainView;
	},
	
	_addForm : function(theView) {

		var self = this;
		var formParam = {
			formDefn	: self.DATA.form,
			formData	: self.DATA.formData,
			DATA		: self.DATA,
			stylePath	: self.stylePath,
			eventProxy	: self._eventProxy,
			defaultMode : 'edit',
			tabGroup	: self.tabGroupObj ? self.tabGroupObj.tabGroup : undefined,
			navGroup 	: self.navGroupObj ? self.navGroupObj.navGroup : undefined,
		};
		// var form = new App.WOForm(formParam);
		var form = App.Helper.newForm('CardAddForm', formParam);
		self.FORM = form;

		var formView = form.render();
		
		if(theView) theView.add(formView);
		return formView;
	},
	
	_addSubmitBtn : function(theWindow) {
		var self = this;
		//--- if need signup first , skip add this button ---
		if(self.DATA.cardMaster.isDigital && self.DATA.authState.state != App.Const.AUTH_LOGGED_IN) return;
		
		if(self.DATA.cardMaster.isDigital){
			var submitBtn = Ti.UI.createButton(self.STYLE.btn.REGISTER);
			submitBtn.title =  App.Helper.L('BUTTON_REGISTER');
		} else {
			var submitBtn = Ti.UI.createButton(self.STYLE.btn.SAVE);
			submitBtn.title =  App.Helper.L('BUTTON_SAVE');
		}
		
		submitBtn.addEventListener('click', function(evt){
			
			if (App.Config.IS_ANDROID) {
				if (checkIfButtonWasClickedThenDisableForShortPeriod
					(evt.source,1000)) {
						return;
				}
				$.app.showBusy({message:App.Helper.L('SHOW_SAVING')});
				disableButtonUntilEventOccurs(evt.source,'SAVE_BUTTON_RESET_EVENT');
				self.VIEW.addEventListener('close', function(e){
					Ti.App.fireEvent('SAVE_BUTTON_RESET_EVENT');
					$.app.hideBusy();
				})
			}
			
			if (App.Config.IS_ANDROID)	Ti.UI.Android.hideSoftKeyboard();
			if(self.notRapidFire(evt.source.title)){
				//---  Prep view & data for Controller to animate 'flying' card
				self.FORM.scrollToTop(0);
				
				self.FORM.blur();
				var formData = self.FORM.getFieldValues();
	
				self._eventProxy.fireEvent(self.EVENT.formSubmit, {
					isDigital	: self.DATA.cardMaster.isDigital,
					masterID	: self.DATA.cardMaster.id,
					formData	: formData,
					animateCard : self.FORM.getCardWidget(),
					viewToUnclick: evt.source,
				});
			}
		});

		if(theWindow){
			theWindow.setRightNavButton(submitBtn);
		}
	},
	
	_addCancelBtn : function(theWindow){
		var self = this;
		
		var cancelBtn = Ti.UI.createButton(self.STYLE.btn.CANCEL);
		cancelBtn.addEventListener('click', function(evt){
			if (App.Config.IS_ANDROID) {
				if (checkIfButtonWasClickedThenDisableForShortPeriod
					(evt.source,1000)) {
						return;
					}
			}

			if (App.Config.IS_ANDROID)	Ti.UI.Android.hideSoftKeyboard();
			self.close({animated : true});
		});
		
		if(theWindow) theWindow.setLeftNavButton(cancelBtn);
		return cancelBtn;
	},
	
	_addSignupBtn : function(theWindow){
		var self = this;
		
		var signupBtn = Ti.UI.createButton();
		signupBtn.title = App.Helper.L('BUTTON_SIGNUP');
		
		signupBtn.addEventListener('click', function(evt) {
			if (App.Config.IS_ANDROID) {
				if (checkIfButtonWasClickedThenDisableForShortPeriod
					(evt.source,1000)) {
						return;
					}
			}

			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			if(self.notRapidFire(evt.source.title)){
				Ti.App.fireEvent(self.EVENT.goPerkdIDView);
			}
		});

		if(theWindow) theWindow.setRightNavButton(signupBtn);
		return signupBtn;
	},
	
	_checkSignupState : function() {
		var self = this;
		
		if(self.DATA.cardMaster.isDigital && self.DATA.authState.state != App.Const.AUTH_LOGGED_IN){
			var dialog = Ti.UI.createAlertDialog({
				message: App.Helper.L('popmsg_addDigitalCard'),
				title:App.Helper.L('poptitle_addDigitalCard'),
				buttonNames:[App.Helper.L('BUTTON_CANCEL'), App.Helper.L('BUTTON_SIGNUPNOW')],
			});
			dialog.addEventListener('click', function(evt){
				// if(0 == evt.index) self.close({animated : true});
				if(1 == evt.index) Ti.App.fireEvent(self.EVENT.goPerkdIDView);
			});
			dialog.show();
		}
	},

});

module.exports = CardAddWindow;

//---  End of file: CardAddWindow.js
