/**
 * CardDetailWindow
 */
Ti.include('/globals.js');
if (App.Config.IS_ANDROID) {
Ti.include('/waveo/core/WOAndroidUtils.js');
}

var CardDetailWindow = App.Class(App.View.WOWindow, {
	className : 'CardDetailWindow',
	stylePath : 'CardDetailStyle',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		registerCard	: 'CardDetailWindow.registerCard',
		editCard		: 'CardDetailWindow.editCard',
		toShareCard		: 'CardDetailWindow.toShareCard',
		viewAbout		: 'CardDetailWindow.viewAbout',
		viewRewardset	: 'CardDetailWindow.viewRewardset',
		viewOffer		: 'CardDetailWindow.viewOffer',
		viewPoints		: 'CardDetailWindow.viewPoints',
		closedCardDetailWindow	: 'CardDetailWindow.closed',
    },

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

	    self.WINDOW.title = self.DATA.aCard.masterName;

		self.WINDOW.hideTabBar = true;
		self.WINDOW.hideNavBar = true;
				
		self.viewing = true;
		// self.lazyRender = true;

		self.CARD = null;
		self.hasDashboard = false;
		
		// self.DATA.aCard;
		// self.DATA.rewardsets;
		// self.DATA.offers;
		// self.DATA.points;
// 		
		// self.DATA.aCard.allowShare = false; // TODO [ZJ] for testing...
	},
	
	draw : function(param){
		var self = this;
		
		var canvas = Ti.UI.createView(self.STYLE.view.canvas);
		$.app.viewingCardID = self.DATA.aCard.id;

		self._drawCard(canvas);
		self._drawLandscapeControls();

		self.dashboardArea = Ti.UI.createView(self.STYLE.view.flexFooter);
		self._drawDashBoard(self.dashboardArea);
		
        canvas.add(self.dashboardArea);
		self.VIEW.add(canvas);

		self._drawToolBar();
		
		//---  Auto-flip card with number  ---
		if(!self.DATA.noFlip && self.DATA.aCard.number){
			setTimeout(function(){
				self._eventProxy.fireEvent(self.EVENT.doFlipCard, {});
			}, 300);
		}
		
		self._setupEventHandlers();
		
		// if (App.Config.IS_ANDROID){
			// Ti.API.info('CTKACCEL opens');
			// function onOrientationChange (e) {
				// Ti.API.info ('CTKORIENT='+e.orientation);
			// }
			// function onAccelerometerCallback (e) {
				// var inOri = $.Android.orientationCurrent;
				// AndroidAccelerometerCallback(e);
				// if ($.Android.orientationCurrent!=inOri){
					// if ($.Android.orientationCurrent=='landscape') {
						// /*
						// self._eventProxy.fireEvent(self._eventProxy.EVENT.inLandscape,
							// {orientation:Ti.UI.LANDSCAPE_LEFT});
						// self._eventProxy.fireEvent(self._eventProxy.EVENT.outPortrait,
							// {orientation:Ti.UI.LANDSCAPE_LEFT});
						// */
						// Ti.Gesture.fireEvent('orientationchange', { orientation:  Titanium.UI.LANDSCAPE_LEFT });
					// } else {
						// /*
						// self._eventProxy.fireEvent(self._eventProxy.EVENT.outLandscape,
							// {orientation:Ti.UI.PORTRAIT});
						// self._eventProxy.fireEvent(self._eventProxy.EVENT.inPortrait,
							// {orientation:Ti.UI.LANDSCAPE_LEFT});
						// */
						// Ti.Gesture.fireEvent('orientationchange', { orientation:  Titanium.UI.PORTRAIT });
					// }
				// }
			// }
			// Ti.Accelerometer.addEventListener('update',onAccelerometerCallback);
			// Ti.Gesture.addEventListener('orientationchange',onOrientationChange);
			// self.VIEW.addEventListener('close',function(e){
				// Ti.Accelerometer.removeEventListener('update',onAccelerometerCallback);
				// Ti.Gesture.removeEventListener('orientationchange',onOrientationChange);
				// Ti.API.info('CTKACCEL closes');			
			// });
		// }
	},
	
	_drawCard : function(canvas){
		var self = this;
		
		//---  Card Definition  ---
		var cardDefn = {
			name		: self.DATA.aCard.masterName,
			style		: self.STYLE.view.cardFace,
			properties 	: {
				cardObj			: self.DATA.aCard,
				format			: $.cardMgr.factory.FORMAT.standard,
				cardFront		: true,
				cardBack		: true,
				canFlip			: (self.DATA.aCard.isDigital && !self.DATA.aCard.isRegistered) ? false : true,
				shadow			: true,
				landscape		: {
					inLandscape	: false,
					auto		: true,
				},
				showName		: true,
				touchEnabled	: (self.DATA.aCard.isDigital && !self.DATA.aCard.isRegistered) ? false : true,
			},
			useRow		: false,
			eventProxy	: self._eventProxy,
		};
		if(self.DATA.aCard.isDigital && !self.DATA.aCard.isRegistered)
			cardDefn.properties.landscape = undefined;		// disable landscape mode
		
		self.CARD = $.cardMgr.factory.make(cardDefn, self.DATA.aCard);

		var cardView = self.CARD.getView();
		if (App.Config.IS_ANDROID) {
			// adding zIndex line below prevents the cardView from being shown. 
			// To be resolved later. 
		} else {
			cardView.zIndex = 99;		// make sure that we are topmost & not blocked by Dashboard		
		}
		canvas.add(cardView);
		//---  Name  ---------------------------
		
		if(App.Config.IS_ANDROID){
			self.DISPLAYNAME = Ti.UI.createLabel(self.STYLE.label.name_android);
		} else {
			self.DISPLAYNAME = Ti.UI.createLabel(self.STYLE.label.name);
		}
		self.DISPLAYNAME.text = self.DATA.aCard.display;

		canvas.add(self.DISPLAYNAME);
	},

	_drawLandscapeControls : function(param){
		var self = this;

		//---  Landscape Lock  ------------------
		self.orientLocked = false;			// landscape lock state
		
		self.LANDSCAPELOCK = Ti.UI.createButton(self.STYLE.btn.lock);
		self.LANDSCAPELOCK.addEventListener('click', function(evt){
			self.orientLocked = !self.orientLocked;
			if(self.orientLocked){
				self.LANDSCAPELOCK.backgroundImage = 'assets/images/buttons/locked.png';
				self._eventProxy.fireEvent(self._eventProxy.EVENT.setAutoRotate, { turnOn: false });
			}else{
				self.LANDSCAPELOCK.backgroundImage = 'assets/images/buttons/unlocked.png';
				self._eventProxy.fireEvent(self._eventProxy.EVENT.setAutoRotate, { turnOn: true });
			}
		});
		
		self.LANDSCAPELOCK.hide();
		self.VIEW.add(self.LANDSCAPELOCK);
		
		return self.LANDSCAPELOCK;
	},

	_drawDashBoard : function(dashboardArea){
		var self = this;
		
		var buttonCount = 0;
		if(self.DATA.aCard.allowShare)	buttonCount++;
		if(self.DATA.rewardsets.length>0)	buttonCount++;
		if(self.DATA.offers.length>0)	buttonCount++;
		if(self.DATA.points.length>0)	buttonCount++;

		self.view_DASHBOARD = Ti.UI.createView(self.STYLE.view.cardDashboard);
         
        self.view_DASHBOARD.visible = false;
	
		//---  Dashboard  -----------------------
		var left = Math.round( (parseInt(self.view_DASHBOARD.width)-buttonCount*72)/2 )+'dp';

		//var left = (buttonCount==1)?96:(buttonCount==2)?56:(buttonCount==3)?16:(buttonCount==4)?0:0;
		
		if( self.DATA.aCard.allowShare){
			if(!self.shareBtnFrame) self.renderShareBtn();
			self.shareBtnFrame.left = left;
			left = null;
			self.hasDashboard = true;
		}
		
		if( self.DATA.rewardsets.length>0){
			self.renderRewardBtn(self.DATA.rewardsets.length);
			self.rewardsBtnFrame.left = left;
			left = null;
			self.hasDashboard = true;
		}
		
		if( self.DATA.offers.length>0){
			self.renderOfferBtn(self.DATA.offers.length);
			self.offerBtnFrame.left = left;
			left = null;
			self.hasDashboard = true;
		}
		
		if( self.DATA.points.length>0){
			self.renderPointsBtn(self.DATA.points.length);
			self.pointsBtnFrame.left = left;
			left = null;
			self.hasDashboard = true;
		}
		
        dashboardArea.add(self.view_DASHBOARD);
        self.showDashboard(true);			// only show when self.hasDashboard == true
        
        if(-1 == self.DATA.aCard.state){
        // if(true){
			self.registerBtn = Ti.UI.createButton(self.STYLE.btn.main);
			self.registerBtn.width = "210dp";
			self.registerBtn.title = App.Helper.L('BUTTON_REGISTER');

			self.registerBtn.addEventListener('touchstart', function(evt){
				self.registerBtn.backgroundGradient = self.STYLE.buttonSelectGradient;
			});
			self.registerBtn.addEventListener('touchend', function(evt){
				self.registerBtn.backgroundGradient = self.STYLE.buttonGradient;
			});
			self.registerBtn.addEventListener('click', function(evt){
				if(self.notRapidFire(evt.source.title)){
					self._eventProxy.fireEvent(self.EVENT.registerCard, { cardID: self.DATA.aCard.id });
				}
			});
			dashboardArea.add(self.registerBtn);
			self.view_DASHBOARD.visible = false;
			self.view_DASHBOARD.borderColor = 'transparent';
		}

		self.VIEW.addEventListener('blur', function(evt){
			if(self.shareBtnFrame)	self.shareBtnFrame.backgroundColor = 'transparent';
			if(self.offerBtnFrame)	self.offerBtnFrame.backgroundColor = 'transparent';
			if(self.rewardsBtnFrame)	self.rewardsBtnFrame.backgroundColor = 'transparent';
			if(self.pointsBtnFrame)	self.pointsBtnFrame.backgroundColor = 'transparent';
		});
		
		return self.view_DASHBOARD;
	},

	_drawToolBar : function(param){
		var self = this;
	
		var btnDone = Ti.UI.createButton(self.STYLE.btn.done);		
		btnDone.addEventListener('click', function(evt){
			//---  Turn OFF auto-rotate mode  ---
			self._eventProxy.fireEvent(self._eventProxy.EVENT.setAutoRotate, { turnOn: false });
			self.close();
		});
		
		var btnEdit = App.Config.IS_ANDROID? Ti.UI.createImageView(self.STYLE.btn.edit) : Ti.UI.createButton(self.STYLE.btn.edit);

		btnEdit.addEventListener('click', function(evt){
			self._eventProxy.fireEvent(self.EVENT.editCard, { cardID: self.DATA.aCard.id });
		});

		var buttons = [];

		var space = Ti.UI.createButton(self.STYLE.btn.fixSpace);
		var flexSpace1 = Ti.UI.createButton(self.STYLE.btn.flexSpace);
		var flexSpace2 = Ti.UI.createButton(self.STYLE.btn.flexSpace);
		
		if(self.DATA.aCard.about){
			var aboutBtn = App.Config.IS_ANDROID? Ti.UI.createImageView(self.STYLE.btn.cardinfo) :  Ti.UI.createButton(self.STYLE.btn.cardinfo);
			aboutBtn.addEventListener('click', function(evt){
				self._eventProxy.fireEvent(self._eventProxy.EVENT.viewAbout, {
					cardID 	: self.DATA.aCard.id,
					about	: self.DATA.aCard.about,
				});
			});
			buttons = App.Config.IS_ANDROID? [aboutBtn, btnEdit] : [aboutBtn, space, btnEdit];
		}else{
			buttons = [btnEdit];
		}
		
		if(self.DATA.aCard.allowScan && (Ti.Media.isCameraSupported || App.Config.IS_SIMULATOR)){
			var scanBtn = App.Config.IS_ANDROID? Ti.UI.createImageView(self.STYLE.btn.scan) :  Ti.UI.createButton(self.STYLE.btn.scan);
			scanBtn.addEventListener('click', function(evt){
				$.perkMgr.scan({
					cardID : self.DATA.aCard.id,
				});
			});
			if (!App.Config.IS_ANDROID) {buttons.push(flexSpace1);}
			buttons.push(scanBtn);
		}

		if (!App.Config.IS_ANDROID) {buttons.push(flexSpace2);}
		buttons.push(btnDone);
		
		if (App.Config.IS_ANDROID) {
			self.TOOLBAR = createAndroidToolbar (self.STYLE.toolBar,{items: buttons});
		} else {	
			self.TOOLBAR = Ti.UI.iOS.createToolbar(self.STYLE.toolBar);
			self.TOOLBAR.items = buttons;
		}

		self.VIEW.add(self.TOOLBAR);
		return self.TOOLBAR;
	},

	showDashboard : function(show){
		var self = this;
		
		if(show && self.hasDashboard){
			self.view_DASHBOARD.visible = true;
		if(App.Config.IS_ANDROID) self.view_DASHBOARD.borderColor = '#D04D4D4D';

		}else{
			self.view_DASHBOARD.visible = false;
		if(App.Config.IS_ANDROID) self.view_DASHBOARD.borderColor = 'transparent';
		}
	},

	_setupEventHandlers : function(param){
		var self = this;

		//---  leaving portrait ---
		self._eventProxy.addEventListener(self._eventProxy.EVENT.outPortrait, function(evt){
			if (App.Config.IS_ANDROID) {
				
			} else {
				Ti.UI.iPhone.hideStatusBar();			
			}
			self.TOOLBAR.hide();
			self.DISPLAYNAME.hide();
			self.showDashboard(false);
		});
		
		//---  back at portrait ---
		self._eventProxy.addEventListener(self._eventProxy.EVENT.inPortrait, function(evt){
			if (App.Config.IS_ANDROID) {
				
			} else {
				Ti.UI.iPhone.showStatusBar();
			}
			self.TOOLBAR.show();
			self.DISPLAYNAME.show();
			self.showDashboard(true);
		});
		
		//---  into Landscape ---
		self._eventProxy.addEventListener(self._eventProxy.EVENT.inLandscape, function(evt){
			$.app.doNotDisturb(true);
			if(evt.orientation == Ti.UI.LANDSCAPE_LEFT){
				self.LANDSCAPELOCK.right = 3;
				self.LANDSCAPELOCK.bottom = 5;
				self.LANDSCAPELOCK.top = undefined;
				self.LANDSCAPELOCK.left = undefined;
				var matrix = Ti.UI.create2DMatrix();
					matrix = matrix.rotate(-90);
				var anim = Ti.UI.createAnimation({
					transform	: matrix,
				});
				self.LANDSCAPELOCK.animate(anim);
			}else{
				self.LANDSCAPELOCK.left = 3;
				self.LANDSCAPELOCK.top = 5;
				self.LANDSCAPELOCK.bottom = undefined;
				self.LANDSCAPELOCK.right = undefined;
				var matrix = Ti.UI.create2DMatrix();
					matrix = matrix.rotate(90);
				var anim = Ti.UI.createAnimation({
					transform	: matrix,
				});
				self.LANDSCAPELOCK.animate(anim);
			}

			self.LANDSCAPELOCK.show();
		});		
		
		//---  leaving Landscape ---
		self._eventProxy.addEventListener(self._eventProxy.EVENT.outLandscape, function(evt){
			self.LANDSCAPELOCK.hide();
			$.app.doNotDisturb(false);
		});	

		// //---  Turn ON auto-rotate mode  ---
		self._eventProxy.fireEvent(self._eventProxy.EVENT.setAutoRotate, { turnOn: true });
	},

	onFocus : function(){
		var self = this;
		//---  Turn ON auto-rotate mode  ---
		self._eventProxy.fireEvent(self._eventProxy.EVENT.setAutoRotate, { turnOn: true });
	},
	
	onBlur : function(){
		var self = this;
		//---  Turn OFF auto-rotate mode  ---
		self._eventProxy.fireEvent(self._eventProxy.EVENT.setAutoRotate, { turnOn: false });
	},
	
	close : function(param){
		var self = this;
		$.app.doNotDisturb(false);
		self.base(param);
	},
			
	dispose : function(){
		var self = this;
		self._eventProxy.fireEvent(self.EVENT.closedCardDetailWindow, {});
		self._eventProxy.fireEvent(self._eventProxy.EVENT.setAutoRotate, { turnOn: false });
		
		$.app.viewingCard 	= false;
		$.app.viewingCardID = null;

		self.base();
	},
	
	updateCard : function(card){
		var self = this;
		self.DISPLAYNAME.text = card.display;
	},
	
	updateDashboard : function(data){
		var self = this;
		
		var buttonCount = 0;
		if(data.aCard.allowShare)	buttonCount++;
		if(data.rewardsets.length>0)	buttonCount++;
		if(data.offers.length>0)	buttonCount++;
		if(data.points.length>0)	buttonCount++;
		
        self.view_DASHBOARD.visible = false;
	
		//---  Dashboard  -----------------------
		var left_num = Math.round( (parseInt(self.view_DASHBOARD.width)-buttonCount*72)/2 );
		var left = left_num +'dp';
		var cur  = left;
		var inc  = 72;

		if( data.aCard.allowShare){
			if(!self.shareBtnFrame) self.renderShareBtn();
			self.shareBtnFrame.left = left;
			left = null;
			self.hasDashboard = true;
		}

		self.renderRewardBtn(0);
		if( data.rewardsets.length>0){
			self.renderRewardBtn(data.rewardsets.length);
			self.rewardsBtnFrame.left = left;
			left = null;
			self.hasDashboard = true;
		}
		
		self.renderOfferBtn(0);
		if( data.offers.length>0){
			self.renderOfferBtn(data.offers.length);
			self.offerBtnFrame.left = left;
			left = null;
			self.hasDashboard = true;
		}

		self.renderPointsBtn(0);
		if( data.points.length>0){
			self.renderPointsBtn(data.points.length);
			self.pointsBtnFrame.left = left;
			left = null;
			self.hasDashboard = true;
		}
		
        self.showDashboard(true);			// only show when self.hasDashboard == true
	},
	
	renderShareBtn:function(){
		var self = this;

		self.shareBtnFrame = Ti.UI.createView(self.STYLE.view.btnFrame);		

		var lbl_shareBtn = Ti.UI.createLabel(self.STYLE.label.btnLabel);		
		lbl_shareBtn.text = App.Helper.L('cardDetail_DashboardShareCard');
		
//		self.shareBtn = Ti.UI.createButton(self.STYLE.btn.cardDashItem);
//		self.shareBtn.image = (App.Config.IS_ANDROID)?'/assets/images/buttons/btn_share@2x.png':'/assets/images/buttons/btn_share.png';

		var view_shareBtnImgFrame = Ti.UI.createView({
			width:'64dp', height:'64dp', top:'5dp',
			layout: 'composite',  touchEnable: false,
		});		
		var img_shareBtn = Ti.UI.createImageView({
			touchEnabled:false,
			image: (App.Config.IS_ANDROID)?'/assets/images/buttons/btn_share@2x.png':'/assets/images/buttons/btn_share.png',
		});
		
		view_shareBtnImgFrame.add(img_shareBtn);

	//	self.shareBtnFrame.add(self.shareBtn);		
		self.shareBtnFrame.add(view_shareBtnImgFrame);		
		self.shareBtnFrame.add(lbl_shareBtn);

		self.shareBtnFrame.addEventListener('click', function(evt) {
			if(self.notRapidFire('dashboard')){
				$.app.doNotDisturb(true);
				self._eventProxy.fireEvent(self.EVENT.toShareCard, {
					cardID	: self.DATA.aCard.id,
				});
			}
		});
		
		self.shareBtnFrame.addEventListener('touchstart', function(evt) {
			self.shareBtnFrame.backgroundColor = '#2F9AFE';
		});
		
		self.shareBtnFrame.addEventListener('touchend', function(evt) {
			self.shareBtnFrame.backgroundColor = 'transparent';
		});
		
		self.view_DASHBOARD.add(self.shareBtnFrame);
	},
	
	renderOfferBtn : function(count){
		var self = this;

		if (App.Config.IS_ANDROID) {
			if(!self.offerBtnFrame){
				self.offerBtnFrame = Ti.UI.createView(self.STYLE.view.btnFrame);		
				self.lbl_offersBtn = Ti.UI.createLabel(self.STYLE.label.btnLabel);		
				self.lbl_offerBadge = self._getBadgeView();
				self.offerBtnFrame.add(self.lbl_offersBtn);
				self.offerBtnFrame.add(self.lbl_offerBadge);
				self.offerBtnFrame.addEventListener('click', function(evt){
					if(self.notRapidFire('dashboard')){
						$.app.doNotDisturb(true);
						self._eventProxy.fireEvent(self.EVENT.viewOffer, {
							cardID : self.DATA.aCard.id,
						});
					}
				});
				self.offerBtnFrame.addEventListener('touchstart', function(evt){
					self.offerBtnFrame.backgroundColor = '#2F9AFE';
				});
				self.offerBtnFrame.addEventListener('touchend', function(evt){
					self.offerBtnFrame.backgroundColor = 'transparent';
				});		
				self.view_DASHBOARD.add(self.offerBtnFrame);
			}
			if (count<1) {
				self.offerBtnFrame.setVisible(false);
			} else {
				self.lbl_offersBtn.setText((count>1)?App.Helper.L('cardDetail_DashboardOffers'):App.Helper.L('cardDetail_DashboardOffer'));
				self.lbl_offerBadge.setText(count+'');
				self.offerBtnFrame.setVisible(true);
			}

			return;
		}


		if( count <= 0 ) {
			if(self.offerBtnFrame) {
				self.offerBtnFrame.hide();
				self.view_DASHBOARD.remove(self.offerBtnFrame);
				self.offerBtnFrame = null;
			}
			return;
		} 
		if(!self.offerBtnFrame){
	
			self.offerBtnFrame = Ti.UI.createView(self.STYLE.view.btnFrame);		

			var lbl_offersBtn = Ti.UI.createLabel(self.STYLE.label.btnLabel);		
			count > 1 ? lbl_offersBtn.text = App.Helper.L('cardDetail_DashboardOffers') : lbl_offersBtn.text = App.Helper.L('cardDetail_DashboardOffer');

			var lbl_badge = self._getBadgeView();
			lbl_badge.text = count+'';

		//	self.offersBtn = Ti.UI.createButton(self.STYLE.btn.cardDashItem);
			
		//	self.offerBtnFrame.add(self.offersBtn);
			self.offerBtnFrame.add(lbl_offersBtn);
			self.offerBtnFrame.add(lbl_badge);
			
			self.offerBtnFrame.addEventListener('click', function(evt){
				
				if(self.notRapidFire('dashboard')){
					$.app.doNotDisturb(true);
					self._eventProxy.fireEvent(self.EVENT.viewOffer, {
						cardID : self.DATA.aCard.id,
					});
				}
					// if($.app.isDND) return;
					// $.app.route({
						// url		: 'reward/offerList', 
						// style	: App.Const.WINDOW.effect.flip,
						// data	: {cardID:self.DATA.aCard.id}
					// });
			});

			self.offerBtnFrame.addEventListener('touchstart', function(evt){
				self.offerBtnFrame.backgroundColor = '#2F9AFE';
			});
			
			self.offerBtnFrame.addEventListener('touchend', function(evt){
				self.offerBtnFrame.backgroundColor = 'transparent';
			});		
			self.view_DASHBOARD.add(self.offerBtnFrame);
		}

		self.offerBtnFrame.show();
	},
	
	renderRewardBtn : function(count){
		var self = this;

		if (App.Config.IS_ANDROID) {
			if(!self.rewardsBtnFrame){
				self.rewardsBtnFrame = Ti.UI.createView(self.STYLE.view.btnFrame);		
				self.lbl_rewardsBtn = Ti.UI.createLabel(self.STYLE.label.btnLabel);		
//				count > 1 ? lbl_rewardsBtn.text = 'Rewards' : lbl_rewardsBtn.text = 'Reward';
				self.lbl_rewardsBadge = self._getBadgeView();
//				lbl_badge.text = count+'';
				self.rewardsBtnFrame.add(self.lbl_rewardsBtn);
				self.rewardsBtnFrame.add(self.lbl_rewardsBadge);
				self.rewardsBtnFrame.addEventListener('click', function(evt){
					if(self.notRapidFire('#999999')){
						$.app.doNotDisturb(true);
						self._eventProxy.fireEvent(self.EVENT.viewRewardset, {
							cardID : self.DATA.aCard.id,
							// allowScan : self.DATA.aCard.allowScan && (Ti.Media.isCameraSupported || App.Config.IS_SIMULATOR), //TODO [ZJ] : to support scan.
						});
					}
				});
				self.rewardsBtnFrame.addEventListener('touchstart', function(evt){
					self.rewardsBtnFrame.backgroundColor = '#2F9AFE';
				});
				self.rewardsBtnFrame.addEventListener('touchend', function(evt){
					self.rewardsBtnFrame.backgroundColor = 'transparent';
				});		
				self.view_DASHBOARD.add(self.rewardsBtnFrame);
			}
			if (count<1) {
				self.rewardsBtnFrame.setVisible(false);
			} else {
				self.lbl_rewardsBtn.setText((count>1)?App.Helper.L('cardDetail_DashboardRewards'):App.Helper.L('cardDetail_DashboardReward'));
				self.lbl_rewardsBadge.setText(count+'');
				self.rewardsBtnFrame.setVisible(true);
			}

			return;
		}

		if( count <= 0 ) {
			if(self.rewardsBtnFrame) {
				self.rewardsBtnFrame.hide();
				self.view_DASHBOARD.remove(self.rewardsBtnFrame);
				self.rewardsBtnFrame = null;
			}
			return;
		} 

		if(!self.rewardsBtnFrame){

			self.rewardsBtnFrame = Ti.UI.createView(self.STYLE.view.btnFrame);		

			var lbl_rewardsBtn = Ti.UI.createLabel(self.STYLE.label.btnLabel);		
			count > 1 ? lbl_rewardsBtn.text = App.Helper.L('cardDetail_DashboardRewards') : lbl_rewardsBtn.text = App.Helper.L('cardDetail_DashboardReward');

			var lbl_badge = self._getBadgeView();
			lbl_badge.text = count+'';
			
		//	self.rewardsBtn = Ti.UI.createButton(self.STYLE.btn.cardDashItem);

		//	self.rewardsBtnFrame.add(self.rewardsBtn);
			self.rewardsBtnFrame.add(lbl_rewardsBtn);
			self.rewardsBtnFrame.add(lbl_badge);
			
			self.rewardsBtnFrame.addEventListener('click', function(evt){
				if(self.notRapidFire('#999999')){
					$.app.doNotDisturb(true);
					self._eventProxy.fireEvent(self.EVENT.viewRewardset, {
						cardID : self.DATA.aCard.id,
						// allowScan : self.DATA.aCard.allowScan && (Ti.Media.isCameraSupported || App.Config.IS_SIMULATOR), //TODO [ZJ] : to support scan.
					});
				}
			});
			self.rewardsBtnFrame.addEventListener('touchstart', function(evt){
				self.rewardsBtnFrame.backgroundColor = '#2F9AFE';
			});
			self.rewardsBtnFrame.addEventListener('touchend', function(evt){
				self.rewardsBtnFrame.backgroundColor = 'transparent';
			});		
			self.view_DASHBOARD.add(self.rewardsBtnFrame);
		}
				
		self.rewardsBtnFrame.show();
	},
	
	renderPointsBtn : function(count){
		var self = this;

		if (App.Config.IS_ANDROID) {
			if(!self.pointsBtnFrame){	
				self.pointsBtnFrame = Ti.UI.createView(self.STYLE.view.btnFrame);		
				self.lbl_pointsBadge = self._getBadgeView();
//				lbl_badge.text = self.DATA.points[0].balance;
				self.lbl_pointsBtn = Ti.UI.createLabel(self.STYLE.label.btnLabel);		
//				self.DATA.points[0].balance > 1 ? lbl_pointsBtn.text = 'Points' : lbl_pointsBtn.text = 'Point';
				self.pointsBtnFrame.add(self.lbl_pointsBtn);
				self.pointsBtnFrame.add(self.lbl_pointsBadge);
				self.pointsBtnFrame.addEventListener('click', function(evt){
					if(self.notRapidFire('dashboard')){
						$.app.doNotDisturb(true);
						self._eventProxy.fireEvent(self.EVENT.viewPoints, {
							cardID : self.DATA.aCard.id,
						});
					}
				});
				self.pointsBtnFrame.addEventListener('touchstart', function(evt){
					self.pointsBtnFrame.backgroundColor = '#2F9AFE';
				});
				self.pointsBtnFrame.addEventListener('touchend', function(evt){
					self.pointsBtnFrame.backgroundColor = 'transparent';
				});
				self.view_DASHBOARD.add(self.pointsBtnFrame);
			}
			if (count>0) {
				count = self.DATA.points[0].balance;
				if (count<1) {
					self.pointsBtnFrame.setVisible(false);
				} else {
					self.lbl_pointsBtn.setText((count>1)?'Points':'Point');
					self.lbl_pointsBadge.setText(count+'');
					self.pointsBtnFrame.setVisible(true);
				}				
			} else {
				self.pointsBtnFrame.setVisible(false);				
			}
			
			return;
		}


		if( count <= 0 ) {
			if(self.pointsBtnFrame) {
				self.pointsBtnFrame.hide();
				self.view_DASHBOARD.remove(self.pointsBtnFrame);
				self.pointsBtnFrame = null;
			}
			return;
		}

		if(!self.pointsBtnFrame){

			self.pointsBtnFrame = Ti.UI.createView(self.STYLE.view.btnFrame);		

			var lbl_badge = self._getBadgeView();
			lbl_badge.text = self.DATA.points[0].balance;

			var lbl_pointsBtn = Ti.UI.createLabel(self.STYLE.label.btnLabel);		
			self.DATA.points[0].balance > 1 ? lbl_pointsBtn.text = App.Helper.L('cardDetail_DashboardPoints') : lbl_pointsBtn.text = App.Helper.L('cardDetail_DashboardPoint');

		//	self.pointsBtn = Ti.UI.createButton(self.STYLE.btn.cardDashItem);
 
		//	self.pointsBtnFrame.add(self.pointsBtn);
			self.pointsBtnFrame.add(lbl_pointsBtn);
			self.pointsBtnFrame.add(lbl_badge);

			self.pointsBtnFrame.addEventListener('click', function(evt){
				if(self.notRapidFire('dashboard')){
					$.app.doNotDisturb(true);
					self._eventProxy.fireEvent(self.EVENT.viewPoints, {
						cardID : self.DATA.aCard.id,
					});
				}
			});
			self.pointsBtnFrame.addEventListener('touchstart', function(evt){
				self.pointsBtnFrame.backgroundColor = '#2F9AFE';
			});
			self.pointsBtnFrame.addEventListener('touchend', function(evt){
				self.pointsBtnFrame.backgroundColor = 'transparent';
			});		
			self.view_DASHBOARD.add(self.pointsBtnFrame);
		}
		
		self.pointsBtnFrame.show();
	},
	
	_getBadgeView : function(param){
		var self = this;
		var view = Ti.UI.createLabel(self.STYLE.label.btnValue);
		view.text = param+'';
		return view;
	},
});

module.exports = CardDetailWindow;

//---  End of file: CardDetailWindow.js
