/**
 * CardEditWindow
 */
Ti.include('/globals.js');
var helper = App.loadHelper('default'); //TODO [ZJ]
if (App.Config.IS_ANDROID) {
Ti.include('/waveo/core/WOAndroidUtils.js');
}

var CardEditWindow = App.Class(App.View.WOWindow, {
	className 	: 'CardEditWindow',
	stylePath : 'CardFormStyle',
	
	EVENT : {
		//--- Controller to handle:
		formSubmit	: 'CardEditWindow.formSubmit',
		deleteCard  : 'CardEditWindow.deleteCard',
		//--- events from Controller:
		profileUpdated	: 'CardEditWindow.profileUpdated',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

		self.WINDOW.hideTabBar = true;
	    self.WINDOW.title = self.DATA.aCard.masterName;
	    
 	// --- DATA Package from Controller ---
		// self.DATA.aCard;
		// self.DATA.form;
		
	// --- Form ---
		self.FORM = null;
	},
	
	draw : function(param){
		var self = this;
		
		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		self.VIEW.add(titlebarShadowContainer);

		var mainView = self._addMainView(self.VIEW);
		
		self._addForm(mainView);
		
		var saveBtn = self._addSaveBtn(self.VIEW);
		var cancelBtn = self._addCancelBtn(self.VIEW);
		
		//----------  Setup Event handlers  ----------
		saveBtn.addEventListener('click', function(evt){
			
			if (App.Config.IS_ANDROID) {
				if (checkIfButtonWasClickedThenDisableForShortPeriod
					(evt.source,1000)) {
						return;
					}
			}
			
			if (App.Config.IS_ANDROID) {
				Ti.UI.Android.hideSoftKeyboard();
			} else {
				titlebarShadowContainer.hide();
				self.VIEW.backgroundImage = null;
				self.VIEW.backgroundColor = 'transparent';				
			}
			
			var formData = self.FORM.getFieldValues();
			self._eventProxy.fireEvent(self.EVENT.formSubmit, {
				cardID	: self.DATA.aCard.id,
				formData	: formData,
			});
			
			// self.close({animated : true});
		});
		cancelBtn.addEventListener('click', function(evt){
			if (App.Config.IS_ANDROID) {
				Ti.UI.Android.hideSoftKeyboard();
			} else {
				titlebarShadowContainer.hide();
				self.VIEW.backgroundImage = null;
				self.VIEW.backgroundColor = 'transparent';				
			}
			self.close({animated : true});
		});
	},

	// ------------------------ Draw UI Components ------------------------
	
	_addMainView : function(myWindow) {
		var self = this;
		
//		var mainView = Ti.UI.createScrollView(self.STYLE.view.scrollableBg);
//		myWindow.add(mainView);
		
		return myWindow;
	},
	
	_addForm : function(theView) {
		var self = this;
		
		//--- create profile form view ---
		var formParam = {
			formDefn	: self.DATA.form,
			formData	: self.DATA.aCard.profile,
			DATA		: self.DATA,
			stylePath	: self.stylePath,
			eventProxy	: self._eventProxy,
			defaultMode	: 'edit',
			tabGroup	: self.tabGroupObj.tabGroup,
		};
		// var form = new App.WOForm(formParam);
		var form = App.Helper.newForm('CardEditForm', formParam);
		self.FORM = form;
		
		var formView = form.render();
		
		if(theView) theView.add(formView);
		return formView;
	},
	
	_addSaveBtn : function(theWindow) {
		var self = this;
		
		var saveBtn = Ti.UI.createButton(self.STYLE.btn.SAVE);
		
		if(theWindow) theWindow.setRightNavButton(saveBtn);
		
		return saveBtn;
	},
	
	_addCancelBtn : function(theWindow) {
		var self = this;
		
		var cancelBtn = Ti.UI.createButton(self.STYLE.btn.CANCEL);
		
		if(theWindow) theWindow.setLeftNavButton(cancelBtn);
		
		return cancelBtn;
	},
});

module.exports = CardEditWindow;

//---  End of file: CardEditWindow.js
