/**
 * CardRegisterWindow
 */
Ti.include('/globals.js');
if (App.Config.IS_ANDROID) {
Ti.include('/waveo/core/WOAndroidUtils.js');
}

var CardRegisterWindow = App.Class(App.View.WOWindow, {
	className 	: 'CardRegisterWindow',
	stylePath : 'CardFormStyle',
	
	EVENT : {
		//--- Controller to handle:
		formSubmit	: 'CardRegisterWindow.formSubmit',
		submitLater	: 'CardRegisterWindow.submitLater',
		// deleteCard  : 'CardRegisterWindow.deleteCard',
		//--- events from Controller:
		// profileUpdated	: 'CardRegisterWindow.profileUpdated',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

		self.WINDOW.hideTabBar = true;
	    self.WINDOW.title = self.DATA.aCard.masterName;
	    
 	// --- DATA Package from Controller ---
		// self.DATA.aCard;
		// self.DATA.cardMaster;
		
	// --- Form ---
		self.FORM = null;
	},
	
	draw : function(param){
		var self = this;
		
		self.goBackWindow = false;

		var mainView = self._addMainView(self.VIEW);
		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		
		self.VIEW.add(titlebarShadowContainer);
		
		self._addForm(mainView);
		
		var regBtn = self._addRegBtn(self.VIEW);
		
		if(self.DATA.aCard.allowLater) {
			var laterBtn = self._addLaterBtn(self.VIEW);
			
			laterBtn.addEventListener('click', function(evt){
			
			if (App.Config.IS_ANDROID) {
				if (checkIfButtonWasClickedThenDisableForShortPeriod
					(evt.source,1000)) {
						return;
					}
			}

			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			
			var formData = self.FORM.getFieldValues();
			
			if(self.notRapidFire(evt.source.title)){
					self._eventProxy.fireEvent(self.EVENT.submitLater, {
						cardID	: self.DATA.aCard.id,
						formData	: formData,
					});
					self.goBackWindow = true;
				}
			});
		}
		
		// var deleteBtn = self._addDeleteBtn(mainView);
		
		//----------  Setup Event handlers  ----------
		regBtn.addEventListener('click', function(evt){
			if (App.Config.IS_ANDROID) {
				if (checkIfButtonWasClickedThenDisableForShortPeriod
					(evt.source,1000)) {
						return;
					}
			}

			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			if(self.notRapidFire(evt.source.title)){
				var formData = self.FORM.getFieldValues();
				self._eventProxy.fireEvent(self.EVENT.formSubmit, {
					cardID	: self.DATA.aCard.id,
					formData	: formData,
				});
				self.goBackWindow = true;
				// self.close({animated : true});
			}
		});
		
		self.VIEW.addEventListener('blur', function(e){
		 	if(self.goBackWindow && self.VIEW && !App.Config.IS_ANDROID){
				titlebarShadowContainer.hide();
				/*
				 *  you have been perkd, if error message pop, click eg: policy field, window background missing... strange effect...
				 * 
				 */
				// self.VIEW.backgroundImage = null;
				// self.VIEW.backgroundColor = 'transparent';
			}
			self.goBackWindow = false;
		});
	},

	// ------------------------ Draw UI Components ------------------------
	
	_addMainView : function(myWindow) {
		var self = this;
		
		// return myWindow;
		
		var mainScrollView = Ti.UI.createScrollView({
			height : Ti.UI.SIZE,
		});
		myWindow.add(mainScrollView);
		
		var mainView = Ti.UI.createView({
			height : '640dp',
			top : 0,
		});
		mainScrollView.add(mainView);
		
		return mainView;
	},
	
	_addForm : function(theView) {
		var self = this;
		
		// var canvas = Ti.UI.createView({
			// // height: Ti.UI.SIZE,
			 // top: 10, width: 320,backgroundColor:'green',
		// });
		
		//--- create profile form view ---
		var formParam = {
			formDefn	: self.DATA.form,
			formData	: self.DATA.formData,
			stylePath	: self.stylePath,
			DATA		: self.DATA,
			eventProxy	: self._eventProxy,
			defaultMode	: 'edit',
		    tabGroup	: self.tabGroupObj ? self.tabGroupObj.tabGroup : undefined,
			navGroup 	: self.navGroupObj ? self.navGroupObj.navGroup : undefined,
		};
		// var form = new App.WOForm(formParam);
		var form = App.Helper.newForm('CardRegisterForm', formParam);
		self.FORM = form;
		var formView = form.render();
		// canvas.add(formView);
		
		if(theView) theView.add(formView);
		return formView;
	},
	
	_addRegBtn : function(theWindow) {
		var self = this;
		
		var regBtn = Ti.UI.createButton(self.STYLE.btn.REGISTER);
		regBtn.title = App.Helper.L('BUTTON_REGISTER');
		theWindow.setRightNavButton(regBtn);
		
		return regBtn;
	},
	
	_addLaterBtn : function(theWindow) {
		var self = this;
		
		var laterBtn = Ti.UI.createButton(self.STYLE.btn.LATER);
		laterBtn.title = App.Helper.L('BUTTON_LATER');
		theWindow.setLeftNavButton(laterBtn);
		
		return laterBtn;
	},
	
	// _addDeleteBtn : function(theView) {
		// var self = this;
// 		
		// var deleteBtn = Ti.UI.createButton(self.STYLE.btn.deleteCard);
		// deleteBtn.title = App.Helper.L('delete_card');
// 		
		// if(theView) theView.add(deleteBtn);
// 		
		// return deleteBtn;
	// },
	

});

module.exports = CardRegisterWindow;

//---  End of file: CardRegisterWindow.js
