/**
 * PerkdIDDetailWindow
 */
Ti.include('/globals.js');
if (App.Config.IS_ANDROID) {
Ti.include('/waveo/core/WOAndroidUtils.js');
}

var CardDetailWindow = App.Helper.requireView('card/CardDetailWindow');

var PerkdIDDetailWindow = App.Class(CardDetailWindow, {
	className : 'PerkdIDDetailWindow',
	stylePath : 'CardDetailStyle',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		manageAccount			: 'PerkdIDDetailWindow.manageAccount',
		closedCardDetailWindow	: 'CardDetailWindow.closed',
    },

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.hasDashboard = true;
	},

	_drawDashBoard : function(dashboardArea){
		var self = this;

		//---  Account Management  --------------
		
		self.view_DASHBOARD = Ti.UI.createTableView(self.STYLE.tableView);

		var row_accountMgt = Ti.UI.createTableViewRow(self.STYLE.tableRow);

		var rowLabel_accountMgt = Ti.UI.createLabel(self.STYLE.label.manageAccount);
		rowLabel_accountMgt.text = App.Helper.L('account_manage');
		row_accountMgt.add(rowLabel_accountMgt);
		
		row_accountMgt.addEventListener('click', _doAccountMgt);
		self.view_DASHBOARD.appendRow(row_accountMgt);
        dashboardArea.add(self.view_DASHBOARD);

		return self.view_DASHBOARD;
		
		//---------------------  Controller Event Handlers  ----------------------
		function _doAccountMgt(evt){
			self._eventProxy.fireEvent(self._eventProxy.EVENT.setAutoRotate, { turnOn: false });
			self._eventProxy.fireEvent(self.EVENT.manageAccount, { navGroupObj: self.navGroupObj });
		}
	},

	_drawToolBar : function(param){
		var self = this;

		var btnDone = Ti.UI.createButton(self.STYLE.btn.done);
		btnDone.addEventListener('click', function(evt){
			//---  Turn OFF auto-rotate mode  ---
			self._eventProxy.fireEvent(self._eventProxy.EVENT.setAutoRotate, { turnOn: false });
			self.close();
		});

		var buttons = [];
		var flexSpace = Ti.UI.createButton(self.STYLE.btn.flexSpace);

		if (!App.Config.IS_ANDROID) {
			buttons.push(flexSpace);
		}		
		buttons.push(btnDone);
		
		if (App.Config.IS_ANDROID) {
			self.TOOLBAR = createAndroidToolbar (self.STYLE.toolBar,{items: buttons});
		} else {	
			self.TOOLBAR = Ti.UI.iOS.createToolbar(self.STYLE.toolBar);
			self.TOOLBAR.items = buttons;
		}

		self.VIEW.add(self.TOOLBAR);
		
		return self.TOOLBAR;
	},
	
});

module.exports = PerkdIDDetailWindow;

//---  End of file: PerkdIDDetailWindow.js
