/**
 * CardListView2
 */
Ti.include('/globals.js');

var CardListView2 = App.Class(App.View.WOList2, {
	className 	: 'CardListView2',
	stylePath 	: 'CardListStyle',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		rowClicked		: 'CardListView2.rowClicked',
		rowDeleted		: 'CardListView2.rowDeleted',
		rowMoved        : 'CardListView2.rowMoved',
		orderCards		: 'CardListView2.orderCards',
		listRendered	: 'CardListView2.listRendered',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.activityIndicator = false;
		// Just for testing.
		self.dynamicMode = false;
		self.dynamicFirstRows = 10;
		self.dynamicRows = 10;
		
		// self.listenEvents.scroll = true;
		// self.listenEvents.scrollEnd = true;
		
		self.rowsBackgroundColorEnabled = true;
		self.headerPullViewShowing = false;
		
		self.DATA;
	},
	
	setData : function(rowsData, animation){
		var self = this;
		self.base(rowsData, animation);
		self.drawHeaderPullView();
	},
	
	removeRow : function(index){
		var self = this;
		self.base(index);
		self.drawHeaderPullView();
	},
	
	insertRow : function(data, index){
		var self = this;
		self.base(data, index);
		self.drawHeaderPullView();		
	},
	
	drawHeaderPullView : function(){
		var self = this;
		
		var view_hiddenTip = Ti.UI.createView(self.STYLE.view.hiddenTip);
    	var text = App.Helper.L('cardlist_hiddenTip');

		if(self.DATA.length>1){
			text = App.Helper.L('cardlist_hiddenTip1')+(self.DATA.length)+App.Helper.L('cardlist_hiddenTip2');
		}
		label = Ti.UI.createLabel(self.STYLE.desc.L1b);
		label.text = text;
		view_hiddenTip.add(label);
		self.tableView.headerPullView = view_hiddenTip;
	},
	
	drawHeaderPullView_test : function(){
		var self = this;
		
		var canvas = Ti.UI.createView({
			backgroundColor : 'green',
		});
		
		var orderBtnBar = Ti.UI.createButtonBar({ //TODO [WX]
			labels:['Name', 'Frequency', 'Custom', 'None'],
			style:Ti.UI.iPhone.SystemButtonStyle.BAR,
			left : '10dp',
			bottom : '20dp',
		});
		
		var first = true;
		orderBtnBar.addEventListener('click', function(evt){
			if(evt.index == 0) {
				// self.DATA.sort(function(a,b){
					// var aa = new String(a.name);
					// return aa.localeCompare(new String(b.name));
				// });
				// self.setData(self.DATA, {animated:true});
				self._eventProxy.fireEvent(self.EVENT.orderCards, {orderType:'nameAZ'});
			}
			if(evt.index == 1){
				// self.DATA.sort(function(a,b){
					// var aa = new String(a.name);
					// return -1*aa.localeCompare(new String(b.name));
				// });
				// self.setData(self.DATA, {animated:true});
				self._eventProxy.fireEvent(self.EVENT.orderCards, {orderType:'nameZA'});
			}
			if(evt.index == 2){
				if(first) {
					var dialog = Ti.UI.createAlertDialog({
						message		: 'Explain message',
						buttonNames	: ['OK'],
					});
					dialog.addEventListener('click', function(evt){
						first = false;
						self.tableView.setMoving(true);
						// setTimeout(function(){
							// self.tableView.setContentInsets({top:0},{animated:true});
							// self.headerPullViewShowing = false;						
						// }, 100);
					})
					dialog.show();
				}
				else {
					if(self.tableView.getMoving()) {
						self.tableView.setMoving(false);
					} else {
						self.tableView.setMoving(true);
					}
					// setTimeout(function(){
						// self.tableView.setContentInsets({top:0},{animated:true});
						// self.headerPullViewShowing = false;						
					// }, 100);
				}
			}
			if(evt.index == 3){
				self._eventProxy.fireEvent(self.EVENT.orderCards, {orderType:'none'});
			}
		});
		
		canvas.add(orderBtnBar);
		return canvas;
	},
		
	renderRow : function(theCard, index){
		var self = this;

		//--- Card Definition ---------
		var cardDefn = {
			name		: theCard.masterName,
			style		: {touchEnabled: false},
			properties 	: {
				cardObj			: theCard,
				format			: $.cardMgr.factory.FORMAT.singleRow,
				cardFront		: true,
				shadow			: true,
				row		: {
					style	: self.STYLE.tableRow2,
				},
			},
			useRow		: true,
			eventProxy	: self._eventProxy,
		};
		var card = $.cardMgr.factory.make(cardDefn, theCard);
		
		var row = card.getRow();
		row.objectID = theCard.cardID;
		
		self.setRowBackgroundColor(row, index);
		return row;
	},
	
	setRowBackgroundColor : function(row, index){
		var self = this;
		row.backgroundColor = (index%2==0)?'#16000000':'transparent';
		return row;
	},	
	
	clickHandler : function(evt){
		var self = this;
		var cardID = evt.rowData.objectID;
		
		self._eventProxy.fireEvent(self.EVENT.rowClicked, {
			data:{cardID:cardID}
		});
	},
		
	listenForEvents : function(tableView){
		var self = this;
		self.base(tableView);
		
		// self.listenPullHeaderView(tableView);
		self.listenRowMoved(tableView);
	},
	
	listenRowMoved : function(tableView){
		var self = this;
		
		tableView.addEventListener('move', function(evt){
			if(self._eventProxy) self._eventProxy.fireEvent(self.EVENT.rowMoved, evt);
		});
	},
	
	listenPullHeaderView : function(tableView) {
		var self = this;
				
		var curDeep = 0;
		var maxDeep = 0;
		var goingUp = false;
		var ignore = false;
		var processing = false;
		tableView.addEventListener('scroll', _scrollCheck);
		
		function _scrollCheck(evt) {
			
			Ti.API.warn('scrolling................................................'+evt.contentOffset.y);
			if(ignore) return;
			
			tableView.removeEventListener('scroll', _scrollCheck);
			
			evt.contentOffset.y < curDeep ? goingUp = false : goingUp = true;
			evt.contentOffset.y < maxDeep ? maxDeep = evt.contentOffset.y : maxDeep;
			curDeep = evt.contentOffset.y;
			
			if(!ignore && goingUp && maxDeep <= -70.0 && !self.headerPullViewShowing) {
				tableView.setContentInsets({top:80},{animated:true});
				self.headerPullViewShowing = true;
				ignore = true;
			}
			if(!ignore && goingUp && maxDeep <= -100.0 && self.headerPullViewShowing) {
				tableView.setContentInsets({top:0},{animated:true});
				self.headerPullViewShowing = false;
				
				self.tableView.setMoving(false);
				
				ignore = true;
			}
			tableView.addEventListener('scroll', _scrollCheck);
		}
		
		tableView.addEventListener('scrollEnd',function(evt) {
			Ti.API.warn('scrollEnd................................................'+evt.contentOffset.y);
			curDeep = 0;
			maxDeep = 0;
			goingUp = false;
			ignore = false;
		});
	},
});

module.exports = CardListView2;

//---  End of file: CardListView2.js
