/**
 * Card List View
 */
Ti.include('/globals.js');

var CardListViewBig = App.Class(App.View.WOList, {
	className 	: 'CardListViewBig',
	stylePath 	: 'CardListStyle',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		rowClicked		: 'CardListViewBig.rowClicked',
		rowDeleted		: 'CardListViewBig.rowDeleted',
    },

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.ITEM_KEY		= 'cardID';
		
		self.ALTERNATE		= true;
		self.renderbyTimer	= false;
		self.renderInterval	= 10;
		
		self.count          = 0;
	},
	
	/**
	 * Row render
	 * Should be implement by sub-class
	 */

	renderRow : function(theCard, index){
		var self = this;

		//--- Card Definition ---------
		var cardDefn = {
			name		: theCard.masterName,
			style		: self.STYLE.view.cardFace,
			properties 	: {
				cardObj			: theCard,
				format			: $.cardMgr.factory.FORMAT.standard,
				cardFront		: true,
				cardBack		: false,
				canFlip			: false,
				shadow			: true,
				showName		: true,
				touchEnabled	: false,
				longPress		: false,
				row		: {
					style	: self.STYLE.tableRow1,
				},
			},
			useRow		: true,
			eventProxy	: self._eventProxy,
		};
		var card = $.cardMgr.factory.make(cardDefn, theCard);
		var row = card.getRow();
		row.cardID = theCard.cardID;
		
		return row;
	},
	
	updateOneRow : function(row, param, index){
		var self = this;
		var aCard = param;
	},
});

module.exports = CardListViewBig;

//---  End of file: CardListViewBig.js
