/**
 * CardListViewBig2
 */
Ti.include('/globals.js');

var CardListViewBig2 = App.Class(App.View.WOList2, {
	className 	: 'CardListViewBig2',
	stylePath 	: 'CardListStyle',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		rowClicked		: 'CardListViewBig2.rowClicked',
		rowDeleted		: 'CardListViewBig2.rowDeleted',
		rowMoved        : 'CardListViewBig2.rowMoved',
		orderCards		: 'CardListViewBig2.orderCards',
		listRendered	: 'CardListViewBig2.listRendered',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.activityIndicator = false;
		// Just for testing.
		self.dynamicMode = false;
		self.dynamicFirstRows = 5;
		self.dynamicRows = 5;
		
		self.DATA;
	},
		
	renderRow : function(theCard, index){
		var self = this;

		//--- Card Definition ---------
		var cardDefn = {
			name		: theCard.masterName,
			style		: self.STYLE.view.cardFace,
			properties 	: {
				cardObj			: theCard,
				format			: $.cardMgr.factory.FORMAT.standard,
				cardFront		: true,
				cardBack		: false,
				canFlip			: false,
				shadow			: true,
				showName		: true,
				touchEnabled	: false,
				longPress		: false,
				row		: {
					style	: self.STYLE.tableRow1,
				},
			},
			useRow		: true,
			eventProxy	: self._eventProxy,
		};
		var card = $.cardMgr.factory.make(cardDefn, theCard);
		var row = card.getRow();
		row.objectID = theCard.cardID;
		
		return row;
	},
	
	clickHandler : function(evt){
		var self = this;
		var cardID = evt.rowData.objectID;
		self._eventProxy.fireEvent(self.EVENT.rowClicked, {
			data:{cardID:cardID}
		});
	},	
});

module.exports = CardListViewBig2;

//---  End of file: CardListViewBig2.js
