/**
 * Card List View
 */
Ti.include('/globals.js');

var CardListViewBigAndroid = App.Class(App.View.WOList, {
	className 	: 'CardListViewBigAndroid',
	stylePath 	: ['CardListStyle','CardFactoryStyle'],

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		rowClicked		: 'CardListViewBigAndroid.rowClicked',
		rowDeleted		: 'CardListViewBigAndroid.rowDeleted',
    },

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.ITEM_KEY		= 'cardID';
		
		self.ALTERNATE		= false;
		self.renderbyTimer	= false;
		self.renderInterval	= 10;
	},
	
	/**
	 * Row render
	 * Should be implement by sub-class
	 */
	
	// renderRow : function(theCard, index){
		// var self = this;
// 
		// //--- Card Definition ---------
		// var cardDefn = {
			// name		: theCard.masterName,
			// style		: self.STYLE.view.cardFace,
			// properties 	: {
				// cardObj			: theCard,
				// format			: $.cardMgr.factory.FORMAT.standard,
				// cardFront		: true,
				// cardBack		: false,
				// canFlip			: false,
				// shadow			: false,
				// showName		: true,
				// touchEnabled	: false,
				// longPress		: false,
				// row		: {
					// style	: self.STYLE.tableRow1,
				// },
			// },
			// useRow		: true,
			// eventProxy	: self._eventProxy,
		// };
		// var card   = $.cardMgr.factory.make(cardDefn, theCard);
		// var row    = card.getRow();
		// row.cardID = theCard.cardID;
// 		
		// return row;
	// },
	
	
	renderRow : function(theCard, index){
		Ti.API.info('CTK:card:'+index+':'+theCard.frontImage);
		var self = this;
		var row = Ti.UI.createTableViewRow({
			height: '200dp',
			className: 'BigCardListAndroid',
			backgroundSelectedColor: '#C4C4C4',
		});
		var isCustom = theCard.isCustom; //(theCard.masterID==App.Config.CUSTOM_CID);

//		var cardFront = new App.Model.WOImage(theCard.frontImage);
		var cardFront = new App.Model.WOImage(theCard.frontImage);
		cardFront.initialize();
		
		cardFront.fetch();
		var aCard = cardFront.getView({
			style				: {
				width:  '288dp',     // 288dp
				height: '180dp',     // 180dp
				borderWidth: 0,
				borderRadius: self.STYLE.DEVICEDP.dp15,
				touchEnabled : false,	
			},
			activityIndicator	: { show: true },			
		});
		aCard.thisParent = self.tableView;
		aCard.thisID = index;
		aCard.thisName = theCard.name;
		aCard.addEventListener ('start' ,function(e){ Ti.API.info('CTK:Card-Start:'+e.source.thisID); });
		aCard.addEventListener ('stop' ,function(e){ Ti.API.info('CTK:Card-Stop:'+e.source.thisID); });
		aCard.addEventListener ('load' ,function(e){ 
//			Ti.API.info('CTK:Card-Load:'+e.source.thisID+':'+e.source.thisName+':'
//				+e.source.thisParent.data[0].rows[e.source.thisID].children[0].thisID); 
		});
		aCard.addEventListener ('error',function(e){ Ti.API.info('CTK:Card-Error:'+e.source.thisID); });
		aCard.addEventListener ('change',function(e){ Ti.API.info('CTK:Card-Change:'+e.source.thisID); });
		row.add (aCard);
		row.cardID = theCard.cardID;
		
		if (isCustom){
	        var cardFrontName = Ti.UI.createLabel(self.STYLE.standard.cardName);
	        cardFrontName.bottom = '16dp';
	        cardFrontName.text = theCard.name;
			row.add(cardFrontName);
		}

		aCard.state = theCard.state;
       	var cardBadge = Ti.UI.createView(self.STYLE.standard.badge);
        cardBadge.top = '12dp';
        cardBadge.right =  ((self.STYLE.SCREEN.width - parseInt(aCard.width))/2 + 3) +'dp';
        cardBadge.visible = (theCard.state < 0) ? true : false;
		aCard.cardBadge = cardBadge;
		row.add(cardBadge);

		return row;
	},
	
	refreshRow : function (index) {
		var self = this;
		var datas = self.tableView.data[0].rows;
		var arow = datas[index];
///		var img = arow.children[0];
///		Ti.API.info('CTK:Card-refreshing:'+index+':'+img.thisName); 
	} ,
	
	updateOneRow : function(row, param, index){
		var self = this;
		var aCard = param;
	},
});

module.exports = CardListViewBigAndroid;

//---  End of file: CardListViewBigAndroid.js
