/**
 * CountrySearchListView
 */
Ti.include('/globals.js');

var CountrySearchListView = App.Class(App.View.WOList2, {
	className	: 'CountrySearchListView',
	stylePath	: 'CountrySearchStyle',
	
	//--- Event Name constants -----
	EVENT		: {
		//--- view controller to handle:
		rowClicked : 'CountrySearchListView.rowClicked'
    },
	
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
	    self.DATA = App.Helper.getCountryISO();
		
		self.index = [];
		for(var i=0; i<self.DATA.length; i++){
			if('undefined' != typeof self.DATA[i].header) self.index.push({title:self.DATA[i].header, index:i});
		}
	},
	
	draw : function(){
		var self = this;
		self.base();
		self.tableView.separatorColor='#CCCCCC';
		
		var search = Titanium.UI.createSearchBar(self.STYLE.searchBar);
		self.tableView.search = search;
		self.tableView.index = self.index;
		if(!App.Config.IS_ANDROID) self.tableView.filterAttribute = 'filterValue';
		if(App.Config.IS_ANDROID){
			search.addEventListener('return', function(evt){
				search.blur();
			});
		}
	},
	
	renderRow : function(data){
		var self = this;
		
		var row = Ti.UI.createTableViewRow(self.STYLE.tableRow);
		if(App.Config.IS_ANDROID){
			var L_CountryName = Ti.UI.createLabel(self.STYLE.countryName);
			L_CountryName.text = data.name;
			row.add(L_CountryName);
			row.title = data.name+'+'+data.code; //Just used for search, title not visible in Android
		} else {
			row.title = data.name;
		}
		row.header = data.header || undefined;

		row.objectID = data.id;
		row.objectData = data;
		
		row.filterValue = data.name+'+'+data.code;
		
		var L_CountryCode = Ti.UI.createLabel(self.STYLE.countryCode);
		L_CountryCode.text = data.code ? '+'+data.code : '';
		row.add(L_CountryCode);
		
		return row;
	}
});

module.exports = CountrySearchListView;

//---  End of file: CountrySearchListView.js
