/**
 * CountrySearchWindow
 */
Ti.include('/globals.js');

var CountrySearchWindow = App.Class(App.View.WOWindow, {
	className	: 'CountrySearchWindow',
	stylePath	: 'CountrySearchStyle',
	
	//--- Event Name constants -----
	EVENT		: {
		//--- view controller to handle:
		countrySelected : 'CountrySearchWindow.countrySelected'
    },
	
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		self.WINDOW.hideTabBar = true;
		self.WINDOW.title = App.Helper.L('TITLE_COUNTRY');
	},
	
	draw : function(param){	
		var self = this;
		
		var viewParam = {
			eventProxy	: self._eventProxy,
			tabGroupObj	: self.tabGroupObj || undefined,
			navGroupObj	: self.navGroupObj || undefined,
		};
		
		if (App.Config.IS_ANDROID) {
			var F_HIDDEN = Ti.UI.createTextField(self.STYLE.TEXTFIELD_HIDDEN);
			self.VIEW.add(F_HIDDEN);
		};

		var countryView = App.Helper.loadView('components/CountrySearchListView', viewParam);
		var proxy = countryView.getEventProxy();
		proxy.addEventListener(proxy.EVENT.rowClicked, function(evt){
			countryView.setData([]);
			self._eventProxy.fireEvent(self.EVENT.countrySelected, evt.row.objectData);
		});
		
		self.VIEW.add(countryView.render());
	},
});

module.exports = CountrySearchWindow;

//---  End of file: CountrySearchWindow.js
