/**
 * CardIntroWindow
 */
Ti.include('/globals.js');

var CardIntroWindow = App.Class(App.View.WOWindow, {
	className 	: 'CardIntroWindow',
	stylePath 	: 'CardIntroStyle',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		addCard			: 'CardIntroWindow.addCard',
		goPerkdIDView	: 'Nav.goPerkdIDView',
    },

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.WINDOW.title = self.DATA.cardMaster.brandName;
	    self.WINDOW.hideTabBar = true;
		
		self.DATA.cardMaster;
		self.CARD;
		self.FORM;
	},
	
	draw : function(param){
		var self = this;

		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		self.VIEW.add(titlebarShadowContainer);

		self._addCardIntroForm(self.VIEW);
	},
	
	dispose : function(){
		var self = this;

		$.app.viewingMasterInfo = false;
		$.app.viewingMasterList = false;
		
		self.base();
	},
		
	_addCardIntroForm : function(myWindow){
		var self = this;
		//--- Test Data ---
		// self.DATA.cardMaster.extraInfo = [
			// {
				// type : 'phone',
				// label : 'Phone',
				// value : '90481331',
			// },
			// {
				// type : 'link',
				// label : 'Link',
				// value : 'http://www.google.com',
			// },
			// {
				// type : 'info',
				// label : 'info',
				// value : 'Hahahahahahahaha!!!!',
			// },
			// {
				// type : 'html',
				// label : 'html',
				// value : '<b>Hahahahahahahaha!!!!</b>',
			// },
		// ];
		//--- Test Data ---
		// var formData = {
			// 'name_0'	: '90481331',
			// 'name_1'	: 'http://www.google.com',
			// 'name_2' 	: 'Hahahahahahahaha!!!!',
			// 'name_3' 	: 'http://perkd.me/tbssg/about.html',
		// };
		var formParam = {
			formDefn	: self._getFormDefn(self.DATA.cardMaster.extraInfo),
			formData	: self._getFormData(self.DATA.cardMaster.extraInfo),
			stylePath	: self.stylePath,
			DATA		: self.DATA,
			eventProxy	: self._eventProxy,
			defaultMode	: 'display',
			tabGroup	: self.tabGroupObj.tabGroup,
		};
		
		self.FORM = App.Helper.newForm('CardIntroForm', formParam);
		var formView  = self.FORM.render();
		
		if(myWindow)		myWindow.add(formView);
		return formView;
	},
	
	_getFormDefn : function(param) {
		var self = this;
		
		var extraInfoForm = {};
		extraInfoForm.form = {
			name : 'extraInfo',
			style : 'form',
			properties 	: {						// (optional) styles for each display mode
				fieldWindow	: {
					style	: 'fieldWindow',
				},
			},
		};
		extraInfoForm.header = {
			type  : 'text',
			style : 'view_formHeader',
		};
		extraInfoForm.sections = [{}];
		extraInfoForm.sections[0].name = 'extraInfo';
		extraInfoForm.sections[0].fields = [];
		for(var i=0; i<param.length; i++) {
			switch(param[i].type) {
				case 'info': 
					extraInfoForm.sections[0].fields[i] = {
						name : 'name_'+i,
						type : param[i].type,
						style: 'view_formfield',
						properties : {
							row : {
								style : 'view_formRow_withWindow',
							},
							label : {
								value : param[i].label,
								style : 'label_fieldLabel',
							},
							field : {
								style : 'label_fieldData',
							},							
							fieldView : {
								style : 'fieldView_webview',
							},
						},
					};
					break;
				case 'html': 
					extraInfoForm.sections[0].fields[i] = {
						name : 'name_'+i,
						type : param[i].type,
						style: 'view_formfield',
						properties : {
							row : {
								style : 'view_formRow_withWindow',
							},
							label : {
								value : param[i].label,
								style : 'label_fieldLabel',
							},
							field : {
								style : 'label_fieldData',
							},							
							fieldView : {
								style : 'fieldView_webview',
							},
						},
					};
				break;	
				case 'link': 
					extraInfoForm.sections[0].fields[i] = {
						name : 'name_'+i,
						type : param[i].type,
						style: 'view_formfield',
						properties : {
							row : {
								style : 'view_formRow_withWindow',
							},
							label : {
								value : param[i].label,
								style : 'label_fieldLabel',
							},
							field : {
								style : 'label_fieldData',
							},
						},
					};
					break;
				case 'phone': 
					extraInfoForm.sections[0].fields[i] = {
						name : 'name_'+i,
						type : param[i].type,
						style: 'view_formfield',
						properties : {
							label : {
								value : param[i].label,
								style : 'label_fieldLabel',
							},
							field : {
								style : 'label_fieldData',
							}
						},
					};
					break;
				case 'url': 
					extraInfoForm.sections[0].fields[i] = {
						name : 'name_'+i,
						type : param[i].type,
						style: 'view_formfield',
						properties : {
							row : {
								style : 'view_formRow_withWindow',
							},
							label : {
								value : param[i].label,
								style : 'label_fieldLabel',
							},
							field : {
								style : 'label_fieldData',
							},
						},
					};
					break;					
				default : 
					Ti.API.error(param[i].type+' field is undefined in CardIntroWindow line 158.');
			}
		}
		if(!i) extraInfoForm.sections = [];
		return extraInfoForm;
	},
	
	_getFormData : function(param) {
		var self = this;
		var formData = {};
		for(var i=0; i<param.length; i++) formData['name_'+i] = param[i].value;
		return formData;
	},
});

module.exports = CardIntroWindow;
//---  End of file: CardIntroWindow.js