/**
 * CategoryList View
 */
Ti.include('/globals.js');

var CategoryList = App.Class(App.View.WOList, {
	className 	: 'CategoryList',
	stylePath 	: 'CardListStyle',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		rowClicked		: 'CategoryList.rowClicked',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

		self.ITEM_KEY		= 'category';
		self.ALTERNATE		= true;
	},
	
	/**
	 * Row render
	 * Should be implement by sub-class
	 */
	renderRow : function(param, index){
		var self = this;
		var aCard = param;
		
		var row = Ti.UI.createTableViewRow(self.STYLE.tableRow3);
		row.category = param.category;
        row.backgroundColor = (index%2==0)?'#16000000':'transparent';

      	var categoryName = Ti.UI.createLabel(self.STYLE.label.categoryName);
      	categoryName.category		= App.Helper.L(param.category, 'category');
      	categoryName.text			= categoryName.category
      	categoryName.touchEnabled	= false;
      	
      	row.add(categoryName)
		return row;
	},
	
	alternateUpdateRow : function(row, index){
		var self = this;
		var bgColor = (index%2==0)?'#16000000':'transparent';
		row.backgroundColor = bgColor;
	},
	
	renderLastRow : function(index){
		var self = this;
		var row = Ti.UI.createTableViewRow(self.STYLE.tableRow3);
		
		row.addCustomCard = true;		//--- mark this special row --
		
        row.backgroundColor = (index%2==0)?'#16000000':'transparent';
        var lbl_addCustomCard = Ti.UI.createLabel(self.STYLE.label.addCustomCard);
	    lbl_addCustomCard.text = App.Helper.L('categoryList_addCustomCard');
		row.add(lbl_addCustomCard);
		return row;
	},
});

module.exports = CategoryList;

//---  End of file: CategoryList.js
