/**
 * CityList View
 */
Ti.include('/globals.js');

var CityList = App.Class(App.View.WOList2, {
	className 	: 'CityList',
	stylePath 	: 'CityListStyle',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		rowClicked		: 'CityList.rowClicked',
		rowDeleted		: 'CityList.rowDeleted',
   },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.activityIndicator = false;
	},
	
	/**
	 * Row render
	 * Should be implement by sub-class
	 */

	renderRow : function(city, index){
		var self = this;
		if(!city) return false;
		
		var row = Ti.UI.createTableViewRow(self.STYLE.tableRow);
		row.objectID = city.id;
		row.objectData = city;

      	switch(city.type){
      		case 'city' :
  		      	var cityName = Ti.UI.createLabel(self.STYLE.label.city);
		      	cityName.touchEnabled	= false;
		      	var stateName = Ti.UI.createLabel(self.STYLE.label.state);
		      	stateName.touchEnabled	= false;
		      	var countryName = Ti.UI.createLabel(self.STYLE.label.countrystate);
		      	countryName.touchEnabled	= false;
      			if('undefined' != typeof city.name[App.Config.LANG]){
      				cityName.text = city.name[App.Config.LANG].city;
      				stateName.text = city.name[App.Config.LANG].state;
      				countryName.text = city.name[App.Config.LANG].country;
      			} else {
      				cityName.text = city.name.en.city;
      				stateName.text = city.name.en.state;
      				countryName.text = city.name.en.country;
      			}
      			row.add(cityName);
		      	row.add(stateName);
		      	row.add(countryName);
      			break;
      		case 'state':
      			var cityName = Ti.UI.createLabel(self.STYLE.label.city);
		      	cityName.touchEnabled	= false;
		      	var countryName = Ti.UI.createLabel(self.STYLE.label.country);
		      	countryName.touchEnabled	= false;
      		    if('undefined' != typeof city.name[App.Config.LANG]){
      				cityName.text = city.name[App.Config.LANG].state;
      				countryName.text = city.name[App.Config.LANG].country;
      			} else {
      				cityName.text = city.name.en.state;
      				countryName.text = city.name.en.country;
      			}
      			row.add(cityName);
		      	row.add(countryName);      			
      			break;
      		case 'country':
      			var cityName = Ti.UI.createLabel(self.STYLE.label.city);
		      	cityName.touchEnabled	= false;
      		    if('undefined' != typeof city.name[App.Config.LANG]){
      				cityName.text = city.name[App.Config.LANG].country;
      			} else {
      				cityName.text = city.name.en.country;
      			}
  				row.add(cityName);
      			break;
      	}
		return row;
	},
	
	setData : function(rowsData, animation){
		var self = this;
		var rowNum = self.base(rowsData, animation);
		if(App.Config.IS_ANDROID) rowNum >1 ? self.setEditable(true) : self.setEditable(false);
		else rowNum >1 ? self.tableView.setEditable(true) : self.tableView.setEditable(false);
	},
	
	appendRow : function(city){
		var self = this;
		var rowNum = self.base(city);
		if(App.Config.IS_ANDROID) rowNum >1 ? self.setEditable(true) : self.setEditable(false);
		else rowNum >1 ? self.tableView.setEditable(true) : self.tableView.setEditable(false);
	},
	
	deleteHandler : function(evt){
		var self = this;
		var rowNum = self.base(evt);
		if(App.Config.IS_ANDROID) rowNum >1 ? self.setEditable(true) : self.setEditable(false);
		else rowNum >1 ? self.tableView.setEditable(true) : self.tableView.setEditable(false);
	},
});

module.exports = CityList;

//---  End of file: CityList.js
