/**
 * MasterList
 */
Ti.include('/globals.js');

var MasterList = App.Class(App.View.WOList, {
	className 	: 'MasterList',
	stylePath 	: 'CardListStyle',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		rowClicked		: 'MasterList.rowClicked',
		rowDeleted		: 'MasterList.rowDeleted',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

		self.ITEM_KEY		= 'id';
		self.ALTERNATE		= true;
		
		self.renderbyTimer	= true;
		self.renderInterval	= 10;
		
		self.showLoadingIndicator = true;
	},
	
	/**
	 * Row render
	 * Should be implement by sub-class
	 */
	renderRow : function(param, index){
		var self = this;

		var cardMaster = param;
		//--- Card Definition ---------
		var cardDefn = {
			name		: cardMaster.name,
			style		: { touchEnabled: false },
			properties 	: {
				cardObj			: cardMaster,
				format			: $.cardMgr.factory.FORMAT.singleRow,
				cardFront		: true,
				shadow			: true,
				isCardMaster	: true,
				row		: {
					style	: self.STYLE.tableRow2,
				},
			},
			useRow		: true,
			eventProxy	: self._eventProxy,
		};

		var cardData = {};
		var card = $.cardMgr.factory.make(cardDefn, cardData);
		card.setMode('display');
		
		var row = card.getRow();
		row.masterID = cardMaster.id;
		row.backgroundColor = (index%2==0)?'#16000000':'transparent';

		return row;
	},
	
	alternateUpdateRow : function(row, index){
		var self = this;
		var bgColor = (index%2==0)?'#16000000':'transparent';
		row.backgroundColor = bgColor;
	}
	
});

module.exports = MasterList;

//---  End of file: MasterList.js
