/**
 * MasterList2
 */
Ti.include('/globals.js');

var MasterList2 = App.Class(App.View.WOList2, {
	className 	: 'MasterList2',
	stylePath 	: 'CardListStyle',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		rowClicked		: 'MasterList2.rowClicked',
		rowDeleted		: 'MasterList2.rowDeleted',
		rowMoved        : 'MasterList2.rowMoved',
		orderList		: 'MasterList2.orderList',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.dynamicMode = true;
		self.dynamicFirstRows = 10;
		self.dynamicRows = 10; //only valid when dynamicLoading is true;
		
		self.rowsBackgroundColorEnabled = true;
		
		self.DATA;
	},
	
		
	renderRow : function(cardMaster, index){
		var self = this;

		//--- Card Definition ---------
		var cardDefn = {
			name		: cardMaster.name,
			style		: { touchEnabled: false },
			properties 	: {
				cardObj			: cardMaster,
				format			: $.cardMgr.factory.FORMAT.singleRow,
				cardFront		: true,
				shadow			: true,
				isCardMaster	: true,
				row		: {
					style	: self.STYLE.tableRow2,
				},
			},
			useRow		: true,
			eventProxy	: self._eventProxy,
		};

		var cardData = {};
		var card = $.cardMgr.factory.make(cardDefn, cardData);
		card.setMode('display');
		
		var row = card.getRow();
		row.objectID = cardMaster.id;
		
		self.setRowBackgroundColor(row, index);
		return row;
	},

	setRowBackgroundColor : function(row, index){
		var self = this;
		row.backgroundColor = (index%2==0)?'#16000000':'transparent';
		return row;
	},		
	
	clickHandler : function(evt){
		var self = this;
		var masterID = evt.rowData.objectID;
		self._eventProxy.fireEvent(self.EVENT.rowClicked, {
			data:{masterID:masterID}
		});
	},
});

module.exports = MasterList2;

//---  End of file: MasterList2.js
