/**
 * MasterListWindow
 */
Ti.include('/globals.js');

var MasterListWindow = App.Class(App.View.WOWindow, {
	className 	: 'MasterListWindow',
	stylePath 	: 'CardListStyle',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		viewCardMaster	: 'MasterListWindow.viewCardMaster',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

		self.locked = false;
		
		self.WINDOW.title = self.DATA.category;
	},
	
	draw : function(param){
		var self = this;
		
		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		titlebarShadowContainer.top = '-44dp';
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		self.VIEW.add(titlebarShadowContainer);
			
		//---  Render subview  ---
		var viewParam = {
			DATA		: self.DATA.cardMasters,
			eventProxy	: self._eventProxy,
		};
		self.masterList = App.Helper.loadView('discover/MasterList', viewParam);
		var _listView = self.masterList.render();
		
		//---  Set Data & Render Rows  ---
		self.masterList.setData(self.DATA.cardMasters);
		
		//---  Setup event handlers  ---
		self._eventProxy.addEventListener(self.masterList.EVENT.rowClicked, function(evt){
			self._eventProxy.fireEvent(self.EVENT.viewCardMaster, { masterID: evt.data.masterID });
		});

		self.VIEW.add(_listView);
	},
	
	setData : function(data){
		var self = this;
		self.masterList.setData(data);
	},
	
	dispose : function(){
		var self = this;
		
		self.masterList.dispose();		
		self.base();
	}
	
});

module.exports = MasterListWindow;

//---  End of file: MasterListWindow.js
