/**
 * PushRequestWindow
 */
Ti.include('/globals.js');

var PushRequestWindow = App.Class(App.View.WOWindow, {
	className : 'PushRequestWindow',
	stylePath : 'AuthStyle',

	EVENT	: {
		//--- Handles these events:
		//--- Produces these events:
		requestDone		: 'PushRequestWindow.requestDone',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

		self.WINDOW.backgroundColor = '#FFBA00'; 
		self.WINDOW.hideNavBar = true;
	},
	
	draw : function(param){
		var self = this;

		//------------  Place components onto View  -----------		
		var canvas = Ti.UI.createView(self.STYLE.PushRequest.canvas);

		var L_Notification = Ti.UI.createLabel(self.STYLE.PushRequest.H1);
		L_Notification.text = App.Helper.L('auth_NOTIFICATION');
	
		canvas.add(L_Notification);
		
		var L_Reason = Ti.UI.createLabel(self.STYLE.PushRequest.desc);
		L_Reason.text = App.Helper.L('auth_REASON');
		canvas.add(L_Reason);		

		
		var V_EnablePushFrame = Ti.UI.createView(self.STYLE.PushRequest.frame);

		var V_EnablePush1 = Ti.UI.createView(self.STYLE.PushRequest.contentBox);
		var V_Loading =Ti.UI.createView(self.STYLE.PushRequest.contentBox);
		var V_EnablePush2 = Ti.UI.createView(self.STYLE.PushRequest.contentBox);

		V_EnablePushFrame.add(V_EnablePush2);
		V_EnablePushFrame.add(V_Loading);
		V_EnablePushFrame.add(V_EnablePush1);


		var L_Todo1 = Ti.UI.createLabel(self.STYLE.PushRequest.todo);
		L_Todo1.text = App.Helper.L('auth_TODO1');
		V_EnablePush1.add(L_Todo1);

		var timer;
		var B_OK = Ti.UI.createButton(self.STYLE.PushRequest.okBtn);
		B_OK.title = App.Helper.L('BUTTON_OK');
		V_EnablePush1.add(B_OK);

		var loading = Ti.UI.createActivityIndicator(App.Config.IS_ANDROID?({message: 'Checking...'}):(self.STYLE.activityIndicator));
				
	//	loading.top = (parseInt(L_Todo1.height)/2)+'dp';
		V_Loading.add(loading);
		
		
		var L_Todo2 = Ti.UI.createLabel(self.STYLE.PushRequest.todo);
		L_Todo2.text = App.Helper.L('auth_TODO2');
		V_EnablePush2.add(L_Todo2);
		
		var B_Continue = Ti.UI.createButton(self.STYLE.PushRequest.continueBtn);
		B_Continue.title = App.Helper.L('BUTTON_CONTINUE');
		V_EnablePush2.add(B_Continue);
		
		var B_Later = Ti.UI.createButton(self.STYLE.PushRequest.laterBtn);
		B_Later.title = App.Helper.L('BUTTON_DOLATER');
		V_EnablePush2.add(B_Later);
		

		var checkCount = 0;

		V_EnablePush2.visible=false;
		V_Loading.visible=false;
	    

		B_OK.addEventListener('touchstart', function(){
			B_OK.backgroundGradient = self.STYLE.buttonSelectGradient;
		});
		B_OK.addEventListener('touchend', function(){
			B_OK.backgroundGradient = self.STYLE.buttonGradient;
		});
		B_Continue.addEventListener('touchstart', function(){
			B_Continue.backgroundGradient = self.STYLE.buttonSelectGradient;
		});
		B_Continue.addEventListener('touchend', function(){
			B_Continue.backgroundGradient = self.STYLE.buttonGradient;
		});		
		B_Later.addEventListener('touchstart', function(){
			B_Later.backgroundGradient = self.STYLE.buttonSelectGradient_sub;
		});
		B_Later.addEventListener('touchend', function(){
			B_Later.backgroundGradient = self.STYLE.buttonGradient_sub;
		});
		
		B_OK.addEventListener('click', function(e){
			//app.checkNotification();
			$.notifyMgr.checkRemoteNotify();
			V_EnablePush1.visible=false;
			V_Loading.visible=true;
			loading.show();
			timer = setInterval(function(){
				checkService();
			}, 1000);
		});

		B_Continue.addEventListener('click', function(evt){
			checkService(true);
		});
		B_Later.addEventListener('click', function(evt){
			self._eventProxy.fireEvent(self.EVENT.requestDone, {});
		});
		
		
		canvas.add(V_EnablePushFrame);		
		
		//------------  Place components onto View  -----------
		var scrollBg = Ti.UI.createScrollView(self.STYLE.PushRequest.view);
		scrollBg.add(canvas);
		self.VIEW.add(scrollBg);
		
		function checkService(report){
			checkCount++;
			if($.notifyMgr.remoteNotifyEnabled()){
				clearInterval(timer);
				self._eventProxy.fireEvent(self.EVENT.requestDone, {});
			}else{
				if(checkCount>2){
					clearInterval(timer);
					timeOutHandler();
				}
				if(report){
					$.app.showAlert(App.Helper.L('auth_NOTIFICATIONALERT'), App.Helper.L('auth_NOTIFICATIONALERTTITLE'));
				}
			}
		}
		
		function timeOutHandler(){
			V_EnablePush1.visible=false;
			loading.hide();
			V_Loading.visible=false;
			V_EnablePush2.visible=true;
		}
	},

});

module.exports = PushRequestWindow;

//---  End of file: PushRequestWindow.js
