/**
 * IssueCard
 */
Ti.include('/globals.js');

var YouBeenPerkd = App.Helper.requireView('perk/YouBeenPerkd');

var IssueCard = App.Class(YouBeenPerkd, {
	className 	: 'IssueCard',
	
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
/* ----- Defined in WOMessage -----
		self.DATA = message.content
		{
			source	: '',
			sourceAction : 2,
			title : '',
			desc : '',
			//------ param -----
			cardMID : param.data.cardMID,
			cardID	: param.data.cardID,
		};
*/		 
		 self.cardMaster = $.dataMgr.get('WOCardMaster', self.DATA.cardMID);
		 $.app.doNotDisturb(true);
	},
	
	_drawPerkObject : function(perkObjView){
		var self = this;
		
		var cardDefn = {
			name		: self.cardMaster.name,
			style		: self.STYLE.view.cardFace,
			properties 	: {
				cardObj			: self.cardMaster,
				format			: $.cardMgr.factory.FORMAT.standard,
				cardFront		: true,
				shadow			: true,
			},
		};
		var cardData = {};
		self.cardWidget = $.cardMgr.factory.make(cardDefn, cardData);
		self.cardWidget.setMode('display');
		
		self.cardWidget.parent = perkObjView;		//  needed for animateCardAdd !!
		
		var cardView = self.cardWidget.getView();
		var cardFrame = Ti.UI.createView(self.STYLE.view.cardFrame);
		cardFrame.add(cardView);		// so that when we animate, layout don't collapse
		perkObjView.add(cardFrame);
		return cardFrame;
	},

	_drawNotice : function(view_notice){
		var self = this;

		//--- Title  -----
		var label_haveNewCard = Ti.UI.createLabel(self.STYLE.label.obj_desc0);
		label_haveNewCard.text = App.Helper.L('beenPerkd_card');
		view_notice.add(label_haveNewCard);
					
		switch(self.DATA.sourceAction){
			case self.SOURCE_ACTION.share:
				//--- Source Desc  -----
				if(self.DATA.source){
					var label_desc = Ti.UI.createLabel(self.STYLE.label.obj_desc2);
				//	var desc = 'shared to you by ##SOURCE##';
					label_desc.text = String.format(App.Helper.L('beenPerkd_sharedby'), self.DATA.source);
	
			//		label_desc.text = desc.replace(/##SOURCE##/g, self.DATA.source);
					view_notice.add(label_desc);
				}
				break;
							
			case self.SOURCE_ACTION.issue:
			default:
				//--- Source Desc  -----
				if(self.DATA.source){
					var label_desc = Ti.UI.createLabel(self.STYLE.label.obj_desc2);
			//		var desc = 
					label_desc.text = String.format(App.Helper.L('beenPerkd_issuedby'), self.DATA.source);
					view_notice.add(label_desc);
				}
				break;
		}
	},

	_genButtonDefn : function(){
		var self = this;
		
		var buttonDefn = [];
		//---  Decline button  --------
		buttonDefn[0] = {
			style	: self.STYLE.btn_actl,
			label 	: App.Helper.L('BUTTON_DECLINE'),
			handler	: [
				{ event: 'click',		method: _doDecline,			data: {} },
				// { event: 'touchstart',	method: _doTouchStart,		data: {} },
				// { event: 'touchend',	method: _doTouchEnd,		data: {} },
			],
		};
		
		//---  Accept button  --------
		buttonDefn[1] = {
			style	: self.STYLE.btn_actm,
			label 	: App.Helper.L('BUTTON_ACCEPT'),
			handler	: [
				{ event: 'click',		method: _doAccept,			data: {} },
				// { event: 'touchstart',	method: _doTouchStart,		data: {} },
				// { event: 'touchend',	method: _doTouchEnd,		data: {} },
			],		
		};
		
		return buttonDefn;

		//-------------------  Button Event Handlers  --------------		
		function _doDecline(evt){
			
			var card = $.dataMgr.newModel('WOCard', self.DATA.cardID);
			card.remove(true);
			
			self._eventProxy.fireEvent(self.EVENT.perkdDone, {
				action		: 'Decline',
				animated	: true,
				hasRead		: true,
			});
			
			Ti.App.fireEvent($.notifyMgr.EVENT.doNotifyCallback, {
				data : {
					msgID : self.DATA.msgID,
					op : 0,
				}
			});
		}
		
		function _doAccept(evt){
			evt.source.setEnabled(false);
			$.app.showBusy({message:App.Helper.L('hint_wait')});
			//---------------  Call Server  ------------- 
	        var callParam = {
	        	report		: true,
	            action      : 'perkevt_cbk',
	            data        : {
					msgID : self.DATA.msgID,
					op : 1,
				},
				callback 	: _cardAccepted,
				errorback 	: function(result) {
					self._eventProxy.fireEvent(self.EVENT.perkdDone, {
						action		: 'serverErr',
						animated	: true,
						hasRead		: false,
					});
					$.app.hideBusy();
					evt.source.setEnabled(true);
				},
	        };
	        
	        $.syncMgr.callServer(callParam);
		}
		
		function _cardAccepted(result){
			
			if(result.objects) $.syncMgr.updateSyncDownObjects(result.objects);
			$.app.hideBusy();
			
			if(self.cardMaster.isDigital){
				var winObj = $.app.route({
					url			: 'card/register',
					type		: App.Const.WINDOW.type.navGroup,
					style		: App.Const.WINDOW.effect.flip,
	//				navGroupObj	: self.navGroupObj,
					data		: {
						cardID	: self.DATA.cardID
					}
				});
				var proxy = winObj.getEventProxy();
				
				proxy.addEventListener($.cardMgr.EVENT.cardAccepted, function(evt) {
					// $.cardMgr.animateCardAdd(self.cardWidget);
					winObj.close({ animated: true });
				});
				
				setTimeout(function(){
					self._eventProxy.fireEvent(self.EVENT.perkdDone, {
						action		: 'Accept', // registered or later.
						animated	: false,
						hasRead		: true,
						dnd			: true,
					});
				}, 1500);
			} else {
				// Ti.App.fireEvent($.cardMgr.EVENT.cardAdded, { data: card.p2l() });
//				$.cardMgr.animateCardAdd(self.cardWidget);
				self._eventProxy.fireEvent(self.EVENT.perkdDone, {
						action		: 'Accept',
						animated	: true,
						// effect		: App.Const.WINDOW.effect.fade,		// window close effect
				});
			}
		}
		
		function _doTouchStart(evt, data){
			evt.source.color = '#000000';
			//self._swapGradientColors(evt.source.backgroundGradient.colors);
		}
		function _doTouchEnd(evt, data){
			evt.source.color = '#FFFFFF';
			//self._swapGradientColors(evt.source.backgroundGradient.colors);
		}
	},
});

module.exports = IssueCard;

//---  End of file: IssueCard.js
