/**
 * IssueOffer
 */
Ti.include('/globals.js');

var YouBeenPerkd = App.Helper.requireView('perk/YouBeenPerkd');

var IssueOffer = App.Class(YouBeenPerkd, {
	className 	: 'IssueOffer',
	
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
/* ----- Defined in WOMessage -----
		self.DATA = message.content
		{
			source : '',// the offer issued by...
			sourceAction : 2,// issue
			title		: '',
			desc		: '',
			//------ param -----	
			cardID		: '',
			offerIDs	: [],
		};
*/	
		self.numOffers = self.DATA.offerIDs.length;
		if(self.numOffers > 0)
			self.theOffer = $.dataMgr.get('WOOffer', self.DATA.offerIDs[0]);
		else
			self.theOffer = $.dataMgr.newModel('WOOffer');
	},
	
	_drawPerkObject : function(perkObjView){
		var self = this;

		var view_offerCanvas = Ti.UI.createView(self.STYLE.view.offerCanvas);

		var view_offerImageFrame = Ti.UI.createView(self.STYLE.view.offerImageFrame);

		var offerImageObj = $.dataMgr.newModel('WOImage', self.theOffer.image);
		offerImageObj.fetch();
		var offerImageView = offerImageObj.getView({style : self.STYLE.img.offerImg});
		
		offerImageObj.getView({style : self.STYLE.img.offerImg});
		view_offerImageFrame.add(offerImageView);
		

		var imgShadow = Ti.UI.createView(self.STYLE.OfferImgShadow);
		view_offerImageFrame.add(imgShadow);		

		view_offerCanvas.add(view_offerImageFrame);

		var line = Ti.UI.createView(self.STYLE.line);
		view_offerCanvas.add(line);
				
		perkObjView.add(view_offerCanvas);
		return view_offerCanvas;
		
	},
	
	_drawNotice : function(view_notice){
		var self = this;
		
		var label_haveNewOffer = Ti.UI.createLabel(self.STYLE.label.obj_desc1);
			label_haveNewOffer.text = App.Helper.L('beenPerkd_receivedOffer');

		var label_offerBrand = Ti.UI.createLabel(self.STYLE.label.obj_desc2);
		label_offerBrand.text = String.format(App.Helper.L('beenPerkd_receivedOfferFrom'), self.DATA.source);
		
		view_notice.add(label_haveNewOffer);
		view_notice.add(label_offerBrand);
	},
	
	_genButtonDefn : function(){
		var self = this;
		
		var buttonDefn = [];
		//---  Decline button  --------
		buttonDefn[0] = {
			style	: self.STYLE.btn_actl,
			label 	: App.Helper.L('BUTTON_OK'),
			handler	: [
				{ event: 'click',		method: _doCancel,		data: {} },
				// { event: 'touchstart',	method: _doTouchStart,		data: {} },
				// { event: 'touchend',	method: _doTouchEnd,		data: {} },
			],
		};
		
		//---  Accept button  --------
		buttonDefn[1] = {
			style	: self.STYLE.btn_actm,
			label 	: App.Helper.L('BUTTON_VIEW'),
			handler	: [
				{ event: 'click',		method: _doView,		data: {} },
				// { event: 'touchstart',	method: _doTouchStart,		data: {} },
				// { event: 'touchend',	method: _doTouchEnd,		data: {} },
			],
		};
		
		return buttonDefn;

		//-------------------  Button Click Handlers  --------------		
		function _doCancel(evt){
			self._eventProxy.fireEvent(self.EVENT.perkdDone, {
				action		: 'OK',
				animated	: true,
				hasRead		: true,
				dnd			: false,
			});
			
			Ti.App.fireEvent($.notifyMgr.EVENT.doNotifyCallback, {
				data : {
					msgID : self.DATA.msgID,
					op : 1, //OK
				}
			});
		}
		function _doView(evt){
			Ti.App.fireEvent($.cardMgr.EVENT.goCardView, { cardID: self.DATA.cardID, noFlip: true });

			self._eventProxy.fireEvent(self.EVENT.perkdDone, {
				action		: 'View',
				animated	: false,
				effect		: App.Const.WINDOW.effect.fade,
				hasRead		: true,
			});
			
			Ti.App.fireEvent($.notifyMgr.EVENT.doNotifyCallback, {
				data : {
					msgID : self.DATA.msgID,
					op : 2, //VIEW
				}
			});			
		}
	},
});

module.exports = IssueOffer;

//---  End of file: IssueOffer.js
