/**
 * IssueStamp
 */
Ti.include('/globals.js');

var YouBeenPerkd = App.Helper.requireView('perk/YouBeenPerkd');

var IssueStamp = App.Class(YouBeenPerkd, {
	className 	: 'IssueStamp',
	
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
/* ----- Defined in WOMessage -----
		self.DATA = message.content
		{
			source : '', // the stamp issued by ...
			sourceAction : 2, // issue
			title 	: '',
			desc	: '',
			//------ param -----	
			cardID 			: '',
			rewardsetMID	: '',
			stampIDs 		: [], // imageObj.
		};
*/
		self.numStamps = self.DATA.stampIDs.length;
		self.rewardsetMaster = $.dataMgr.get('WORewardsetMaster', self.DATA.rewardsetMID);
	},
	
	_drawPerkObject : function(perkObjView){
		var self = this;

		
		var stampsLayout = self._getStampsLayout(self.numStamps);
		var stampsFrame = Ti.UI.createView(self.STYLE.view.stampsFrame);

					
		var stampsCanvas = Ti.UI.createView(self.STYLE.view.stampsCanvas);
		stampsFrame.add(stampsCanvas);
		
		var stamps = [];
		for(var i=0; i < self.DATA.stampIDs.length; i++){
			var stampObj = new App.Model.WOImage({
				id: self.DATA.stampIDs[i],
	         	placeholder: '/assets/images/ui/default_logo.png',
	       		defaultImage: '/assets/images/ui/default_logo.png',
			});
			stampObj.initialize();
			
			// var stampObj = $.dataMgr.newModel('WOImage', self.DATA.stampIDs[i]);
			stampObj.fetch();
			stamps.push(stampObj.getView({
				style : stampsLayout.stampStyle,
			}));
		}
		
		var n=0;
		for(var r=0; r < stampsLayout.grid.length; r++){
			var canvas = Ti.UI.createView(stampsLayout.rowStyle);
			
			var stampsArray = [];
			for(var i=0; i < stampsLayout.grid[r]; i++, n++){
				canvas.add(stamps[n]);
				stampsArray.push({obj : stamps[n]});
			}

			var itemDefn = {
				canvas	: canvas,
				item	: stampsArray,
				style	: 'center',
			}
			App.loadHelper('layout').layout(itemDefn);
			
			stampsCanvas.add(canvas);
		}
		
		if(perkObjView) perkObjView.add(stampsFrame);
		return stampsFrame;
	},	
	
	_drawNotice : function(noticeView){
		var self = this;
				
		//--- Title  -----
		var titleLabel = Ti.UI.createLabel(self.STYLE.label.obj_desc1);
		
		if(self.numStamps>1) 
			titleLabel.text = String.format(App.Helper.L('beenPerkd_receivedStamps'), self.numStamps);
		else
			titleLabel.text = String.format(App.Helper.L('beenPerkd_receivedStamp'), self.numStamps);	
		
		var label_desc = Ti.UI.createLabel(self.STYLE.label.obj_desc2);
		
		//		var desc = 
		label_desc.text = String.format(App.Helper.L('beenPerkd_issuedby'), self.DATA.source);
		
		noticeView.add(titleLabel);
		noticeView.add(label_desc);
	},

	_genButtonDefn : function(){
		var self = this;
		
		var buttonDefn = [];
		//---  Decline button  --------
		buttonDefn[0] = {
			style	: self.STYLE.btn_actl,
			label 	: App.Helper.L('BUTTON_OK'),
			handler	: [
				{ event: 'click',		method: _doCancel,			data: {} },
				// { event: 'touchstart',	method: _doTouchStart,		data: {} },
				// { event: 'touchend',	method: _doTouchEnd,		data: {} },
			],				
		};

		//---  Accept button  --------
		buttonDefn[1] = {
			style	: self.STYLE.btn_actm,
			label 	: App.Helper.L('BUTTON_VIEW'),
			handler	: [
				{ event: 'click',		method: _doView,			data: {} },
				// { event: 'touchstart',	method: _doTouchStart,		data: {} },
				// { event: 'touchend',	method: _doTouchEnd,		data: {} },
			],			
		};

		return buttonDefn;

		//-------------------  Button Click Handlers  --------------		
		function _doCancel(evt){
			self._eventProxy.fireEvent(self.EVENT.perkdDone, {
				action		: 'OK',
				animated	: true,
				hasRead		: true,
			});
			
			Ti.App.fireEvent($.notifyMgr.EVENT.doNotifyCallback, {
				data : {
					msgID : self.DATA.msgID,
					op : 1, //OK
				}
			});
		}
		function _doView(evt){
			Ti.App.fireEvent($.cardMgr.EVENT.goCardView, { cardID: self.DATA.cardID, noFlip: true });
			
			self._eventProxy.fireEvent(self.EVENT.perkdDone, {
				action		: 'View',
				animated	: true,
				hasRead		: true,
			});
			
			Ti.App.fireEvent($.notifyMgr.EVENT.doNotifyCallback, {
				data : {
					msgID : self.DATA.msgID,
					op : 2, //VIEW
				}
			});
		}
	},
	
	_getStampsLayout : function(numStamps){
		var self = this;
		
		var stampsLayoutConfig = [];
		stampsLayoutConfig[0] = {
			// you got xxx stamos!!!
		};
		stampsLayoutConfig[1] = {
			grid : [1],
			stampStyle : {
				width : '160dp',
				height : '160dp',
			},
			rowStyle : {
				width: '290dp',
				height: '200dp',
			},
		};
		stampsLayoutConfig[2] = {
			grid : [2],
			stampStyle : {
				width : '120dp',
				height : '120dp',
			},
			rowStyle : {
				width: '290dp',
				height: '200dp',
			},
		};
		stampsLayoutConfig[3] = {
			grid : [3],
			stampStyle : {
				width : '90dp',
				height : '90dp',
			},
			rowStyle : {
				width: '290dp',
				height: '200dp',
			},
		};
		stampsLayoutConfig[4] = {
			grid : [2, 2],
			stampStyle : {
				width : '120dp',
				height : '120dp',
			},
			rowStyle : {
				width: '290dp',
				height: '120dp',
			},
		};
		stampsLayoutConfig[5] = {
			grid : [3, 2],
			stampStyle : {
				width : '90dp',
				height : '90dp',
			},
			rowStyle : {
				width: '290dp',
				height: '100dp',
			},
		};
		stampsLayoutConfig[6] = {
			grid : [3, 3],
			stampStyle : {
				width : '90dp',
				height : '90dp',
			},
			rowStyle : {
				width: '290dp',
				height: '100dp',
			},
		};
		stampsLayoutConfig[7] = {
			grid : [2, 3, 2],
			stampStyle : {
				width : '72dp',
				height : '72dp',
			},
			rowStyle : {
				width: '290dp',
				height: '75dp',
			},
		};
		stampsLayoutConfig[8] = {
			grid : [3, 2, 3],
			stampStyle : {
				width : '72dp',
				height : '72dp',
			},
			rowStyle : {
				width: '290dp',
				height: '75dp',
			},
		};
		stampsLayoutConfig[9] = {
			grid : [3, 4, 2],
			stampStyle : {
				width : '64dp',
				height : '64dp',
			},
			rowStyle : {
				width: '290dp',
				height: '70dp',
			},
		};
		stampsLayoutConfig[10] = {
			grid : [3, 4, 3],
			stampStyle : {
				width : '64dp',
				height : '64dp',
			},
			rowStyle : {
				width: '290dp',
				height: '70dp',
			},	
		};
		stampsLayoutConfig[15] = {
			grid : [5, 5, 5],
			stampStyle : {
				width : '56dp',
				height : '56dp',
			},
			rowStyle : {
				width: '290dp',
				height: '64dp',
			},	
		};
		
		return stampsLayoutConfig[numStamps];
	}
});

module.exports = IssueStamp;

//---  End of file: IssueStamp.js