/**
 * PerkCodeWindow
 */
Ti.include('/globals.js');

var PerkcodeWindow = App.Class(App.View.WOWindow, {
	className 	: 'PerkcodeWindow',
	stylePath 	: 'scanStyle',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		scanQR			: 'PerkcodeWindow.scanQR',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

		self.WINDOW.title = '';
	},
	
	draw : function(param){
		var self = this;

		var mainView = self._addMainView(self.VIEW);
		var scanView = self._addScanView(mainView);
		var scanBtn	 = self._addScanButton(scanView);
		
		scanBtn.addEventListener('click', function(){
			self._eventProxy.fireEvent(self.EVENT.scanQR, {});
		});
	},
	
	_addMainView : function(myWindow){
		var self = this;
		
		var mainView = Ti.UI.createView(self.STYLE.view.canvas_absolute);		
		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		mainView.add(titlebarShadowContainer);
		
		var btnPerkd = Ti.UI.createButton(self.STYLE.perkd_btn);
		
		if(myWindow) {
			if (App.Config.IS_ANDROID) {
				myWindow.setLeftNavButton(btnPerkd);
			} else {
				myWindow.leftNavButton = btnPerkd;			
			}
		}
		if(myWindow) myWindow.add(mainView);
		return mainView;
	},
	
	_addScanView : function(theView){
		var self = this;
		
		var scanView = Ti.UI.createView(self.STYLE.view.scan);
		var scanViewImg = Ti.UI.createView(self.STYLE.view.scanImg);
		scanView.add(scanViewImg);
		
		if(theView) theView.add(scanView);
		return scanView;
	},
	
	_addScanButton : function(theView){
		var self = this;
		
		var scanBtn = Ti.UI.createButton(self.STYLE.btn.scan);
		scanBtn.title = App.Helper.L('BUTTON_SCAN');
		
		scanBtn.addEventListener('touchstart', function(){
			scanBtn.backgroundGradient = self.STYLE.buttonSelectGradient;
		});	
		scanBtn.addEventListener('touchend', function(){
			scanBtn.backgroundGradient = self.STYLE.buttonGradient;
		});	

		if(theView) theView.add(scanBtn);
		return scanBtn;
	},
	
	//-------------------------  Event Handlers  --------------------------
	// onFocus : function(){
		// $.app.doNotDisturb(true);		// don't disturb when we are about to scan
	// },

	// onBlur : function(){
		// $.app.doNotDisturb(false);
	// },

});

module.exports = PerkcodeWindow;

//---  End of file: PerkcodeWindow.js
