/**
 * YouBeenPerkd
 */
Ti.include('/globals.js');

var YouBeenPerkd = App.Class(App.View.WOWindow, {
	className 	: 'YouBeenPerkd',
	stylePath 	: 'PerkdStyle',
    
	EVENT		: {
		//--- handles these events:
		//--- produces these events:
		perkdDone		: 'YouBeenPerkd.perkdDone',	
	},

	SOURCE_ACTION	: {
		share	: 1,
		issue 	: 2,
	},

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

		self.WINDOW.title = self.DATA.title  || App.Helper.L('beenPerkd_title');
	    self.WINDOW.hideNavBar = true;  // mainly for Android, otherwise will display 2 titlebars.
	},

	draw : function(param){
		var self = this;

		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		
		var titleBar = Ti.UI.createView(self.STYLE.titlebar);
		var titleLabel = Ti.UI.createLabel(self.STYLE.windowTitle);
		titleLabel.text = self.WINDOW.title;
		titleBar.add(titleLabel);
		self.VIEW.add(titleBar);
		self.VIEW.add(titlebarShadowContainer);

		var canvas = Ti.UI.createView(self.STYLE.view.canvas);
		canvas.top = '44dp';
		self.VIEW.add(canvas);

		//---  Perk Object section  ---
		var view_obj = Ti.UI.createView(self.STYLE.view.obj);
		self._drawPerkObject(view_obj);
		canvas.add(view_obj);

		//---  Notice section  --------
		var noticeView = Ti.UI.createView(self.STYLE.view.notice);
		self._drawNotice(noticeView);
		canvas.add(noticeView);
		
		//---  Buttons section  -------
		var buttonView = Ti.UI.createView(self.STYLE.view.btn);
		self._drawButtons(buttonView);
		canvas.add(buttonView);
	},

	_drawPerkObject : function(perkObjView){
	},
	
	_drawNotice : function(noticeView){
	},

	_drawButtons : function(buttonView, buttonDefn){
		var self = this;

		//---  Generate the buttons  ---
		var buttonDefn = self._genButtonDefn();
		
		var buttons = [];
		for(var i=0; i<buttonDefn.length; i++){
			var aButton = Ti.UI.createButton(buttonDefn[i].style);
			aButton.title = buttonDefn[i].label;
			
			//---  Attach 'click' event handlers to buttons  ---
			if(buttonDefn[i].handler){
				for(aHandler in buttonDefn[i].handler){
					var handle = buttonDefn[i].handler[aHandler];
					var eventHandler = _handlerClosure(handle.method, handle.data);
					aButton.addEventListener(handle.event, eventHandler);
				}
			}
			buttons.push({ obj: aButton });
			buttonView.add(aButton);
		}

		//---  Layout the buttons  -----
		var layoutDefn = {
			canvas	: buttonView,
			style	: 'flush',
			item	: buttons,
		};
		App.loadHelper('layout').layout(layoutDefn);

		return buttonView;
		
		//--- Closure function for Event Handlers -----------------
		function _handlerClosure(method, data){
			var closure = function(evt){
				if(self.notRapidFire(evt.source.title))    method(evt, data);
			};
			return closure;
		}
	},

	_genButtonDefn : function(){
		var self = this;
		
		var buttonDefn = [];
		//---  OK button  --------
		buttonDefn[0] = {
			style	: self.STYLE.btn.main,
			label 	: App.Helper.L('BUTTON_OK'),
			handler	: [
				{ event: 'click',		method: _doCloseWindow,		data: {} },
				// { event: 'touchstart',	method: _doTouchStart,		data: {} },
				// { event: 'touchend',	method: _doTouchEnd,		data: {} },
			],
		};
		
		return buttonDefn;
		
		//-------------------  Button Event Handlers  --------------
		function _doCloseWindow(evt, data){
			self._doCloseWindow();
		}
		function _doTouchStart(evt, data){
			self._swapGradientColors(evt.source.backgroundGradient.colors);
		}
		function _doTouchEnd(evt, data){
			self._swapGradientColors(evt.source.backgroundGradient.colors);
		}
	},

	//-------------------  Button Event Handlers  --------------
	_doCloseWindow : function(evt, data){
		var self = this;
		self.closeWindow();
	},
	_swapGradientColors : function(gradientColor){
		var tmp = evt.source.backgroundGradient.colors[0];
		gradientColor[0] = gradientColor[1];
		evt.source.backgroundGradient.colors[1] = tmp;			
	},
	
	closeWindow : function(param){
		var self = this;
		
		param = param || {
			action : false,
			animated : true,
		};
		self._eventProxy.fireEvent(self.EVENT.perkdDone, param);
	}
});

module.exports = YouBeenPerkd;

//---  End of file: YouBeenPerkd.js
