/**
 * PointsListView
 */
Ti.include('/globals.js');

var PointsListView = App.Class(App.View.WOList, {
	className 	: 'PointsListView',
	stylePath 	: 'PointsListStyle',
	
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.ITEM_KEY		= 'id';
		
		self.ALTERNATE		= false;
	},
	
	/**
	 * Row render
	 * Should be implement by sub-class
	 */
	renderRow : function(aPoints, index){
		var self = this;
		var row = Ti.UI.createTableViewRow(self.STYLE.tableRow);
		row.id = aPoints.id;
	
  		var rowView = Ti.UI.createView(self.STYLE.view.rowView);
  		var view_storeName = Ti.UI.createView(self.STYLE.view.storeName);
  		var view_transDate = Ti.UI.createView(self.STYLE.view.transDate);
  		var view_pointNo = Ti.UI.createView(self.STYLE.view.pointNo);

		
        Ti.API.info('---flag---');
        Ti.API.info(aPoints);

        if(aPoints.txTime){
        	switch(aPoints.kind) {
        		case 'nostore':
        			_renderPointsWithoutStore();
        			break;
        		
        		case 'store':
        		default:
        			_renderPointsWithStore();
        	}
        }
        
        function _renderPointsWithStore(){
        	//---  Store Name  -------------------
        	var lbl_storeName = Ti.UI.createLabel(self.STYLE.label.storeName);
        	lbl_storeName.text = (null != aPoints.storeName) ? aPoints.storeName : '';

        	//---  Transaction Date  --------------
        	var transactionDate = (new Date(Number(aPoints.txTime)*1000));        	
        	var lbl_transDate = Ti.UI.createLabel(self.STYLE.label.transDate);

        	if((new Date() - transactionDate) <= 604800000){ 		//  = 7 days = 7 * 1000 * 3600 * 24 milliseconds
        		lbl_transDate.text = App.Moment(transactionDate).fromNow();
        	}else{
		        lbl_transDate.text = App.Helper.humaneDate(transactionDate);
        	}
	        	// text:'collect on '+transactionDate, color:'#FFFFFF', opacity:0.6, textAlign:'right', touchEnabled:false, minimumFontSize:14,
				// font:{fontFamily:"Melbourne-Bold", fontSize:14},  left:0, height:21,

	        var lbl_pointNo = Ti.UI.createLabel(self.STYLE.label.pointNo);
        	// text:aPoints.quantity, color:'#FFFFFF', textAlign:'left', touchEnabled:false, minimumFontSize:16,
			// font:{fontFamily:"Melbourne-Bold", fontSize:25}, width:270, height:26, left:15, top:20,

			if(aPoints.type==2){		// points redemption
				lbl_pointNo.text = '-' + aPoints.quantity;
				lbl_pointNo.color ='#DFFF0000';
			}else{
				lbl_pointNo.text = '+' + aPoints.quantity;
				lbl_pointNo.color ='#AC00FF00';
			}
			view_storeName.add(lbl_storeName);
		    view_transDate.add(lbl_transDate);
			view_pointNo.add(lbl_pointNo);
			
			rowView.add(view_storeName);
		    rowView.add(view_transDate);
			rowView.add(view_pointNo);
			row.add(rowView);
        }
        
        function _renderPointsWithoutStore(){

        	//---  Transaction Date  --------------
        	var transactionDate = (new Date(Number(aPoints.txTime)*1000));        	
        	var lbl_storeName = Ti.UI.createLabel(self.STYLE.label.storeName);

        	if((new Date() - transactionDate) <= 604800000){ 		//  = 7 days = 7 * 1000 * 3600 * 24 milliseconds
        		lbl_storeName.text = App.Moment(transactionDate).fromNow();
        	}else{
		        lbl_storeName.text = App.Helper.humaneDate(transactionDate);
        	}
	        	// text:'collect on '+transactionDate, color:'#FFFFFF', opacity:0.6, textAlign:'right', touchEnabled:false, minimumFontSize:14,
				// font:{fontFamily:"Melbourne-Bold", fontSize:14},  left:0, height:21,

	        var lbl_pointNo = Ti.UI.createLabel(self.STYLE.label.pointNo);
        	// text:aPoints.quantity, color:'#FFFFFF', textAlign:'left', touchEnabled:false, minimumFontSize:16,
			// font:{fontFamily:"Melbourne-Bold", fontSize:25}, width:270, height:26, left:15, top:20,

			if(aPoints.type==2){		// points redemption
				lbl_pointNo.text = '-' + aPoints.quantity;
				lbl_pointNo.color ='#DFFF0000';
			}else{
				lbl_pointNo.text = '+' + aPoints.quantity;
				lbl_pointNo.color ='#AC00FF00';
			}
			view_storeName.add(lbl_storeName);
			view_pointNo.add(lbl_pointNo);
			
			rowView.add(view_storeName);
			rowView.add(view_pointNo);
			row.add(rowView);
        }
        
        row.backgroundColor = (index%2==0)?'#16000000':'transparent';
		return row;
	},
});
module.exports = PointsListView;

//---  End of file: PointsListView.js
