/**
 * PointsWindow
 */
Ti.include('/globals.js');

var PointsWindow = App.Class(App.View.WOWindow, {
	className 	: 'PointsWindow',
	stylePath	: 'PointsListStyle',
	
	EVENT		: {
		//--- Controller to handle:
		//--- events from Controller:
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

	    self.WINDOW.title = App.Helper.L('win_title_point');
	    self.WINDOW.hideTabBar = true;

		//---  Data package from Controller ---
		self.DATA;
		
		// --- UI Components ---
		self.FORM;
	},
	
	draw : function(param){
		var self = this;

		var viewParam = {
			eventProxy	: self.getEventProxy(),
			tabGroup	: self.tabGroup,
		};

		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		self.VIEW.add(titlebarShadowContainer);
		
		self.listSmallObj 	= App.Helper.loadView('points/PointsListView', viewParam);
		// var proxy = self.listSmallObj.getEventProxy();
		self.listSmallView  = self.listSmallObj.render();
		self.listSmallObj.setData(self.DATA.points);
		
		self.VIEW.add(self.listSmallView);
		
		self.VIEW.addEventListener('blur', function(e){
			if(self.VIEW && !App.Config.IS_ANDROID){
				titlebarShadowContainer.hide();
				self.VIEW.backgroundImage = null; 
				self.VIEW.backgroundColor = null; 
			}
		});
	
		// var closeBtn = Ti.UI.createButton(self.STYLE.btn.done);
		// closeBtn.addEventListener('click', function(e){
			// self.close({ animated: true });
		// });
		// self.VIEW.setRightNavButton(closeBtn);
	},

	close : function(param){
		var self = this;
		
		$.app.doNotDisturb(false);
		self.base(param);
	},
	
	dispose:function(){
		var self = this;
		self.listSmallObj.dispose();
		self.base();
	},
});

module.exports = PointsWindow;

//---  End of file: PointsWindow.js
