/**
 * Registration: Later Window
 */
Ti.include('/globals.js');

var LaterWindow = App.Class(App.View.WOWindow, {
	className	: 'LaterWindow',
	stylePath	: 'AuthStyle',

	EVENT		: {
		//--- Controller to handle:
		signup			: 'LaterWindow.signup',
		skipRegister	: 'LaterWindow.skipRegister',
    },

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.WINDOW.hideNavBar = true;
	},
	
	draw : function(param){
		var self = this;

		//------  Cancel Button  --------------
		var B_Back = Ti.UI.createButton(self.STYLE.Reason.backBtn);
		B_Back.addEventListener('touchstart', function(){
			B_Back.opacity=0.5;
		});
		B_Back.addEventListener('touchend', function(){
			B_Back.opacity=1;
		});
		B_Back.addEventListener('click', function(evt){
			if (App.Config.IS_ANDROID)	Ti.UI.Android.hideSoftKeyboard();
			self.back(self.VIEW);
		});
		
		//------------  Place components onto View  -----------		
		var canvas = Ti.UI.createView(self.STYLE.Reason.canvas);

		//-----  Title & Sub-title  -----------
		var L_YouKnow = Ti.UI.createLabel(self.STYLE.Later.H1);
		L_YouKnow.text = App.Helper.L('auth_YOUKNOW');
		
		var L_HavePerkd = Ti.UI.createLabel(self.STYLE.Later.H2);
		L_HavePerkd.text = App.Helper.L('auth_HAVEPERKD');
	
		canvas.add(L_YouKnow);
		canvas.add(L_HavePerkd);
			
		//---  Always get Your Perks  ----------------------
		var V_Reason1 = Ti.UI.createView(self.STYLE.Reason.frame);

		var I_Image1 = Ti.UI.createImageView(self.STYLE.Later.image);
		I_Image1.image = '/assets/images/ui/later_pic1.png';
		
		var V_textBox1 = Ti.UI.createView (self.STYLE.Reason.textBox);
		
		var L_ReasonTitle1 = Ti.UI.createLabel(self.STYLE.Later.title);
		L_ReasonTitle1.text = App.Helper.L('auth_KNOW1TITLE');
		
		var L_ReasonDesc1 =  Ti.UI.createLabel(self.STYLE.Reason.desc);
		L_ReasonDesc1.text = App.Helper.L('auth_KNOW1DESC');
		V_Reason1.add(I_Image1);
		V_textBox1.add(L_ReasonTitle1);
		V_textBox1.add(L_ReasonDesc1);
		V_Reason1.add(V_textBox1);
		canvas.add(V_Reason1);

		//---  Never Lose Your Cards  ----------------------
		var V_Reason2 = Ti.UI.createView(self.STYLE.Reason.frame);

		var I_Image2 = Ti.UI.createImageView(self.STYLE.Later.image);
		I_Image2.image = '/assets/images/ui/later_pic2.png';
		
		var V_textBox2 = Ti.UI.createView (self.STYLE.Reason.textBox);
		
		var L_ReasonTitle2 = Ti.UI.createLabel(self.STYLE.Later.title);;
		L_ReasonTitle2.text = App.Helper.L('auth_KNOW2TITLE');
		
		var L_ReasonDesc2 = Ti.UI.createLabel(self.STYLE.Reason.desc);
		L_ReasonDesc2.text = App.Helper.L('auth_KNOW2DESC');
		V_Reason2.add(I_Image2);
		V_textBox2.add(L_ReasonTitle2);
		V_textBox2.add(L_ReasonDesc2);
		V_Reason2.add(V_textBox2);
		canvas.add(V_Reason2);
		
		
		//-------  Sign Up Now button  --------
		var B_Signup = Ti.UI.createButton(self.STYLE.Later.signupBtn);
		B_Signup.title = App.Helper.L('BUTTON_SIGNUPNOW');
		
		B_Signup.addEventListener('touchstart', function(){
			B_Signup.backgroundGradient = self.STYLE.buttonSelectGradient;
		});
		B_Signup.addEventListener('touchend', function(){
			B_Signup.backgroundGradient = self.STYLE.buttonGradient;
		});
		B_Signup.addEventListener('click', _doSignup);

		canvas.add(B_Signup);
	
		//-------  Do it Later button  ----------
		if(! self.DATA.isSkipped){
			var L_Later = Ti.UI.createLabel(self.STYLE.Later.link);
			L_Later.right = B_Signup.right;
			L_Later.left = null;
			L_Later.text = App.Helper.L('auth_LATER');
			L_Later.addEventListener('click', _doSkipRegister);
			canvas.add(L_Later);			
		}

		//------------  Place components onto View  -----------
		var scrollBg = Ti.UI.createScrollView(self.STYLE.Reason.view);
		scrollBg.add(B_Back);
		scrollBg.add(canvas);
		self.VIEW.add(scrollBg);

		//---------------------  Controller Event Handlers  ----------------------		
		function _doSignup(evt){
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			self._eventProxy.fireEvent(self.EVENT.signup, {});
		}
		function _doSkipRegister(evt){
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();

 			L_Later.color='#000000';
            L_Later.opacity=0.5;
            L_Later.shadowColor = "#FFFFFF";
			
			self._eventProxy.fireEvent(self.EVENT.skipRegister, {});
			
			L_Later.color='#FFFFFF';
            L_Later.opacity=0.6;
            L_Later.shadowColor = "transparent";
		}
	},
});

module.exports = LaterWindow;

//---  End of file: LaterWindow.js
