/**
 * SignupWindow
 */
Ti.include('/globals.js');
if (App.Config.IS_ANDROID){	Ti.include('/waveo/core/WOAndroidUtils.js');	};

var SignupWindow = App.Class(App.View.WOWindow, {
	className 	: 'SignupWindow',
	stylePath 	: 'AuthStyle',

	EVENT		: {
		//--- Controller to handle:
		signup			: 'SignupWindow.signup',
		searchCountry	: 'SignupWindow.searchCountry',
    },
    
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.WINDOW.hideNavBar = true;
		
		self.DATA.countryCode;
		self.DATA.countryName;
		
	},

	draw : function(param){
		var self = this;

		//20 = statusbar height   215 = keyboard height		
		var scrollBg = Ti.UI.createScrollView(self.STYLE.Signup.view);
		var canvas = Ti.UI.createView(self.STYLE.Signup.canvas);
		//---  Cancel Button  ------------
		var B_Back = Ti.UI.createButton(self.STYLE.Signup.backBtn);
		B_Back.addEventListener('touchstart', function(){
			B_Back.opacity=0.5;
		});
		B_Back.addEventListener('touchend', function(){
			B_Back.opacity=1;
		});
		B_Back.addEventListener('click', function(e){
			if (App.Config.IS_ANDROID)	Ti.UI.Android.hideSoftKeyboard();
			// self.back(self.VIEW);
			self.close({animated:true});
		});

		//------------  Place components onto View  -----------
			scrollBg.add(canvas);
			scrollBg.add(B_Back);
		
			scrollBg.addEventListener('click', function(){
				if(!self.showingPick){
					blurAll();
				};
			});
			self.VIEW.add(scrollBg);
				
		//---  Title  --------------------
		var L_NewAccount = Ti.UI.createLabel(self.STYLE.Signup.H1);
		L_NewAccount.text = App.Helper.L('auth_NEWACCOUNT');

		canvas.add(L_NewAccount);

		//Android Start use a hidden textfield to fix the autofocus issue temporarily
		if (App.Config.IS_ANDROID) {
			var F_HIDDEN = Ti.UI.createTextField(self.STYLE.TEXTFIELD_HIDDEN);
			canvas.add(F_HIDDEN);
			F_HIDDEN.addEventListener('blur', function(){
				Ti.API.info('CTKKB:F_HIDDEN:blurred');
			});
			F_HIDDEN.addEventListener('focus', function(){
				Ti.API.info('CTKKB:F_HIDDEN:focused');
				// if (self.lastFocused==F_PASSWORD){
					// F_PASSWORD.focus();
				// } else if (self.lastFocused==F_MOBILE){
					// F_MOBILE.focus();					
				// }
			});
		};
		//Android END

		//---  Name  ---------------------
		var FM_Name = Ti.UI.createView(self.STYLE.Signup.form);
		
		var F_FAMILYNAME = Ti.UI.createTextField(self.STYLE.Signup.F_FamilyName);
		F_FAMILYNAME.value = self.DATA.familyName;

		var F_GIVENNAME = Ti.UI.createTextField(self.STYLE.Signup.F_GivenName);
		F_GIVENNAME.value = self.DATA.givenName;
		
		var line = Ti.UI.createView (self.STYLE.Signup.separetor);
		
		if('zh-Hant' == Ti.Locale.currentLanguage || 'zh-Hans' == Ti.Locale.currentLanguage || 'zh' == Ti.Locale.currentLanguage) {
		
			FM_Name.add(F_FAMILYNAME);
			FM_Name.add(line);
			FM_Name.add(F_GIVENNAME);
			
			F_FAMILYNAME.addEventListener('return', function(){
				F_GIVENNAME.focus();
			});
		} else {

			FM_Name.add(F_GIVENNAME);
			FM_Name.add(line);
			FM_Name.add(F_FAMILYNAME);
			
			F_GIVENNAME.addEventListener('return', function(){
				F_FAMILYNAME.focus();
			});
		}
		
		F_FAMILYNAME.addEventListener('focus', function(){
			hidePicker();
		});
		F_GIVENNAME.addEventListener('focus', function(){
			hidePicker();
		});

		canvas.add(FM_Name);


		//---  Gender & Birthday  --------------		
		var FM_BirthGender = Ti.UI.createView(self.STYLE.Signup.form);
		
		//---  Gender  --------------		
		var FM_Gender = Ti.UI.createView(self.STYLE.Signup.formField);
		var L_Gender = Ti.UI.createLabel(self.STYLE.Signup.formLabel);
		L_Gender.text = App.Helper.L('auth_GENDER');
		
		if (App.Config.IS_ANDROID){
			var F_GENDER = createAndroidTabbedBar(self.STYLE.Signup.F_Gender);
		}else{		
			var F_GENDER = Ti.UI.iOS.createTabbedBar(self.STYLE.Signup.F_Gender);
		}
		F_GENDER.gender = 0; //[TODO] ZJ FIXME this is not a titanium property
		
		F_GENDER.addEventListener('click', function(e){
			if (e.index==undefined||e.index==null) return; // Quick fix for Android multiple event on single click. Does not happen on iphone			
			blurAll();
			hidePicker();
			if (e.index == 0){
				F_GENDER.gender = 1;
			}else{
				F_GENDER.gender = 2;
			}
		});
		if(self.DATA.gender){
			F_GENDER.gender = self.DATA.gender;
			if('1' == self.DATA.gender){
				F_GENDER.setIndex(0);
			}else if('2' == self.DATA.gender){
				F_GENDER.setIndex(1);
			}
		}	
		FM_Gender.add(L_Gender);
		FM_Gender.add(F_GENDER);

		//---  Date of Birth  --------
		var FM_Birth =	Ti.UI.createView(self.STYLE.Signup.formField);
		FM_Birth.touchEnabled =  true;
		var L_Birth = Ti.UI.createLabel(self.STYLE.Signup.formLabel);
		L_Birth.text = App.Helper.L('auth_DOB');

		var F_BIRTH = Ti.UI.createLabel(self.STYLE.Signup.F_Birth);
		F_BIRTH.text = '';
		
		if(self.DATA.birth){
			var birthDate = new Date(Number(self.DATA.birth*1000));
			F_BIRTH.text = App.Moment(birthDate).format('LL');
			F_BIRTH.date 	= self.DATA.birth;
		}
		
		FM_Birth.add(L_Birth);
		FM_Birth.add(F_BIRTH);

		var line2 = Ti.UI.createView (self.STYLE.Signup.separetor);
		FM_BirthGender.add(FM_Gender);
		FM_BirthGender.add(line2);
		FM_BirthGender.add(FM_Birth);
		
		canvas.add(FM_BirthGender);


		var V_datePickerPanel = Ti.UI.createView(self.STYLE.datePickerPanel);
		V_datePickerPanel.visible = false;


		var V_datePicker = Ti.UI.createView(self.STYLE.datePickerArea);
		//---  Datepicker  ------
		var picker_date = Ti.UI.createPicker({
			type:Ti.UI.PICKER_TYPE_DATE,
			value:new Date(),
			// maxDate:new Date(),  //because some users don't know need to choose year first!
		});
		V_datePicker.add(picker_date);

		if (!App.Config.IS_ANDROID) {	

			picker_date.addEventListener('change', function(e){
				picker_date.value = e.value;
			});
			//--- Datepicker toolbar  ------
			var pickToolBar = Ti.UI.iOS.createToolbar(self.STYLE.toolBar);

			var flexSpace = Ti.UI.createButton(self.STYLE.btn.flexSpace);
			var btn_done = Ti.UI.createButton(self.STYLE.btn.done);
			var btn_clear = Ti.UI.createButton(self.STYLE.btn.clear);

			pickToolBar.items = [btn_clear, flexSpace, btn_done];		
						
			btn_done.addEventListener('click', function(){
				if(picker_date.value >= new Date()){
					$.app.showAlert(App.Helper.L('birth_error'), App.Helper.L('TITLE_DOB'));
					return;
				}
				var birthDate 	= picker_date.value;
	
				F_BIRTH.text = App.Moment(birthDate).format('LL');
				F_BIRTH.date 	= Math.round(birthDate.getTime()/1000);
				hidePicker();
			});
			btn_clear.addEventListener('click', function(){
				hidePicker();
				F_BIRTH.text = '';
				F_BIRTH.date = null;
			});

			V_datePickerPanel.add(pickToolBar);		
		}

		V_datePickerPanel.add(V_datePicker);		
		self.VIEW.add(V_datePickerPanel);

		FM_Birth.addEventListener('click', function(){

			if (App.Config.IS_ANDROID) {
				picker_date.showDatePickerDialog({
				  value: new Date(F_BIRTH.date*1000),
				  callback: function(e) {
				  	if (e.cancel) {
				      Ti.API.info('User canceled dialog');
				    } else {
						F_BIRTH.text	= App.Moment(e.value).format('LL');
						F_BIRTH.date 	= Math.round(e.value/1000);
						picker_date.value	= e.value;
						Ti.API.info('birthday = '+e.value);
				    }
				  }
				});
				blurAll();
			} else {
				self.showingPick = true;
				showPicker();
			}

		});


		//---  Mobile No  ------------------
		var L_Mobile = Ti.UI.createLabel(self.STYLE.Signup.H2);
		L_Mobile.text = App.Helper.L('auth_ENTERMOBILE');

		var line2 = Ti.UI.createView (self.STYLE.selector.LINE1);
		var line3 = Ti.UI.createView (self.STYLE.selector.LINE2);
		
		var V_CountryCode =  Ti.UI.createView(self.STYLE.selector.view);
		self.L_CountryCode = Ti.UI.createLabel(self.STYLE.selector.countryCode);
		self.L_CountryCode.text = '+'+self.DATA.countryCode;
		
		self.L_CountryName = Ti.UI.createLabel(self.STYLE.selector.countryName);
		self.L_CountryName.text = self.DATA.countryName;
		var arrow = Ti.UI.createImageView(self.STYLE.selector.arrow);

		V_CountryCode.add(self.L_CountryCode);
		V_CountryCode.add(line2);
		V_CountryCode.add(line3);
		V_CountryCode.add(self.L_CountryName);
		V_CountryCode.add(arrow);

		V_CountryCode.addEventListener('click', function(evt){
			blurAll();
			hidePicker();
			V_CountryCode.backgroundGradient = self.STYLE.buttonSelectGradient;
			self._eventProxy.fireEvent(self.EVENT.searchCountry, {});
			V_CountryCode.backgroundGradient = self.STYLE.buttonGradient;
		});
		var FM_Mobile =  Ti.UI.createView(self.STYLE.Signup.form);
		var F_MOBILE = Ti.UI.createTextField(self.STYLE.Signup.F_Mobile);

		F_MOBILE.addEventListener('focus', function(){
			hidePicker();
			// if(!F_MOBILE.value){
				// F_MOBILE.value = self.DATA.mobilePrefix;
				// if(App.Config.IS_ANDROID) F_MOBILE.setSelection(F_MOBILE.value.length,F_MOBILE.value.length)
			// };
		});
		F_MOBILE.addEventListener('return', _doSignup);

		FM_Mobile.add(F_MOBILE);
		canvas.add(L_Mobile);
		canvas.add(V_CountryCode);
		canvas.add(FM_Mobile);

		//---  Submit Button  --------------------
		var V_GetPerkd =	Ti.UI.createView(self.STYLE.goNext.view);
		
		var B_GetPerkd = Ti.UI.createButton(self.STYLE.goNext.btn);
		var L_GetPerkd = Ti.UI.createLabel(self.STYLE.goNext.btnLabel);
		L_GetPerkd.text = App.Helper.L('Get_Perkd');

		V_GetPerkd.add(L_GetPerkd);
		V_GetPerkd.add(B_GetPerkd);

		V_GetPerkd.addEventListener('click', _doSignup);

		canvas.add(V_GetPerkd);


		//---------------------  Controller Event Handlers  ----------------------
		function _doSignup(evt){
			V_GetPerkd.opacity=0.5;
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			blurAll();
			
			var result = {
				countryCode : self.DATA.countryCode, // eg: 65
				countryName	: self.DATA.countryName,
				mobileNum	: F_MOBILE.value,
                mobileNo    : self.L_CountryCode.text+F_MOBILE.value,
				givenName	: F_GIVENNAME.value,
				familyName	: F_FAMILYNAME.value,
				gender		: F_GENDER.gender,
				birth		: F_BIRTH.date,
				skip        : false,
			};
			if(! result.givenName){
				$.app.showAlert(App.Helper.L('gname_required'), App.Helper.L('title_register'));
				V_GetPerkd.opacity=1;
				return;
			}
			if(! result.familyName){
				$.app.showAlert(App.Helper.L('fname_required'), App.Helper.L('title_register'));
				V_GetPerkd.opacity=1;
				return;
			}
			if(null == result.gender){
				$.app.showAlert(App.Helper.L('gender_required'), App.Helper.L('title_register'));
				V_GetPerkd.opacity=1;
				return;
			}
			if(! result.birth){
				$.app.showAlert(App.Helper.L('birth_required'), App.Helper.L('title_register'));
				V_GetPerkd.opacity=1;
				return;
			}else if(Number(result)*1000>(new Date()).valueOf()){
				$.app.showAlert(App.Helper.L('birth_error'), App.Helper.L('title_register'));
				V_GetPerkd.opacity=1;
				return;
			}
			if(!result.mobileNum || result.mobileNum == ''){
				$.app.showAlert(App.Helper.L('mobile_error'), App.Helper.L('title_register'));
				V_GetPerkd.opacity=1;
				return;
			}
			
			//---  Confirm Sign-up  ----
			var comfirmAlert = Ti.UI.createAlertDialog({
				title       : App.Helper.L('TITLE_CONFIRM'),
				message     : String.format(App.Helper.L('confirm_mobile'), result.mobileNo),
				buttonNames : [App.Helper.L('BUTTON_CANCEL'), App.Helper.L('BUTTON_OK')]
			});
			comfirmAlert.show();
			comfirmAlert.addEventListener('click', function(e){
				if(e.index == 1){
					self._eventProxy.fireEvent(self.EVENT.signup, {
						profile		: result,
					});
				}
				V_GetPerkd.opacity=1;
			});

		}

		//---------------------  Private Methods  ----------------------		

		function blurAll(){
			F_FAMILYNAME.blur();
			F_GIVENNAME.blur();
			F_MOBILE.blur();
		}
		function hidePicker(){
			self.showingPick = false;
			V_datePickerPanel.visible = false;
			scrollBg.scrollTo(0,0);
		}
		function showPicker(){
			blurAll();
			V_datePickerPanel.visible = true;
			Ti.API.info('scrollBg height ='+scrollBg.height);
			if(!App.Config.IS_ANDROID && scrollBg.height == 480){scrollBg.scrollTo(0,'46dp');};
			if(!App.Config.IS_ANDROID && scrollBg.height == 568){scrollBg.scrollTo(0,'2dp');}
		}
	},
	
	updateCountry : function(country){
		var self = this;
		self.DATA.countryCode = country.code;
		self.L_CountryCode.text = '+'+self.DATA.countryCode;
		
		self.DATA.countryName = country.name;
		self.L_CountryName.text = self.DATA.countryName;
	},
	
});
module.exports = SignupWindow;

//---  End of file: SignupWindow.js
