/**
 * OffersRedeem
 */
Ti.include('/globals.js');

var OffersRedeem = App.Class(App.View.WOWindow, {
	className 	: 'OffersRedeem',
	stylePath	: 'OfferRedeemStyle',
	
	EVENT : {
		//--- handles these events:
		//--- produces these events:		
	},
	
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.DATA ; // anOffer		
		self.WINDOW.title = App.Helper.L('TITLE_REDEEMOFFER');
		self.WINDOW.hideNavBar = true;  // mainly for Android, otherwise will display 2 titlebars.
	},

	draw : function(param){
		var self = this;

 		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		
		var titleBar = Ti.UI.createView(self.STYLE.titlebar);
		var titleLabel = Ti.UI.createLabel(self.STYLE.windowTitle);
		titleLabel.text = App.Helper.L('TITLE_REDEEMOFFER');
		titleBar.add(titleLabel);
		self.VIEW.add(titleBar);
		self.VIEW.add(titlebarShadowContainer);

	   	var brand 	= self.DATA.anOffer.brandName;
		var name 	= self.DATA.anOffer.name;
		var desc 	= self.DATA.anOffer.desc;

		var view_scrollableBg = Ti.UI.createScrollView(self.STYLE.view.scrollableBg);
		var canvas = Ti.UI.createView(self.STYLE.view.canvas);

		var couponBrand = Ti.UI.createLabel(self.STYLE.label.couponBrand);
		couponBrand.text = brand;
		
		var couponName = Ti.UI.createLabel(self.STYLE.label.couponName);
		couponName.text = name;
		
		canvas.add(couponBrand);
		canvas.add(couponName);
		
		var couponCodeBg = Ti.UI.createView(self.STYLE.view.couponCodeBg);

		// qrcode
		var barcodeType = Number(self.DATA.anOffer.barcodeType);
		
		if(self.DATA.anOffer.barcodeValue && barcodeType!=-1){
			

			if(barcodeType==1){
				var codeParam = self.STYLE.view.QRCode;
			}else{
				var codeParam = self.STYLE.view.barCode;
			}
			
			
			// Draw Code			
			if (App.Config.IS_ANDROID) {
//				var barcodeModule = require('com.bsl.lbarcode');
				var barcodeModule = require('com.bsl.zxbarcode');
				
				var viewBarcode = Ti.UI.createImageView(codeParam);
				var option = barcodeType;
				var code = self.DATA.anOffer.barcodeValue; 	

				var img = null;
				/*
				if (option == 2) {
					img = barcodeModule.encodeCode39(code);
				} else if (option == 4) {
					img = barcodeModule.encodeCode128(code);
				} else if (option == 1) {
					img = barcodeModule.encodeQRCode(code);
				} else if (option == 8) {
					img = barcodeModule.encodeEan8(code);
				} else if (option == 7) {
					img = barcodeModule.encodeEan13(code);
				} else if (option == 5) {
					img = barcodeModule.encodeUpcA(code);
				} else if (option == 6) {
					img = barcodeModule.encodeUpcE(code);
//				} else if (option == ?) {
//					img = self.barcodeModule.encodeItf(code);
			}
				*/
	

				if (option == 2) {
					//img = self.barcodeModule.encodeCode39(code);
					img = barcodeModule.encode(code,"code39");
				} else if (option == 4) {
					//img = self.barcodeModule.encodeCode128(code);
					img = barcodeModule.encode(code,"code128");
				} else if (option == 1) {
					//img = self.barcodeModule.encodeQRCode(code);
					img = barcodeModule.encode(code,"qrcode");
				} else if (option == 8) {
					//img = self.barcodeModule.encodeEan8(code);
					img = barcodeModule.encode(code,"ean8");
				} else if (option == 7) {
					//img = self.barcodeModule.encodeEan13(code);
					img = barcodeModule.encode(code,"ean13");
				} else if (option == 5) {
					//img = self.barcodeModule.encodeUpcA(code);
					img = barcodeModule.encode(code,"upca");
				} else if (option == 6) {
					//img = self.barcodeModule.encodeUpcE(code);
					img = barcodeModule.encode(code,"upce");
				} else if (option == 9) {
//						img = self.barcodeModule.encodeItf(code);
					img = barcodeModule.encode(code,"itf");
				} else if (option == 15) {
					img = barcodeModule.encode(code, "codabar");
				} else if (option == 16) {
					img = barcodeModule.encode(code, "aztec");
				} else if (option == 14) {
					img = barcodeModule.encode(code, "pdf417");
				}


				viewBarcode.setImage (img);


			} else {
				var barcodeModule = require('com.test');			

			
				codeParam.ctype  = barcodeType;
				codeParam.code   = self.DATA.anOffer.barcodeValue; 			
				var viewBarcode = barcodeModule.createView(codeParam);
				
			}


			var couponCodeFrame = Ti.UI.createView(self.STYLE.view.couponCodeFrame);
			couponCodeFrame.add(viewBarcode);
					
			if(self.DATA.anOffer.displayCode){
				// Draw code label
				var codeLabel_withCode = Ti.UI.createLabel(self.STYLE.label.codeLabel_withCode);
				codeLabel_withCode.text  = self.DATA.anOffer.displayCode;

				couponCodeBg.add(couponCodeFrame);
				couponCodeBg.add(codeLabel_withCode);
		  		
			}else {
				couponCodeFrame.top = null;
				couponCodeBg.add(couponCodeFrame);
			}
	
		} else {
		// only code label display
			var codeLabel = Ti.UI.createLabel(self.STYLE.label.codeLabel);
			codeLabel.text  = self.DATA.anOffer.displayCode;
			couponCodeBg.add(codeLabel);
		}
		
		
		canvas.add(couponCodeBg);
			
		var couponDesc = Ti.UI.createLabel(self.STYLE.label.couponDesc);
		couponDesc.text = desc;
				
		canvas.add(couponDesc);		
		view_scrollableBg.add(canvas);
		
		self.VIEW.add(view_scrollableBg);
		
		var btnDone = Ti.UI.createButton(self.STYLE.systemButton.DONE);
		btnDone.addEventListener('click', _doConfirm);

		var btnLabel = Ti.UI.createLabel(self.STYLE.systemButton.btnLabel);
		btnLabel.setText(App.Helper.L('BUTTON_DONE'));

		titleBar.add(btnDone);
		titleBar.add(btnLabel);

		
		function _doConfirm(evt){
			self.close({ animated : true}); // changed to false, temporary fixed redeem crash issue. [ZJ]
		}
	},

});

module.exports = OffersRedeem;

//---  End of file: OffersRedeem.js
