/**
 * OffersUnlock
 */
Ti.include('/globals.js');

var YouBeenPerkd = App.Helper.requireView('perk/YouBeenPerkd');

var OffersUnlock = App.Class(YouBeenPerkd, {
	className 	: 'OffersUnlock',
	
	EVENT : {
		//--- handles these events:
		//--- produces these events:		
		passedCheck : 'OffersUnlock.passedCheck',
	},
	
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		// self.DATA = {
			// passwords : { //FIXME [Zj] : temporary for test.
				// '12345' : '12345',
				// '1q2w3e': '',
			// }
		// }; // == passwords
		self.F_PASSWORD = null;
	},
	
	_drawPerkObject : function(perkObjView){
		var self = this;
		
		var view_password = Ti.UI.createView(self.STYLE.view.password);
		self.F_PASSWORD = Ti.UI.createTextField(self.STYLE.textfield.password);
		self.F_PASSWORD.hintText = App.Helper.L('offerDetail_unlockpsw');

		view_password.add(self.F_PASSWORD);
		
		if(perkObjView) perkObjView.add(view_password);
		return view_password;
	},

	_genButtonDefn : function(){
		var self = this;
		
		var buttonDefn = [];
		//---  Decline button  --------
		buttonDefn[0] = {
			style	: self.STYLE.btn_actl,
			label 	: App.Helper.L('BUTTON_CANCEL'),
			handler	: [
				{ event: 'click',		method: _doCancel,			data: {} },
				// { event: 'touchstart',	method: _doTouchStart,		data: {} },
				// { event: 'touchend',	method: _doTouchEnd,		data: {} },
			],		
		};
		buttonDefn[0].style.top =  '25dp';
		
		//---  Accept button  --------
		buttonDefn[1] = {
			style	: self.STYLE.btn_actm,
			label 	: App.Helper.L('BUTTON_OK'),
			handler	: [
				{ event: 'click',		method: _doConfirm,			data: {} },
				// { event: 'touchstart',	method: _doTouchStart,		data: {} },
				// { event: 'touchend',	method: _doTouchEnd,		data: {} },
			],				
		};
		buttonDefn[1].style.top =  '25dp';
		
		return buttonDefn;

		//-------------------  Button Click Handlers  --------------		
		function _doCancel(evt){
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();
			self.close({animated:true});
		}
		function _doConfirm(evt){
			if(App.Config.IS_ANDROID) Ti.UI.Android.hideSoftKeyboard();

			if(!self.F_PASSWORD.value) return;
			
			if(self.F_PASSWORD.value in self.DATA.passwords) {
				self._eventProxy.fireEvent(self.EVENT.passedCheck, {});
			} else {
				$.app.showAlert(App.Helper.L('ALERT_INCORRECTPASSWORD'));
			}
		}
	},
});

module.exports = OffersUnlock;

//---  End of file: OffersUnlock.js
