/**
 * OffersWindow
 */
Ti.include('/globals.js');

var OffersWindow = App.Class(App.View.WOWindow, {
	className 	: 'OffersWindow',
	stylePath 	: 'OfferStyle',
	
	EVENT : {
		//--- Handles these events:
		doRefresh	: 'OffersWindow.doRefresh',
		//--- Produces these events:
		redeemOffer : 'OffersWindow.redeemOffer',
		unlockOffer : 'OffersWindow.unlockOffer',
	},
	
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
	// --- DATA Package from Controller ---		
		self.DATA.cardID;
		self.DATA.offers;
		
		self.UI = {
			pages : [],
		};

		self.currentPage = 0;

		self.WINDOW.title = App.Helper.L('TITLE_OFFER');
//		self.lazyRender = true;
		
		self.UI.offerImageScrollableView = null;
		self.UI.currentOfferDetailView = null;
		self.UI.offerDetailViews = {};
		
		self.WINDOW.hideTabBar = true;		
		
		self.listenForEvents();
	},

	listenForEvents : function(){
		var self = this;
		
		self.getEventProxy();
		
		self._eventProxy.addEventListener(self.EVENT.doRefresh, function(evt){
			self._doRefresh(evt.data.page, evt.data.anOffer);
		});
	},
	
	draw : function(param){
		var self = this;
		
		self.goNextpage = false;
		
		if(self.DATA.offers.length > 1) {
		 	if(App.Config.IS_IOS4) {
			 	self.VIEW.setTitle(String.format(App.Helper.L('TITLE_OFFEROFOFFERS'), 1, self.DATA.offers.length));
			}else {
				self.setWindowTitle(String.format(App.Helper.L('TITLE_OFFEROFOFFERS'), 1, self.DATA.offers.length));
			}
		 };

		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		self.VIEW.add(titlebarShadowContainer);
		
		self.canvas = self._addMainView(self.VIEW);
		
		self._addOfferImageScrollableView(self.canvas);		
		self.UI.currentOfferDetailView = self._addOfferDetailViews(self.canvas);
			
		self.UI.offerImageScrollableView.addEventListener('scrollEnd', function(evt){
			self.UI.currentOfferDetailView.remove(self.UI.offerDetailViews[self.currentPage]);
			self.currentPage = evt.currentPage;
			self.UI.currentOfferDetailView.add(self.UI.offerDetailViews[self.currentPage]);
			
			if(self.DATA.offers.length > 1) {
			 	if(App.Config.IS_IOS4) {
				 	self.VIEW.setTitle(String.format(App.Helper.L('TITLE_OFFEROFOFFERS'), evt.currentPage+1, self.DATA.offers.length));
				 	
				}else {
					self.setWindowTitle(String.format(App.Helper.L('TITLE_OFFEROFOFFERS'), evt.currentPage+1, self.DATA.offers.length));
				}
			 };
			// self.canvas.updateLayout({
					// contentHeight: (parseInt(self.UI.offerDetailScrollableView.views[evt.currentPage].height)+ 210)+'dp',
			// });
		});

// 		
		// self.VIEW.addEventListener('blur', function(evt){
			// if(!self.goNextpage){
				// titlebarShadowContainer.hide();
				// self.VIEW.backgroundImage = null; 
				// self.VIEW.backgroundColor = null;
			// }
			// self.goNextpage = false;
		// });
	},
	
	close : function(param){
		var self = this;
		
		$.app.doNotDisturb(false);
		self.base(param);
	},

	_addMainView : function(myWindow) {
		var self = this;
		
		var view = Ti.UI.createScrollView(self.STYLE.view.scrollableBg);
		// view.backgroundColor = 'red';
		
		myWindow.add(view);
		return view;
	},
		
	_addOfferImageScrollableView : function(theView) {
		var self = this;
		
		self.UI.offerImageScrollableView = Ti.UI.createScrollableView(self.STYLE.view.scrollableViewImage);
		
		// self.UI.offerImageScrollableView.backgroundColor = 'red';
		
		var views = [];
		for (var i = 0; i < self.DATA.offers.length; i++) {
			var anOffer = self.DATA.offers[i];
			self.UI.pages[i] = self.UI.pages[i] || {};
			views.push(self._addOfferView(i, anOffer));
		}
		
		if(self.DATA.offers.length==1){
			self.UI.offerImageScrollableView.showPagingControl = false;
		};
		
		self.UI.offerImageScrollableView.views = views;
		
		if(theView) theView.add(self.UI.offerImageScrollableView);
		return self.UI.offerImageScrollableView;
	},
	
	// _addOfferDetailScrollableView : function(theView) {
		// var self = this;
// 		
		// self.UI.offerDetailScrollableView = Ti.UI.createScrollableView(self.STYLE.view.scrollableViewDesc);
// 		
		// var views = [];
		// for (var i = 0; i < self.DATA.offers.length; i++) {
			// var anOffer = self.DATA.offers[i];
			// // var aView = self._getOfferview_offerDetail(anOffer);
			// var aView = self._addOfferview_offerDetail(i, anOffer);
			// views.push(aView);
		// }
		// self.UI.offerDetailScrollableView.views = views;
		// if(theView) theView.add(self.UI.offerDetailScrollableView);
// 		
		// return self.UI.offerDetailScrollableView;
	// },
	
	_addOfferDetailViews : function(theView) {
		var self = this;
		
		var view = Ti.UI.createView(self.STYLE.view.obj_DetailsFrame); 
		var line = Ti.UI.createView(self.STYLE.line);
		view.add(line);
				
		for (var i = 0; i < self.DATA.offers.length; i++) {
			var anOffer = self.DATA.offers[i];
			var aView = self._addOfferview_offerDetail(i, anOffer);
			self.UI.offerDetailViews[i] = aView;
		}
		
		if(i) view.add(self.UI.offerDetailViews[0]);
		
		if(theView) theView.add(view);
		return view;
	},
	
	_addOfferView : function(page, anOffer, theView) {
		var self = this;
		App.Helper.requireModel('WOImage');
		
		var view_imageFrame = Ti.UI.createView(self.STYLE.view.ImageFrame);
		var image = new App.Model.WOImage({
			id: anOffer.image,
         	placeholder: '/assets/images/ui/default_placeholders.png',
       		defaultImage: '/assets/images/ui/default_offerreward.png',
		});
		image.initialize();
		image.fetch();
		
		self.UI.pages[page].offerImageView = image.getView({
			style: self.STYLE.view.imageView,
    	    activityIndicator	: { show: true },	
		});	

		view_imageFrame.add(self.UI.pages[page].offerImageView);

		//self.UI.pages[0].offerImageView.image = 'http://newsletter.waveo.com/temp/7.png';
		var imgShadow = Ti.UI.createView(self.STYLE.scrollImgShadow);
		view_imageFrame.add(imgShadow);


		var view_offerStatusContainer = Ti.UI.createView(self.STYLE.view.obj_statusContainer);
		view_offerStatusContainer.visible = false;
		var view_offerStatusBox = Ti.UI.createView(self.STYLE.view.obj_status);
		var lbl_offerStatus = Ti.UI.createLabel(self.STYLE.label.obj_status);
		
		view_offerStatusContainer.add(view_offerStatusBox);
		view_offerStatusBox.add(lbl_offerStatus);
		
		view_imageFrame.add(view_offerStatusContainer);

		self.UI.pages[page].offerStatusContainer = view_offerStatusContainer;
		self.UI.pages[page].offerStatusBox = view_offerStatusBox;
		self.UI.pages[page].lbl_offerStatus = lbl_offerStatus;

				
		var lbl_offerName = Ti.UI.createLabel(self.STYLE.label.obj_name);
		anOffer.showName ? lbl_offerName.text = anOffer.name : lbl_offerName.text='';
		if(self.DATA.offers.length==1){
			lbl_offerName.setBottom('5dp');
		};		
		self.UI.pages[page].lbl_offerName = lbl_offerName.text;

		view_imageFrame.add(lbl_offerName);

		self._doRefreshStatusContainer(page, anOffer);
		
		if(theView) theView.add(view_imageFrame);
		return view_imageFrame;
	},
	
	_addOfferview_offerDetail : function(page, anOffer, theView) {
		var self = this;
		
		var view_offerDetail = Ti.UI.createView(self.STYLE.view.obj_Details);
		
		//add validity period
		self._addValidDateView(page, anOffer, view_offerDetail);		
		//add brand name view
		self._addBrandNameView(page, anOffer, view_offerDetail);
		//add description view
		self._addDescriptionView(page, anOffer, view_offerDetail);
		//add status controls view
		self._addStatusControls(page, anOffer, view_offerDetail);
		//add terms&conditions view
		self._addTermsAndConditionsView(page, anOffer, view_offerDetail);
		
		if(theView) theView.add(view_offerDetail);
		return view_offerDetail;
	},

	_addValidDateView : function(page, anOffer, theView) {
		var self = this;

		var view_offerTips = Ti.UI.createView(self.STYLE.view.obj_tips);

		var lbl_validDate = Ti.UI.createLabel(self.STYLE.label.obj_validDate);
		// if(!App.Config.IS_ANDROID){
			var startDate = App.Helper.humaneDate(new Date(Number(anOffer.validBegin)*1000), -1);
			var expiryDate = App.Helper.humaneDate(new Date(Number(anOffer.validEnd)*1000), -1);
		// }else {
			// var startDate = App.Moment(new Date(anOffer.validBegin*1000.0)).format('LL');
			// var expiryDate = App.Moment(new Date(anOffer.validEnd*1000.0)).format('LL');
		// }
		
		lbl_validDate.text = String.format(App.Helper.L('LABEL_VALIEDBETWEEN'), startDate, expiryDate);
		view_offerTips.add(lbl_validDate);
		
		self.UI.pages[page].lbl_validDate = lbl_validDate;
		
		if(theView) theView.add(view_offerTips);
		return view_offerTips;
	},
		
	_addBrandNameView : function(page, anOffer, theView) {
		var self = this;
		
		var lbl_brandName = Ti.UI.createLabel(self.STYLE.label.obj_brand);
		lbl_brandName.text = anOffer.brandName;
		
		self.UI.pages[page].lbl_brandName = lbl_brandName;
		
		if(theView) theView.add(lbl_brandName);
		return lbl_brandName;
	},
	
	_addDescriptionView : function(page, anOffer, theView) {
		var self = this;
		
		var lbl_desc = Ti.UI.createLabel(self.STYLE.label.obj_desc);
		lbl_desc.text = anOffer.desc;
		
		self.UI.pages[page].lbl_desc = lbl_desc;
		
		if(theView) theView.add(lbl_desc);
		return lbl_desc;
	},
	
	_addTermsAndConditionsView : function(page, anOffer, theView) {
		var self = this;

		if(anOffer.tc.slice(0, 20).indexOf('<!DOCTYPE') > -1) { // ok, webview

			var offerTandC = Ti.UI.createWebView(self.STYLE.webView.tandc);
			offerTandC.html = anOffer.tc;
		} else {
			var offerTandC = Ti.UI.createLabel(self.STYLE.label.tandc);
			offerTandC.text	= anOffer.tc;
		}

		if(offerTandC) self.UI.pages[page].offerTandC = offerTandC;		
		if(offerTandC) theView.add(offerTandC);
				
		return offerTandC;
	},
	
	_addStatusControls : function(page, anOffer, theView) {
		var self = this;

		// var canvas  = Ti.UI.createView(self.STYLE.view.offerStatus);
		var view_offerStatus = Ti.UI.createView(self.STYLE.view.offerStatus);
		if(!anOffer.showRdmBtn) {
			view_offerStatus.height = 0;
			view_offerStatus.bottom = 0;
		} else {
			view_offerStatus.height = Ti.UI.SIZE;
			view_offerStatus.bottom = '15dp';
		};
				
		self.UI.pages[page].unlockBtn = self._addUnlockButton(page, anOffer, view_offerStatus);
		// self.UI.pages[page].redeemDlg = self._addRedeemDialog(page, anOffer, view_offerStatus);
		self.UI.pages[page].redeemBtn = self._addRedeemButton(page, anOffer, view_offerStatus);
		
		self.UI.pages[page].statusDesc = self._addStatusLabel(page, anOffer, view_offerStatus);

		self._doRefreshUnlockButton(page, anOffer);
		// self._doRefreshRedeemDialog(page, anOffer);
		
		/*=========*/
		/* CTK     */
		/* Problem */
		self._doRefreshRedeemButton(page, anOffer);
		
		
		
		
		theView.add(view_offerStatus);
		return view_offerStatus;
	},
	
	_addUnlockButton : function(page, anOffer, theView) {
		var self = this;
		
		var unlockBtn = Ti.UI.createButton(self.STYLE.btn.unlock);
		unlockBtn.title = App.Helper.L('BUTTON_UNLOCK');
		
		//-----------  Button Event Handlers  ----------
		unlockBtn.addEventListener('click', function(evt){
			if(self.notRapidFire(evt.source.text)){
				self.goNextpage = true;
				self._eventProxy.fireEvent(self.EVENT.unlockOffer, {
					data : {
						cardID		: self.DATA.cardID,
						offerID		: anOffer.id,
						passwords	: anOffer.passwords,
						currentPage	: page,
					}
				});
			}
		});
		unlockBtn.addEventListener('touchstart', function(evt){
			unlockBtn.backgroundGradient = self.STYLE.buttonGradient_mainSelected;
		});
		unlockBtn.addEventListener('touchend', function(evt){
			unlockBtn.backgroundGradient = self.STYLE.buttonGradient_main;
		});
		unlockBtn.addEventListener('touchcancel', function(evt){
			unlockBtn.backgroundGradient = self.STYLE.buttonGradient_main;
		});		
		theView.add(unlockBtn);
		return unlockBtn;
	},
	
	_addRedeemButton : function(page, anOffer, theView) {
		var self = this;
		
		if(!anOffer.showRdmBtn) return;
		
		var redeemBtn = Ti.UI.createButton(self.STYLE.btn.redeem);
		// self.UI.pages[page].redeemBtnLabel = Ti.UI.createLabel(self.STYLE.label.btnLabel);
		// redeemBtn.add(self.UI.pages[page].redeemBtnLabel);
// 
		// self.UI.pages[page].redeemBtnSubLabel = Ti.UI.createLabel(self.STYLE.label.btnsubLabel);
		// redeemBtn.add(self.UI.pages[page].redeemBtnSubLabel);
		
		//---------  Button Event Handlers  -----------
		redeemBtn.addEventListener('click', function(evt){
			if(self.notRapidFire(evt.source.text)){
				self._showRedeemDialog(page, anOffer);
			}
		});
		redeemBtn.addEventListener('touchstart', function(){
			redeemBtn.backgroundGradient = self.STYLE.buttonGradient_mainSelected;
		});
		redeemBtn.addEventListener('touchend', function(){
			redeemBtn.backgroundGradient = self.STYLE.buttonGradient_main;
		});
		redeemBtn.addEventListener('touchcancel', function(evt){
			redeemBtn.backgroundGradient = self.STYLE.buttonGradient_main;
		});	
		theView.add(redeemBtn);
		return redeemBtn;
	},
	
	_addStatusLabel : function(page, anOffer, theView) {
		var self = this;

		var view_statusDesc = Ti.UI.createView(self.STYLE.view.statusDesc);

		self.UI.pages[page].redeemBtnLabel = Ti.UI.createLabel(self.STYLE.label.btnLabel);
		self.UI.pages[page].redeemBtnSubLabel = Ti.UI.createLabel(self.STYLE.label.btnsubLabel);
		
		view_statusDesc.add(self.UI.pages[page].redeemBtnLabel);
		view_statusDesc.add(self.UI.pages[page].redeemBtnSubLabel);

		theView.add(view_statusDesc);
		return view_statusDesc;
	},
	
	

	_showRedeemDialog : function(page, anOffer) {
		var self = this;

		//---  Construct message  ---
		var timesStr = '';
		if(1 == anOffer.canRedeemTimes){
			var msg = App.Helper.L('ALERT_CanUseOfferOnlyOnce');
		} else if(anOffer.canRedeemTimes > 1) {
			var msg = String.format(App.Helper.L('ALERT_CanUseOfferManyTimes'), anOffer.canRedeemTimes);
		} else if(-1 == anOffer.canRedeemTimes) {
			var msg = App.Helper.L('ALERT_CanUseOfferUnlimitTimes');
		}

		var dialog = Ti.UI.createAlertDialog({
			title		: App.Helper.L('poptitle_redeemOffer'),
			message		: msg,
			buttonNames	: [App.Helper.L('BUTTON_CANCEL'), App.Helper.L('BUTTON_USENOW')],
		});
		
		dialog.mySelf = self;

		dialog.addEventListener ('click', (function(){
			return (function(evt) {
				if(1 == evt.index) {
					evt.source.mySelf.goNextpage = true;
					evt.source.mySelf._eventProxy.fireEvent(evt.source.mySelf.EVENT.redeemOffer, {
						data : {
							cardID		: evt.source.mySelf.DATA.cardID,
							offerID		: anOffer.id,
							currentPage	: page,
						}
					});
				}
			});
		})());
		dialog.show();
	},
	
	_doRefresh : function(page, anOffer) {
		var self = this;
		
		App.Helper.requireModel('WOImage');
		
		if(!self.UI.pages[page]) return;
		
		// if(!App.Config.IS_ANDROID){
			var startDate = App.Helper.humaneDate(new Date(Number(anOffer.validBegin)*1000), -1);
			var expiryDate = App.Helper.humaneDate(new Date(Number(anOffer.validEnd)*1000), -1);
		// }else {
			// var startDate = App.Moment(new Date(anOffer.validBegin*1000.0)).format('LL');
			// var expiryDate = App.Moment(new Date(anOffer.validEnd*1000.0)).format('LL');
		// }
		
		var image = new App.Model.WOImage({
			id: anOffer.image,
         	placeholder: '/assets/images/ui/default_placeholders.png',
       		defaultImage: '/assets/images/ui/default_offerreward.png',
		});
		image.initialize();
		image.fetch();
		image.getView({
			style: self.STYLE.view.imageView,
    	    activityIndicator	: { show: true },
		});
		
		self.UI.pages[page].offerImageView.image = image.getFilepath();
		anOffer.showName ? self.UI.pages[page].lbl_offerName.text = anOffer.name : self.UI.pages[page].lbl_offerName.text='';
		self.UI.pages[page].lbl_validDate.text = String.format(App.Helper.L('LABEL_VALIEDBETWEEN'), startDate, expiryDate);
		self.UI.pages[page].lbl_brandName.text = anOffer.brandName;
		self.UI.pages[page].lbl_desc.text = anOffer.desc;
		// self.UI.pages[page].lbl_tcTitle.text = 'Terms & Conditions';
		// self.UI.pages[page].offerTandC.html = anOffer.tc || '';
		
		self._doRefreshStatusContainer(page, anOffer);
		self._doRefreshRedeemButton(page, anOffer);
		self._doRefreshUnlockButton(page, anOffer);
	},
	
	_doRefreshUnlockButton : function(page, anOffer) {
		var self = this;

		if(anOffer.isLocked && anOffer.status != anOffer.STATUS.expiry && anOffer.status != anOffer.STATUS.fullyRedeemed && anOffer.status != anOffer.STATUS.unstart) {
			self.UI.pages[page].unlockBtn.disable = false;
			self.UI.pages[page].unlockBtn.visible = true;
			self.UI.pages[page].unlockBtn.borderColor = self.STYLE.btn.unlock.borderColor;
		}else{
			self.UI.pages[page].unlockBtn.disable = true;
			self.UI.pages[page].unlockBtn.visible = false;
			self.UI.pages[page].unlockBtn.borderColor = 'transparent';
		}
	},

	
	_doRefreshStatusContainer : function(page, anOffer) {
		var self = this;

		// status		show on the top
		var _statusContainer	= self.UI.pages[page].offerStatusContainer;
		var _statusBox	= 		self.UI.pages[page].offerStatusBox;
		var _statusLabel	= self.UI.pages[page].lbl_offerStatus;

		_statusContainer.visible	= false;
		_statusLabel.text		= '';
		
///		_statusDesc.startLayout();
		switch (anOffer.status) {
			case anOffer.STATUS.valid :
				_refreshValidStatus();
				break;
			case anOffer.STATUS.redeemed :
				_refreshRedeemedStatus();
				break;
			case anOffer.STATUS.unstart :
				_refreshUnstartStatus();
				break;
			case anOffer.STATUS.expiry :
				_refreshExpiryStatus();
				break;
			case anOffer.STATUS.fullyRedeemed :
				_refreshFullyRedeemedStatus();
				break;
		}
///		_statusDesc.finishLayout();

		//--------------  Private Methods  ----------------
		function _refreshValidStatus(){	
			_statusContainer.visible	= false;
			_statusLabel.text		= '';
		}
		function _refreshRedeemedStatus(){
			_statusContainer.visible	= true;
			_statusBox.backgroundColor = '#000000';
			_statusBox.borderColor =  '#5a5a5a';
			_statusLabel.text		= App.Helper.L('LABEL_OFFER_REDEEMED');
		}
		function _refreshUnstartStatus(){
			_statusContainer.visible	= false;
		}
		function _refreshExpiryStatus(){
			_statusContainer.visible	= true;
			_statusBox.backgroundColor = '#DD0000';
			_statusBox.borderColor = '#ff6e6e';
			_statusLabel.text		= App.Helper.L('LABEL_OFFER_EXPIRED');
		}
		function _refreshFullyRedeemedStatus(){
			_statusContainer.visible	= true;
			_statusBox.backgroundColor = '#DD0000';
			_statusBox.borderColor = '#ff6e6e';
			_statusLabel.text		= App.Helper.L('LABEL_OFFER_FULLYREDEEMED');
		}
	},
	
	_doRefreshRedeemButton : function(page, anOffer) {
		var self = this;

		if(!anOffer.showRdmBtn) return;

		var _button = self.UI.pages[page].redeemBtn;
		var _label = self.UI.pages[page].redeemBtnLabel;
		var _subLabel = self.UI.pages[page].redeemBtnSubLabel;
		var _statusDesc = self.UI.pages[page].statusDesc;
		// self.UI.pages[page].redeemBtnLabel.text = '';
		_button.touchEnabled	= false;
		_button.visible			= false;
		_button.borderColor		= 'transparent';
		_subLabel.text			= '';

		_statusDesc.backgroundColor = 'transparent';
		_statusDesc.borderColor	= 'transparent';

///		_statusDesc.startLayout();
		switch (anOffer.status) {
			case anOffer.STATUS.valid :
				_refreshValidStatus();
				break;
			case anOffer.STATUS.redeemed :
				_refreshRedeemedStatus();
				break;
			case anOffer.STATUS.unstart :
				_refreshUnstartStatus();
				break;
			case anOffer.STATUS.expiry :
				_refreshExpiryStatus();
				break;
			case anOffer.STATUS.fullyRedeemed :
				_refreshFullyRedeemedStatus();
				break;
		}
///		_statusDesc.finishLayout();

		//--------------  Private Methods  ----------------
		function _refreshValidStatus(){	
			_statusDesc.layout = 'horizontal';
			_statusDesc.width = Ti.UI.SIZE;
			_statusDesc.backgroundColor = 'transparent';
			_statusDesc.borderColor =  'transparent';
// 	
			_label.left				= null;
			_label.text				= App.Helper.L('BUTTON_REDEEM');
			_button.touchEnabled	= true;
			_button.visible			= true;
			_button.borderColor		= self.STYLE.btn.redeem.borderColor;
			if(anOffer.canRedeemTimes > 1) {
				_subLabel.right				=  null;
				_subLabel.left				= '8dp';
				_subLabel.text = String.format(App.Helper.L('BUTTON_TIMESLEFT'), anOffer.canRedeemTimes);
			} else if(-1 == anOffer.canRedeemTimes) {
				//TODO [ZJ]
			}
		}
		function _refreshRedeemedStatus(){				
			_statusDesc.setLayout('composite');
			_statusDesc.width			= '100%';
			_statusDesc.backgroundColor = '#53000000';
			_statusDesc.borderColor		=  '#DD4D4D4D';
			_subLabel.color		= '#E0FFFFFF';
			_subLabel.setLeft(null);
			_subLabel.setRight('10dp');
		
			if(anOffer.canRedeemTimes == 0) {
				_button.visible			= false;
				_button.borderColor		= 'transparent';
				_label.left					= '10dp';
			}

			_label.text = App.Helper.L('LABEL_OFFER_REDEEMED');

			if(anOffer.redeemInfo.length > 0) {
				var redeemInfo = anOffer.redeemInfo[anOffer.redeemInfo.length-1];
				var redeemDate = App.Helper.humaneDate(new Date(Number(redeemInfo.when)*1000));
				_subLabel.text		= redeemDate;
			}
		}
		function _refreshUnstartStatus(){
			var startDate	= App.Helper.humaneDate(new Date(Number(anOffer.validBegin*1000)), 366);
			
			_statusDesc.backgroundColor = '#53000000';
			_statusDesc.borderColor = '#DD4D4D4D';
			_label.color		= '#B900FF00';
			_subLabel.color		= '#E900FF00';
			_label.text		= App.Helper.L('LABEL_OFFER_STARTING');
			_subLabel.text	=  startDate;
		}
		function _refreshExpiryStatus(){
			var expiryDate	= App.Helper.humaneDate(new Date(Number(anOffer.validEnd*1000)));
			
			_statusDesc.backgroundColor = '#53000000';
			_statusDesc.borderColor = '#DD4D4D4D';
			_label.color		= '#D0FFFFFF';
			_subLabel.color		= '#D0FFFFFF';
			_label.text		= App.Helper.L('LABEL_OFFER_EXPIRED');
			_subLabel.text	= expiryDate;

		}
		function _refreshFullyRedeemedStatus(){
			_statusDesc.backgroundColor = '#53000000';
			_statusDesc.borderColor = '#DD4D4D4D';
			_label.left		=  null;
			_label.color		= '#E13030';
			_label.text		= App.Helper.L('LABEL_OFFER_FULLYREDEEMED');
		}
	},


});

module.exports = OffersWindow;
/**
 * End of file: OffersWindow.js
 */