/**
 * RedeemWindow
 */
Ti.include('/globals.js');

var RedeemWindow = App.Class(App.View.WOWindow, {
	className : 'RedeemWindow',
	stylePath : 'CouponRedeemStyle',

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

		self.detailViews = [];
		self.offerViews = [];
		self.WINDOW.title = App.Helper.L('TITLE_REDEEMOFFER');
	},
	
	draw : function(param){
		var self = this;
		self.base(param);
		
		self.inst 	= param.offer;
		
		var data 		= JSON.parse(self.inst.get('data'));
		var master 		= self.inst.master;
		var masterData 	= JSON.parse(master.get('data'));
		
		
		var scrollableBg = Ti.UI.createView(self.STYLE.scrollableBg);
		
		var brand 	= masterData.brand;
		var name 	= self.inst.master.get('name');
		var desc 	= self.inst.master.get('desc');
		
		var canvas = Ti.UI.createView(self.STYLE.view.canvas);
	
		var couponBrand = Ti.UI.createLabel(self.STYLE.obj_brand);
		couponBrand.text = brand;
		
		var couponName = Ti.UI.createLabel(self.STYLE.obj_name);
		couponName.text = name;
	
		var couponDesc = Ti.UI.createLabel(self.STYLE.obj_desc);
		couponDesc.text = desc;
		
		canvas.add(couponBrand);
		canvas.add(couponName);
		
		Ti.API.info(data);

		var couponCodeFrame = Ti.UI.createView(self.STYLE.view.couponCodeFrame);

		var codeLabel = Ti.UI.createLabel(self.STYLE.label.codeLabel);
		codeLabel.text = data.rdp_code;
		
		var barcodeType = Number(masterData.barcd_type);

			// qrcode

		if(data.barcd_val && barcodeType!=-1){
			
			if (App.Config.IS_ANDROID) {
//				var barcodeModule = require('com.bsl.lbarcode');
				var barcodeModule = require('com.bsl.zxbarcode');
			} else {
				var barcodeModule = require('com.test');			
			}

				
			if(data.rdp_code){
				var codeParam = self.STYLE.view.couponCode_bar;
			}else {
				var codeParam = self.STYLE.view.couponCode_QR;
				
			}
			codeParam.ctype  = barcodeType;
			codeParam.code   = data.barcd_val;
			
			self.viewBarcode = barcodeModule.createView(codeParam);
			couponCodeFrame.add(self.viewBarcode);
			codeLabel.bottom=6;
			codeLabel.font = {fontFamily:"Courier New", fontSize:48,};
			codeLabel.height = 52;
		}
		
		Ti.API.info(codeParam);


		canvas.add(couponDesc);

		couponCodeFrame.add(codeLabel);
	
		scrollableBg.add(canvas);
		self.VIEW.add(scrollableBg);	
		
	}

});

module.exports = RedeemWindow;

//---  End of file: RedeemWindow.js
