/**
 * RewardDetailWindow
 */
Ti.include('/globals.js');

var RewardDetailWindow = App.Class(App.View.WOWindow, {
	className : 'RewardDetailWindow',
	stylePath : 'OfferStyle',

	EVENT		: {
		//--- Handles these events:
		//--- Produces these events:
		close		: 'RewardDetailWindow.close',
		clickStamp	: 'RewardDetailWindow.clickStamp',
    },

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.levelStampViews = {};
		
		self.lazyRender = true;
		
		self.currentPage = 0;
		
 	// --- DATA Package from Controller ---
		self.DATA.cardID;
		self.DATA.aRewardset;

		self.WINDOW.hideTabBar = true;
		self.WINDOW.title = self.DATA.aRewardset.name;
	},
	
	// preDraw : function(param) {
		// var self = this;
		// self.base(param);
// 		
		// if(1) {
			// var scanBtn = Ti.UI.createButton({
				// systemButton: Ti.UI.iPhone.SystemButton.PLAIN,
				// image	: '/assets/images/buttons/scan.png',
				// width : '30dp', height : '30dp',
			// });
			// self.VIEW.setRightNavButton(scanBtn);
			// scanBtn.addEventListener('click', function(evt){
				// $.perkMgr.scan({
					// cardID : self.DATA.cardID,
				// });
			// });
		// }
	// },
	
	draw : function(param) {
		var self = this;
		
		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		self.VIEW.add(titlebarShadowContainer);

		self.canvas = self._addMainView(self.VIEW);
		self.levelScrollableView = self._addLevelScrollableView(self.canvas);
		// self.stampScrollableView = self._addStampScrollableView(self.canvas);
		self.currentLevelStampView = self._addLevelStampViews(self.canvas);
		
		self.levelScrollableView.addEventListener('scrollEnd', function(evt){
			self.currentLevelStampView.remove(self.levelStampViews[self.currentPage]);
			self.currentPage = evt.currentPage;
			self.currentLevelStampView.add(self.levelStampViews[self.currentPage]);
			
			// self.canvas.updateLayout({
				// contentHeight:  (parseInt(self.currentLevelStampView.height) + 210)+'dp',
			// });
		});
		// levelScrollableView.fireEvent('scrollEnd', {currentPage:0});
// 		
		// self.VIEW.addEventListener('focus', function(){
			// mainView.updateLayout({
				// contentHeight: (parseInt(stampScrollableView.views[0].height)+ 210)+'dp',
			// });
		// });
	},
			
	_addMainView : function(myWindow) {
		var self = this;
		
		var view = Ti.UI.createScrollView(self.STYLE.view.scrollableBg);
		myWindow.add(view);
		return view;
	},
	
	_addLevelScrollableView : function(theView) {
		var self = this;
		
		var views = [];
		for (var i = 0; i < self.DATA.aRewardset.level.length; i++) {
			var alevel = self.DATA.aRewardset.level[i];
			views.push(self._getLevelView(alevel));
		}
		var view = Ti.UI.createScrollableView(self.STYLE.view.scrollableViewImage);

		if(self.DATA.aRewardset.level.length==1){
			view.showPagingControl = false;
		};
		
		view.views = views;
		
		if(theView) theView.add(view);
		return view;
	},
	
	// _addStampScrollableView : function(theView) {
		// var self = this;
// 			
		// var views = [];
		// for (var i = 0; i < self.DATA.aRewardset.level.length; i++) {
			// var aView = self._getLevelStampView(i);
			// views.push(aView);
		// }
		// var view = Ti.UI.createScrollableView(self.STYLE.view.scrollableViewDesc);
// 
		// view.views = views;
// 		
		// if(theView) theView.add(view);
		// return view;
	// },
	
	_addLevelStampViews : function(theView) {
		var self = this;
		
		for (var i = 0; i < self.DATA.aRewardset.level.length; i++) self.levelStampViews[i] = self._getLevelStampView(i);

		var view = Ti.UI.createView(self.STYLE.view.obj_DetailsFrame);   
		var line = Ti.UI.createView(self.STYLE.line);
		view.add(line);

		view.add(self.levelStampViews[0]);
		
		if(theView) theView.add(view);
		return view;
	},

	_getLevelStampView : function(levelID) {
		var self = this;
				
		var view = Ti.UI.createView(self.STYLE.view.obj_Details);

		// daynamic part for every stamp
		var levelData = self.DATA.aRewardset.level[levelID];
		var levelDeep = self.DATA.aRewardset.level.length;
		var levelNo = levelID + 1;

		// Rewards Tips
		var view_rewardTips = Ti.UI.createView(self.STYLE.view.obj_tips);
		view.add(view_rewardTips);
	
		// stampDetailView: 1. levelNotice
		var lbl_levelInfo = Ti.UI.createLabel(self.STYLE.label.levelInfo);
		lbl_levelInfo.text =  String.format(App.Helper.L('LABEL_LEVELOFLEVELS'), levelNo, levelDeep);
		if (levelDeep > 1) {
			view_rewardTips.add(lbl_levelInfo);
		}

		//Validity
		if(levelData.validBegin && levelData.validEnd) {
			var lbl_validDate = Ti.UI.createLabel(self.STYLE.label.obj_validDate);
			var startDate = App.Helper.humaneDate(new Date(Number(levelData.validBegin)*1000), -1);
			var expiryDate = App.Helper.humaneDate(new Date(Number(levelData.validEnd)*1000), -1);
			lbl_validDate.text = String.format(App.Helper.L('LABEL_VALIEDBETWEEN'), startDate, expiryDate);
			view_rewardTips.add(lbl_validDate);
		}
		
		// Rewards Description
		var lbl_desc = Ti.UI.createLabel(self.STYLE.label.obj_desc);
		lbl_desc.text = levelData.desc;
		view.add(lbl_desc);
		// stampDetailView: 2. Stamps
		var levelSize = levelData.stampSize || 'M';
		var levelsizeReal = ((levelSize == 'XL') ? 120 : ((levelSize == 'L') ? 90 : ((levelSize == 'M') ? 72 : ((levelSize == 'S') ? 56 : 72))));

		Ti.API.info('image size = '+levelsizeReal);
		var badgeStampViewW = 300;
		// only accept 3 size: 120, 90, 72, 56
		var stampImageW = levelsizeReal;
		var stampImageH = levelsizeReal;
		var colNo = 0;
		var marginTop = 0;
		
		switch(stampImageW) {
			case 56:
				colNo = 5;
				marginTop = 2;
				break;
			case 72:
				colNo = 4;
				marginTop = 3;
				break;
			case 90:
				colNo = 3;
				marginTop = 10;
				break;
			case 120:
				colNo = 2;
				marginTop = 15;
				break;
		};
		
		var rowNo = Math.ceil(levelData.stamp.length / colNo);
		var stampNo = levelData.stamp.length;

		Ti.API.info('rowNo = '+rowNo);

		var badgeStampView = Ti.UI.createView({
			top: (20-marginTop)+'dp', bottom: '5dp',
			width: badgeStampViewW+'dp',
			height : (rowNo * (stampImageH + marginTop)+10)+'dp',
			layout: 'vertical',	
		});
		var horSpacing = (badgeStampViewW - colNo * stampImageW) / colNo;

		Ti.API.info('horSpacing = '+horSpacing);

		var currentCol = colNo;
		
		for(var r=1; r <= rowNo; r++){
				//last row horSpacing should be different
			if(r===rowNo){
				currentCol = stampNo - (rowNo-1)*colNo;
				if(currentCol===1) {
					horSpacing = (badgeStampViewW- stampImageW) / 2;
				}else{
					horSpacing = (badgeStampViewW- currentCol* stampImageW) / currentCol;
				}
			};
			var stampRow = Ti.UI.createView(self.STYLE.view.stampRow);
			stampRow.height = stampImageH+'dp';
			stampRow.top = marginTop+'dp';
			
			for(var i= 1; i <= currentCol; i++){
				var stampID = (r-1)*colNo+i-1;
				var stampData = levelData.stamp[stampID];
				var state = Number(stampData.stateID);
				var stampImage = stampData.image;
				var leftPos = (horSpacing / 2); 
			//first col stamp stamp_left = leftPos
				if( (stampID+1)%currentCol ===1 ){
					var stamp_left = leftPos;
				}else{
					var stamp_left = horSpacing;
				}
				
				var stampImageView = self._getStampView({
					width : stampImageW+'dp',
					height : stampImageH+'dp',
					left : stamp_left+'dp',
					stamp : stampData,
					touchEnabled : (stampData.drill) ? true : false,
					img : stampImage,
				});

				if(App.Config.IS_ANDROID) {
					if (stampData.drill) { // some how touch enabled not working. hence need this if.
						stampImageView.addEventListener ('click', (function(id,stamp){
							return function(evt) {
								if (stamp)
								self._eventProxy.fireEvent(self._eventProxy.EVENT.clickStamp, {
									cardID		: id,
									aStamp		: stamp,
								});
							}
						}) (self.DATA.cardID,stampData)  ) ;
					}
				} else { // iOS.
					stampImageView.addEventListener('click', _handlerClosure(self.DATA.cardID, stampData));
					function _handlerClosure(_cardID, _stampData){
						var closure = function(evt){
							self._eventProxy.fireEvent(self._eventProxy.EVENT.clickStamp, {
								cardID		: _cardID,
								aStamp		: _stampData,
							});
						};
						return closure;
					}
				}
				/*
				_handlerClosure(self.DATA.cardID, stampData));
				function _handlerClosure(_cardID, _stampData){
					var closure = function(evt){
						self._eventProxy.fireEvent(self._eventProxy.EVENT.clickStamp, {
							cardID		: _cardID,
							aStamp		: _stampData,
						});
					};
					return closure;
				}
				*/

				stampRow.add(stampImageView);
			}
			badgeStampView.add(stampRow);
		};
		view.add(badgeStampView);
		
		// view.updateLayout({
			// height: (140 + parseInt(badgeStampView.height) + parseInt(badgeStampView.top) + parseInt(badgeStampView.bottom))+'dp',
		// });
		// self.canvas.updateLayout({
			// contentHeight: (140 + parseInt(badgeStampView.height) + parseInt(badgeStampView.top) + parseInt(badgeStampView.bottom)+ 210)+'dp',
		// });		
		// Rewards Description					
		if(levelData.tc.slice(0, 20).indexOf('<!DOCTYPE') > -1) { // ok, webview

			var rewardTandC = Ti.UI.createWebView(self.STYLE.webView.tandc);
			rewardTandC.html = levelData.tc;
		} else {
			var rewardTandC = Ti.UI.createLabel(self.STYLE.label.tandc);
			rewardTandC.text	= levelData.tc;
		}

		if(rewardTandC)  view.add(rewardTandC);
		return view;
	},
	
	_getLevelView : function(level) {
		var self = this;
		var view = Ti.UI.createView(self.STYLE.view.ImageFrame);
		App.Helper.requireModel('WOImage');
		var image = new App.Model.WOImage({
		  	id:  level.image, 
         	// placeholder: '/assets/images/ui/default_placeholders.png',
         	placeholder: '/assets/images/ui/default_brand.png',
       		defaultImage: '/assets/images/ui/default_brand.png',
		});
		image.initialize();
        image.fetch();
        
        var img_reward  = image.getView({
        	style:	self.STYLE.view.imageView,
    	    activityIndicator	: { show: true },	
    	});
		view.add(img_reward);
		if(level.isFinished || level.isChecking || level.isExpired) {
			var view_rewardStatusContainer = Ti.UI.createView(self.STYLE.view.obj_statusContainer);

			var view_rewardStatus = Ti.UI.createView(self.STYLE.view.obj_status);
			var lbl_rewardStatus = Ti.UI.createLabel(self.STYLE.label.obj_status);

			view.add(view_rewardStatusContainer);
			view_rewardStatusContainer.add(view_rewardStatus);
			view_rewardStatus.add(lbl_rewardStatus);
			
			if(level.isFinished){
				view_rewardStatus.backgroundColor =  '#000000';
				view_rewardStatus.borderColor =  '#5a5a5a';
				lbl_rewardStatus.text = App.Helper.L('LABEL_LEVELSTATUS_COMPLETED');
			} else if (level.isChecking){
				view_rewardStatus.backgroundColor =  '#fd6b00';
				view_rewardStatus.borderColor =  '#ff9446';
				lbl_rewardStatus.text = App.Helper.L('LABEL_REWARDSTATUS_CHECKING');
			} else if (level.isExpired){
				view_rewardStatus.backgroundColor =  '#DD0000';
				view_rewardStatus.borderColor =  '#ff6e6e';
				lbl_rewardStatus.text = App.Helper.L('LABEL_LEVELSTATUS_EXPIRED');
			}

			
		};

		var imgShadow = Ti.UI.createView(self.STYLE.scrollImgShadow);
		view.add(imgShadow);
		
		var levelInfoPrize = Ti.UI.createLabel(self.STYLE.label.obj_name);
		levelInfoPrize.text = level.showName ? level.name : '';
		
		if(self.DATA.aRewardset.level.length==1){
			levelInfoPrize.setBottom('5dp');
		};
		
		view.add(levelInfoPrize);

		return view;
	},
	
	_getStampView : function(param) {
		var self = this;

		App.Helper.requireModel('WOImage');
		var view = Ti.UI.createView(param);

		var image = new App.Model.WOImage({
		  	id: param.img,
         	placeholder	: '/assets/images/ui/default_logo.png',
       		defaultImage: '/assets/images/ui/default_logo.png',
		});
		image.initialize();

        image.fetch();
 		view.add(image.getView());
		
		return view;
	}
});

module.exports = RewardDetailWindow;

//---  End of file: RewardDetailWindow.js
