/**
 * RewardsListView
 */
Ti.include('/globals.js');

var RewardsListView = App.Class(App.View.WOList, {
	className 	: 'RewardsListView',
	stylePath 	: 'RewardsListStyle',
	
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.ITEM_KEY		= 'id';
		
		self.ALTERNATE		= false;
	},
	
	/**
	 * Row render
	 * Should be implement by sub-class
	 */
	renderRow : function(aRewardset, index){
		var self = this;
 
		var row = Ti.UI.createTableViewRow(self.STYLE.tableRow);
		
		row.id = aRewardset.id;
		
		// if(aRewardset.isFinished){
			// row.header = 'COMPLETED'
		// } else {
			// row.header = 'CURRENT'
		// }
 
 		var view_rewardBrand =  Ti.UI.createView(self.STYLE.view.rewardBrand);

      // var img_rewardBrand = Ti.UI.createView(self.STYLE.view.rewardBrandImg);
		App.Helper.requireModel('WOImage');
		var image = new App.Model.WOImage({
		  	id: aRewardset.brandLogo,
         	placeholder: '/assets/images/ui/default_placeholders.png',
       		defaultImage: '/assets/images/ui/default_logo.png',
		});
		image.initialize();
        image.fetch();
        var img_rewardBrand  = image.getView({
        	style:	self.STYLE.view.rewardBrandImg,
    	    activityIndicator	: { show: true },	
    	});
        view_rewardBrand.add(img_rewardBrand);
        row.add(view_rewardBrand);


		var view_rewardFrame =  Ti.UI.createView(self.STYLE.view.rewardFrame);
		
		
       var lbl_rewardName = Ti.UI.createLabel(self.STYLE.label.rewardName);
       lbl_rewardName.text = aRewardset.name;
       view_rewardFrame.add(lbl_rewardName);
       
      	//---  Progress Status description - ----
		var lbl_actionDesc = Ti.UI.createLabel(self.STYLE.label.actionDesc);

		var statusStr = '';
		var outstandingStamps = aRewardset.DATA.totalRequiredStamps - aRewardset.DATA.collectedStamps;

		var view_actionDesc =  Ti.UI.createView(self.STYLE.view.actionDesc);
		
		if(aRewardset.DATA.isFinished){
			statusStr = App.Helper.L('LABEL_REWARDSTATUS_COMPLETED');
			
			view_actionDesc.backgroundColor = '#000000';
			lbl_actionDesc.color = '#BFFFFFFF';
			lbl_actionDesc.left='5dp';
			lbl_actionDesc.right='5dp';
			
		} else if(aRewardset.DATA.isChecking){
			statusStr = App.Helper.L('LABEL_REWARDSTATUS_CHECKING');
			
			view_actionDesc.backgroundColor = '#fd6b00';
			lbl_actionDesc.color = '#FFFFFF';
			lbl_actionDesc.left='5dp';
			lbl_actionDesc.right='5dp';
					
		} else if(aRewardset.isExpired){
			statusStr = App.Helper.L('LABEL_REWARDSTATUS_EXPIRED');
			
			view_actionDesc.backgroundColor = '#DD0000';
			lbl_actionDesc.color = '#FFFFFF';
			lbl_actionDesc.left='5dp';
			lbl_actionDesc.right='5dp';
					
		} else if(aRewardset.DATA.collectedStamps==0){
			statusStr = (outstandingStamps==1) ? String.format(App.Helper.L('LABEL_REWARDSTATUS_COLLECTSTAMP'), 1) : String.format(App.Helper.L('LABEL_REWARDSTATUS_COLLECTSTAMPS'), outstandingStamps);
		} else if(outstandingStamps <= 2){
			statusStr = (outstandingStamps==1) ? String.format(App.Helper.L('LABEL_REWARDSTATUS_COLLECTMORESTAMP'), 1) : String.format(App.Helper.L('LABEL_REWARDSTATUS_COLLECTMORESTAMPS'), outstandingStamps);
		} else {
	   		statusStr = (aRewardset.DATA.collectedStamps==1) ? String.format(App.Helper.L('LABEL_REWARDSTATUS_COLLECTEDSTAMP'), 1) : String.format(App.Helper.L('LABEL_REWARDSTATUS_COLLECTEDSTAMPS'), aRewardset.DATA.collectedStamps);
		}
		lbl_actionDesc.text = statusStr;
         view_actionDesc.add(lbl_actionDesc);

        view_rewardFrame.add(view_actionDesc);		
		row.add(view_rewardFrame);

    
		//---  Set number  --------------------
		if(aRewardset.DATA.setNo){
 		   	var view_rewardBaseStatus = Ti.UI.createView(self.STYLE.view.rewardBaseStatus);			
	        var lbl_rewardSetNo = Ti.UI.createLabel(self.STYLE.label.rewardSetNo);
	   	 	lbl_rewardSetNo.text = String.format(App.Helper.L('LABEL_REWARD_SETNUMBER'), aRewardset.DATA.setNo);
         	view_rewardBaseStatus.add(lbl_rewardSetNo);
 		    row.add(view_rewardBaseStatus);
		}
 
		// var view_stamps = Ti.UI.createView(self.STYLE.view.stamps);
		// var view_stampChecked = Ti.UI.createView(self.STYLE.view.stampChecked);
 		// var view_stampUnChecked = Ti.UI.createView(self.STYLE.view.stampUnChecked);
       // view_stamps.add(view_stampChecked);
       // view_stamps.add(view_stampUnChecked);
       
              
      //  var expiryLabel = Ti.UI.createLabel({
     //   	text:'expires in 30 days', color:'#5D8FF8', textAlign:'right', touchEnabled:false,
	//		font:{fontFamily:"Melbourne-Bold", fontSize:13}, width:100, height:13, right:10, bottom:10
    //    });
   //     row.add(expiryLabel);
        
        row.backgroundColor = (index%2==0)?'#16000000':'transparent';

		return row;
	},
	
});
module.exports = RewardsListView;

//---  End of file: RewardsListView.js
