/**
 * RewardsListWindow
 */
Ti.include('/globals.js');

var RewardsListWindow = App.Class(App.View.WOWindow, {
	className 	: 'RewardsListWindow',
	stylePath 	: 'RewardsListStyle',
	
	EVENT : {
		//--- Handles these events:
		//--- Produces these events:		
		viewRewardset : 'RewardsListWindow.viewRewardset',
	},
	
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		//--- DATA Package From Controller ---
		self.DATA.cardID;
		self.DATA.rewardsets;
		self.WINDOW.hideTabBar = true;
	    self.WINDOW.title	= App.Helper.L('TITLE_REWARDS');

	    // self.WINDOW.type	= App.Const.WINDOW.type.navGroup;
	},
	
	draw : function(param) {
		var self = this;
		
		self.goNextpage = false;
		
		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		self.VIEW.add(titlebarShadowContainer);
		
		var viewParam = {
			eventProxy	: self.getEventProxy(),
			navGroupObj	: self.navGroupObj,
		};
		self.listSmallObj 	= App.Helper.loadView('reward/RewardsListView', viewParam);
		// var proxy = self.listSmallObj.getEventProxy();
		self.listSmallView  = self.listSmallObj.render();
		self.listSmallObj.setData(self.DATA.rewardsets);
		
		self.VIEW.add(self.listSmallView);

		self.listSmallView.addEventListener('click', function(e){
			self.goNextpage = true;
		});
				
		self.VIEW.addEventListener('blur', function(e){
			if(!self.goNextpage && self.VIEW && !App.Config.IS_ANDROID){
				titlebarShadowContainer.hide();
				self.VIEW.backgroundImage = null; 
				self.VIEW.backgroundColor = 'transparent';
			}
			self.goNextpage = false;
		});
	
	},

	close : function(param){
		var self = this;
		
		$.app.doNotDisturb(false);
		self.base(param);
	},
	
	dispose : function(){
		var self = this;

		self.listSmallObj.dispose();
		self.base();
	},
});

module.exports = RewardsListWindow;

/**
 * End of file: RewardsListWindow.js
 */