/**
 * StampDetailWindow
 */
Ti.include('/globals.js');

var StampDetailWindow = App.Class(App.View.WOWindow, {
	className : 'StampDetailWindow',
	stylePath : 'OfferStyle',
	
	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);
		
		self.levelViews = [];
		self.stampViews = [];
		self.levelData	= null;
		
		self.WINDOW.hideTabBar = true;		
		self.WINDOW.title = self.DATA.aStamp.name;
		
 	// --- DATA Package from Controller ---
 		self.DATA.cardID;
		self.DATA.aStamp;
		App.Helper.requireModel('WOImage');
	},
	
	draw : function(param){
		var self = this;
		
		
		var titlebarShadowContainer = Ti.UI.createView(self.STYLE.titlebarShadowContainer);
		var titlebarShadow = Ti.UI.createView(self.STYLE.titlebarShadow);
		titlebarShadowContainer.add(titlebarShadow);
		
		self.VIEW.add(titlebarShadowContainer);
			
		var view_scrollableBg = Ti.UI.createScrollView(self.STYLE.view.scrollableBg);
		var canvas = Ti.UI.createView(self.STYLE.view.canvas);
		
		var image = new App.Model.WOImage({
			id: self.DATA.aStamp.image,
         	placeholder: '/assets/images/ui/default_logo.png',
       		defaultImage: '/assets/images/ui/default_logo.png',
		});
		image.initialize();
		image.fetch();
		
		var stampImageView = image.getView({
			style: self.STYLE.view.imageViewStamp,
		});
		
		var stampImageFrame = Ti.UI.createView(self.STYLE.view.stampImageFrame);
		stampImageFrame.add(stampImageView);
		
		if(self.DATA.aStamp.desc.slice(0, 20).indexOf('<!DOCTYPE') > -1) { // ok, webview
			var stampDesc = self.getWebView({
				html	: self.DATA.aStamp.desc,
				style	: self.STYLE.webView.stampDesc,
			});
		} else { // plaintext
			var stampDesc = Ti.UI.createLabel(self.STYLE.label.stampDesc);
			stampDesc.text = self.DATA.aStamp.desc;
		}

		canvas.add(stampImageFrame);
		canvas.add(stampDesc);
		view_scrollableBg.add(canvas);	

		self.VIEW.add(view_scrollableBg);
	
	//	self.VIEW.add(footerView);
	},
	
	dispose:function(){
		var self = this;
	},

});
module.exports = StampDetailWindow;

/**
 * End of file: StampDetail.js
 */