/**
 * ContactSelector
 * @copyright WaveO
 */
Ti.include('/globals.js');
Ti.include('/waveo/core/WOAndroidUtils.js');	

var ContactSelectorAndroid = App.Class(App.View.WOWindow, {
	className 	: 'ContactSelectorAndroid',
	stylePath 	: 'ContactSelectorStyle',

	EVENT		: {
		//--- Handles these events:
		clearSelection	: 'ContactSelectorAndroid.clearSelection',
		//--- Produces these events:
    },

	//---  Constructor  ---------------
	initialize : function(param){
		var self = this;
		self.base(param);

		self.WINDOW.title	= self.DATA.group.name;
		/* CTK - do not use lazy renderer. Complicates things.
		self.lazyRender		= self.DATA.lazyRender;
		*/
		self.SHARED			= param.SHARED;		// shared memory space with other windows

		self.contacts       = param.DATA.contacts;

		self.sortName   = Ti.Contacts.CONTACTS_SORT_ORDER == 0 ? 'firstName': 'lastName';
		self.unsortName = Ti.Contacts.CONTACTS_SORT_ORDER == 0 ? 'lastName' : 'firstName';
		
		self.rowListeners	= [];				// list of row event listeners
		
	},
	
	waitWindow : null,
	startLoading : function(param) {
		Ti.API.info('CTK:SHARE --> StartLoading');
		this.waitWindow = AndroidStartWait(this.contactListView);
	},
	stopLoading : function(param) {
		Ti.API.info('CTK:SHARE --> StopLoading');
		AndroidStopWait(this.contactListView,this.waitWindow);
	},


	delayedRender : function () {
		var self = this;
//	    self.startLoading(); 
		self._renderList(self.DATA.group, self.contactListView);
//		self.stopLoading();			
	},

	// --------------------------------------------------------
	draw : function(param) {
		var self = this;

		Ti.API.info('CTK:SHARE ! --> StartLoading');
		
		var contactPageView = Ti.UI.createView({
			top: 0,
			height: '44dp',
			width:  '100%',
			backgroundColor: 'black',
			layout : 'horizontal',
		});


		function addVerticalPartitionAtLeft (location, parent) {			
			var partion = Ti.UI.createView ({
				left:  location,
				width: '1dp',
				top:   '2dp',
				height: '42dp',
				backgroundColor:  '#80808080',
			});
			parent.add(partion);
		}

		var contactPageHomeButton = Ti.UI.createLabel(self.STYLE.label.pageNavFirst);	
		contactPageView.add(contactPageHomeButton);
		addVerticalPartitionAtLeft ('0',contactPageView);

		var contactPageBackButton = Ti.UI.createLabel(self.STYLE.label.pageNavPrevious);	
		contactPageView.add(contactPageBackButton);
		addVerticalPartitionAtLeft ('0',contactPageView);


		self.contactPageNumber = Ti.UI.createLabel(self.STYLE.label.pageNo);
		contactPageView.add(self.contactPageNumber);
		addVerticalPartitionAtLeft ('0',contactPageView);

		var contactPageForwardButton = Ti.UI.createLabel(self.STYLE.label.pageNavNext);
		contactPageView.add(contactPageForwardButton);
		addVerticalPartitionAtLeft ('0',contactPageView);
		
		var contactPageEndButton = Ti.UI.createLabel(self.STYLE.label.pageNavLast);
		contactPageView.add(contactPageEndButton);

		self.VIEW.add(contactPageView);
		self.STYLE.tableView.contact.top = '44dp';

		self.contactListView = Ti.UI.createTableView(self.STYLE.tableView.contact);

		//--- Search Bar  ------------

		self._setupEventHandlers();

	    //--- Contact List  ----------
	    	    /*
	    self.startLoading(); 
		self._renderList(self.DATA.group, self.contactListView);
		self.stopLoading();	
			*/
//		setTimeout(function(){self.delayedRender()},0);
		
		Ti.API.info('CTK:SHARE ! --> StopLoading');

		self.VIEW.add(self.contactListView);
		
//	    $.contacts = self.DATA.group.sortedMembers(Ti.Contacts.CONTACTS_SORT_LAST_NAME /* 3 */) || {};
		$.contacts = self.contacts;
		self.contactIds = [];
		for (var n=0; n<self.contacts.length; n++) {
			self.contactIds.push(self.contacts[n]['id']);
//			Ti.API.info('CTKID:'+n+'-'+self.contactIds[n]);
		}
		self.totalContacts = $.contacts.length;
		self.contactsPerPage = 20;
		self.totalPages = Math.ceil(self.totalContacts/self.contactsPerPage);
		self.currentPage = 0;
		
	    self._eventProxy.fireEvent(self._eventProxy.EVENT.updateToolbar, {
	    	contactCount	: self.totalContacts,
	    });

		function setPageNumber (self) {
			var from = self.currentPage*self.contactsPerPage+1;
			var to = (self.currentPage==(self.totalPages-1))?self.totalContacts:
				(self.currentPage+1)*self.contactsPerPage;
			self.contactPageNumber.setText(from+'-'+to);
		}
		
		function setPageContent (self) {
			var rows = [];
			var contacts = $.contacts;
			var from = self.currentPage*self.contactsPerPage;
			var to = (self.currentPage==(self.totalPages-1))?self.totalContacts:
				(self.currentPage+1)*self.contactsPerPage;
			var astyle = {
				font:  self.STYLE.label.contactName.font,
				className : 'a_contact_row',
				top : '1dp',
				bottom : '1dp',
				height : '50dp',
				left  : '10dp',
				right : '10dp',
			};
	    	self.contactListView.setData([]);
	    	delete self.contactListView.data;
//	    	for (var i = self.contactListView.data.length-1; i >= 0; i--) {
//	    		self.contactListView.deleteRow(i);
//   		}
			for (var i=from; i<to; i++) {
				
//				var	acontact = contacts[i];
				var	acontact = Ti.Contacts.getPersonByID(self.contactIds[i]);
				
		    	var aname = acontact[self.sortName];
				if(!aname)	aname = acontact[self.unsortName];
				if(!aname)	aname = acontact['fullName'];

				astyle.title = aname;
	    		var arow = Ti.UI.createTableViewRow(
					astyle
	    		);
	    		
	    		arow.className = 'a_contact_row';
	    		arow.contactId = contacts[i]['id'];
	    		arow.name = aname;
	    		
	    		var key = arow.contactId + '';
	    		arow.mobile = '';
	    		
				var contactName = Ti.UI.createLabel(self.STYLE.label.contactName);
 				var	phoneLabel = Ti.UI.createLabel(self.STYLE.label.phoneLabel);
	 			var phoneNo = Ti.UI.createLabel(self.STYLE.label.phoneNo); 		
				var unCheckIcon = Ti.UI.createImageView(self.STYLE.img.unCheckIcon);
				var checkIcon = Ti.UI.createImageView(self.STYLE.img.checkIcon);
				unCheckIcon.setVisible('false');
				checkIcon.setVisible('false');
				
				arow.add(contactName);
				arow.add(phoneLabel);
				arow.add(phoneNo);
				arow.add(checkIcon);
				arow.add(unCheckIcon);

	    		arow.contactName = contactName;
	    		arow.phoneNo = phoneNo;
	    		arow.phoneLabel = phoneLabel;
	    		arow.unCheckIcon = unCheckIcon;
	    		arow.checkIcon = checkIcon;

	    		if (self.SHARED.contactSelected[key]) {
		    		if (self.SHARED.contactSelected[key].selected.value) {
		    			arow.mobile = self.SHARED.contactSelected[key].selected.value;	
		    		}
		    	}
	    		
				if (arow.mobile!='') {
					arow.setBackgroundColor('#EEEEEE');
					unCheckIcon.setVisible('false');
					checkIcon.setVisible('true');
		    		contactName.bottom = '20dp';
		    		contactName.text = 	arow.name;
					phoneLabel.text = App.Helper.L('ANDROID_CONTACT_SELECTOR_NUMBER');
					phoneNo.text = arow.mobile;
		    		
				} else {
					arow.setBackgroundColor('#FFFFFF');
					unCheckIcon.setVisible('true');
					checkIcon.setVisible('false');
					contactName.bottom = '13dp';
		    		contactName.text = 	arow.name;
					phoneLabel.text = "";
		    		phoneNo.text = 	"";
				}
				Ti.API.info('Row-'+i+':'+arow.name);
				self.contactListView.appendRow(arow);
	    		rows.push(arow);
			}
//	    	self.contactListView.setData(rows);
		}
		
		setPageContent(self);
		setPageNumber(self);

		contactPageHomeButton.addEventListener('touchstart',function(e){
			e.source.setColor('#FFFFFF');
		});
		contactPageHomeButton.addEventListener('touchend',function(e){
			e.source.setColor('#99DFDFDF');
		});
		contactPageHomeButton.addEventListener('click',function(e){
			if (self.currentPage!=0){
				self.currentPage=0;
				setPageNumber(self);
				setPageContent(self);
			}
		});
		
		contactPageForwardButton.addEventListener('touchstart',function(e){
			e.source.setColor('#FFFFFF');
		});
		contactPageForwardButton.addEventListener('touchend',function(e){
			e.source.setColor('#99DFDFDF');
		});
		contactPageForwardButton.addEventListener('click',function(e){
			if (self.currentPage<(self.totalPages-1)){
				self.currentPage++;
				setPageNumber(self);
				setPageContent(self);
			}
		});
		
		contactPageBackButton.addEventListener('touchstart',function(e){
			e.source.setColor('#FFFFFF');
		});
		contactPageBackButton.addEventListener('touchend',function(e){
			e.source.setColor('#99DFDFDF');
		});
		contactPageBackButton.addEventListener('click',function(e){
			if (self.currentPage>0){
				self.currentPage--;
				setPageNumber(self);
				setPageContent(self);
			}
		});
		
		contactPageEndButton.addEventListener('touchstart',function(e){
			e.source.setColor('#FFFFFF');
		});
		contactPageEndButton.addEventListener('touchend',function(e){
			e.source.setColor('#99DFDFDF');
		});
		contactPageEndButton.addEventListener('click',function(e){
			if (self.currentPage!=(self.totalPages-1)){
				self.currentPage=(self.totalPages-1);
				setPageNumber(self);
				setPageContent(self);
			}
		});
		
		if (App.Config.IS_ANDROID) {
			self.VIEW.addEventListener('close',function(e){
				self._eventProxy.fireEvent(self._eventProxy.EVENT.clearContactCount, {});
			});
		}
	},

	_onClearSelection : function (e) {
		var self = this;
		if (self.contactListView) {
			for (var iSection=0; iSection<self.contactListView.sectionCount; iSection++) {
				var aSection = self.contactListView.sections[iSection];
				for (var iRow=0; iRow<aSection.rowCount; iRow++) {
					var aRow = aSection.rows[iRow];
					if (aRow.mobile!='') {
						aRow.mobile='';
						self._updateRowUI(aRow);
					}
				}
			}
			self._eventProxy.fireEvent(self._eventProxy.EVENT.updateContactCount, {
				contactCount : self.totalContacts,
			});
		
		}
	},

	_setupEventHandlers : function(param){
		var self = this;

		//---  List View Events  --------------
		self.contactListView.addEventListener('click', function(evt){
			self.rowClickHandler(evt.row);
		});
		//---  Search Bar Events  --------------
		if(! App.Config.IS_ANDROID){
		    self.search.addEventListener('cancel', function(evt){
				self.search.searching = false;
				if (self.VIEW) 		self.VIEW.showNavBar();
		    });
		    self.search.addEventListener('focus', function(evt){
				self.search.searching = true;
				if (self.VIEW) 		self.VIEW.hideNavBar();
		    });
		    self.search.addEventListener('return', function(evt){
				if (self.VIEW)		self.VIEW.showNavBar();
		    });
	
		    self.search.addEventListener('blur', function(evt){
				if(self.search.searching == false)		return;
	
				if(!self.search.value || self.search.value == '')
					self.search.searching = false;
				if (self.VIEW) 		self.VIEW.showNavBar();
			});
		} else {
			self._eventProxy.addEventListener (self.EVENT.clearSelection, function(e){
				self._onClearSelection();
			});
		}
	},
	
	_renderList : function(group, contactListView){
	    var self = this;

	    var contacts = group.sortedMembers(Ti.Contacts.CONTACTS_SORT_LAST_NAME /* 3 */) || {};
	    var rows = [];
	    var sections = [];
	    
	    var acount = contacts.length;
	    acount = 150;
	    
	    if(contacts.length > 0){
			var astyle = {
				font:  self.STYLE.label.contactName.font,
				className : 'a_contact_row',
//				top : '1dp',
//				bottom : '1dp',
				height : '55dp',
				left  : '10dp',
				right : '10dp',
			};
			/*
			astyle.top = '2dp';
			astyle.bottom = '2dp';
			astyle.height = '55dp';
			astyle.left = '10dp';
			astyle.right = '10dp';
			*/
			
			var j0 = 100;
			var j1 = j0 + 25;
		    for (var j=j0; j<j1; j++) {

		    	var aname = contacts[j][self.sortName];
				if(!aname)	aname = contacts[j][self.unsortName];
				if(!aname)	aname = contacts[j]['fullName'];

				astyle.title = aname;
	    		var arow = Ti.UI.createTableViewRow(
					astyle
	    		);
	    		
	    		Ti.API.info('CTKSHARE:'+j);
	    		
	    		arow.className = 'a_contact_row';
	    		arow.contactId = contacts[j]['id'];
	    		arow.name = aname;
	    		
	    		var key = arow.contactId + '';
	    		arow.mobile = '';
	    		
	    		

				var contactName = Ti.UI.createLabel(self.STYLE.label.contactName);
 				var	phoneLabel = Ti.UI.createLabel(self.STYLE.label.phoneLabel);
	 			var phoneNo = Ti.UI.createLabel(self.STYLE.label.phoneNo); 		
				var unCheckIcon = Ti.UI.createImageView(self.STYLE.img.unCheckIcon);
				var checkIcon = Ti.UI.createImageView(self.STYLE.img.checkIcon);
				unCheckIcon.setVisible('false');
				checkIcon.setVisible('false');
				
				arow.add(contactName);
				arow.add(phoneLabel);
				arow.add(phoneNo);
				arow.add(checkIcon);
				arow.add(unCheckIcon);

	    		arow.contactName = contactName;
	    		arow.phoneNo = phoneNo;
	    		arow.phoneLabel = phoneLabel;
	    		arow.unCheckIcon = unCheckIcon;
	    		arow.checkIcon = checkIcon;

	    		if (self.SHARED.contactSelected[key]) {
		    		if (self.SHARED.contactSelected[key].selected.value) {
		    			arow.mobile = self.SHARED.contactSelected[key].selected.value;	
		    		}
		    	}
	    		
				if (arow.mobile!='') {
					arow.setBackgroundColor('#EEEEEE');
					unCheckIcon.setVisible('false');
					checkIcon.setVisible('true');
					contactName.bottom = '20dp';
		    		contactName.text = 	arow.name;
					phoneLabel.text = App.Helper.L('ANDROID_CONTACT_SELECTOR_NUMBER');
					phoneNo.text = arow.mobile;
		    		
				} else {
					arow.setBackgroundColor('#FFFFFF');
					unCheckIcon.setVisible('true');
					checkIcon.setVisible('false');
					contactName.bottom = '13dp';
		    		contactName.text = 	arow.name;
					phoneLabel.text = "";
		    		phoneNo.text = 	"";
				}
				
				
				
	    		rows.push(arow);
		    }
		}
		
	    self._eventProxy.fireEvent(self._eventProxy.EVENT.updateToolbar, {
	    	contactCount	: acount || 0,
	    });

	    contactListView.setData(rows);

	    //-------------  Private Methods  ---------------
	    function sortByKey(arr){
			// Setup Arrays
			var sortedKeys = new Array();
			var sortedObj = {};

			// Separate keys and sort them
			for(i in arr)
				sortedKeys.push(i);

			sortedKeys.sort();
			// Reconstruct sorted obj based on keys
			for (i in sortedKeys)
				sortedObj[sortedKeys[i]] = arr[sortedKeys[i]];
			return sortedObj;
		}
	},

	_renderRow : function(aContact){
		var self = this;

		var row = Ti.UI.createTableViewRow(self.STYLE.tableRow_Contact);
		row.contactId	= aContact['id'];
	    row.name		= aContact.fullName;
	    row.searchField	= aContact.fullName;
		//---  Contact Name  ---------------
		row.nameTxt1 = Ti.UI.createLabel(self.STYLE.label.contactName);
		row.nameTxt1.text = row.name;
		row.add(row.nameTxt1);
		//---  Check box  ---------------
		var unCheckIcon = Ti.UI.createImageView(self.STYLE.img.unCheckIcon);
		row.add(unCheckIcon);
		
		row.className = 'contact_row';

		return row;
	},

	_updateSelectedContact : function(aRow, isSelected){
		var self = this;
		if(isSelected){
			self.SHARED.selectedCount++;
	    }else{
			self.SHARED.selectedCount--;
	    }
	    Ti.API.info('CTK_>Select='+self.SHARED.selectedCount);
    	//---  Update Share button on Toolbar  ---
		self._eventProxy.fireEvent(self._eventProxy.EVENT.updateToolbar, {
			selectedCount	: self.SHARED.selectedCount,
		});
	},

	_updateRowUI : function (row) {
		var self = this;
		if (row.mobile!='') {
			row.setBackgroundColor('#EEEEEE');
			row.unCheckIcon.setVisible('false');
			row.checkIcon.setVisible('true');
		    row.contactName.bottom = '20dp';
			row.phoneLabel.text = App.Helper.L('ANDROID_CONTACT_SELECTOR_NUMBER');
			row.phoneNo.text = row.mobile;
		    row.contactName.text = 	row.name;
		    		
			self._updateSelectedContact(row,true);
		} else {
			row.setBackgroundColor('#FFFFFF');
			row.unCheckIcon.setVisible('true');
			row.checkIcon.setVisible('false');
		    row.contactName.bottom = '13dp';
		    row.contactName.text = 	row.name;
			row.phoneLabel.text = "";
			row.phoneNo.text = ""; 
	//		row.setTitle(row.name);
			self._updateSelectedContact(row,false);
		}
		
		var key = row.contactId + '';
		if (row.mobile=='') {
		    if(self.SHARED.contactSelected[key]) {
		    	delete self.SHARED.contactSelected[key];
		    }
		} else {
			if (!self.SHARED.contactSelected[key]) {
				self.SHARED.contactSelected[key] = { selected: {} };
			}
			self.SHARED.contactSelected[key].selected.value = row.mobile;
			self.SHARED.contactSelected[key].selected.name = row.name;
			Ti.API.info ('CTK_!'+key+':'+self.SHARED.contactSelected[key].selected.name);
			if(!self.SHARED.contactSelected[key].group)
				self.SHARED.contactSelected[key].group = {};
			self.SHARED.contactSelected[key].group[self.DATA.groupID] = true;
		}
		/*
			var key = row.contactId + '';	// coerce to string
		    if(!self.SHARED.contactSelected[key])
		    	self.SHARED.contactSelected[key] = {};
		    if(row.mobile!='')
				self.SHARED.contactSelected[key].selected = row.mobile;

			if(!self.SHARED.contactSelected[key].group)
				self.SHARED.contactSelected[key].group = {};
			self.SHARED.contactSelected[key].group[self.DATA.groupID] = true;
		*/
	},

	rowClickHandler : function(row){
		var self = this;

		/*
		if(!row.rendered){
			self._renderSelectedView(row);
		}
		if(row.selected){
			row.unselectHandler();
		}else{
			self._doSelectPhoneNo(row);
		}
		*/
		function getPhoneNumber (parent, row) {
			var person = Ti.Contacts.getPersonByID(row.contactId);
			var phone = person.getPhone();
			if(!phone){
				row.mobile = '';
				return true;
			}
			var phones = [];
			for(key in phone){
				var fieldTotal = phone[key].length;
				for(var m=0;m<fieldTotal;m++){
					var param = { name: row.name, key: key, value: phone[key][m], uid: row.contactId };
					phones.push(param);
				}
			}
			if(phones.length==0){
				row.mobile = '';
				$.app.showAlert(App.Helper.L('no_mobile'), App.Helper.L('TITLE_SHARE'));
				//alert('no phone number');
				return false;
			}
			if (phones.length==1){
				row.mobile = phones[0].value;
				return true;				
			}
			// More than one phone number
			var numbersSelect = [];
			for(var i=0;i<phones.length;i++){
				numbersSelect.push( phones[i].key+' '+phones[i].value );
			}
			numbersSelect.push('Cancel');
			if (row.mobile!='') {
				row.mobile='';
				parent._updateRowUI (row);				
			}
			var phoneDialog = Ti.UI.createOptionDialog({
			    title		: App.Helper.L('select_mobile'),
			    options		: numbersSelect,
				cancel		: phones.length,
			});
			phoneDialog.addEventListener('click', function(evt){
				if(evt.index < phones.length) {
					row.mobile = phones[evt.index].value;
					parent._updateRowUI (row);
				} else {
					row.mobile = '';
				}
			});
			phoneDialog.show();
			return false;			
		}
		var valid_return = true;
		if (row.mobile=='') {
			valid_return = getPhoneNumber (self, row);
		} else {
			row.mobile = '';
		}
		if (valid_return) {
			self._updateRowUI (row);		
		} 
	},

	_renderSelectedView : function(row){
		var self = this;
 
		var selectedView = Ti.UI.createView(self.STYLE.tableRow_SelectedContact);

		row.nameTxt = Ti.UI.createLabel(self.STYLE.label.contactName);
		row.nameTxt.text = row.name;
		row.nameTxt.bottom = '20dp'; 
		selectedView.add(row.nameTxt);

		row.fieldTxt = Ti.UI.createLabel(self.STYLE.label.phoneLabel);
	  	row.numberTxt = Ti.UI.createLabel(self.STYLE.label.phoneNo);

		row.txtView = Ti.UI.createView(self.STYLE.view.phone);
	  	row.txtView.add(row.fieldTxt);
	  	row.txtView.add(row.numberTxt);
		selectedView.add(row.txtView);

		var checkIcon = Ti.UI.createImageView(self.STYLE.img.checkIcon);
		selectedView.add(checkIcon);

		//--- Attach row handler methods  ---
		row.doRowSelect = _doRowSelect;
		row.selectHandler	= function(selectedPhone){
			_doRowSelect(row, selectedPhone);
			_updateSelectedContact(row, true);
		}
		row.unselectHandler	= function(){
			_doRowUnselect(row);
			_updateSelectedContact(row, false);
		};
		row.updatePhone		= function(phoneParam){
			_doUpdatePhone(row, phoneParam);
		};

		//---  Fetch Person's Phone Number  ---
		var person = Ti.Contacts.getPersonByID(row.contactId);
		var phone = person.getPhone();
		if(!phone){
			$.app.showAlert(App.Helper.L('ALERT_PHONENBRNOTFOUND'));
		}else{
			var phones = [];
			for(key in phone){
				var fieldTotal = phone[key].length;
			    for(var m=0;m<fieldTotal;m++){
					var param = { name: row.name, key: key, value: phone[key][m], uid: row.contactId };
					phones.push(param);
			    }
			}
			if(phones.length==0){
				$.app.showAlert(App.Helper.L('no_mobile'), App.Helper.L('TITLE_SHARE'));
			}
		}

		selectedView.backgroundColor = selectedView.backgroundColor;
		selectedView.visible = false;

		row.add(selectedView);
		row.selectedView = selectedView;
		row.phones = phones;
		row.rendered = true;
		  
		//----------------  Event Handlers  ------------------
		function _clearSelection(){
			if(row.selected){
				row.unselectHandler();
			}
		}
		function _doRowSelect(aRow, selectedPhone){
		    aRow.selectedView.visible = true;
			aRow.selectedView.backgroundColor = aRow.selectedView.backgroundColor;
		    aRow.selected = true;

			var key = aRow.contactId + '';	// coerce to string
		    if(!self.SHARED.contactSelected[key])
		    	self.SHARED.contactSelected[key] = {};
		    if(selectedPhone)
				self.SHARED.contactSelected[key].selected.value = selectedPhone;

			if(!self.SHARED.contactSelected[key].group)
				self.SHARED.contactSelected[key].group = {};
			self.SHARED.contactSelected[key].group[self.DATA.groupID] = true;

			self._eventProxy.addEventListener(self.EVENT.clearSelection, _clearSelection, self.rowListeners);
		}
		function _doRowUnselect(aRow){
		    aRow.selectedView.visible = false;
		    aRow.selected = false;

			var key = aRow.contactId + '';
		    delete self.SHARED.contactSelected[key];

			self._eventProxy.removeEventListener(self.EVENT.clearSelection, _clearSelection, self.rowListeners);
		}
		function _doUpdatePhone(aRow, phoneParam){
		    aRow.numberTxt.text  = phoneParam.value;
		    aRow.fieldTxt.text   = phoneParam.key;
		}
		function _updateSelectedContact(aRow, isSelected){
			if(isSelected){
				self.SHARED.selectedCount++;
		    }else{
				self.SHARED.selectedCount--;
		    }
	    	//---  Update Share button on Toolbar  ---
			self._eventProxy.fireEvent(self._eventProxy.EVENT.updateToolbar, {
				selectedCount	: self.SHARED.selectedCount,
			});
		}
	},

	_doSelectPhoneNo : function(row){
		var self = this;

		if(('undefined' == typeof row.phones) || (row.phones.length == 0)){
			return;
		}else if(row.phones.length == 1){
			//--- only 1 phone, use it ---
			_updateSelection(row.phones[0]);
		}else{
			//---  multiple phone no., display options dialog to select ---
			var numbersSelect = [];
			for(var i=0;i<row.phones.length;i++){
				numbersSelect.push( row.phones[i].key+' '+row.phones[i].value );
			}
			numbersSelect.push('Cancel');

			var phoneDialog = Ti.UI.createOptionDialog({
			    title		: App.Helper.L('select_mobile'),
			    options		: numbersSelect,
				cancel		: row.phones.length,
			});
			phoneDialog.addEventListener('click', function(evt){
				if(evt.index < row.phones.length){
				    _updateSelection(row.phones[evt.index]);
				}
			});
			phoneDialog.show();
			
		}

		function _updateSelection(selectedPhone){
			row.updatePhone(selectedPhone);
			row.selectHandler(selectedPhone);
		}
	},

	// --------------------------------------------------------
	dispose : function() {
	    var self = this;

		if(App.Config.IS_ANDROID){
			self._eventProxy.removeListeners(self.rowListeners);
		}
	    self.contactListView = null;
	    self.base();
	},
});

module.exports = ContactSelectorAndroid;

